﻿using System;
using System.Threading;
using System.Linq;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Diagnostics;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using System.Text.RegularExpressions;
using System.Xml.Serialization;

using Buddy.Common;
using Buddy.CommonBot;
using Buddy.Swtor;
using Buddy.Swtor.Objects;
using Buddy.Common.Math;
using Buddy.Navigation;
using Buddy.BehaviorTree;
using Buddy.CommonBot;

using Action = Buddy.BehaviorTree.Action;

/* Notes:  By JoeBrewski - Started in Sep 2012.  Recommended you REMOVE/DELETE ALL BW PLUGINS - They kill stability with the bot.
 */
namespace JoesCombat
{

    public static class MercHelpers
    {
        /*******************************************                 DRIVER VARIABLES - YOU CAN MODIFY THESE TO MODIFY BEHAVIORS WITH THE CC               ********************************************************************/
        public static bool DoRandomGrind { get { return false; } }                           // Run around and kill shit.  Run with CombatBot.xml, and park in a mob-rich area before you start.
        
        private static bool EnableMount = false;
        private static bool EnableRocketBoost = false;
        private static char chMount = 'X';                                                  // Key to use for mounting - MUST CORRESPOND TO KEY SET FOR THE QUICKBAR BUTTON IN SWTOR 'x' in SWTOR, = 'X' here.
        private static char chRocketBoost = (char)0x62; // NumPad2                          // Virtual Key Codes available at http://msdn.microsoft.com/en-us/library/windows/desktop/dd375731(v=vs.85).aspx        

        public static float MedProbeMaxWait = 60;                                           // Maximum amount of time in Seconds to wait for the Med Probe Rez to become available after death.  After this, a Medcenter Rez will be used.
        private static float MaxNodeDist = 4.0f;                                            // Max Distance Used to scan for harvestable nodes/corpses (10x multiplier in variable value vs. displayed value, so 10=100)
        public static float PullDist = 2.0f;                                                // Char Settings - Pull Distance - used in MyTargetingProvider/MTP - bot doesn't seem to really 'Listen' to this setting at the moment, anything less than 3.0f(30m) it wants to run right up to the mob with
        public static int CheckInvMinSlots = 10;                                            // Minimum number of Inventory slots to activate the FRD on, if that's been enabled.
        private static bool UseXPBoosters = true;                                          // Use Experience Boosters in inventory if they're present.

        private static CombatToughness DRGMinToughness = CombatToughness.Strong;            // Min Combat Toughness with DoRandomGrind - if doing this above CombatToughness.Standard, park it in a spot where you KNOW there will be alot of these.

        public static bool AutoTarget = true;                                               // ONLY Set this to False if YOU will (manually) target, and don't want ANY Auto-Targeting to take place.  Will default to true on DoRandomGrind.
        public static bool AutoTargetTank = true;                                           // Used for TANKS ONLY - when false, disables the HandleGuarding() routine - for stuff like Mandalorian Raiders - Bosses like Braxx the Bloodhound, where you're only hitting BOSS
        private static bool AutoTargetExplicit = true;                                      // Explicitly (i.e. ON-SCREEN) 'Target' the Auto-Targeted Mob - Can cause delays/lag if not true, especially in Ops/FPs
        public static bool AutoTargetLOSOnly = true;                                       // Only AutoTarget Mobs in Line-Of-Sight

        private static bool ProcessSetAffin = true;                                         // Set the process Affinity on startup.  Modify if you're running into 'Stutter Issues' or your sound in-game went to hell, and it actually matters to you, you dirty botter.
        private static bool ProcessSetPriority = true;                                      // Ditto

        // If you're running into frequent hangs with the CC, you can adjust this as necessary (generally the approach would be to RAISE THE PRIORITY STEP-BY-STEP on the bot, up to .RealTime). 
        private static ProcessPriorityClass BotDefaultPriority = ProcessPriorityClass.BelowNormal;
        private static ProcessPriorityClass SWTORDefaultPriority = ProcessPriorityClass.AboveNormal;

        private static bool ScanForLoot = true;                                             // Set to true for Loot-Scanning w/DoRandomGrind - If you're bent on levelling, set this to false - you won't hit nodes, but it will run faster.
        private static bool ScanForNodes = true;                                            // Set to true for Node-Scanning w/DoRandomGrind - If you're bent on levelling, set this to false - you won't hit nodes, but it will run faster.
        private static bool ScanForChests = true;                                           // Set to false to ignore chests due to meshing issues etc
        private static float KillFestLootFreq = 59f;                                           // With DoRandomGrind, only loot/harvest every X seconds.  Only used if >= 60.  Speeds up grinding.  Will slow down your Crew Skill gains of course.


        // RunCycle: If true, will set EnableObjMgrUpd and EnableGC to false, and on each round of combat etc, 'Returns to the Mothership' (.exe) for a 'Proper Object Manager Update'.  Suggested you DO NOT SET THIS TO TRUE if In-Group and tanking or healing.  
        // Makes the CC 'less invasive' on the bot itself. If you're running a DPS, should be fine to set (to true).  And you may get better Buff-Detection with this set (if you're having problems with it)
        // Suggested you just set this to true if questing/grinding and you have stability issues.  Not that when EnableObjMgr is false, targeting WILL get WAY HERKY-JERKY (I can't disable my own targeting mechanism, and queries are often sketchy when false).
        public static bool RunCycle = false;                                                

        public static bool EnableObjMgrUpd = true;                                         // Enable coded ObjectManager.Update(s).  Pretty much REQUIRED TO BE TRUE if running Heals or Tanking.
        private static bool EnableGC = true;                                               // If you're getting alot of 'Failed to ReadProcessMemory' or 'Object reference not set to an instance of an object' etc errors, set this to true.
        public static bool UseFramelocks = true;                                            // Enable Framelocks - GREATLY improves speed and reliability of queries and game-memory-writes.  Only place I've seen this cause issues is in the Kuat Drive Yards (guessing it was 'Contracted-Out' for the coding - and laggy anyhow)

        private static bool DisableAutoRez = false;                                         // In-Group, Auto-Rez is AUTOMATICALLY disabled.  Set this for when you're running solo - typically set to true if running CombatBot.  In-Group, AUTOMATICALLY, true.

        private static ulong DRGMinLevel = 1;                                               // Min DoRandomGrind Level:  Set to something like Me.Level-6 to hit mobs that are 6 or fewer levels below you, for example. 
        private static bool EnableVendor            = true;                                 // Use vendor (every 20 minutes) on Rez at MedCenter
        private static int MountCheckFreq           = 15;                                   // Mount Check Frequency (in Seconds)

        public static bool AllowCombat             = true;                                 // Combat - mainly for use in groups
        private static bool ReportDurs              = false;                                // Report Durations in log
        private static bool LogCTDebuffs            = false;                                // Curr Target Debuff Logging
        private static bool LogMyBuffs              = false;                                // Char Buff Logging:  Debugging Purposes
        private static bool PullIG = false;                                // ONLY set this to true if you want to pull while In-Group for whatever reason
        private static bool HarvestCorpses          = true;                                 // Harvest corpses if you have de skills on given corpse (i.e. strong Droid=Scav, etc)
        private static bool InGroupTargetWeakest    = false;                                // For Instances/Ops - When In-Group, always target the weakest attacker - if false, target the Group Target (first NPC targeted by a group member other than you)
        private static bool Backpedal = false;                                               // If you're a ranged class/spec, and the mob is in Melee range, backpedal (first back, then forward, to 'break melee') (sketchy ATM)

        private static int RehookFreq = 600;                                                 // Re-Hook/Reload Frequency - Due to the frequent SWTOR 'Musical Chairs' with offset/addr changes
        private static int MaxNodesBetweenFights = 2;                                       // Max nodes to harvest between fights, IF ScanForNodes is true
        private static bool Rehooking = false;

        private static Keys CombatToggleHotKey                          = Keys.Home;                         // Combat Toggle - Mainly for Use in Ops, FPs, etc
        private static Keys MovementToggleHotKey                        = Keys.Delete;                       // Movement Toggle - Mainly for Use in Ops, FPs, etc
        //private static Keys DRGToggle                                 = Keys.Add;                          // DoRandomGrind Toggle Key
        private static Keys TargetingToggle                             = Keys.Add;                          // Target-Weakest Toggle (in-Group)
        private static Keys PauseToggle = Keys.Subtract;
        
        private static bool UseFRD = true;                                                  // This will only be used if you have the ability "Deploy Field Repair Droid" - From Legacy - Character Perks - No-Workie ATM
        public static bool ProtectCompWhenWeak = false;                                     // Target the Comp's attackers when Comp is at 70%-or-less-health - used in GetTarget().  ONLY enable this if (a) Not Melee, and (b) You can AFFORD to be running around ALOT during combat
        
        /*******************************************                                          END OF DRIVER VARIABLES                                                  ********************************************************************/

        public static bool PauseBot = false;
        
        private static long RehookLastMemSize;
        private static string MyAbilities = "";                                             // Abilities List, Semicolon-Separated, for Example:  MyAbilities.Contains("Wrath") - for a Sorc - Basically a Skill-Tree Check option
        private static bool BackPedalToggle = false;
        
        private static string ProfilePath = "";

        private static Dictionary<string, TorAbility> MyAbilDct = new Dictionary<string, TorAbility>();
        private static Dictionary<string, DateTime> MyAbilCast = new Dictionary<string, DateTime>();
        private static Dictionary<ulong, int> MyQuests = new Dictionary<ulong, int>();
        private static OrderedDictionary MyCastTgtDct = new OrderedDictionary();

        public static DateTime DateLastPingOOC                      = DateTime.Now;
        public static DateTime DateLastPingCombat                   = DateTime.Now;
        public static bool GOMLoaded = false;
        public static IntPtr BWWH;

        private static bool LastCombatResult = false;

        private static bool Is55H = false;

        [DllImport("user32.dll")] private static extern int SendMessage(IntPtr hWnd, int wMsg, IntPtr wParam, IntPtr lParam);  // Used for mounting/keysend
        [DllImport("user32.dll")] private static extern bool SetForegroundWindow(IntPtr hWnd);
                
        private static string LastPOIName = "";
        private static List<Vector3> DRGGrindPath=new List<Vector3>();
        private static Vector3 DRGVendorPos;
        private static string DRGVendorName = "";
        private static DateTime DRGLastVendorUse=DateTime.Now;

        public static Dictionary<ulong, float> AttackersHP = new Dictionary<ulong, float>();
        public static List<TorNpc> Attackers = new List<TorNpc>();
        public static Vector3 AttackersMidpoint = new Vector3();
        public static DateTime CombatStart = DateTime.MinValue;
        //public static List<string> AttackersInfo = new List<string>();
        public static int LastDPSIndex = 0;
        public static float AttackersHPTotal = 0f;

        public static string StatusLastDPS = "";
        public static string StatusETAToLevel = "";

        public static double CombatGCTime = 0;
        public static double CombatPullTime = 0;

        //private static System.Windows.Forms.Keys TargWeakestToggleHotKey = Keys.Home;     // Obsolete
        private static System.Windows.Forms.Keys ForceAbortHotKey = Keys.NumPad0;           // Force the bot to ABORT the bot main thread if hung 
        private static DateTime KillFestLastLootScan = DateTime.Now.AddSeconds(-300);

        private static Vector3 LastCombatPt;

        private static Buddy.CommonBot.Settings.GlobalSettings GS = new Buddy.CommonBot.Settings.GlobalSettings();

        private static int SWTORPID;                                                        // For Mounting and Spell Cancel/Stop
        private static IntPtr SWTORHWnd;

        private static DateTime LastXPCheckTime = DateTime.Now;
        private static ulong LastXPCheck = Me.Xp;
        private static DateTime LastXPShownTime = DateTime.Now;

        private static string MountName = Buddy.Swtor.Mounts.GetFastestAvailableMount();    // For use with DoRandomGrind (since the OOC pretty much overrides any 'idle time' for normal profile operations)

        private const float MaxDist = 50f;                                                   // 10x factor internally in SWTOR - For use with DoRandomGrind

        private static bool InitsComplete = false;
        private static bool HasScav = false;
        private static bool HasBio = false;
        private static bool HasArch = false;
        private static bool HasSlicing = false;                                             
        private static bool IsRanged = false;                                               // Ranged or Melee Combat Spec
        
        private static Dictionary<ulong,DateTime> MyBlacklist = new Dictionary<ulong,DateTime>();
        // Blacklist for Mob Corpse-Harvesting/Nodes

        private static bool UseAOE = true;

        private static Dictionary<string, DateTime> EquippedRelics=new Dictionary<string,DateTime>();

        private static float MeleeDist;                                                     // Melee Distance - Used mainly for LARGE MOBS - where CT.Scale < 1
        private static DateTime datLCast;                                                   // Last Cast (Used for aggro mobs not attackable)
        private static DateTime datLC;                                                      // Last check for harvestables
        private static DateTime datLDCC = Now;                                              // Last Dead Comp Check
        private static DateTime datLMC;                                                     // Last check for harvestables
        private static DateTime datLCs;                                                     // Last cast - Used for check in ForcedCast - mainly PvP
        private static DateTime datLCL;                                                     // Last Check Local (used locally in various routines)
        private static DateTime datLFP=Now;                                                 // Last Forced Pulse() - ONLY do this once every 5 seconds max
        private static DateTime datLOOC;                                                    // Last OOC call - for OOC 'throttling'
        private static DateTime datLCC = DateTime.Now;                                      // Last Comp Check
        private static DateTime datLGC = DateTime.Now;                                      // Last GC (runs roughly once-per-minute Out-Of-Combat)
        private static DateTime datLGC2 = DateTime.Now;
        private static DateTime datLLS = DateTime.Now;                                      // Last Loot Scan:  To Be Used w/KillFest (only scan for loot every 2 minutes)
        private static DateTime datLMPU = DateTime.Now;                                     // Last Medpack Used - 2-minute restriction
        private static DateTime datLBC = DateTime.Now;                                      // Last Buff Check - Only check buffs every 20s
        private static DateTime datLCCoTF = DateTime.Now;
        private static DateTime CS;                                                         // Last GC
        private static ulong CG;                                                            // Cur Target GUI(ID)
        private static DateTime datLastHM = DateTime.Now;                                   // Last Heroic Moment:  Buggy Casting on Heroic Moment
        private static bool MovementAllowed = true;
        private static bool MovementAllowedOrig = true;
        private static DateTime datLSC = DateTime.Now;                                      // Last Summon Companion (only try once every 5 minutes)
        private static DateTime datLFRD = Now.Subtract(TimeSpan.FromSeconds(900));                                // Last Field Repair Droid Deployment - 15 minute CD on this
        private static DateTime datLOMU;                                                    // Last ObjectManager Update
        private static DateTime datLLBScan = Now.Subtract(TimeSpan.FromSeconds(300));                                                 // Last inventory Lockbox/Goodies scan
        private static DateTime datLInvScan = Now.Subtract(TimeSpan.FromSeconds(300));                                                 // Last inventory Lockbox/Goodies scan
        private static DateTime datLRB = Now;                                               // Last Rocket Boost (timer set to 30s in MountUp()
        private static DateTime datLKSU = Now;                                              // Last Kolto Station Used (for In-Group Ops/FPs where they're available and in-range)
        private static DateTime datLKSC = Now;                                              // Last Kolto Station Check (Check done every 5s)
        private static DateTime datLCQP = Now;                                              // Last CheckQuestingPOI
        
        private static bool CheckForFRDImmediate = false;

        private static IMovementProvider DefaultMP = Navigator.MovementProvider;
        private static INavigationProvider DefaultNP = Navigator.NavigationProvider;
        private static IMovementProvider CurrentMP = Navigator.MovementProvider;
        private static INavigationProvider CurrentNP = Navigator.NavigationProvider;
        private static NoMovement_MovementProvider NoMovementProvider = new NoMovement_MovementProvider();
        private static NoMovement_NavigationProvider NoNavigationProvider = new NoMovement_NavigationProvider();
        
        private static MyTargetingProvider MTP = new MyTargetingProvider();
        //private static MyTargetingProvider MTP = null;

        private static MyMainWindow MMW = null;
        public static bool Restarting = false;

        private static TorCharacter LHUnit = null;                                             // Low-Health Unit - For Healing Classes such as BG, Seer, etc
        private static TorCharacter NGUnit = null;                                          // 'Needs Guarding' Unit - for Tanking
        private static Dictionary<string, int> LHDebuffs = new Dictionary<string, int>();
        private static string sLHDebuffs = "";
        private static string sLHBuffs = "";
        private static TorCharacter NAUnit = null;                                                // 'Needs Aggroed' NPC Unit - for Tanking
        private static TorCharacter CT;                                                     // Curr Targ
        private static string CTName = "";                                                  // Curr Targ Name
        private static TorPlayer CTP;                                                       // Curr Targ Player - PvP - useless
        private static TorCharacter CompTarg = null;                                        // Comp Targ
        private static TorCharacter LastComp = null;

        private static string MyBuffs = "";                                                 // Buffs/Affects List (String, Semicolon-Delimited)
        private static string CTDebuffs = "";                                               // Cur Targ Debuffs List (String, Semicolon-Delimited)

        private static Vector3 TP;                                                          // Targ Pos
        private static SkillTreeId MySpec = SpecHandler.GetSpec();                          // Current Spec
        private static float MyAlignment = GetAlignment();
        public static ulong MyLevel = Me.Level;
        private static bool FF = false;                                                     // Full Fury:  For Knights (Pub) or Warrior (Emp)
        private static float HP = 0;                                                        // Health Pct
        private static float EP = 0;                                                        // Energy Pct
        private static float FP = 0;                                                        // Energy Pct
        private static float TD = 0;                                                        // Targ Dist
        private static bool TC = false;                                                     // Targ Casting
        private static bool SoG = false;                                                    // StrongOrGreater
        private static float RS = 0;                                                        // Resource Stat
        private static float THP = 0;                                                       // Targ Health Pct
        public static bool IG = false;                                                      // In-Group - Important Re:  Healing and Pulls
        public static bool AmTank = false;
        public static List<TorPlayer> MyGroup = new List<TorPlayer>();                        
        public static int GroupSize = 0;                                                    // IG; Group Size
        public static TorPlayer theTank = null;
        private static float CHP = 0;                                                       // Comp Health Pct
        private static CombatToughness CTT;                                                 // Cur Targ Toughness
        private static int TWR30 = 0;                                                       // Target Count within 30m
        private static int TWR10 = 0;                                                       // Targets within 10m
        private static int TWR5 = 0;                                                        // Targets within 5m
        private static float LHH = 0;                                                       // Lowest-Health Health Pct (for In-Group Healing)
        private static float LHD = 0;                                                       // Lowest-Health Dist
        private static Vector3 LHP;                                                         // Lowest-Health Pct

        private static TorAbility taDeployFRD=null;                                         // Field Repair Droid Deployment - Used in CheckInventory() - Issues trying to deplay and then interact with the droid ATM
        private static TorAbility taSummComp = null;                                        // Summon Companion
        private static TorAbility taDismissComp = null;                                     // Dismiss Companion
        private static TorAbility taUM = null;                                              // Underworld Medicine - BUGGY AS HELL via normal casting
        private static TorAbility taCompAttack = null;                                      // Attack Ability
        private static TorAbility taMedCenter = null;                                       // Return to Medcenter on death
        private static TorAbility taFieldRevive = null;
        private static TorAbility taAcceptRevive = null;
        private static TorAbility taForceArmor = null;                                      // Force Armor, Because Trying to Cast it NEVER WORKS
        private static TorAbility taQT = null;                                              // Quick Travel
        private static TorAbility taRB = null;                                              // Rocket Boost
        private static TorAbility taLoot = null;                                            
        private static EffectResult er;                                                     // Ability Use Result (Code)
        private static Buddy.CommonBot.IBot IB;

        private static Thread thStart;
        private static Thread thStop;

        public static MyQuestDef myHS_XenovirusPrime;
        public static MyQuestDef myHS_DroidMalfunction;
        public static PrioritySelector MyPS;
        public static string MyName = "";                                                   // Issues comparing a TorChar to BuddyTor.Me, so this is used
        public static ulong MyGUID = 0;
        public static string CompName = "";
        public static string OurGUIDs = "";                                                 // MyGUID+Comp's GUID, as a Concat'd String

        public static int OpsID = 0;                                                        // 1=TC - Rest ignored at this point (due to constant Isotope-5-Targeting I CANNOT SEEM TO AVOID otherwise) - Set and used in GetTarget
                                                                                            // For TC, EXPLICITLY TARGET GOLDEN FURY
        public static DateTime LastGuardCheck = DateTime.Now;

        public static PrioritySelector psCombat()
        {
            return new PrioritySelector(actCombat);
        }
        public static PrioritySelector psOOC()
        {
            return new PrioritySelector(actOOC);
        }

        public static Action actCombat = 
            new Action(r =>
            {
                CheckObjCount();
                StopMoving(); 
                MyCombat(); 
                return IAmInCombat() ? RunStatus.Success : RunStatus.Failure;
            }
        );
 
        public static Action actOOC = new Action(ret =>
        {
            try
            {
                CheckObjCount();
                PauseWait();

                CheckInventory();
                if (CheckForFRDImmediate) return RunStatus.Success; // Cycle until we time-out at 3m or score a hit on the vendor

                if (Me.GroupId != 0) 
                { 
                    OOCIG(); 
                    Thread.Sleep(1200); 
                    return RunStatus.Failure; 
                }
                else if (DoRandomGrind) 
                { 
                    RunRandomGrind(); 
                    return IAmInCombat()?RunStatus.Failure:RunStatus.Success; 
                }
                else { 
                    OOCQuestingGrinding(); 
                    return RunStatus.Failure; 
                }
            }
            catch { return RunStatus.Failure; }
        });

        public static void CheckSpec()
        {
            if (MyLevel > 12 && MySpec == SkillTreeId.None)
                try { MySpec = SpecHandler.GetSpec(Me); }
                catch { }
        }

        // Experimental
        //public static bool HandleSpaceCombat()
        //{
        //    //using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
        //    //{
        //    //    foreach (TorAbility ta in Me.KnownAbilitiesContainer) try { Logger.Write("TorAbility: " + ta.Name); }
        //    //        catch { }
        //    //}
        //    using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
        //    {
        //        foreach (TorPlaceable tx in ObjectManager.GetObjects<TorPlaceable>()) try { Logger.Write("TorPlaceable: " + tx.Name); }
        //            catch { }
        //    }
        //    using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
        //    {
        //        foreach (TorCharacter tv in ObjectManager.GetObjects<TorNpc>()) try { Logger.Write("TorCharacter: " + tv.Name); }
        //            catch { }
        //    }
        //    Thread.Sleep(1000);
        //    Buddy.CommonBot.BotMain.BotThread.Abort();
        //    return true;

        //}

        //public static bool HandleConvo()
        //{
        //    if (IAmInConvo())
        //    {
        //        SendKey(' ');
        //        // A response of '3' in alot of quests = 'Decline this Quest' in parts, so only do it IN-GROUP if Dark
        //        // And sorry, alot of '2's are Neutral, but there's only so much I can do w/o the goodies/knowledge that Aevitas provides
        //        SendKey(MyAlignment<0?IG?'3':'2':'1'); 
        //        Thread.Sleep(250+(new Random().Next(200)));
        //        return true;
        //    }
        //    return false;
        //}

        //public static bool WaitForConvo()
        //{
        //    if (IAmInConvo())
        //    {
        //        Thread.Sleep(500);
        //        return true;
        //    }
        //    return false;
        //}

        // I'm guessing TicksPerSecond 'Caps at Minimum' of 1, but it WILL let me set it to zero, so...
        public static void SetTPS(int ForceTo = -1)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                int tps;
                if (!EnableObjMgrUpd) 
                    tps=8;
                else
                    if (ForceTo != -1 && ForceTo>=0) tps = ForceTo;
                else 
                    if (Me.GroupId!=0) tps = 0;
                else 
                    tps = 0;
                Buddy.CommonBot.BotMain.TicksPerSecond = tps;
            }
        }


        public static void SetProcessAttrs()
        {
            int ProcessorCount = Environment.ProcessorCount;
            Logger.Write("Reported Processor Count: " + ProcessorCount.ToString());
            try
            {
                uint Affin = (uint)ProcessorCount;
                if (ProcessSetAffin) Process.GetCurrentProcess().ProcessorAffinity = (IntPtr)(1 << ProcessorCount - 1);
                if (ProcessSetPriority) Process.GetCurrentProcess().PriorityClass = (Me.GroupId!=0?ProcessPriorityClass.RealTime:BotDefaultPriority);
                //if (ProcessSetPriority) Process.GetCurrentProcess().PriorityClass = BotDefaultPriority;
                BWWH = Process.GetCurrentProcess().MainWindowHandle;
            }
            catch { Logger.Write("Failed setting process attributes on BuddyWing."); }

            int TorMem = 0;
            foreach (Process proc in Process.GetProcesses()) if (proc.ProcessName.Contains("swtor"))
            try
            {
                if (ProcessSetAffin)
                {
                    uint Affin = ProcessorCount >= 4 ?
                        (uint)((1 << (ProcessorCount - 2) | (1 << (ProcessorCount - 3)))) :
                        (uint)(1 << (ProcessorCount - 2));
                    proc.ProcessorAffinity = (IntPtr)Affin;
                    proc.PriorityClass = SWTORDefaultPriority;
                }
                if (ProcessSetPriority) proc.PriorityClass = ProcessPriorityClass.AboveNormal;
            }
            catch (Exception ex)
            {
                Logger.Write("Failed setting process attributes on Star Wars (Main Window).");
                Logger.Write("Error: " + ex.Message);
            }
            foreach (Process proc in Process.GetProcesses()) if (proc.ProcessName.Contains("swtor") && proc.MainWindowTitle.Contains("Star Wars"))
                if (proc.PrivateMemorySize64 > TorMem)
                {

                    SWTORPID = proc.Id;
                    TorMem = (int)proc.NonpagedSystemMemorySize64;
                    SWTORHWnd = proc.MainWindowHandle;
                }
            SetTPS();
            //if (EnableObjMgrUpd)

        }

        public static void GetProfessions()
        {
            try
            {
                Logger.Write("************* PROFESSIONS CHECK **************");
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    foreach (Buddy.Swtor.Objects.Components.ProfessionInfo pi in BuddyTor.Me.ProfessionInfos)
                    {
                        Logger.Write("Abil " + pi.Name + " found");
                        if (pi.Name.Contains("Bioanalysis")) HasBio = true;
                        if (pi.Name.Contains("Scavenging")) HasScav = true;
                        if (pi.Name.Contains("Archaeology")) HasArch = true;
                        if (pi.Name.Contains("Slicing")) HasSlicing = true;
                    }
                }
            }
            catch { Logger.Write("Error in GetProfessions()."); }
        }

        public static void AbortBW()
        {
            try
            {
                Process.GetCurrentProcess().PriorityClass = ProcessPriorityClass.RealTime;
                //using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                //{
                //    try
                //    {
                        InitsComplete = false;
                //        ClearCacheAndPOI();
                //    }
                //    catch { }
                //}
                Buddy.CommonBot.BotMain.BotThread.Abort();
                return;
            }
            catch { }
            //    try { ClearAndReloadProfile(); }
            //    catch { }
            //    while (true)
            //    {
            //        //try { if (Buddy.CommonBot.BotMain.IsRunning) Buddy.CommonBot.BotMain.Stop(); break; }
            //        try {
            //            if (Buddy.CommonBot.BotMain.IsRunning)
            //            {
            //                Buddy.CommonBot.BotMain.BotThread.Abort();
            //                Thread.Sleep(1000); if (!BotMain.IsRunning) break;
            //            }
            //            else break;
            //        }
            //        catch { }
            //        Thread.Sleep(1000);
            //    }
            //    //try { DoRehook(); }
            //    //catch { }
            //    //ClearCacheAndPOI();
            //    Process.GetCurrentProcess().PriorityClass = BotDefaultPriority;
            //}
            //catch { }
            ////try { BotMain.CurrentBot.Stop(); Thread.Sleep(2000); }
            ////catch { }
        }

        public static void PauseWait()
        {
            if (PauseBot)
            {
                Logger.Write("Bot Paused, waiting on Pause Toggle...");
                while (PauseBot) Thread.Sleep(1000);
            }
        }

        public static void SetHotKeys()
        {
            Logger.Write("********************** HOTKEYS *****************************");
            //Logger.Write("DoRandomGrind Key [" + DRGToggle.ToString() + "] HotKey Registered.");
            //Hotkeys.RegisterHotkey("DoRandomGrind", () => { DoRandomGrind = !DoRandomGrind; Logger.Write("DoRandom Grind: " + DoRandomGrind.ToString()); OOC(); }, DRGToggle);
            Logger.Write("Combat Toggle Key [" + CombatToggleHotKey.ToString() + "] HotKey Registered.");
            Hotkeys.RegisterHotkey("Combat Toggle", () => { AllowCombat = !AllowCombat; Logger.Write("AllowCombat: " + AllowCombat.ToString()); }, CombatToggleHotKey);
            Logger.Write("Bot Pause Toggle Key [" + PauseToggle.ToString() + "] HotKey Registered.");
            Hotkeys.RegisterHotkey("Pause Bot Toggle", () => { PauseBot = !PauseBot; Logger.Write("Pause Bot: " + PauseBot.ToString()); }, PauseToggle);
            Logger.Write("Movement Toggle Key [" + MovementToggleHotKey.ToString() + "] HotKey Registered...  You can edit the value in MercHelpers.cs if necessary (and then restart the .exe)");
            Hotkeys.RegisterHotkey("Movement Toggle", () => { if (!(!IG && DoRandomGrind)) MovementToggle(); }, MovementToggleHotKey);
            //Logger.Write("Target-Weakest Toggle Key [" + TargWeakestToggleHotKey.ToString() + "] HotKey Registered...  You can edit the value in MercHelpers.cs if necessary (and then restart the .exe)");
            //Hotkeys.RegisterHotkey("Targeting Toggle", () => { TargetingToggle(); }, TargWeakestToggleHotKey);
            if (!AmTank)
            {
                Logger.Write("Targeting Toggle [" + TargetingToggle.ToString() + "] HotKey Registered.");
                Hotkeys.RegisterHotkey("Target Toggle",
                    () =>
                    {
                        if (!DoRandomGrind || IG) { AutoTarget = !AutoTarget; Logger.Write("AutoTarget: " + AutoTarget.ToString()); }
                        //if (IG)  { InGroupTargetWeakest = !InGroupTargetWeakest; Logger.Write("In-Group Target-Weakest: " + InGroupTargetWeakest.ToString()); 
                    }, TargetingToggle);
            }
            else
            {
                Logger.Write("AutoTargetTankToggle [" + TargetingToggle.ToString() + "] HotKey Registered.");
                Hotkeys.RegisterHotkey("AutoTargetTankToggle",
                    () => { AutoTargetTank = !AutoTargetTank; AutoTarget = AutoTargetTank; Logger.Write("Auto-Target-Tank/Auto-Target: " + AutoTargetTank.ToString()); }, TargetingToggle);
            }
            Logger.Write("Forced Bot Thread ABORT [" + ForceAbortHotKey.ToString() + "] HotKey Registered.  Use this after a few seconds of no action, and the bot window is unresponsive/hung (and then wait 5-10s after pressing it,and try and Alt-Tab back to BuddyWing window).");
            Hotkeys.RegisterHotkey("Forced Abort", () => { AbortBW(); }, ForceAbortHotKey);
        }

        public static void BindAbility(string scanFor, TorAbility taSource, ref TorAbility ta)
        {
            if (taSource!=null && taSource.Name != null && taSource.Name.Contains(scanFor) && ta == null)
            {
                ta = taSource;
                Logger.Write("Ability " + taSource.Name + " found.");
                //WriteObject((MyTorObject)((TorObject)ta));
            }
        }

        public static void ShowAbilInfo(TorAbility ta)
        {
            Logger.Write("Ability " + ta.Name + " found. TargetingRule: " + ta.TargetRule.ToString() + " IconSpec: " + ta.IconSpec.ToString() + " AIType: " + ta.AiType.ToString() +
              " AppearanceSpec: " + ta.AppearanceSpec.ToString() + " IsHidden: " + ta.IsHidden);
        }

        public static TorAbility GetAbility(string theName, TorCharacter fromUnit, bool exactMatch = false)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                foreach (TorAbility ta in fromUnit.KnownAbilitiesContainer.Where(d => (!exactMatch && d.Name.Contains(theName)) || d.Name == theName)) { return ta; }
            }
            return null;
        }

        public static void LoadAbilities()
        {
            try
            {

                Logger.Write("***************** CHECKING ABILITIES ********************");
                foreach (TorAbility ta in BuddyTor.Me.KnownAbilitiesContainer)
                {
                    if (!MyAbilDct.ContainsKey(ta.Name) && !ta.IsPassive)
                    {
                        MyAbilDct.Add(ta.Name, ta);
                        MyAbilCast.Add(ta.Name, new DateTime(DateTime.MinValue.Ticks));
                    }

                    if (ta.IsPassive) MyAbilities += ta.Name + ";";

                    if (ta.Name.Contains("Wounding Shots")) { MySpec = SkillTreeId.GunslingerDirtyFighting; Logger.Write("Spec overridden to: " + MySpec.ToString()); }
                    if (ta.Name.Contains("Incendiary Missile")) MySpec = SkillTreeId.MercenaryFirebug;

                    BindAbility("Underworld Medicine", ta, ref taUM);
                    BindAbility("Force Armor", ta, ref taForceArmor);

                    BindAbility("Loot", ta, ref taLoot);
                    BindAbility("Quick Travel", ta, ref taQT);
                    BindAbility("Rocket", ta, ref taRB);

                    BindAbility("Deploy Field Repair", ta, ref taDeployFRD);
                    BindAbility("Summon Companion", ta, ref taSummComp);
                    BindAbility("Dismiss Companion", ta, ref taDismissComp);
                    BindAbility("Medcenter", ta, ref taMedCenter);
                    BindAbility("Field Revive", ta, ref taFieldRevive);
                    BindAbility("Accept Revive", ta, ref taAcceptRevive);

                    if (ta.Name.Contains("Junk"))ShowAbilInfo(ta);      
                }

                //foreach (TorAbility ta in Me.KnownAbilitiesContainer.Where(t => t.IsHidden)) ShowAbilInfo(ta);

                Logger.Write("Total (Non-Passive) Abilities Found: " + MyAbilDct.Count().ToString());
                //Logger.Write("MyAbilities: " + MyAbilities);
                //Logger.Write("MyAbilities StrLen: " + MyAbilities.Length);
                //UpdateObjects();
                if (Me.Companion!=null) 
                    foreach (TorAbility ta in Me.Companion.KnownAbilitiesContainer)
                    {
                        if (ta.Name=="Attack" && taCompAttack == null) { taCompAttack = ta; Logger.Write("Companion Ability " + ta.Name + " found."); }
                        //Logger.Write("Companion Ability " + ta.Name + " found.  StrLen: " + ta.Name.Length.ToString());
                        //ShowAbilInfo(ta);
                        //if (ta.Name.Length == 0 && ta.TargetRule==TargettingRule.Self && ta.AiType == AbilityType.Buff) Me.AbilityActivate(ta, Me.Companion, out er);
                    }
            }
            catch { }
        }
        
        //public static void WriteObject(MyTorObject O)
        //{
        //    if (O != null)
        //    {
        //        try
        //        {
        //            XmlSerializer xmlserializer = new XmlSerializer(typeof(MyTorObject));
        //            //StringWriter stringWriter = new StringWriter();
        //            //XmlWriter writer = XmlWriter.Create(stringWriter);

        //            System.IO.Stream sOut = new System.IO.MemoryStream();
        //            System.IO.StreamWriter strOut = new System.IO.StreamWriter(sOut,System.Text.UTF8Encoding.Unicode);
        //            xmlserializer.Serialize(strOut, O);
        //            Logger.Write(strOut.ToString());
        //            //Write(stringWriter.ToString());
        //            strOut.Close();
        //            sOut.Close();
        //            //writer.Close();

        //        }
        //        catch (Exception ex)
        //        {
        //            Logger.Write("Serialization Error: " + ex.Message);
        //            //Write("EX: " + ex.ToString());
        //        }
        //    }
        //}

        public static void IssueInitsMessages()
        {
            if (DoRandomGrind)
            {
                Logger.Write("RANDOM-GRIND IS ACTIVE.  If not intended, update the DoRandomGrind flag in MercHelpers.cs to false, and restart the .exe (as in exit and reopen).");
                Logger.Write("WITH DoRandomGrind, YOU NEED TO PARK YOUR CHARACTER IN A MOB-RICH AREA BEFORE STARTING (So it has plenty to find/attack).");
            }
            Logger.Write("*********************************************************");
            //Logger.Write("Check Abilities: Bio " + HasBio.ToString() + " Scav " + HasScav.ToString() + " Arch " + HasArch.ToString() + " Slicing " + HasSlicing.ToString());
            //Logger.Write("***IF YOU ARE RUNNING A QUESTING PROFILE AND CHANGE PLANETS/INSTANCES, OR LOG IN TO ANOTHER CHARACTER, RESTART SWTOR AND THEN RESTART THE BOT (AS IN CLOSE/RE-RUN THE APP)***");        
        }

        public static void Inits()
        {
            if (!InitsComplete)
            {
                try
                {
                    Thread.Sleep(1000);

                    datLGC = DateTime.Now;
                    datLGC2 = DateTime.Now;

                    try
                    {
                        ProfilePath = Buddy.CommonBot.ProfileManager.CurrentProfile.Path.ToLower();
                    }
                    catch { }

                    if (RunCycle) { EnableObjMgrUpd = false; EnableGC = false; }

                    Thread.Sleep(1000);
                    SynchObjCacheAll();
                    Logger.Write("***************** PROCESS INFO ******************");
                    SetProcessAttrs();
                    SetHotKeys();
                    //LoadQuests();

                    Logger.Write("Star Wars Process ID Detected as: " + SWTORPID.ToString());

                    //if (DoRandomGrind || IG || Me.PvpFlagged) Buddy.CommonBot.CombatTargeting.Instance.Provider = null;
                    //else 
                        Buddy.CommonBot.CombatTargeting.Instance.Provider = MTP;
                    //Buddy.CommonBot.CombatTargeting.Instance.Provider = MTP;
                    GetProfessions();

                    CT = null;

                    Buddy.CommonBot.Settings.CharacterSettings.Instance.PullDistance = PullDist;
                    //Buddy.CommonBot.Settings.CharacterSettings.Instance.PullDistance = 2.90f;
                    //Buddy.CommonBot.Settings.GlobalSettings.Instance.PullRange = PullDist;
                    Buddy.CommonBot.Settings.GlobalSettings.Instance.PullRange = PullDist;

                    if (ScanForLoot || IG || Me.PvpFlagged) Buddy.CommonBot.Settings.CharacterSettings.Instance.LootNpcs = false;
                    if (ScanForNodes || IG || Me.PvpFlagged) Buddy.CommonBot.Settings.CharacterSettings.Instance.LootProfessionHarvestables = false;

                    Logger.Write("***************** CHAR MISC ******************");
                    Logger.Write("Pull Range set at " + GS.PullRange.ToString());

                    MySpec = SpecHandler.GetSpec(Me);
                    Logger.Write("Spec Detected as: " + MySpec.ToString());

                    LoadAbilities();
                    IssueInitsMessages();
                    CheckForGroup();
                    AmTank = IAmTank();
                    RehookLastMemSize = Process.GetCurrentProcess().PrivateMemorySize64;

                    //FindVendor(10);
                    //ForcePulse();
                }
                catch (Exception Exception) 
                {
                    Logger.Write("Error in Inits().  MessageText: " + Exception.Message);
                }
                InitsComplete = true;
                //LoadVars();
                //EnableGC = true;
                //EnableGC = (Me.GroupId!=0 || DoRandomGrind); // Messes up questing (ptrs/hdls out-of-synch w/de Brain), just TURN IT OFF if not doing random grind or in-group w/FPs or Ops
                //EnableObjMgrUpd = EnableGC;

            }
        }

        public static TorCharacter Comp
        {
            get
            {
                float HealthTest = 0;
                float DistTest = 0;

                DateTime CompCheckBeg = DateTime.Now;

                if (IG || IAmMounted() || BuddyTor.Me.PvpFlagged) { LastComp = null; CHP = 100; return null; }

                //UpdateGameEvents();

                for (int i = 0; i < 3; i++)
                {
                    //SynchObjCache(true, true);
                    UpdateObjects();
                    using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                    {
                        if (Me.Companion != null && UpdateCompInfo(Me.Companion)) { LastComp = Me.Companion; return LastComp; }
                        bool bErr = false;
                        if (LastComp != null)
                        {
                            if (LastComp.IsDeleted || LastComp == null) bErr = true;
                            else
                            {
                                try { HealthTest = LastComp.HealthPercent; DistTest = LastComp.Distance; if (DistTest > 4.0f)bErr = true; }
                                catch { bErr = true; }
                            }
                            if (!bErr && LastComp != null)
                            {
                                if (UpdateCompInfo(LastComp)) return LastComp;
                            }
                        }

                        LastComp = null;
                        try
                        {
                            var theList = ObjectManager.GetObjects<TorObject>().OrderBy(t => t.Distance)
                                .AsParallel().ToArray().Where(t => (t.IsKindOf(Buddy.Swtor.Enums.DomDefIds.npc_class) || t.IsKindOf(Buddy.Swtor.Enums.DomDefIds.character_class)) && ((TorCharacter)t).Toughness == CombatToughness.Companion);
                            if(theList!=null && theList.Count()>0) foreach (TorCharacter mob in theList.Where(d=>d.Distance<4.5f))
                            {
                                //Logger.Write("TorCharacter Name: " + mob.Name + " Toughness: " + mob.Toughness.ToString() + " Distance: " + mob.Distance.ToString());
                                //TorNpc compTest = null;
                                //if (mob != null) try
                                //    {
                                //        Logger.Write("Testing the goddamn mob...");
                                //        compTest = (TorNpc)mob;
                                //    }
                                //    catch { }
                                try
                                {
                                    Logger.Write("Got Comp via TorObject. Comp: " + mob.Name + " Toughness: " + mob.Toughness + " Distance: " + mob.Distance);
                                    if (mob != null && mob.Distance <= 3.5f)
                                    {
                                        try
                                        {
                                            LastComp = (TorCharacter)mob;
                                            UpdateCompInfo(LastComp);
                                            return LastComp;
                                        }
                                        catch (Exception ex) { Logger.Write("Error: " + ex.Message); }
                                    }
                                }
                                catch { }
                            }
                        }
                        catch
                        {
                            // fails on Comp death, CheckLootability errors, just query TorNpc and TorCharacter objs at that point
                        }
                        try
                        {
                            foreach (TorCharacter mob in ObjectManager.GetObjects<TorCharacter>().AsParallel().ToList().OrderBy(t => (float)t.Distance).Where(t => t.Toughness == CombatToughness.Companion))
                            {
                                //Logger.Write("TorCharacter Name: " + mob.Name + " Toughness: " + mob.Toughness.ToString() + " Distance: " + mob.Distance.ToString());
                                LastComp = mob; UpdateCompInfo(LastComp); break;
                            }
                        }
                        catch { }
                        if (LastComp != null) return LastComp;

                        try
                        {
                            foreach (TorNpc mob in ObjectManager.GetObjects<TorNpc>().AsParallel().ToList().OrderBy(t => (float)t.Distance).Where(t => t.Toughness == CombatToughness.Companion && t.Distance <= 3.0f))
                            {
                                LastComp = (TorCharacter)mob; UpdateCompInfo(LastComp); break;
                            }
                        }
                        catch { }

                        if (LastComp != null) return LastComp;
                    }
                    //Thread.Sleep(50);
                }
                return LastComp;
            }
        }

        //private static void OnBotStart(IBot bot)
        //{
        //    try { 
        //        datLFP = DateTime.Now;
        //        datLGC = DateTime.Now;
        //        Thread.Sleep(500);
        //    }
        //    catch { }
        //    InitsComplete = false;
        //    OOC();
        //}

        private static void OnBotStop(IBot bot)
        {
        }

        //public delegate BotEvent_OnBotShutdown BotEventHandler(object sender, BotEvent_OnBotShutdown e);

        private static void OnBotShutdown(IBot bot)
        {
        }


        private static void DisposeBot()
        {
            try
            {
                BotMain.CurrentBot.Dispose();
            }
            catch { }
        }

        private static void SynchObjCacheAll()
        {
            SynchObjCache(true, true, true, true, true, true);
        }

        private static void SynchObjCache(bool Npcs = false, bool Players = false, bool Abilities=false, bool Effects=false, bool Vendors=false, bool Placeables=false)
        {
            if (!EnableObjMgrUpd) return;
            // 'Force' the load of objects from memory into the cache (to make sure they're 'Current').
            // A generic query will load objects into the cache from memory... Seems to kill questing errors as well as 'missing buffs'.
            DateTime datStart = Now;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                try
                {
                    try { if (Placeables) foreach (TorObject tx in ObjectManager.GetObjects<TorObject>().AsParallel().ToList()) { var ty = tx; }; }
                    catch { }
                    if (Npcs || Vendors) foreach (TorCharacter tx in ObjectManager.GetObjects<TorCharacter>().AsParallel().ToList()) { var ty = tx; };
                    if (Placeables || Vendors) foreach (TorPlaceable tx in ObjectManager.GetObjects<TorPlaceable>().AsParallel().ToList()) { var ty = tx; };
                    try { if (Npcs || Vendors) foreach (TorNpc tx in ObjectManager.GetObjects<TorNpc>().AsParallel().ToList()) { var ty = tx; }; }
                    catch { }
                    if (Players) foreach (TorPlayer tx in ObjectManager.GetObjects<TorPlayer>().AsParallel().ToList()) { var ty = tx; };
                    if (Abilities) foreach (TorAbility tx in ObjectManager.GetObjects<TorAbility>().AsParallel().ToList()) { var ty = tx; };
                    if (Effects) foreach (TorEffect tx in ObjectManager.GetObjects<TorEffect>().AsParallel().ToList()) { var ty = tx; };
                    //ObjectManager.Update();
                }
                catch { }
            }
            //Logger.Write("Object Cache Synch: " + Now.Subtract(datStart).TotalMilliseconds.ToString("0"));
        }

        private static void ClearObjects()
        {
            try
            {
                ObjectManager.Cache.Clear();
                SynchObjCacheAll();
            }
            catch { }
        }
        private static void UpdateNodeManagerAndBrain()
        {
            try
            {
                Buddy.Swtor.NodeManager.Update();
                Buddy.CommonBot.Logic.BrainBehavior.CreateBrain();
            }
            catch { }
        }

        private static void UpdateRoutines()
        {
            try
            {
                Buddy.CommonBot.RoutineManager.Reload();
            //Buddy.CommonBot.BotMain.SetCurrentCombatRoutine();
            //Buddy.CommonBot.RoutineManager.Current.Initialize();
            //Buddy.CommonBot.RoutineManager.Routines.Clear();
            //JoesCombat.Instance.Initialize();
            }
            catch { }
        }

        private static void StopStartBot()
        {
            try
            {
                BotMain.CurrentBot.Stop();
                Thread.Sleep(2000);
                BotMain.CurrentBot.Start();
                Thread.Sleep(2000);
            }
            catch { }
        }

        private static void ReloadGOM()
        {
            if (!(IG))
            {
                try
                {
                    // This apparently runs ASynch
                    GOMLoaded = true;
                    Buddy.Swtor.Objects.Engine.Gom GOM = new Buddy.Swtor.Objects.Engine.Gom();
                    GOM.Client.Read();
                }
                catch { }
            }
        }

        private static void UpdateMovement()
        {
            try
            {
                Buddy.Swtor.Movement.Update();
                DefaultNP.Clear();
            }
            catch { }
        }

        private static void GCCollect()
        {
            try
            {
                System.GC.Collect();
                System.GC.GetTotalMemory(true);
            }
            catch { }
        }

        public static void ClearPOI()
        {
            try
            {
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    Buddy.CommonBot.Poi.Current = null; 
                    //Buddy.CommonBot.Poi.Clear("FightAtJoes:  Rehook/Reload.");
                }
            }
            catch { }
        }

        public static void UpdateGameEvents()
        {
            try
            {
                Buddy.CommonBot.GameEvents.Update();
            }
            catch { }
        }

        // SHITLOADS of Trial-and-Error on this, it's 'Constantly Evolving' depending on updates to the .exe for the week, and SWTOR.
        public static void DoRehook()
        {
            DateTime datRehookStart = DateTime.Now;

            System.GC.Collect();
            System.GC.GetTotalMemory(true);
            Thread.Sleep(1000);

            if (!GOMLoaded) { ReloadGOM(); Thread.Sleep(500); return; }

            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {

                try
                {
                    //return;
                    Rehooking = true;

                    //Thread.Sleep(2000);

                    datLGC = DateTime.Now;
                    GCCollect();

                    Logger.Write("***** Starting GC/Rehook *****");

                    if (MyBlacklist.Count() >= 200) MyBlacklist.Clear();

                    UpdateMovement();

                    ClearObjects();
                    ClearPOI();

                    //Thread.Sleep(3500);
                    if (IAmInCombat()) CombatGCTime += DiffInSeconds(datRehookStart,Now);
                    ClearAndReloadProfile();
                    UpdateNodeManagerAndBrain();
                    RehookLastMemSize = BotMemory();
                    Rehooking = false;
                    while (Rehooking) Thread.Sleep(1000);
                    Logger.Write(" ***** GC/Rehook Complete  *****");

                    //if (IG || DoRandomGrind) Buddy.CommonBot.Poi.Clear("JoesCombat:  DoRandomGrind/In-Group.");

                    //Me.Target();
                    //Thread.Sleep(1000);
                    //ClearTarget(); 

                    LoadVars();

                    GOMLoaded = false;

                    //ForcePulse();
                }
                catch { }
            }
            datLGC = DateTime.Now;
            datLGC2 = DateTime.Now;
            RehookLastMemSize = BotMemory();

            Logger.Write("Re-Hook/Reload Processed.  Total Rehook Time: " + (ReportDurs?"":DateTime.Now.Subtract(datRehookStart).TotalSeconds.ToString("0.0")+"s"));

        }

        private static long BotMemory()
        {
            return Process.GetCurrentProcess().PrivateMemorySize64;
        }

        private static void ClearAndReloadProfile()
        {
            if (IG) return;

            var CurProfile = Buddy.CommonBot.ProfileManager.CurrentProfile.Path;
            //if (!CurProfile.ToLower().Contains("combatbot")) 
            if (!IG && !DoRandomGrind) 
            {
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    try
                    {
                        Buddy.CommonBot.Poi.Current = null;
                        var qp = Buddy.CommonBot.Profile.Profile.Load(CurProfile);
                        ///ObjectManager.Cache.Clear();
                        //qb.Pulse();
                        //x.Questing.Clear();
                        var cqp = Buddy.CommonBot.ProfileManager.CurrentProfile;
                        if (IG || DoRandomGrind) cqp.Questing.Clear();
                        cqp.ForceAlignment.AutoSkip = true;
                        //cqp.ForceAlignment.Type = ConversationSkip.Light;
                        //Buddy.Swtor.OracleManager.SetConversationSkip(Buddy.Swtor.ConversationSkip.Light);
                        cqp.ForceAlignment.SetSettings();
                        SynchObjCacheAll();
                        //var qb = new Buddy.CommonBot.Logic.BuddyQuestBot();
                        //qb.Stop();
                        //qb.Start();
                    }
                    catch { }
                }
                Thread.Sleep(500);
            }
        }

        public static void ClearCacheAndPOI()
        {

            GC.Collect(); GC.GetTotalMemory(true); 
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            try
            {
                if (EnableObjMgrUpd)
                {
                    Logger.Write("Flushing Cache.");
                    ClearObjects();
                    //ObjectManager.Update();
                    //Buddy.CommonBot.GameEvents.Update();
                }
                //if (!IG && DoRandomGrind) Buddy.CommonBot.Poi.Clear("FightAtJoes:  Cache/POI Clear.");
                //if (!IG && DoRandomGrind) Buddy.CommonBot.Poi.Current = new Poi(Me.Position, PoiType.Hotspot);
                //ObjectManager.Update();
                //Thread.Sleep(1000);
                if (IG||DoRandomGrind) Buddy.CommonBot.Poi.Current = null;
            }
            catch { }
            if (!DoRandomGrind) ClearAndReloadProfile();
            datLGC2 = DateTime.Now;
        }

        private static void CheckObjCount()
        { 
            bool BadMojo = false;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                try 
                {
                    BadMojo = ObjectManager.Cache.Count()>(Int32)1000 || ObjectManager.Cache.Count() < (Int32)0 || BotMemory() > (long)200000000;
                } 
                catch {BadMojo=true;}
                
                if (BadMojo)
                {
                    while (true)
                    {
                        try
                        {
                            ObjectManager.Cache.Clear();
                            GC.Collect();
                            GC.GetTotalMemory(true);
                            SynchObjCacheAll();
                            var objAll = ObjectManager.GetObjects<TorObject>();
                            var objChar = ObjectManager.GetObjects<TorCharacter>();
                            Thread.Sleep(300); 
                            break;
                        }
                        catch { }
                    }
                }
            }
            if (BadMojo)
            {
                System.GC.Collect();
                System.GC.GetTotalMemory(true);
            }
        }

        private static void CheckGC()
        {
            Inits();
            if (CheckForFRDImmediate) return;
            if (!EnableGC || !EnableObjMgrUpd) return;

            CheckObjCount();
            if (!EnableGC)
            {
                if (DateTime.Now.Subtract(datLGC).TotalSeconds >= 119)
                {
                    DateTime datRehookStart = DateTime.Now;
                    ClearObjects();
                    ClearAndReloadProfile();
                    datLGC = DateTime.Now;
                }
            }
            //        // This is to 'let the bot get the 'HLL Fit out of its System' (quickly) if it's gone apeshit
            //        Process.GetCurrentProcess().PriorityClass = ProcessPriorityClass.RealTime;
                    
            //        SetTPS(true);
            //        ClearCacheAndPOI();
            //        SetTPS();
            //        Thread.Sleep(500);
            //        datLGC = DateTime.Now;
            //        datLGC2 = DateTime.Now;
            //        Process.GetCurrentProcess().PriorityClass = BotDefaultPriority;
            //        Logger.Write("Bot Memory: " + BotMemory().ToString("0,0"));
            //        if (IAmInCombat()) CombatGCTime += DateTime.Now.Subtract(datRehookStart).TotalSeconds;
            //    }
            //}
            //else
            //{
                if (DateTime.Now.Subtract(datLGC).TotalSeconds >= RehookFreq)
                    if (!IAmInCombat()) try
                    {
                        if (!IG) { DoRehook(); Thread.Sleep(1000); DoRehook(); }
                        Logger.Write("Bot Memory: " + RehookLastMemSize.ToString("0,0"));
                        //OOC(); 
                    }
                    catch { Thread.Sleep(4000); }
                if (EnableObjMgrUpd && EnableGC && DateTime.Now.Subtract(datLGC2).TotalSeconds >= 30)
                {
                    //if (!IG && !DoRandomGrind) ClearAndReloadProfile(); else ClearCacheAndPOI();
                    ClearCacheAndPOI();
                    datLGC2 = Now;
                }
            //}
        }

        // Obsolete
        //private static void MoveIfNec()
        //{
        //    MoveIfNec(2.8f);
        //}

        //private static void MoveIfNec(float dist)
        //{

        //    if (CT == null) return;
        //    if (CTT == CombatToughness.Player) return;

        //    MoveTo(CT, dist);

        //}

        public static bool IAmCasting()
        {
            bool ac = false;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                try { ac = Me.IsCasting; }
                catch { return false; }
            }
            return ac;
        }

        public static float UHP(TorCharacter theUnit)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (theUnit == null) return 100f;
                return theUnit.HealthPercent;
            }
        }

        public static bool IAmInConvo()
        {
            UpdateObjects();
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {   
                try { return Me.IsInConversation; }
                catch { return false; }
            }
        }

        public static Vector3 MyPosition()
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                return Me.Position;
            }
        }

        public static bool IAmInCombat()
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                try { UpdateObjects(); return Me.InCombat; }
                catch { return false; }
            }
        }

        public static bool IAmMounted()
        {
            UpdateObjects();
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                try { return Me.IsMounted || Me.HasBuff("Rocket Boost"); }
                catch { return false; }
            }
        }

        public static bool IAmStunned()
        {
            UpdateObjects();
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                try { return Me.IsStunned; }
                catch { return false; }
            }
        }

        public static bool CTInCombat()
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (CT == null) return false;
                try { return CT.InCombat; }
                catch { return false; }
            }
        }

        // Only returns true if casting and Object Manager Updates (EnableObjMgrUpd) is set to false.
        // Otherwise, waits for cast to complete, and returns.

        public static bool WaitForCast()
        {
            if (EnableObjMgrUpd && ObjectManager.Cache.Count() > 1000) ObjectManager.Cache.Clear();

            DateTime dStart = DateTime.Now;
            //Logging.Write("Waiting for Cast...");
            //Thread.Sleep(150);
            if (EnableObjMgrUpd) 
            {
                UpdateObjects(); 
            }
            else 
            {
                if (IAmCasting()) Thread.Sleep(150); 
                return IAmInCombat(); 
            }
            //Spell.WaitForCast();
            while (IAmCasting() && DateTime.Now.Subtract(dStart).TotalMilliseconds < 3500f)
            {
                Thread.Sleep(225);
                UpdateObjects();
            }
            if (ReportDurs) Logger.Write("Waiting for Cast Duration: " + DateTime.Now.Subtract(dStart).TotalMilliseconds.ToString("0"));
            //Logger.Write("Waiting for Cast Duration: " + DateTime.Now.Subtract(dStart).TotalMilliseconds.ToString());
            //Logging.Write("Done with Cast...");
            return false;
        }

        public static void StopMoving()
        {
            if (!MovementAllowed) return;

            //Thread.Sleep(50);
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                //Buddy.CommonBot.CommonBehaviors.MoveStop();
                //Buddy.CommonBot.CommonBehaviors.MoveStop();
                //Buddy.Swtor.Movement.Stop(MovementDirection.Forward);
                //Buddy.Swtor.Input.MoveStopAll();
                Buddy.CommonBot.CommonBehaviors.MoveStop();
                Thread.Sleep(50);
                Buddy.Swtor.Input.MoveStopAll();
                Thread.Sleep(50);
                Buddy.Swtor.Input.MoveStopAll();
                //Buddy.Swtor.Input.MoveStopAll();
            }
            //Thread.Sleep(50);
            //Buddy.CommonBot.CommonBehaviors.MoveStop();
        }

        private static void HandleBackpedal()
        {
            if (Backpedal && IsRanged && IAmInCombat() && CT != null && CT.Distance < MeleeDist)
            {
                MovementDirection mvDir = (BackPedalToggle ? MovementDirection.Forward : MovementDirection.Backward);

                Movement.Move(mvDir, TimeSpan.FromMilliseconds(400));
                //Movement.Move(MovementDirection.Backward, TimeSpan.FromMilliseconds(200)); 
                StopMoving();
                StopMoving();
                BackPedalToggle = !BackPedalToggle;
            }
        }

        private static Vector3 CloneUnitPos(TorCharacter theUnit)
        {
            try
            {
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    if (theUnit == null) return new Vector3(0f, 0f, 0f);
                    return new Vector3(theUnit.Position.X, theUnit.Position.Y, theUnit.Position.Z);
                    //return theUnit.Position;
                }
            }
            catch { return new Vector3(0f, 0f, 0f); }
        }

        private static bool PosInLOS(Vector3 thePos)
        {
            if (thePos == null) return false;
            return Buddy.Swtor.BuddyTor.IsInLineOfSight(Me.Position, thePos);
        }

        private static float PosDist(Vector3 thePos)
        {   if (thePos==null) return 0f;

            return thePos.Distance(Me.Position);
        }

        private static void MoveForward(int DurMS)
        {
            if (!MovementAllowed) return;

            //UpdateObjects();
            Input.Move(MovementDirection.Forward,true);
            Movement.Move(MovementDirection.Forward, TimeSpan.FromMilliseconds(DurMS / 2));
            //Input.Move(MovementDirection.Forward, true);
            //Movement.Move(MovementDirection.Forward, TimeSpan.FromMilliseconds(DurMS / 2));
            Thread.Sleep(50);
            Buddy.Swtor.Movement.Stop(MovementDirection.Forward);
            //if (EnableObjMgrUpd) UpdateObjects();
            Input.MoveStopAll();
        }

        public static bool UnitInLOSAndWithinDist(TorCharacter theUnit, float theDist)
        {
            UpdateObjects();
            try
            {
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    return theUnit.InLineOfSight && theUnit.Distance <= theDist;
                }
            }
            catch { }
            return false;
        }

        private static bool UnitInMyBlacklist(TorNpc theUnit)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (MyBlacklist.Count() < 1 || theUnit == null || theUnit.Guid == 0 || theUnit.Guid == null) return false;
                if (MyBlacklist.ContainsKey(theUnit.Guid)) return true;
            }
            return false;

        }

        public static MoveResult MoveToUnit(TorCharacter theUnit)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                return Buddy.Navigation.Navigator.MoveTo(theUnit.Position);
            } 
        }
        public static MoveResult MoveToPlaceable(TorPlaceable thePlc)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                return Buddy.Navigation.Navigator.MoveTo(thePlc.Position);
            }
        }
        public static MoveResult MoveToPosition(Vector3 thePosition)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                return Buddy.Navigation.Navigator.MoveTo(thePosition);
            }
        }
        // Recoded to copy and use the (cloned) position of the unit as I noticed most hangs (HLL Error Apeshit Syndrome) started on MoveTo - Guessing it was/is due to the unit's ptr/hdl getting realloc'ed in the middle of the MoveTo.
        // SO, copy the position up-front, and use that.  (I'm guessing the same issue WILL NOT APPLY to nodes/placeables, but of course next week I'm sure that will change)
        public static void MoveTo(TorCharacter theUnit, float dist, string Cast1 = "", string Cast2 = "", string Cast3 = "", string Cast4 = "")
        {
            try
            {
                if (!MovementAllowed) return;

                if (theUnit == null) theUnit = CT;
                if (theUnit == null || dist <= 0) return;
                if (UnitInLOSAndWithinDist(theUnit, dist)) return;

                Vector3 Loc = CloneUnitPos(theUnit);
                HandleBackpedal();

                //using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                //{
                //    theUnit.Face();
                //    Movement.Move(MovementDirection.Forward, TimeSpan.FromMilliseconds(100));
                //}

                try
                {

                    //StopMoving();           // To (try and) prevent 'The Chicken Dance'
                    datLCL = DateTime.Now;

                    // Sometimes the bot keeps 'running off in the weeds', Face() to try and avoid that

                    //if (!UnitInLOSAndWithinDist(theUnit, dist))
                    {
                        StopMoving();
                        Logger.Write("MoveTo: " + theUnit.Name + " Moving to within " + dist.ToString("0.0") + " from dist of " + theUnit.Distance.ToString("0.0") + " current LOS: " + theUnit.InLineOfSight.ToString());
                        Thread.Sleep(150);
                        //if (MovementAllowed) { Input.MoveStopAll(); Thread.Sleep(50); Input.MoveStopAll(); Thread.Sleep(50); }
                        MoveResult MR = MoveResult.Moved;
                        UpdateObjects();
                        //Navigator.MoveTo(CloneUnitPos(theUnit));
                        while ((!IAmDead() && MR != MoveResult.Failed && MR != MoveResult.PathGenerationFailed) && DiffInSeconds(datLCL, Now) <= 15f && !UnitInLOSAndWithinDist(theUnit, dist))
                        {
                            //if (Me.IsDead || Me.HealthPercent < .05f) { MR = MoveResult.Failed; break; }
                            if (theUnit.InLineOfSight)
                            {
                                if (Cast1 != "") MercCast(Cast1, theUnit);
                                if (Cast2 != "") MercCast(Cast2, theUnit);
                                if (Cast3 != "") MercCast(Cast3, theUnit);
                                if (Cast4 != "") MercCast(Cast4, theUnit);
                            }
                            //if (PosDist(Loc) > dist || !PosInLOS(Loc))
                            if (!UnitInLOSAndWithinDist(theUnit, dist))
                            {
                                MoveToUnit(theUnit);
                                Thread.Sleep(150);
                            }
                            SynchObjCache(true, true);
                            UpdateObjects();
                            Loc = CloneUnitPos(theUnit);
                        }
                        //if (MR == MoveResult.Failed && MR == MoveResult.PathGenerationFailed) Logger.Write("Move Result: " + MR.ToString());
                        //Input.MoveStopAll(); Thread.Sleep(50); Input.MoveStopAll(); Thread.Sleep(50); 
                        if (DiffInSeconds(datLCL, Now) > 15f) 
                        { 
                            MyBlacklist.Add(theUnit.Guid, Now); 
                            Logger.Write("Couldn't reach target in 15s... Adding target to MyBlacklist (GUID " + theUnit.Guid.ToString() + ")"); 
                        }
                        StopMoving();
                        StopMoving();
                        SynchObjCache(true, true);
                        //StopMoving();
                        try { TD = (float)theUnit.Distance; }
                        catch { }
                    }
                }
                catch { }
            }
            catch { }
        }

        private static void MoveTo(Vector3 theLoc, float dist)
        {
            try
            {
                if (!MovementAllowed) return;

                Vector3 Loc = theLoc;
                HandleBackpedal();

                datLCL = DateTime.Now;

                if (Loc.Distance(Me.Position) > dist || !PosInLOS(Loc))
                {
                    MoveResult MR = MoveResult.Moved;
                    StopMoving();
                    while ((!Me.IsDead && UHP(Me) > .1f && MR != MoveResult.Failed && MR != MoveResult.PathGenerationFailed) && DateTime.Now.Subtract(datLCL).TotalSeconds <= 15 && (PosDist(Loc) > dist || !PosInLOS(Loc)))
                    {
                        if (PosDist(Loc) > dist || !PosInLOS(Loc))
                        {
                            MR = Buddy.Navigation.Navigator.MoveTo(Loc, null, true);
                            //Thread.Sleep(125);
                        }
                    }
                    if (MR == MoveResult.Failed && MR == MoveResult.PathGenerationFailed) Logger.Write("Move Result: " + MR.ToString());
                    StopMoving();
                    StopMoving();

                }
            }
            catch { }
        }

        // Doesn't work - ONLY A PLAYER can only use abilities - tried casting a TorCharacter as a Player - but doesn't work
        //private static void SickCompOnTarget()
        //{
        //    if (LastComp==null) return;
        //    try
        //    {
        //        if (LastComp == null) return;
        //        TorNpc CompX = LastComp;
        //        if (CT!=null && !CT.InCombat && !IG && !Me.IsMounted && CompX != null && taCompAttack != null)
        //        {
        //            Logger.Write("Sicking Companion on Target for Pull...");
        //            //EffectResult er;
        //            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
        //            {
        //                ((TorPlayer)CompX).AbilityActivate(taCompAttack, CT, out er);
        //                //BuddyTor.Me.AbilityActivate(taCompAttack, CT, out er);
        //            }
        //            //if (er == EffectResult.Ok)
        //            //    Thread.Sleep(4000);
        //            //else 
        //            //    Logger.Write("Error on CompAttack.");                    }
        //        }
        //    }
        //    catch { Logger.Write("Error in SickCompOnTarget."); }
        //}

        private static bool MeOrCompInCombat()
        {
            try
            {
                var CompX = Comp;
                if (IAmInCombat()) return true;
                if (CompX != null) if (CompX.InCombat) return true;
            }
            catch { }
            return false;
        }

        // For use mainly in groups, trying to determine if the current target's target is a player, and it IS in combat. USED EVERYWHERE IN COMBAT.
        public static bool IGAndTargetNotInCombat()
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                try
                {
                    if ((CT == null || CT.IsDead) && MyTarget() != null && !MyTarget().IsDead) CT = MyTarget();
                    if (CT == null || CT.IsDead || CT.HealthPercent < .05f || IsPlayer(CT) || IsComp(CT) || (IG && !CT.InCombat) || (IG && CT.IsStunned)) { CT = null; ClearTarget(); return true; }
                }
                catch (Exception ex) { CT = null; Logger.Write("Error testing target. Exception Text: " + ex.Message); return true; }
            }
            return false;
        }

        public static void UseMedPackInInventory()
        {
            if (DateTime.Now.Subtract(datLMPU).TotalSeconds < 120) return;
            datLMPU = DateTime.Now;  // One scan every 2 minutes
            foreach (TorItem o in Me.InventoryEquipment)
            {
                if (o.Name.Contains("Medpac") && o.MinimumLevel<=MyLevel && !o.Name.Contains("Warzone"))
                { Logger.Write("Using Medpac " + o.Name + "..."); o.Use(); o.Interact(); o.Interact(); Thread.Sleep(500); return; }
            }
        }

        public static bool UnitHasBuff(TorCharacter theUnit, string strBuff)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                return theUnit.Buffs.Where(t=>t.Name.Contains(strBuff)).Count()>0;
            }
        }

        public static bool HasBuffStacks(TorCharacter theUnit, string strBuff, int intCount)
        {
            bool RtnVal = false;

            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            try
            {
                foreach (TorEffect t in theUnit.Buffs) // Trying to do this in a .Where clause WILL NOT work w/the same conditions, don't ask me why
                {
                    //ShowEffectInfo(t);
                    try
                    {
                        if (t != null && (t.Caster == null || (t.Caster != null && t.Caster.Guid == Me.Guid)) && t.Name.Contains(strBuff) && t.Stacks >= intCount)
                            return true;
                    }
                    catch { }
                }
            }
            catch { }
            return RtnVal;
        }
        public static void ShowEffectInfo(TorEffect te)
        {  
            if (te!=null && !te.IsDeleted) Logger.Write("Name: " + te.Name + "DurS: " + te.Duration.Seconds.ToString() + " Stacks: " + te.Stacks.ToString()); 
        }

        public static bool HaveAbilAndNotBuff(string theAbilBuff)
        {
            try
            {
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    return MyAbilities.Contains(theAbilBuff) && !HaveBuff(theAbilBuff);
                }
            }
            catch { return false; }
        }

        public static bool HasBuff(string strBuff, TorCharacter theChar)
        {
            bool RtnVal = false;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                try
                {
                    return theChar.HasBuff(strBuff);
                }
                catch { }
            return RtnVal;
        }
        public static bool HaveBuffStacks(string strBuff, int intCount)
        {
            bool RtnVal = false;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                try
                {
                    foreach (TorEffect t in Me.Buffs)
                        {
                            //ShowEffectInfo(t);
                            try
                            {
                                if (t != null && !t.IsDeleted &&
                                    (t.Caster == null || (t.Caster != null && t.Caster.Guid == Me.Guid)) && t.Name.Contains(strBuff) && t.Stacks >= intCount)
                                    return true;
                            }
                            catch { }
                        }
                    //var tb = Me.GetBuff(strBuff);
                    //if (BuddyTor.Me.HasBuff(strBuff) && (tb.Caster == null || tb.Caster.Guid == MyGUID) && tb.Stacks >= intCount) RtnVal = true; // .Caster == Me DOES NOT WORK, using a sep obj inst?  Not sure here
                }
                catch { }
            return RtnVal;
        }

        public static int GetBuffStacks(string strBuff, TorCharacter theUnit = null)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                TorCharacter theUnitX = (theUnit == null ? Me : theUnit);
                //foreach (TorEffect tb in theUnitX.Buffs) if (!tb.IsDeleted && tb.Name == strBuff && (tb.Caster.Guid==MyGUID || tb.Caster==null)) return tb.Stacks;
                foreach (TorEffect tb in theUnitX.Buffs) 
                    try 
                    { 
                        if (tb.Name == strBuff && (tb.Caster.Guid == MyGUID || tb.Caster == null)) return tb.Stacks; 
                    }
                    catch { }
                //if (theUnitX.HasBuff(strBuff))return theUnitX.GetBuff(strBuff).Stacks;
            }
            return 0;
        }

        public static bool HasDebuffStacks(string strDebuff, int intCount)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                try { var tb = CT.GetDebuff(strDebuff); if (tb!=null && (tb.Caster == null || tb.Caster.Guid==MyGUID) && tb.Stacks >= intCount) return true;  }
                catch { }
                return false;
            }
        }

        public static bool IsDead(TorCharacter theUnit)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (theUnit == null) return false;
                return theUnit.IsDead || theUnit.HealthPercent < .05f;
            }
        }

        public static bool TryAbility(TorAbility ta, float waitTimeInSecs=0)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (ta == null || !ta.IsValid) return false;
            }

            DateTime datStart=Now;
            while (waitTimeInSecs>0 && Me.IsAbilityReady(ta,Me)!=EffectResult.Ok) Thread.Sleep(2000);
            if (ta != null && Me.IsAbilityReady(ta, Me)==EffectResult.Ok) try
                {
                Me.AbilityActivate(ta, Me, out er);
                    if (er == EffectResult.Ok)
                    {
                        Logger.Write("Ability " + ta.Name + " successfully activated.");
                        Thread.Sleep(8000);
                        //WaitForCast();
                        if (ta.Name=="Field Revive") while (!SafeMove())Thread.Sleep(2000);
                        return true;
                    }
                }
                catch { }
            return false;
        }

        public static bool IAmDead()
        {
            bool AmDead = false;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (BuddyTor.Me.IsDead || BuddyTor.Me.HealthPercent < .05f) AmDead = true;
                //if (AmDead) foreach (TorObject ta in Me.DeathScreenAbilityList) Logger.Write("Available DeathScreenAbility Name: " + ta.Name);
            }

            if (AmDead)
                if (IG || DisableAutoRez)
                {
                    Logger.Write("Death detected and In-Group (or DisableAutoRez set) - waiting for manual rez...");
                    while (IsDead(Me)) Thread.Sleep(3000);
                    //while (!taMedProbe.IsValid) Thread.Sleep(2000);
                    //Me.AbilityActivate(taMedProbe, Me, out er);
                }
                else
                {
                    //foreach (Buddy.Swtor.Objects.Internals.DeathScreenAbility ta in Me.DeathScreenAbilityList) Logger.Write("DSA Name: " + ta.Name);

                    Logger.Write("Death detected.  Waiting for Rez to be Available...");
                    Thread.Sleep(5000);
                    while (!taMedCenter.IsValid) Thread.Sleep(1000);
                    ClearTarget();
                    Thread.Sleep(400);
                    ClearTarget();

                   // if (TryAbility(taFieldRevive, MedProbeMaxWait) || TryAbility(taAcceptRevive) || TryAbility(taMedCenter)) Thread.Sleep(5000);
                        //bool Revived = false;
                    if (TryAbility(taFieldRevive, MedProbeMaxWait) || TryAbility(taAcceptRevive) || TryAbility(taMedCenter))
                    {
                        //Revived = true;
                        CT = null;
                        StopMoving();
                        Thread.Sleep(2000);
                        ClearTarget();
                        ClearObjects();
                        DoRehook();
                        //Thread.Sleep(2000);
                        //Buddy.CommonBot.Poi.Clear("FightAtJoes:  Death, POI Clear.");
                        ////if (!IG && DoRandomGrind) Buddy.CommonBot.Poi.Current = new Poi(Me.Position, PoiType.Hotspot);
                        //Thread.Sleep(2000);
                        ////ClearCacheAndPOI();
                        //Thread.Sleep(2000);
                        MyRestAndBuffs();
                    }
                    if (EnableVendor)
                    {
                        foreach (TorVendor d in ObjectManager.GetObjects<TorVendor>()) { UseVendor(d); return true; }
                        foreach (TorNpc d in ObjectManager.GetObjects<TorCharacter>().Where(d => d.Distance <= 1.0f && d.Name.Contains("Droid"))) { UseVendor(d); return true; }
                    }
                    //Buddy.CommonBot.RoutineManager.Reload();
                    //if (taQT != null && taQT.IsValid) { Me.AbilityActivate(taQT, LastCombatPt, out er); Thread.Sleep(7000); }
                    return true;
                }
            return false;
        }

        public static PrioritySelector SelfBuff(string theSpell, bool Req)
        {
            return new PrioritySelector(Spell.Cast(theSpell, ch=>BuddyTor.Me, ret => !BuddyTor.Me.HasBuff(theSpell) && Req));
        }

        //public static PrioritySelector MercenaryCombatPS()
        //{
        //    return new PrioritySelector(
        //        new Action( ret=> {LoadVars();return RunStatus.Failure;}),
        //        Spell.WaitForCast(),
        //        new Action(ret=>{if(CT!=null){ StopMoving(); MoveTo(CT, 2.8f);} return RunStatus.Failure;}),

        //        SelfBuff("Combustible Gas Cylinder", MySpec==SkillTreeId.MercenaryFirebug),
        //        new Action(ret=>{
        //            if (!CT.InCombat)
        //            {
        //                if (MercCast("Fusion Missile")) Thread.Sleep(400);
        //                if (MercCastOnGround("Death from Above", TD >= .6f, CT,false)) Thread.Sleep(400);
        //                if (MercCast("Explosive Dart")) Thread.Sleep(400);
        //                //if (MercCast("Concussion Missile", !CT.InCombat)) Thread.Sleep(400);
        //                if (MercCastOnGround("Sweeping Blasters", true, CT, false)) ;
        //                if (MercCast("Concussion Missile", MobsInRangeOf(CT, 2.0f) >= 3)) Thread.Sleep(400);
        //            }
        //            return RunStatus.Failure;}),
        //            Spell.Cast("Thermal Detonator", ret=>true),
        //            Spell.Cast("Heatseeker Missiles", ret=>true),
        //            Spell.Cast("Incendiary Missile",ret=>!CTHasDebuff("Burning")),
        //            Spell.Cast("Rapid Shots", ret=>true));
        //}

        public static bool MercenaryCombat()
        {
            datLCL = DateTime.Now;

            while (AllowCombat && !PauseBot)
            {
                LoadVars();

                while (true)
                {

                    if (MercCast("Determination", IAmStunned())) break;
                    if (IAmStunned()) { Thread.Sleep(500); break; }

                    if (MercBuffSelf("Combat Support Cylinder", MySpec == SkillTreeId.MercenaryBodyguard)) ChainCastWait();
                    if (MercBuffSelf("Combustible Gas Cylinder", MySpec == SkillTreeId.MercenaryFirebug)) ChainCastWait();
                    if (MercBuffSelf("High Velocity Gas Cylinder", MySpec == SkillTreeId.MercenaryArsenal)) ChainCastWait();

                    if (MercCast("Vent Heat", RS <= 25f)) ChainCastWait();
                    if (MercBuffSelf("Kolto Shell")) ChainCastWait();
                    if (MercCast("Power Surge", !AmHealer() && EliteOrGreater(CT))) ChainCastWait();
                    if (MercCast("Supercharged Gas", !HaveBuff("Supercharged Gas"))) ChainCastWait();
                    if (MercCast("Thermal Sensor Override", !AmHealer() && RS <= 30f)) ChainCastWait();

                    if (MercCast("Hunter's Boon", !HaveBuff("Hunter's Boon"))) ChainCastWait();

                    if (HP <= 70f)
                    {
                        if (MercCast("Chaff Flare", HP <= 50f)) break;
                        if (MercCast("Energy Shield", HP <= 60f)) break;
                        if (MercCastOnGround("Kolto Missile", HP < 70f, Me)) break;
                        if (MercCast("Emergency Scan", HP <= 70f)) break;
                        if (MercCast("Rapid Scan", HP <= 70f)) break;
                    }

                    if (IG && RunHeals(AmHealer()?80f:50f)) break;
                    if (RS <= 65f) { MercForcedCast("Rapid Shots", CT); ChainCastWait(); break; }

                    if (IGAndTargetNotInCombat()) return false; //else if (CT != MyTarget()) TargetUnit(CT);

                    MoveTo(CT, 2.8f);

                    if (!CTInCombat())
                    {
                        if (MercCast("Fusion Missile")) ChainCastWait();
                        if (MercCastOnGround("Death from Above", TD >= .6f, CT)) ChainCastWait();
                        if (MercCast("Explosive Dart")) ChainCastWait();
                        //if (MercCast("Concussion Missile", !CT.InCombat)) Thread.Sleep(400);
                        if (MercCastOnGround("Sweeping Blasters", true, CT)) break;
                        if (MercCast("Concussion Missile", MobsInRangeOf(CT, 2.0f) >= 3)) Thread.Sleep(900);
                        //break;
                    }

                    //MoveTo(CT, EliteOrGreater(CT)?1.0f:2.8f);
                    //if (CT.Name.Contains("Commander Zaoron")) MoveTo(CT, .50f);

                    if (TC && SoG)
                    {
                        if (MercCast("Disabling Shot")) break;
                        if (MercCast("Electro Dart")) break;
                        //if (MercCast("Neural Dart")) break;
                        if (MercCast("Electro Net")) break;
                        if (MercCast("Concussion Missile")) break;
                    }

                    //if ((!IG && RS <= 35) || (IG && RS <= 70f && AmHealer())) { MercCast("Rapid Shots"); break; }

                    if (!IG && MercCheckCompHealth(AmHealer()?80f:50f)) break;

                    if (MercCast("Jet Boost", TD<=1.1f)) break;

                    if (MercFaceAndCast("Flame Burst", MovementAllowed && TD <= 1.0f && RS >= 65f)) break;
                    if (TD <= .50f)
                    {
                        if (MercCast("Rocket Punch")) break;
                        if (MercCast("Shoulder Slam")) break;
                        if (MercCast("Electro Dart")) break;
                        if (MercFaceAndCast("Flame Thrower", MovementAllowed && TD > .01f && TD <= .60f)) break; // Trying to avoid mobs while running w/this and movment disabled = DEATH
                    }

                    if (MercCast("Heatseeker Missiles", SoG && CTHasDebuff("Heat Signature"))) break;
                    if (MercCast("Thermal Detonator")) break;
                    if (MercCastOnGround("Death from Above", (SoG || MobsInRangeOf(CT, .6f) >= 3) && TD >= .6f && RS >= 70f, CT)) break;
                    if (MercCastOnGround("Sweeping Blasters", RS >= 70f && TD >= .6f && (MobsInRangeOf(CT, .6f) >= 3), CT)) break;

                    if (MercCastOnTimer("Tracer Missile", 30f, SoG && ((!AbilsContain("Tracer Lock") && !CTHasDebuff("Heat Signature")) || (AbilsContain("Tracer Lock") && !HaveBuffStacks("Tracer Lock", 4))))) break;
                    if (MercCastOnTimer("Incendiary Missile", 18f)) break;
                    if (MercCast("Rail Shot")) break;
                    if (MercCast("Unload")) break;
                    if (MercCast("Explosive Dart", SoG || MobsInRangeOf(CT, .80f) >= 3)) break;
                    if (MercCast("Fusion Missile", SoG)) break;
                    if (MercCast("Power Shot", HaveBuff("Power Surge"))) break;

                    //if (Attackers.Count() >= 2 && RS >= 50f) ApplyMassDebuff("Incendiary Missile", "Burning (Tech)");

                    if (MercCastOnGround("Sweeping Blasters", RS >= 65f, CT)) break;
                    if (MercCast("Rapid Shots")) ChainCastWait();
                    //MercForcedCast("Rapid Shots", CT);

                    //Thread.Sleep(150);
                    break;
                }
                Thread.Sleep(150);
                if (WaitForCast()) return IAmInCombat();
                if (!IAmInCombat()) break;
            }
            return IAmInCombat();
        }

        public static DateTime LastOS = Now;

        public static bool PowertechCombat()
        {
            while (AllowCombat && !PauseBot)
            {
                LoadVars();
                while (true)
                {
                    //Thread.Sleep(200);
                    datLCL = DateTime.Now;

                    if (IGAndTargetNotInCombat()) return false;

                    //if (MercCast("Combustible Gas Cylinder", !HaveBuff("Combustible Gas Cylinder") && HP >= 95f)) break;
                    if (MercBuffSelf("Ion Gas Cylinder", MySpec==SkillTreeId.PowertechShieldTech)) break;
                    if (MercBuffSelf("High Energy Gas Cylinder", MySpec == SkillTreeId.PowertechAdvanced)) break;
                    if (MercBuffSelf("Combustible Gas Cylinder", MySpec == SkillTreeId.PowertechFirebug)) break;
                    if (MercBuffSelf("Hunter's Boon")) break;

                    if (MercCast("Vent Heat", Me, RS <= 20f)) break;
                    if (MercCast("Thermal Sensor Override", RS <= 30f)) break;

                    if (HP < 70f)
                    {
                        if (HP <= 30f) UseMedPackInInventory();
                        if (MercCast("Kolto Overload", HP <= 50f)) break;
                        if (MercCast("Energy Shield", HP <= 60f)) break;
                        if (MercCast("Unity", !IG && HP <= 50f && Comp!=null && !Comp.IsDead)) break;
                        //\if (MercCast("Heroic Moment: On the Trail", HP <= 50f)) break;
                    }

                    MoveTo(CT, 2.9f, "Explosive Dart", "Missile Blast", "Rapid Shots");
                    StopMoving();

                    if (TC && SoG)
                    {
                        if (MercCast("Grapple", !IG || AmTank)) break;
                        if (MercCast("Neural Dart", !IG || AmTank)) break;
                        if (MercCast("Quell")) break;
                        if (MercCast("Electro Dart")) break;
                        if (MercCast("Jet Charge", MovementAllowed)) break;
                        if (MercCast("Rocket Punch", TD <= MeleeDist)) break;
                        //if (MercCast("Disabling Shot")) break;
                        if (MercCast("Carbonize", TD<=.50f)) break;
                    }

                    if (!IG || AmTank)
                    {
                        if (MercCast("Neural Dart")) break;
                        if (MercCast("Sonic Missile")) break;
                    }

                    if (MercCast("Determination", IAmStunned())) break;

                    //if (MercCast("Oil Slick", CT, TWR10 >= 3)) break; // Buggy spell, won't cast, and keeps trying after that till we're dead

                    if (!CT.InCombat)
                    {
                        if (MercCast("Explosive Dart")) Thread.Sleep(800);
                        if (MercCastOnGround("Death from Above", TD >= .55f, CT)) Thread.Sleep(800);
                        if (MercCast("Grapple", !IG  || AmTank)) Thread.Sleep(800);
                    }

                    if (MercCast("Power Surge")) break;
                    CheckCompGuard();

                    if (RS < 50f) { if (MercCast("Vent Heat")) break; MercCast("Rapid Shots"); break; }

                    if (MercCastOnGround("Death from Above", TD >= .60f && (MobsInRangeOf(CT, 1.0f) >= 3 || SoG) && RS >= 55f, CT)) break;
                    if (MercCast("Heat Blast", HaveBuffStacks("Heat Screen", 3))) break;
                    if (MercCast("Shoulder Cannon", SoG)) break;
                    if (MercCast("Rail Shot")) break;
                    if (MercCast("Explosive Fuel", SoG)) break;
                    if (MercCast("Explosive Dart")) break;
                    if (MercCast("Incendiary Missile", !CTHasDebuff("Burning (Tech)"))) break;
                    if (MercCastNew("Unload")) break;
                    if (MercCast("Fusion Missile", SoG)) break;
                    if (MercCastOnGround("Sweeping Blasters", MobsInRangeOf(CT, .80f) >= 5, CT)) break;

                    if (TD <= 1.0f)
                    {
                        if (MercCast("Thermal Detonator", SoG)) break;
                        if (MercCast("Immolate", SoG)) break;
                        if (MercCast("Oil Slick", CT, DiffInSeconds(LastOS, Now) >= 30f && (SoG || TWR10 >= 3))) { LastOS = DateTime.Now; break; }
                        if (MercCast("Heat Blast", SoG)) break;
                        if (MercCast("Shoulder Cannon", SoG)) break;
                        if (MercCast("Retractable Blade", TD <= .5f && !CTHasDebuff("Bleeding"))) break;
                        if (MercFaceAndCast("Flame Thrower", true)) break;
                        if (MercCast("Immobilize")) break;
                        if (MercCast("Jet Boost", TD <= .5f)) break;
                        if (MercCast("Shoulder Slam", TD <= .5f)) break;
                        if (MercCast("Rocket Punch", TD <= .5f)) break;
                        if (MercCast("Flame Burst", TD <= .5f && RS>=50)) break;
                        //if (MercCast("Electro Dart", TD <= .8f)) break;
                    }
                
                    if (MercCast("Flame Sweep", TWR5 >= 4)) break;
                    if (MercCast("Power Shot", HaveBuff("Power Surge"))) break;

                    if (Comp != null) if (MercCast("Chaff Flare", HP <= 70f)) break;
                    if (MercCast("Supercharged Gas", !HaveBuff("Supercharged Gas"))) break;

                    if (MercCast("Rapid Shots", HP < 70 && RS >= 30)) break;

                    if (MercCast("Missile Blast", (TD <= .8f && !SoG) || RS >= 50f)) break;
                    if (CTT == CombatToughness.Player) MercCastOnGround("Sweeping Blasters", TD >= .1f && RS >= 35 && (TWR30 > 2 || SoG), CT);
                    if (MercCastOnGround("Sweeping Blasters", TD >= .1f && RS >= 35 && (TWR30 > 2 || SoG), CT)) break;
                
                    if (MercCast("Rapid Shots")) break;

                    Thread.Sleep(150);
                    break;

                }
                if (WaitForCast()) return IAmInCombat();
                if (!IAmInCombat()) break;
            }

            return false;
        }


        public static bool CommandoCombat()
        {
            while (AllowCombat && !PauseBot)
            {
                while (true)
                {
                    LoadVars();

                    datLCL = DateTime.Now;

                    //Thread.Sleep(100);
                    if (MercCast("Tenacity", IAmStunned())) return true;

                    HandleDebuffs();

                    MercBuffSelf("Combat Support Cell", MySpec == SkillTreeId.CommandoCombatMedic);
                    MercBuffSelf("Armor Piercing Cell", MySpec == SkillTreeId.CommandoGunnery);
                    MercBuffSelf("Plasma Cell", MySpec == SkillTreeId.CommandoAssaultSpecialist);

                    if (MercCast("Recharge Cells", RS <= 25f)) break;;
                    if (MercCast("Supercharge Cells", SoG || HP <= 50f || EP <= 25f)) break;;

                    if (HP <= 30f) UseMedPackInInventory();
                    if (HP <= 70f)
                    {
                        MercBuffSelf("Trauma Probe", true);
                        MercCastOnGround("Kolto Bomb", HP <= 70f, Me);
                        MercCast("Reactive Shield", HP <= 50f);
                        MercCast("Adrenaline Rush", Me, HP < 50f);
                        MercCast("Hold the Line", Me, HP < 50f);
                        MercCast("Diversion", HP < 60f);
                        MercCast("Bacta Infusion", Me, HP < 70f);
                        MercCast("Advanced Medical Probe", Me, HP < 70f);
                        MercCast("Medical Probe", Me, HP < 60f);
                        Thread.Sleep(300);
                        if (WaitForCast()) return true;
                    }

                    if (AmHealer() && IG)
                    {
                        RunHeals(Is55H ? 85f : 75f);
                        if (RS <= ((IG && Is55H) ? 95f : 50f)) return MercCast("Hammer Shot");
                        //return false;
                    }

                    if (IGAndTargetNotInCombat()) return false;

                    MoveTo(CT, 2.8f);
                    StopMoving();

                    if (TC && !IG && SoG)
                    {
                        if (MercCast("Cryo Grenade")) break;;
                        if (MercCast("Disabling Shot")) break;;
                        if (MercCast("Electro Net")) break;;
                        if (MercCast("Tech Override")) break;;
                        if (MercCast("Concussive Round", HaveBuff("Tech Override"))) break;;
                    }

                    if (!CT.InCombat)
                    {
                        if (MercCastOnGround("Mortar Volley", true, CT)) Thread.Sleep(500);
                        if (MercCastOnGround("Hail of Bolts", true, CT)) Thread.Sleep(500);
                        if (MercCast("Incendiary Round")) break;;
                        if (MercCast("Sticky Grenade")) break;;
                    }

                    //if (MercCast("Hammer Shot", CT, HP < 70f)) Thread.Sleep(1000); ;

                    if (CMCheckCompHealth()) { Thread.Sleep(500); if (MercCast("Hammer Shot")) break;; }

                    if (AmHealer()) if (IG && RS <= 50f) { MercCast("Hammer Shot"); break;; }

                    if (!IG || !AmHealer() || (IG && RS > 50f))
                    {
                        if (MercCast("Concussion Charge", TD <= MeleeDist)) break;;
                        if (MercCast("Blitz", TD <= MeleeDist)) break;;
                        if (MercCast("Stockstrike", TD <= MeleeDist)) break;;
                        if (MercFaceAndCast("Pulse Cannon", TD <= 1.0f)) break;;

                        if (MercCastOnGround("Mortar Volley", RS >= 50f && TD >= .6f && (SoG || MobsInRangeOf(CT, .60f) >= 3), CT)) break;;
                        if (MercCast("Sticky Grenade")) break;;
                        if (MercCast("High Impact Bolt", SoG)) break;;
                        if (MercCast("Plasma Grenade", SoG || MobsInRangeOf(CT, .50f) >= 3)) break;;
                        if (MercCastOnGround("Hail of Bolts", BuddyTor.Me.ResourceStat > 50f && MobsInRangeOf(CT, .60f) >= 3, CT, true)) break;;

                        if (MercCast("Incendiary Round", SoG || MobsInRangeOf(CT, .50f) >= 4)) break;;
                        if (MercCast("Explosive Round", (TD <= MeleeDist && SoG) || (MyLevel < 10 && RS >= 50f))) break;;

                        if (MercCast("Grav Round", SoG)) break;;
                        if (MercCast("Demolition Round", SoG && CTHasDebuff("Grav"))) break;;

                        if (MercCast("Tech Override", SoG)) break;;
                        if (MercCast("Charged Bolts", HaveBuff("Tech Override"))) break;;
                        if (MercCast("Full Auto")) break;;

                        if (MercCast("Charged Bolts")) break;;
                        if (MercCast("Hammer Shot")) break;;

                        if (MercCast("Hammer Shot")) break; ;
                        break;
                    }
                    if (!EnableObjMgrUpd) return IAmInCombat();
                    Thread.Sleep(150);
                    if (!IAmInCombat()) return false;
                }
            }
            //WaitForCast();
            return IAmInCombat();

        }

        public static bool VanguardCombat()
        {

            while (true)
            {
                datLCL = DateTime.Now;
                UpdateObjects();
                LoadVars();

                while (true)
                {
                    if (IGAndTargetNotInCombat()) return false;
                    if (IAmStunned()) { MercCast("Tenacity"); if (IAmStunned()) { Thread.Sleep(500); break; } }

                    MercBuffSelf("Ion Cell", MySpec == SkillTreeId.VanguardShieldSpecialist);
                    MercBuffSelf("High Energy Cell", MySpec == SkillTreeId.VanguardTactics);
                    MercBuffSelf("Plasma Cell", MySpec == SkillTreeId.VanguardAssaultSpecialist);

                    if (CT != null && !CT.InCombat)
                    {
                        MoveTo(CT, 2.9f);
                        if (MercCastOnGround("Mortar Volley", true, CT)) ChainCastWait();
                        if (MercCast("Sticky Grenade")) ChainCastWait(); ;
                        if (MercCast("Full Auto")) ChainCastWait(); ;
                    }

                    if (CT != null && TC && SoG)
                    {
                        if (MercCast("Harpoon", AmTank || !IG)) break;
                        if (MercCast("Storm")) break;
                        if (MercCast("Cryo Grenade")) break;
                        if (MercCast("Neural Surge", (AmTank || !IG) && TD <= .79f)) break;
                        if (MercCast("Disabling Shot")) break;
                        if (MercCast("Riot Strike")) break;
                        if (MercCast("Neural Jolt", AmTank || !IG)) break;
                    }

                    //MoveTo(CT, AmTank?2.9f:.99f, "Sticky Grenade", "High Impact Bolt", "Explosive Round", "Hammer Shot");
                    MoveTo(CT, 2.9f, "Sticky Grenade", "High Impact Bolt", "Explosive Round", "Hammer Shot");
                    //StopMoving();

                    if (HP <= 30f) UseMedPackInInventory();
                    CheckCompGuard();

                    //Thread.Sleep(100);
                    if (HP <= 70f)
                    {
                        if (MercCast("Reactive Shield", (AmTank && HP <= 50f) || (!AmTank && HP <= 70f))) break;
                        if (MercCast("Diversion", (AmTank && HP <= 35f) || (!AmTank && HP <= 60f))) break;
                        if (MercCast("Adrenaline Rush", HP <= 35f)) break;
                        if (MercCast("Unity", Me, !IG && HP <= 50f & LastComp != null && !LastComp.IsDead)) break;
                    }

                    if (MercCast("Recharge Cells", RS <= 50f)) break;
                    if (MercCast("Reserve Powercell", RS <= 30f)) break;
                    if (MercCast("Supercharge Cells")) break;

                    if (MercCast("Energy Blast", RS <= 50f)) break;

                    if (IG)
                    {
                        if (MercCast("Neural Jolt", AmTank)) break;
                        if (MercCast("Sonic Round", AmTank)) break;
                        if (MercCastNew("Riot Gas", CT, TWR10 >= 3)) break;
                    }

                    if (TD <= MeleeDist)
                    {
                        if (MercCast("Stockstrike")) break;
                        if (MercCast("Blitz")) break;
                        if (MercCast("Gut", TD <= .45f && !CTHasDebuff("Bleeding"))) break;
                        if (MercCast("Concussion Charge")) break;
                        //if (MercCast("Neural Surge")) break;
                        if (MercCast("Explosive Round", !SoG)) break;
                    }

                    if (TD <= 1.0f)
                    {
                        if (MercFaceAndCast("Pulse Cannon", TWR5 >= 2)) break;
                        if (MercCast("Ion Pulse", RS >= 75f)) break;
                    }

                    if (RS < 65f) { /*Logger.Write("Low RS, Casting Hammer Shot.");*/ MercCast("Hammer Shot"); break; }

                    if (MercCast("Fire Pulse", TD <= .99f)) break;  // BUGGY FUCKING ABILITY
                    if (MercCast("Incendiary Round", TD <= .99f & (SoG || MobsInRangeOf(CT, .80f) >= 2))) break;  // BUGGY FUCKING ABILITY
                    if (MercCast("Assault Plastique", TD <= .99f && (SoG || MobsInRangeOf(CT, .8f) >= 2))) break;
                    if (MercCast("High Impact Bolt", HaveBuff("Ionic Accelerator"))) break;
                    if (MercCastOnGround("Mortar Volley", TD >= .65f && (SoG || MobsInRangeOf(CT, .50f) >= 2), CT, true)) break;

                    if (MercCast("Fire Pulse", TD <= .99f)) break;

                    if (MercCast("Shoulder Cannon", SoG)) break;

                    if (MercCast("Explosive Surge", TWR5 >= 2)) break;
                    if (MercCast("Sticky Grenade")) break;
                    if (MercCast("Plasma Grenade", SoG)) break;
                    if (MercCast("High Impact Bolt")) break;
                    if (MercCast("Battle Focus", SoG || HP <= 50f)) break;
                    if (MercCast("Full Auto")) break;

                    //if (MercCast("Concussive Round", HP < 50f)) { ClearTarget(); break; }

                    if (!IG || (IG && RS > 40f))
                    {
                        if (MercCast("Tech Override", SoG)) break;
                        if (MercCast("Charged Bolts", HaveBuff("Tech Override"))) break;
                        //if (MercCast("Riot Gas", SoG)) break; // Can be a bit buggy, moved it down here to try and alleviate that
                    }

                    if (MercCast("Hammer Shot")) break;
                    
                    break;
                }
                Thread.Sleep(350);
                if (WaitForCast()) return IAmInCombat();
                if (!IAmInCombat()) break;
            }
            return IAmInCombat();

        }

        public static bool AmHealer()
        {
            return (MySpec == SkillTreeId.SorcererCorruption || MySpec == SkillTreeId.MercenaryBodyguard || MySpec == SkillTreeId.OperativeMedic
                || MySpec == SkillTreeId.SageSeer || MySpec == SkillTreeId.CommandoCombatMedic || MySpec == SkillTreeId.ScoundrelSawbones);
        }

        public static bool IsTank(SkillTreeId theSTID)
        {
            return (theSTID == SkillTreeId.AssassinDarkness || theSTID == SkillTreeId.PowertechShieldTech || theSTID == SkillTreeId.JuggernautImmortal
                || theSTID == SkillTreeId.GuardianDefense || theSTID == SkillTreeId.VanguardShieldSpecialist || theSTID == SkillTreeId.ShadowCombat);
        }

        public static bool IAmTank()
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                return (MySpec == SkillTreeId.AssassinDarkness || MySpec == SkillTreeId.PowertechShieldTech || MySpec == SkillTreeId.JuggernautImmortal
                    || MySpec == SkillTreeId.GuardianDefense || MySpec == SkillTreeId.VanguardShieldSpecialist || MySpec == SkillTreeId.ShadowCombat);
            }
        }

        public static bool GetGroupTankTarget()
        {
            if (!(IG && AmTank)) return false;
            if (!AutoTargetTank) return false;

            GetGroupAttackees();
            if (NAUnit != null) { CT = NAUnit; return true; } else { CT = MyTarget(); }
            return false;

        }

        public static bool HandleGuarding()
        {
            if (!AutoTargetTank) return false;

            if (!(IG && AmTank)) return false;

            GetGroupAttackees();

            if (NAUnit != null) try
                {
                    CT = NAUnit;
                    TargetUnit(CT);
                    Thread.Sleep(400);
                    UpdateObjects();
                    if (MercCast("Force Pull", NAUnit)) return true;
                    if (MercCast("Mind Control", NAUnit)) return true;
                    if (MercCast("Threatening Scream")) return true;
                    if (MercCast("Intercede", NGUnit, MovementAllowed)) return true;
                    if (MercCast("Taunt", NAUnit)) return true;
                    if (MercCast("Backhand", NAUnit)) return true;
                    if (MercCast("Zealous Leap", NAUnit)) return true;
                    if (MercCast("Mass Mind Control", NAUnit)) return true;
                    if (MercCast("Threatening Scream", NAUnit)) return true;
                    if (MercCast("Guardian Leap", NGUnit, MovementAllowed)) return true;
                    if (MercCast("Saber Throw", NAUnit)) return true;
                    if (MercCast("Dual Saber Throw", NAUnit)) return true;
                    if (MercCast("Force Leap", NAUnit, MovementAllowed)) return true;
                    if (MercCast("Force Charge", NAUnit, MovementAllowed)) return true;
                    if (MercCast("Shock", NAUnit)) return true;
                    if (MercCast("Discharge", NAUnit)) return true;
                    if (MercCast("Force Breach", NAUnit)) return true;
                    if (MercCast("Project", NAUnit)) return true;
                    if (MercCast("Force Slow", NAUnit)) return true;
                    if (MercCast("Guard", DiffInSeconds(LastGuardCheck, Now) >= 30f)) { LastGuardCheck = Now; return true; }

                }
                catch { }
            return false;
        }

        public static bool ShadowCombat()
        {
            while (AllowCombat && !PauseBot)
            {
                while (true)
                {
                    MercCast("Unbreakabile Will", IAmStunned());
                    if (IAmStunned()) { Thread.Sleep(300); break; }

                    LoadVars();

                    datLCL = DateTime.Now;

                    MercBuffSelf("Combat Technique", MySpec == SkillTreeId.ShadowCombat);
                    MercBuffSelf("Shadow Technique", MySpec == SkillTreeId.ShadowInfiltration);
                    MercBuffSelf("Force Technique", MySpec == SkillTreeId.ShadowBalance);

                    MercBuffSelf("Force Valor");

                    if (IGAndTargetNotInCombat()) return false;

                    if (MercBuffSelf("Kinetic Ward")) break;
                    if (!CT.InCombat && CT.HealthPercent > .2f)
                    {
                        DateTime PullStart = DateTime.Now;
                        MercBuffSelf("Stealth");
                        if (MovementAllowed)
                        {
                            MercBuffSelf("Force Speed");
                            while (CT.Distance > .15f && DateTime.Now.Subtract(PullStart).TotalSeconds < 15) MoveTo(CT, .15f);
                            if (MercCast("Shadow Strike", CT.Distance <= .20f)) if (MercCast("Double Strike")) break;
                        }
                        else if (!MercCast("Force Pull")) MercCast("Mass Mind Control");
                    }

                    if (HandleGuarding()) break;

                    //if (TD > 1.5f) if (MercCast("Force Pull")) { Thread.Sleep(700); break; }

                    if (TC && SoG)
                    {
                        if (MercCast("Mind Snap")) break;
                        if (MercFaceAndCast("Force Pull", true)) break;
                        if (MercCast("Spinning Kick")) break;
                        if (MercCast("Mind Control", AmTank)) break;
                        if (MercCast("Mass Mind Control", AmTank)) break;
                    }

                    if (!IG && TD >= 1.0f && TD <= 3.0f) MercCast("Force Pull");

                    MoveTo(CT, MeleeDist, "Force Speed", "Project", "Force Breach");

                    if (HP < 50f)
                    {
                        if (HP <= 30) UseMedPackInInventory();
                        if (MercCast("Unity", HP <= 50f && !IG && Comp != null && !Comp.IsDead)) break;
                        if (MercCast("Battle Readiness", HP <= 50f)) break;
                        if (MercCast("Force Potency", HP <= 50f)) break;
                        if (MercCast("Deflection", HP <= 50f)) break;
                        if (MercCast("Resilience", HP <= 50f && NeedsDispell(Me))) break;
                    }

                    if (MercCast("Spinning Strike", THP <= 30f && RS >= 50f)) break;

                    CheckCompGuard();


                    if (MercCast("Spinning Strike", THP <= 30f)) break;

                    if (MercCast("Force Potency", HP <= 70f || (SoG || TWR10 >= 3))) break;
                    if (MercCastOnGround("Force in Balance",true,CT)) break;
                    if (MercCast("Mind Crush", HaveBuff("Force Strike"))) break;
                    if (MercCast("Shadow Strike", HaveBuff("Shadow Wrap") && (SoG || HP <= 70f || THP > 60f))) break;

                    if (MercCast("Sever Force", SoG && !CTHasDebuff("Sever Force"))) break;
                    if ((TWR10 >= 2 || SoG) &&
                        ((AmTank && !CTHasDebuff("Accuracy Reduced")) ||
                          (HaveBuff("Force Technique") && !CTHasDebuff("Crushed (Force)")) ||
                          (HaveBuff("Shadow Technique") && HaveBuffStacks("Breaching Shadows", 3))
                          )) if (MercCast("Force Breach")) break;
                    if (MercCast("Slow Time", RS>=50 && (TWR10 >= 4 || SoG))) break;
                    if (MercCast("Project", (RS > 45f) || HaveBuff("Clairvoyance"))) break;
                    if (MercCast("Shadow Strike", (SoG || THP >= 40f) && HaveBuff("Shadow Wrap") && RS >= 50f)) break;

                    //if (MercCast("Force Wave", TWR10 >= 3)) break;
                    if (MercCast("Force Stun", SoG && CTT <= CombatToughness.Boss1)) break;

                    if (MercCast("Telekinetic Throw", HaveBuffStacks("Harnessed Shadows", 3))) break;
                    if (MercCast("Clairvoyant Strike", SoG)) break;
                    if (MercCast("Double Strike", MyAbilities.Contains("Shadow Wrap") || EP > 50f)) break;
                    //if (MercCast("Telekinetic Throw", TD >= .6f && Me.ForcePercent <= 50f)) break;

                    if (MercCast("Project", TD <= 1.0f && RS > 45f)) break;
                    if (MercCast("Telekinetic Throw", TD <= 1.0f && HaveBuffStacks("Harnessed Shadows", 3))) break;

                    if (MercCast("Whirling Blow", RS >= 50f && TWR5 >= 3)) break;
                    if (MercCast("Double Strike", EP > 50f && TD <= MeleeDist)) break;

                    if (MercCast("Mind Crush", SoG && !CTHasDebuff("Mind Crush") && THP >= 50)) break;

                    if (MercCast("Force Slow", SoG)) break;

                    if (MercCast("Slow Time", !CTHasDebuff("Slow Time (Force)"))) break;
                    if (MercCast("Project", RS > 45f)) break;
                    //if (MercCast("Telekinetic Throw")) break;				


                    MercCast("Saber Strike");
                    Thread.Sleep(150);
                    break;

                }
                if (WaitForCast()) return IAmInCombat();
                if (!IAmInCombat()) break;

            }
            //WaitForCast();
            return IAmInCombat();

        }

        public static bool SageKineticCombat()
        {
            WaitForCast();
            datLCL = DateTime.Now;

            Thread.Sleep(200);

            LoadVars();

            if (IGAndTargetNotInCombat()) return false;

            MercBuffSelf("Force Valor");

            if (!IG && BuddyTor.Me.IsMoving) StopMoving();
            if (CT == null && MyTarget() != null) CT = MyTarget();

            if (CT == null) { Logger.Write("No target.  Exiting."); return false; }

            MoveTo(CT, 2.90f, "Force Speed");

            MercCast("Force of Will", IAmStunned());
            
            if (MercCast("Force Shield", Comp, Comp!=null && !Comp.HasBuff("Force Shield"))) return true;
            if (MercCast("Force Shield", Me, !HaveBuff("Force Shield"))) return true;
            if (MercCast("Project", RS > 45f && TD >= .6f)) return true;

            if (HP <= 30) UseMedPackInInventory();

            if (MercCast("Force Wave", TWR10 >= 2)) return true;
            //if (MercCast("Heroic Moment: Channel the Force", HP <= 40f)) return true;

            if (MercCast("Force Mend", Me, HP < 80f)) return true;
            if (MercCast("Benevolence", Me, HP < 80f)) return true;
            if (MercCast("Benevolence", Comp, CHP <= 70f)) return true;

            if (MercCast("Telekinetic Throw", TD >= .6f)) return true;

            if (TD > 1.5f) if (MercCast("Force Pull")) return true;

            if (MercCast("Mind Snap", TC)) return true;
            if (MercCast("Mind Control", TC && SoG)) return true;

            if (MercCast("Force Wave", TWR10 >= 3)) return true;
            if (MercCast("Force Stun", SoG && CTT <= CombatToughness.Boss1)) return true;

            if (!IG) foreach (TorCharacter u in Attackers) if (MercCast("Weaken Mind", u, !u.HasDebuff("Weaken Mind (Force)"))) WaitForCast();

            if (MercCast("Battle Readiness", HP <= 50f)) return true;
            if (MercCast("Force Potency", HP <= 50f)) return true;
            if (MercCast("Resilience", HP <= 50f)) return true;
            if (MercCast("Deflection", HP <= 50f)) return true;

            if (MercCast("Force Potency", HP <= 70f || (CTT >= CombatToughness.Boss1) || (TWR10 >= 3))) return true;

            if (MercCast("Force Breach", (TD <= 1.0f && SoG) || TWR10 >= 3)) return true;
            if (MercCast("Force Wave", TWR10 >= 3)) return true;

            if (MercCast("Tumult", TD <= MeleeDist)) return true;
            if (MercCast("Spinning Strike", THP <= 30f)) return true;

            if (MercCast("Mind Crush", SoG && !CTHasDebuff("Mind Crush") && THP >= 50)) return true;

            if (MercCast("Project", TD <= 1.0f && RS > 45f)) return true;
            if (MercCast("Telekinetic Throw", TD <= 1.0f)) return true;

            if (MercCast("Force Slow", SoG)) return true;

            if (MercCast("Slow Time", !CTHasDebuff("Slow Time (Force)"))) return true;
            if (MercCast("Force Breach", TWR10 >= 3)) return true;
            if (MercCast("Whirling Blow", TWR5 >= 3)) return true;
            if (MercCast("Project", RS > 45f)) return true;
            if (MercCast("Telekinetic Throw")) return true;

            if (MercCast("Double Strike", RS > 65f)) return true;

            if (MercCast("Saber Strike"))return true;
            return false;
        }

        public static void InfiltrationCombat()
        {
            WaitForCast();
            datLCL = DateTime.Now;

            Thread.Sleep(200);

            LoadVars();

            if (!IG && BuddyTor.Me.IsMoving) StopMoving();
            if (CT == null && MyTarget() != null) CT = MyTarget();

            if (CT == null) { Logger.Write("No target.  Exiting."); return; }

            MoveTo(CT, 2.9f);
            if (!CT.InCombat && CT.HealthPercent > .2f)
            {
                MercCast("Stealth");
                while (CT.Distance > .15f) MoveTo(CT, .15f);
                if (MercCast("Shadow Strike", CT.Distance <= .20f)) if (MercCast("Double Strike")) return;
            }

            MercCast("Force of Will", IAmStunned());
            if (HandleGuarding()) return;

            if (MercCast("Project", RS > 45f && TD >= .6f)) return;
            if (MercCast("Telekinetic Throw", TD >= .6f)) return;

            if (TD > 1.5f) if (MercCast("Force Pull")) return;
            MoveTo(CT, .490f, "Force Speed");

            if (MercCast("Mind Snap", TC)) return;
            if (MercCast("Mind Control", TC && SoG)) return;

            if (MercCast("Force Wave", TWR10 >= 3)) return;
            if (MercCast("Force Stun", SoG && CTT <= CombatToughness.Boss1)) return;

            if (HP <= 30) UseMedPackInInventory();

            //if (MercCast("Heroic Moment: Channel the Force", HP <= 40f)) return;

            if (MercCast("Kinetic Ward", HP < 80f)) return;
            if (MercCast("Battle Readiness", HP <= 50f)) return;
            if (MercCast("Force Potency", HP <= 50f)) return;
            if (MercCast("Resilience", HP <= 50f)) return;
            if (MercCast("Deflection", HP <= 50f)) return;

            if (MercCast("Force Potency", HP <= 70f || (CTT >= CombatToughness.Boss1) || (TWR10 >= 3))) return;

            if (MercCast("Force Breach", (TD <= 1.0f && SoG) || TWR10 >= 2)) return;
            if (MercCast("Force Wave", TWR10 >= 3)) return;

            if (MercCast("Tumult", TD <= MeleeDist)) return;
            if (MercCast("Spinning Strike", THP <= 30f)) return;

            if (MercCast("Mind Crush", SoG && !CTHasDebuff("Mind Crush") && THP >= 50)) return;

            if (MercCast("Project", TD <= 1.0f && RS > 45f)) return;
            if (MercCast("Telekinetic Throw", TD <= 1.0f)) return;

            if (MercCast("Force Slow", SoG)) return;

            if (MercCast("Slow Time", !CTHasDebuff("Slow Time (Force)"))) return;
            if (MercCast("Force Breach", TWR10 >= 3)) return;
            if (MercCast("Whirling Blow", TWR10 >= 3)) return;
            if (MercCast("Project", RS > 45f)) return;
            if (MercCast("Telekinetic Throw")) return;

            if (MercCast("Whirling Blow", TWR5 >= 2)) return;
            if (MercCast("Double Strike", RS > 65f)) return;

            MercCast("Saber Strike");

        }

        public static void SniperMarksmanshipPull()
        {
            CT = MyTarget();
            if (IGAndTargetNotInCombat()) return;

            LoadVars();
            MoveTo(CT, 2.8f);

            //MyTarget().Face();
            //Thread.Sleep(600);
            MercCast("Crouch");
            Thread.Sleep(600);
            MercCast("Ambush");
            return;
        }

        // Ops Medicine BLOWS, weak, WEAK, heals
        public static void MedicineCombat()
        {
            WaitForCast();
            datLCL = DateTime.Now;

            Thread.Sleep(300);

            LoadVars();

            MercBuffSelf("Coordination");
            if (MercCast("Escape", IAmStunned())) return;

            if (MercCast("Heroic Moment:  Advanced Recon", Me, HP <= 25)) return;
            if (MercCast("Evasion", Me, HP <= 30)) return;
            if (MercCast("Kolto Probe", Me, HP <= 70 && !HaveBuff("Kolto Probe"))) return;
            if (MercCast("Surgical Probe", HP <= 70 && HaveBuff("Tactical Advantage"))) return;
            if (MercCast("Kolto Injection", Me, HP <= 60)) return;
            if (MercCast("Kolto Infusion", Me, HP <= 70)) return;
            if (MercCast("Adrenaline Probe", EP <= 20)) return;
            if (MercCast("Stim Boost", EP <= 60 && HaveBuff("Tactical Advantage"))) return;

            if (IG) if (RunHeals(80)) return;

            if (IGAndTargetNotInCombat()) return;

            MoveTo(CT, 2.80f);
            StopMoving();

            MercCast("Crouch", Me, !Me.IsCoverAffected);
            if (!CT.InCombat)
            {
                Thread.Sleep(600);
                MercCast("Snipe");
            }

            if (MercCast("Distraction", (IG && HP <= 50f) || (SoG && TC))) return;
            if (MercCast("Flash Bang", TD <= MeleeDist)) return;
            if (MercCast("Carbine Burst", HaveBuff("Tactical Advantage") && SoG && TD <= MeleeDist)) return;

            if (MercCast("Debilitate", SoG && TC)) return;
            if (MercCast("Fragmentation Grenade", !IG && SoG && TC)) return;

            //if (HP <= 70) MercCast("Rifle Shot");    // Force a Rifle-Shot on healing so we get at least a LITTLE DAMAGE in - may help with a Heals Catch-22

            if (MercCast("Eviscerate", TD <= MeleeDist)) return;
            if (MercCast("Shiv", TD <= MeleeDist)) return;
            if (MercCast("Sever Tendon", TD <= 1.0f)) return;

            if (OperativeCheckCompHealth(AmHealer()?80f:50f)) return;

            if (MercCast("Rifle Shot", RS <= 30 && (SoG || IG))) return;

            if (MercCast("Fragmentation Grenade", !IG)) return;
            if (MercCast("Explosive Probe")) return;
            if (MercCast("Corrosive Dart", !CTHasDebuff("Poisoned (Tech)"))) return;
            if (MercCast("Flash Bang")) return;

            if (MercCast("Carbine Burst", TWR10 >= 3)) return;

            if (MercCast("Snipe")) return;
            if (MercCast("Rifle Shot")) return;

        }

        public static bool OperativeCombat()
        {

            while (AllowCombat && !PauseBot)
            {
                datLCL = DateTime.Now;

                while (true)
                {

                    LoadVars();

                    if (!IG && CT != null && !CT.InCombat)
                    {
                        MercCast("Acid Blade");
                        MercBuffSelf("Stealth");
                        MercBuffSelf("Stealth");
                        if (MovementAllowed) while (CT.Distance > 2.9f) { Navigator.MoveTo(CT.Position); UpdateObjects(); }
                        if (MercCastOnGround("Orbital Strike", SoG || MobsInRangeOf(CT, .8f) >= 3, CT)) { Thread.Sleep(300); WaitForCast(); }
                        Thread.Sleep(800);
                        MoveTo(CT, .20f);
                        Thread.Sleep(150);
                        if (!MercCast("Hidden Strike")) if (!MercCast("Hidden Strike")) if (!MercCast("Backstab")) if (!MercCast("Laceration")) MercCast("Shiv");
                    }

                    if (MercCast("Escape", IAmStunned())) break;
                    if (IAmStunned()) { Thread.Sleep(500); break; }

                    if (MercBuffSelf("Coordination")) ChainCastWait();
                    if (MercBuffSelf("Acid Blade")) ChainCastWait();
                    if (MercCast("Kolto Probe", Me, !HaveBuffStacks("Kolto Probe", 2))) ChainCastWait();

                    //if (MercCast("Kolto Probe", Me, !HaveBuff("Kolto Probe"))) ;
                    if (MercCast("Adrenaline Probe", EP <= 50f)) break;
                    if (MercCast("Stim Boost", EP <= 40f && HaveBuff("Tactical Advantage"))) break;

                    if (HP < 70f)
                    {
                        if (HP <= 30f) UseMedPackInInventory();
                        bool PreHealsDmg = MercCast("Flash Bang", HP <= 40f) || MercCast("Explosive Probe") || MercCast("Fragmentation Grenade") || MercCast("Shiv") || MercCast("Laceration") || MercCast("Rifle Shot") ;
                        Thread.Sleep(900); WaitForCast();
                        if (MercCast("Recuperative Nanotech", Me)) break;
                        if (MercCast("Kolto Infusion", Me, HP <= 70f)) break;
                        if (MercCast("Toxin Scan", Me, HP <= 70f && NeedsDispell(Me))) break;
                        if (MercCast("Kolto Probe", Me, !HaveBuffStacks("Kolto Probe", 2))) break;
                        if (MercCast("Surgical Probe", Me, HaveBuffStacks("Tactical Advantage",2))) break;
                        if (MercCast("Kolto Injection", Me, HP <= 60f)) break;
                        //if (MercCast("Heroic Moment: Advanced Recon", Me, HP <= 25f)) ;
                        if (MercCast("Unity", !IG && HP <= 50f && Comp != null && !Comp.IsDead)) break;

                        if (MercCast("Distraction", HP <= 40f)) break;
                        if (MercCast("Evasion", Me, HP <= 30f)) break;
                        if (MercCast("Countermeasures", Me, HP <= 50f)) break;
                    }

                    if (IGAndTargetNotInCombat()) return false;

                    if (IG)
                    {
                        RunHeals(!AmHealer()?50f:Is55H?80f:75f);
                        if (RS <= 50) { MercCast("Rifle Shot"); return IAmInCombat(); }
                    }

                    if (!IG && OperativeCheckCompHealth(AmHealer() ? 60f : 50f)) ChainCastWait();

                    MoveTo(CT, AmHealer() && IG ? 2.8f : MeleeDist, "Corrosive Grenade", "Explosive Probe", "Fragmentation Grenade", "Rifle Shot");

                    //if (!CT.InCombat && MySpec != SkillTreeId.OperativeMedic)
                    if (TC && SoG)
                    {
                        if (MercCast("Distraction")) break;
                        if (MercCast("Flash Bang")) break;
                        if (MercCast("Debilitate")) break;
                    }

                    if (MercBuffSelf("Crouch", MovementAllowed && (AmHealer() || (!AmHealer() && HP < 75f)))) ChainCastWait();
                    if (MercBuffSelf("Shield Probe")) ChainCastWait();

                    if (MercCastOnTimer("Corrosive Grenade", 21f, SoG || MobsInRangeOf(CT, .50f)>=2)) break;
                    if (MercCastOnTimer("Corrosive Dart", 21f, SoG || AbilsContain("Cull"))) break;
                    
                    if (!AmHealer() || TD <= 1.0f)
                    {
                        if (MercCast("Cull", TD <= 1.0f && OccurCount(CTDebuffs, "Poisoned") >= 2)) break;
                        if (MercCast("Hidden Strike")) break;
                        if (MercCast("Laceration")) break;
                        if (MercForcedCast("Backstab", CT, HaveBuff("Jarring Strike"))) break;
                        if (MercCast("Backstab")) break;
                        if (MercFaceAndCast("Carbine Burst", TD > 0 && TD <= 1.0f && !IG)) break;
                        if (MercCast("Shiv")) break;


                        if (MercCast("Explosive Probe")) break;
                        if (MercCast("Sever Tendon", SoG && !CTHasDebuff("Slowed (Tech)"))) break;
                    }

                    //if (MercCast("Shield Probe", Me, HP <= 70f)) break;

                    if (TWR10 >= 3)
                    {
                        if (MercCast("Explosive Probe")) break;
                        if (MercCast("Fragmentation Grenade")) break;
                        //if (MercCast("Explosive Probe")) break;
                        //if (MercCast("Fragmentation Grenade")) break;
                    }


                    if (AmHealer() && IG && RS <= 70f) { MercCast("Rifle Shot"); break; }

                    if (MercCastOnGround("Orbital Strike", IG && (EliteOrGreater(CT) || (MobsInRangeOf(CT, .8f) >= 3)), CT)) { Thread.Sleep(1500); break; }

                    if (MercCast("Laceration", TD <= MeleeDist && SoG)) break;
                    if (MercCast("Shiv", TD <= MeleeDist)) break;
                    if (MercCast("Explosive Probe")) break;
                    if (MercCast("Fragmentation Grenade")) break;
                    if (MercCast("Debilitate", TD <= MeleeDist && SoG)) break;

                    if (MercFaceAndCast("Carbine Burst", TD > 0 && TD <= 1.0f && (TWR10 >= 3 || SoG))) break;
                    if (MercCast("Cull", TD <= 1.0f)) break;

                    if (MercCast("Backstab", TD <= MeleeDist)) break;
                    if (MercCast("Sever Tendon", TD <= 1.0f && !CTHasDebuff("Slowed (Tech)"))) break;

                    if (MercCast("Snipe")) break;
                    //foreach (TorCharacter u in Attackers) if (MercCast("Corrosive Dart", u, !u.HasDebuff("Poisoned (Tech)"))) { Thread.Sleep(800); break; }
                    ApplyMassDebuff("Corrosive Dart", "Poisoned (Tech)");
                    if (MercCast("Rifle Shot", CT)) break;

                    //WaitForCast();
                    break;
                }
                Thread.Sleep(200);
                if (!IAmInCombat()) break;
                if (WaitForCast()) return IAmInCombat();
            }
            MoveForward(300);
            return IAmInCombat();
        }

        public static void ConcealmentCombat()
        {
            WaitForCast();
            datLCL = DateTime.Now;

            Thread.Sleep(100);

            LoadVars();

            if (IGAndTargetNotInCombat()) return;

            MercBuffSelf("Coordination");
            MoveTo(CT, 2.8f);

            if (!IG && BuddyTor.Me.IsMoving) StopMoving();
            if (CT == null && MyTarget() != null) CT = MyTarget();

            if (CT == null) { Logger.Write("No target.  Exiting."); return; }
            if (CT == Comp) { ClearTarget(); return; }

            if (!CT.InCombat && CT.HealthPercent > .2f)
            {
                MercCast("Stealth");
                while (CT.Distance > .15f) MoveTo(CT, .15f);
                MercCast("Acid Blade");
                MercCast("Ambush", CT.Distance <= .20f);
                MercCast("Backstab", CT.Distance <= .20f);
            }

            if (MercCast("Escape", IAmStunned())) return;

            MercBuffSelf("Crouch", CT.Distance<=MeleeDist);

            MoveTo(CT, MeleeDist, "Rifle Shot");

            if (MercCast("Acid Blade", !CTHasDebuff("Acid Blade"))) return;

            if (MercCast("Followthrough")) return;
            if (MercCast("Takedown")) return;
            if (MercCast("Headshot")) return;
            if (MercCast("Shattershot")) return;

            //if (HP <= 70) MercCast("Rifle Shot");    // Force a Rifle-Shot on healing so we get at least a LITTLE DAMAGE in - may help with a Heals Catch-22

            if (MercCast("Shield Probe", Me, !HaveBuff("Shield Probe"))) return;

            if (MercCast("Heroic Moment: Advanced Recon", Me, HP <= 25)) return;
            //if (MercCast("Evasion", Me, HP <= 30)) return;
            //if (MercCast("Kolto Probe", Me, HP <= 70 && !HaveBuff("Kolto Probe"))) return;
            //if (MercCast("Surgical Probe", HP <= 70 && HaveBuff("Tactical Advantage"))) return;

            if (MercCast("Kolto Injection", Me, HP <= 60)) return;
            if (MercCast("Kolto Infusion", Me, HP <= 70)) return;
            if (MercCast("Adrenaline Probe", EP <= 20)) return;
            if (MercCast("Stim Boost", EP <= 60 && HaveBuff("Tactical Advantage"))) return;

            if (MercCast("Stim Boost", Me, RS <= 20)) return;
            if (MercCast("Fragmentation Grenade", !IG)) return;

            if (TD <= MeleeDist)
            {
                if (MercCast("Orbital Strike", MobsInRangeOf(CT, .80f)>=3)) return;
                if (MercCast("Shiv")) return;
                if (MercCast("Lacerate", HaveBuff("Tactical Advantage"))) return;
                if (MercCast("Carbine Burst", HaveBuff("Tactical Advantage") && SoG)) return;
                if (MercCast("Eviscerate")) return;
                if (MercCast("Sever Tendon")) return;
            }

            if (MercCast("Distraction", (IG && HP <= 50) || (SoG && TC))) return;
            if (MercCast("Flash Bang", TD <= MeleeDist)) return;
            if (MercCast("Debilitate", SoG && TC)) return;
            if (MercCast("Fragmentation Grenade", !IG && SoG && TC)) return;

            if (MercCast("Cull", HaveBuff("Tactical Advantage") && TWR10 >= 2)) return;

            if (MercCast("Rifle Shot", RS <= 30 && (SoG || IG))) return;

            if (MercCast("Corrosive Grenade")) return;
            if (MercCast("Debilitate", SoG)) return;
            if (MercCast("Headshot", CT.IsStunned)) return;
            if (MercCast("Explosive Probe")) return;
            if (MercCast("Weakening Blast")) return;
            if (MercCast("Corrosive Dart", !CTHasDebuff("Poisoned (Tech)"))) return;
            if (MercCast("Flash Bang")) return;

            if (MercCast("Carbine Burst", TWR10 >= 3)) return;

            if (MercCast("Snipe")) return;
            if (MercCast("Rifle Shot")) return;

        }

        public static bool ScrapperCombat()
        {
            if (Me.HealthPercent < .2f || Me.IsDead) return false;

            WaitForCast();
            datLCL = DateTime.Now;

            Thread.Sleep(200);

            LoadVars();

            if (IGAndTargetNotInCombat()) return false;
            
            //if (!PvP) if(!CT.InCombat) if (TD > 1.50f) if (!Buddy.CommonBot.Blacklist.Contains(CT.Guid)) { Buddy.CommonBot.Blacklist.Add(CT.Guid,BlacklistFlags.Kill,TimeSpan.FromSeconds(120)); return; }

            MercBuffSelf("Lucky Shots");
            MoveTo(CT, 2.8f);

            if (!IG && BuddyTor.Me.IsMoving) StopMoving();
            if (CT == null && MyTarget() != null) CT = MyTarget();

            if (CT == null) { Logger.Write("No target.  Exiting."); return false; }
            if (CT == Comp) { ClearTarget(); return false; }

            if (MercCast("Crouch", Me, !HaveBuff("Crouch"))) Thread.Sleep(500);
            if (TD > 3.0f || !CT.InLineOfSight) return false;
            //MoveTo(CT, MeleeDist,"Sabotage Charge", "Thermal Grenade","Flurry of Bolts");

            if (MercCast("Escape", IAmStunned())) return true;

            if (HP <= 30f) UseMedPackInInventory();

            if (MercCast("Flash Grenade", TD <= 1.0f && TC)) return true;
            if (MercCast("Dirty Kick", TD <= MeleeDist && TC)) return true;
            if (MercCast("Tranquilizer", TD <= 1.0f && TC)) return true;
            if (MercCast("Pugnacity", Me, HP <= 50f || CHP <= 50f)) return true;

            if (MercCast("Shield Probe", Me, HP <= 70f)) return true;
            if (MercCast("Countermeasures", Me, HP <= 60f)) return true;
            if (MercCast("Stim Boost", Me, HP <= 60f)) return true;
            if (MercCast("Adrenaline Probe", Me, EP <= 20f)) return true;
            if (MercCast("Cool Head", RS <= 30f)) return true;
            if (MercCast("Evasion", Me, EP <= 50f)) return true;

            if (HaveBuff("Upper Hand"))
            {
                if (MercCast("Kolto Pack", Me, HP <= 70f)) return true;
                if (MercCast("Kolto Pack", Comp, CHP <= 70f)) return true;
                if (MercCast("Pugnacity", RS <= 20f)) return true;
            }

            if (MercCast("Kolto Infusion", Me, HP <= 70f)) return true;
            if (MercCast("Underworld Medicine", Me, HP <= 50f)) return true;
            if (MercCast("Underworld Medicine", Comp, CHP <= 50f)) return true;

            if (MercCastOnGround("XS Freighter Flyby", CT.Toughness >= CombatToughness.Boss1, CT)) return true;
            if (!IG) foreach (TorCharacter u in Attackers) if (MercCast("Corrosive Dart", u, !u.HasDebuff("Poisoned (Tech)"))) WaitForCast();

            if (MercCast("Vital Shot", !CTHasDebuff("Bleeding (Tech"))) return true;
            if (MercCast("Sucker Punch", TD <= 1.0f)) return true;
            if (MercCast("Carbine Burst", TD <= 1.0f)) return true;
            if (MercCast("Tendon Blast", TD <= 1.0f)) return true;
            if (MercCast("Back Blast", CT.IsFacing && TD<=1.0f)) return true;

            if (MercCast("Carbine Burst", TWR10>=2)) return true;

            if (TD <= MeleeDist)
            {
                if (MercCast("Blaster Whip")) return true;
                if (MercCast("Blaster Volley")) return true;
                if (MercCastOnGround("Flurrry of Bolts", TWR10 >= 3, CT)) return true;
                if (MercCast("Sucker Punch")) return true;
                if (MercCast("Dirty Kick")) return true;
                if (MercCast("Back Blast")) return true;
            }

            if (MercCast("Vital Shot", SoG && !CTHasDebuff("Bleeding (Tech)"))) return true;


            if (MercCast("Thermal Grenade")) return true;
            if (MercCast("Sabotage Charge")) return true;
            if (MercCastOnGround("Flurrry of Bolts", TWR30 >= 3, CT)) return true;
            if (MercCast("Aimed Shot")) return true;
            if (MercCast("Charged Burst")) return true;
            if (MercCast("Quick Shot")) return true;

            if (MercCast("Flurry of Bolts")) return true;

            return false;
        }

        private static DateTime datLastSSMove = DateTime.Now;

        public static bool GunslingerCombat()
        {
            datLastSSMove = DateTime.Now;
            while (AllowCombat && !PauseBot)
            {
                LoadVars();
                while (true)
                {
                    //Thread.Sleep(250);

                    datLCL = DateTime.Now;

                    if (IGAndTargetNotInCombat()) break ;

                    if (MercCast("Escape", IAmStunned())) break;
                    if (IAmStunned()) { Thread.Sleep(500); break; }
                    //if (!PvP) if(!CT.InCombat) if (TD > 1.50f) if (!Buddy.CommonBot.Blacklist.Contains(CT.Guid)) { Buddy.CommonBot.Blacklist.Add(CT.Guid,BlacklistFlags.Kill,TimeSpan.FromSeconds(120)); return; }

                    //if (!CT.InCombat) SickCompOnTarget();

                    MercBuffSelf("Lucky Shots");

                    //MoveTo(CT, MySpec == SkillTreeId.GunslingerDirtyFighting ? MeleeDist : 2.8f, "Thermal Grenade", "Quick Shot", "Shrap Bomb",  "Flurry of Bolts");
                    MoveTo(CT, 2.8f, "Thermal Grenade", "Quick Shot", "Shrap Bomb", "Flurry of Bolts");
                    
                    StopMoving();

                    MercFaceAndCrouch();
                    if (!CT.InLineOfSight && MovementAllowed) { Input.Move(MovementDirection.Forward);Thread.Sleep(500); Input.MoveStopAll(); MercCast("Crouch", Me, !HaveBuff("Crouch")); }

                    if (MercBuffSelf("Shield Probe")) Thread.Sleep(800);

                    //if (TD > 3.0f || !CT.InLineOfSight) return false;
                    //MoveTo(CT, MeleeDist,"Sabotage Charge", "Thermal Grenade","Flurry of Bolts");

                    if (TC && SoG) 
                    {
                        if (MercCast("Flash Grenade")) break;
                        if (MercCast("Distraction")) break;
                        if (MercCast("Leg Shot")) break;
                        if (MercCast("Dirty Kick", TD <= MeleeDist)) break;
                        if (MercCast("Tranquilizer")) break;
                    }

                    if (!CTInCombat() && !IG)
                    {
                        if (MercCastOnGround("XS Freighter Flyby", MobsInRangeOf(CT, .80f) >= 3 || EliteOrGreater(CT), CT)
                         || MercCastOnGround("Sweeping Gunfire", MobsInRangeOf(CT, .80f) >= 3,CT)
                         || MercCast("Shrap Bomb", MobsInRangeOf(CT, .80f) >= 3)
                         || MercCast("Aimed Shot") ||MercCast("Speed Shot"))
                         {
                             ChainCastWait();
                         }
                    }

                    // Wonky as there's no real way to determine if there are obstacles in front of us, and the 'Facing' used on cast is the CAMERA FACING, not the PLAYER FACING (game bug/problem)
                    //if (MercCastOnTimer("Hightail It", 21f, AbilsContain("Scatter Bombs") && IAmInCombat() && MovementAllowed, true)) break;

                    if (TD <= 1.0f)
                    {
                        if (MercCast("Blaster Whip")) break;
                        if (MercCast("Dirty Kick")) break;
                        if (MercCast("Sucker Punch", TD <= 1.0f)) break;
                        if (MercCast("Carbine Burst", TWR10 >= 2)) break;
                        if (MercCast("Tendon Blast", TD <= 1.0f)) break;
                        if (MercCast("Blaster Volley")) break;
                        if (MercCast("Pulse Detonator", TWR10 >= 2 || SoG)) break;
                        if (MercCastOnGround("Sweeping Gunfire", TWR10 >= 3, CT)) break;
                        if (MercCast("Back Blast")) break;
                    }

                    if (MercCast("Cool Head", Me, RS <= 50f)) break;
                    if (MercCast("Burst Volley", Me, RS <= 50f)) break;
                    if (MercCast("Adrenaline Probe", Me, RS <= 50f)) break;

                    if (HP <= 70f)
                    {
                        if (HP <= 30f) UseMedPackInInventory();
                        if (MercCast("Unity", HP <= 30f && !IG && Comp != null && !Comp.IsDead)) break;

                        if (MercCast("Sabotage Charge", HP <= 50f)) break;
                        if (MercCast("Stim Boost", HP <= 50f)) break;
                        if (MercCast("Hunker Down", HP <= 50f)) break;
                        if (MercCast("Scrambling Field", HP <= 50f)) break;  //Another F'D up spell
                        if (MercCast("Pugnacity")) break;
                        if (MercCast("Surrender")) break;
                        if (MercCast("Diversion")) break;
                        if (MercCast("Countermeasures")) break;
                        if (MercCast("Sabotage")) break;
                        if (MercCast("Defense Screen", Me)) break;
                    }

                    if (MercCastOnGround("XS Freighter Flyby", EliteOrGreater(CT) || MobsInRangeOf(CT, .8f) >= 3, CT)) { Thread.Sleep(300); WaitForCast(); break; }

                    CheckSnapShot();

                    if (MercCast("Hemorrhaging Blast")) break;
                    if (MercCast("Illegal Mods", EliteOrGreater(CT))) break;

                    if (MercCast("Sabotage Charge", MobsInRangeOf(CT, .80f) >= 3)) break;
                    if (MercCast("Quickdraw")) break;
                    if (MercCast("Trickshot")) break;
                    if (MercCast("Speed Shot")) break;
                    if (MercCast("Wounding Shots", OccurCount(CTDebuffs, "Bleed") >= 2)) break;
                    if (MercCastOnTimer("Shrap Bomb", 21f)) break;
                    if (MercCastOnTimer("Shock Charge", 21f)) break;
                    if (MercCastOnGround("Incendiary Grenade", SoG || MobsInRangeOf(CT, .50f) >= 2, CT)) break;
                    if (MercCast("Charged Burst", HaveBuff("Snap Shot") || HaveBuff("Pandemonium"))) break;

                    if (MercCastOnTimer("Flourish Shot", 45f, SoG)) break;
                    if (MercCastOnTimer("Vital Shot", 21f, SoG)) break;

                    if (RS <= 60f) { MercCast("Flurry of Bolts"); break; }


                    //if (MercCast("Hemorrhaging Blast", OccurCount(CTDebuffs, "Bleed") >= 2)) break;
                    //if (MercCast("Wounding Shots", SoG && OccurCount(CTDebuffs, "Bleeding") >= 2)) break;
                    if (MercCast("Trickshot")) break;

                    if (MercCastOnGround("Sweeping Gunfire", MobsInRangeOf(CT, MeleeDist) >= 3, CT)) break;
                    if (MercCastOnTimer("Thermal Grenade", 12f, MobsInRangeOf(CT, .80f)>=3)) break;
                    //if (MercCast("Sabotage Charge")) break;

                    if (MercCast("Aimed Shot", HaveBuffStacks("Charged Aim", 2))) break;

                    if (MercCast("Burst Volley", SoG)) break;

                    if (MercCast("Thermal Grenade")) break;

                    if (MercCastOnGround("Incendiary Grenade", SoG || MobsInRangeOf(CT, .50f) >= 3, CT)) break;
                    if (MercCast("Shock Charge", SoG && !CTHasDebuff("Shock Charge"))) break;

                    if (MercCast("Vital Shot", !CTHasDebuff("Bleeding (Tech)"))) break;
                    if (MercCast("Smuggler's Luck", SoG)) break;
                    if (MercCast("Charged Burst", SoG && HaveBuff("Smuggler's Luck"))) break;
                    if (MercCastOnGround("Sweepging Gunfire", MobsInRangeOf(CT, .50f) >= 3, CT)) break;

                    //if (!IG) foreach (TorCharacter u in Attackers) if (MercCast("Corrosive Dart", u, !u.HasDebuff("Poisoned (Tech)"))) WaitForCast();

                    //if (MercCast("Flash Grenade", SoG)) break;

                    if (MercCast("Aimed Shot")) break;
                    if (MercCast("Charged Burst")) break;
                    if (MercCast("Quick Shot")) break;

                    MercCastOnGround("Sweeping Gunfire", true, CT);
                    if (MercCast("Flurry of Bolts")) break;

                    break;
                }

                Thread.Sleep(150);
                if (WaitForCast()) return IAmInCombat();
                if (!IAmInCombat()) break;
            }
            MoveForward(300);
            return IAmInCombat();
        }

        public static void ScoundrelCheckCompHealth(float MinHealth)
        {
            try
            {
                if (WaitForCast()) { Thread.Sleep(500); return; }

                if (LastComp==null) return;
                var CompX = LastComp;
                if (CompX == null) return;
                if (UHP(CompX) > MinHealth) return;
                if (CompX.IsDead && DiffInSeconds(LastRez, Now) >= 300) { MercCast("Heartrigger Patch", CompX); return; }

                WaitForCast();
                WaitForCast();

                while (true)
                {

                    //UpdateObjects();
                    TargetUnit(CompX);
                    Thread.Sleep(500);

                    while (true)
                    {
                        if (MercForcedCast("Kolto Cloud", CompX)) break;
                        if (MercForcedCast("Slow-release Medpac", CompX, !HasBuffStacks(CompX, "Slow-release Medpac", 2))) break;
                        if (MercCast("Triage", CompX, NeedsDispell(CompX))) break;
                        if (MercCast("Emergency Medpac", CompX, HaveBuffStacks("Upper Hand", 2))) break;
                        if (MercCast("Kolto Pack", CompX, !HasBuff("Kolto Pack", CompX))) break;
                        if (MercCast("Underworld Medicine", CompX)) break;
                        if (MercCast("Diagnostic Scan", CompX)) break;
                        break;

                    }
                    Thread.Sleep(700);
                    if (WaitForCast()) { Thread.Sleep(1000); break; }
                    break;
                    //WaitForCast();
                    //if (!IAmInCombat() || UHP(CompX) > MinHealth || CompX.IsDead) break;
                }
            }
            catch { }

            ClearTarget();
            Thread.Sleep(150);

        }

        public static bool SawbonesHeals()
        {
            int UHStacks = GetBuffStacks("Upper Hand", Me);
            int MPStacks = GetBuffStacks("Slow-release Medpac", LHUnit);

            if (MercForcedCast("Kolto Cloud", LHUnit)) return true;
            if (NeedsDispell(LHUnit) && MercCast("Toxin Scan", LHUnit)) return true;
            if (LHH >= 50f && !UnitHasBuff(LHUnit, "Kolto Pack") && UHStacks >= 2 && MercCast("Kolto Pack", LHUnit)) return true;
            if (MPStacks < 2 && MercCast("Slow-release Medpac", LHUnit)) return true;
            if (UHStacks >= 2 && MercCast("Emergency Medpac", LHUnit)) return true;
            if (MercCast("Underworld Medicine", LHUnit)) return true;
            if (MercCast("Diagnostic Scan", LHUnit))return true;
            if (MercForcedCast("Emergency Medpac", LHUnit)) return true;

            return false;

        }

        private static int UHStacks = 0;

        public static bool ScoundrelCombat()
        {
            //Thread.Sleep(300);
            while (AllowCombat && !PauseBot)
            {
                LoadVars();
                UHStacks = GetBuffStacks("Upper Hand", Me);
                
                datLCL = DateTime.Now;

                while (true)
                {

                    if (IGAndTargetNotInCombat()) return false;
                    MercBuffSelf("Lucky Shots");

                    if (!CTInCombat())
                    {
                        MoveTo(CT, 2.9f);
                        if (MercCastOnGround("XS Freighter Flyby", MobsInRangeOf(CT, .80f) >= 3, CT)) break;
                        if (MovementAllowed)
                        {
                            if (MercCastOnGround("XS Freighter Flyby", EliteOrGreater(CT) || MobsInRangeOf(CT, .80f) >= 3, CT)) ChainCastWait();
                            if (MercBuffSelf("Stealth")) Thread.Sleep(800); // Gets sketchy sometimes
                            if (MercBuffSelf("Stealth")) Thread.Sleep(800);
                            if (MercBuffSelf("Flechette Round")) ChainCastWait();
                            while (CT.Distance > .20f) MoveTo(CT, .20f);
                            if (MercCast("Shoot First")) ChainCastWait();
                            if (MercCast("Back Blast")) ChainCastWait();
                            if (MercCast("Blaster Volley")) ChainCastWait();
                            if (MercCast("Sucker Punch")) ChainCastWait();
                        }
                        else MercCast("Charged Burst", CT);
                    }

                    if (MercCast("Escape", IAmStunned())) break;
                    if (IAmStunned()) { Thread.Sleep(500); break; }

                    if (TC && SoG)
                    {
                        if (MercCast("Distraction")) break;
                        if (MercCast("Flash Grenade")) break;
                        if (MercCast("Dirty Kick")) break;
                        if (MercCast("Tranquilizer")) break;
                        if (MercCast("Slice Droid")) break;
                    }

                    //if (!HasBuffStacks(Me, "Slow-release Medpac",2) && MercCast("Slow-release Medpac", Me)) break;
                    if (MercCast("Slow-release Medpac", Me, !HaveBuffStacks("Slow-release Medpac", 2))) break;
                    if (MercCast("Cool Head", Me, RS <= 45f)) break;

                    if (HP <= 70f)
                    {
                        if (HP < 30f) UseMedPackInInventory();

                        // F'Em Up a Little Before Heals
                        if (!MercCast("Sabotage Charge")) if (!MercCast("Sucker Punch")) if (!MercCast("Thermal Grenade")) if (!MercCast("Flash Grenade")) if (!MercCast("Dirty Kick")) if (!MercCast("Blaster Volley")) MercCast("Flurry of Bolts");
                        ChainCastWait();

                        if (MercBuffSelf("Kolto Cloud")) break;
                        if (MercBuffSelf("Triage", NeedsDispell(Me))) break;
                        if (MercBuffSelf("Dodge", NeedsDispell(Me))) break;
                        if (MercCast("Emergency Medpac", Me, UHStacks >= 2)) break;
                        if (MercCast("Surrender", Me, HP <= 50f)) break;
                        if (MercCast("Pugnacity", Me)) break;
                        if (MercCast("Defense Screen", Me)) break;
                        if (MercBuffSelf("Kolto Pack", UHStacks>=1)) break;
                        if (MercCast("Dodge", Me, HP <= 50f)) break;
                        if (MercCast("Underworld Medicine", Me)) break;
                        break;
                    }

                    //MoveTo(CT, MySpec == SkillTreeId.ScoundrelSawbones ? 2.8f : MeleeDist, "Sabotage Charge", "Thermal Grenade", "Flurry of Bolts");
                    MoveTo(CT, AmHealer() && IG ? 2.80f : MeleeDist, "Sabotage Charge", "Thermal Grenade", "Flurry of Bolts");
                    StopMoving();

                    if (MercBuffSelf("Crouch", MovementAllowed && CT.Distance <= 2.9f && CT.InLineOfSight)) break;
                    if (MercCast("Shield Probe", !HaveBuff("Shield Probe"))) break;

                    if (!IG) ScoundrelCheckCompHealth(AmHealer() ? 65f : 50f);
                    if (IG) RunHeals(AmHealer()?Is55H?80f: 70f:50f);

                    //if (!PvP) if(!CT.InCombat) if (TD > 1.50f) if (!Buddy.CommonBot.Blacklist.Contains(CT.Guid)) { Buddy.CommonBot.Blacklist.Add(CT.Guid,BlacklistFlags.Kill,TimeSpan.FromSeconds(120)); return; }

                    if (RS < 65f) { MercCast("Flurry of Bolts"); break; }
                    if (MercCastOnGround("XS Freighter Flyby", EliteOrGreater(CT) || MobsInRangeOf(CT, .80f) >= 3, CT)) break;

                    if (MercCastOnTimer("Vital Shot", 15f, SoG)) break;
                    if (MercCastOnTimer("Tendon Blast", 12f, SoG)) break;

                    if (MercCast("Sucker Punch", AbilsContain("Turn the Tables"))) break;
                    if (MercCast("Shrap Bomb", !CTHasDebuff("Bleeding"))) break;

                    if (MercFaceAndCast("Blaster Volley", MovementAllowed && RS >= 60f && TWR10 >= 3)) break;
                    if (MercCastOnGround("XS Freighter Flyby", EliteOrGreater(CT) || MobsInRangeOf(CT, .80f) >= 3, CT)) break;

                    if (MercCast("Sabotage Charge")) break;
                    if (MercCast("Thermal Grenade")) break;

                    if (TD <= MeleeDist)
                    {
                        if (MercCast("Sucker Punch", UHStacks>=1)) break;
                        if (MercCast("Blaster Whip")) break;
                        if (MercCast("Back Blast")) break;
                        if (MercCast("Quick Shot")) break;
                        if (MercCast("Wounding Shots", UHStacks >= 1 && OccurCount(CTDebuffs, "Bleed") >= 2)) break;
                        if (MercCast("Sucker Punch")) break;
                    }

                    if (TD <= 1.0f && UHStacks >= 1 && (TWR10 >= 2 || SoG) && MercFaceAndCast("Blaster Volley", true)) break;

                    if (MercCast("Debilitate", SoG)) break;

                    if (MercCast("Flash Grenade", TWR10 >= 2 || SoG)) break;

                    if (MercCast("Charged Burst")) break;
                    if (MercCast("Flurry of Bolts")) break;

                    Thread.Sleep(150);
                    break;
                }
                if (!EnableObjMgrUpd) return IAmInCombat();
                if (!IAmInCombat()) { MoveForward(300); break; }
            }

            MoveForward(300);
            return IAmInCombat();
        }

        public static bool CheckSnapShot()
        {
            if (!MovementAllowed) return false;
            bool CanSnapshot = false;

            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (CT.InCombat && MyAbilities.Contains("Snap Shot") && DateTime.Now.Subtract(datLastSSMove).TotalSeconds >= 6 && HP >= 50f)
                {
                    CanSnapshot = true;
                    Input.Move(BackPedalToggle ? MovementDirection.Forward : MovementDirection.Backward, false);
                }
            }
            if (CanSnapshot)
            {
                Thread.Sleep(150);
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    Input.MoveStopAll();
                    Input.MoveStopAll();
                    CT.Face();
                    CT.Face();
                    AbilityManager.Cast("Crouch", Me);
                }
                Thread.Sleep(400);
                //if (Me.AdvancedClass == AdvancedClass.Sniper) MercForcedCast("Snipe", CT); else MercForcedCast("Charged Burst", CT);
                BackPedalToggle = !BackPedalToggle;
                datLastSSMove = DateTime.Now;
                return true;
            }
            return false;
        }

        public static int OccurCount(string strIn, string Expr)
        {
            try
            {   
                //string RE = @"*" + Expr + "*";
                string RE = @Expr;
                int ct = Regex.Matches(strIn, RE).Count;
                //Logger.Write("Matches for " + RE + ": " + ct.ToString());
                return ct;
            }
            catch { }
            return 0;
        }

        public static bool SniperCombat()
        {
            IsRanged = true;
            while (AllowCombat && !PauseBot)
            {
                while (true)
                {

                    LoadVars();

                    datLCL = DateTime.Now;

                    if (IGAndTargetNotInCombat()) break ;

                    if (MercCast("Escape", IAmStunned())) break;
                    if (IAmStunned()) { Thread.Sleep(500); break; }
                    
                    MercBuffSelf("Coordination");

                    MoveTo(CT, 2.80f, "Explosive Probe", "Fragmentation Grenade", "Rifle Shot");
                    StopMoving();

                    if (MercBuffSelf("Crouch", MovementAllowed && CT.InLineOfSight && CT.Distance <= 3.50f)) Thread.Sleep(1000);

                    if (!CT.InCombat)
                    {
                        //SickCompOnTarget();
                        bool PullDone = 
                          MercCast("Orbital Strike", MobsInRangeOf(CT, .80f) >= 4)
                          || MercCast("Ambush")
                          || MercCast("Followthrough")
                          || MercCast("Snipe")
                          || MercCast("Followthrough")
                          || MercCast("Explosive Probe")
                          || MercCast("Fragmentation Grenade");
                        Thread.Sleep(300);
                        WaitForCast();
                        // break;
                    }

                    if (StrongOrGreaterAndCasting())
                    {
                        if (MercCast("Distraction")) break;
                        if (MercCast("Flash Bang")) break;
                        if (MercCast("Debilitate")) break;
                        if (MercCast("Leg Shot")) break;
                        if (MercCast("Covered Escape", CT.Distance <= .50f)) break;
                    }

                    if (MercCast("Adrenaline Probe", RS <= 50f || HP < 60f)) break;
                    if (MercCast("Sniper Volley", RS <= 50f)) break;

                    if (HP < 70f)
                    {
                        if (HP <= 30f) UseMedPackInInventory();

                        if (MercCast("Unity", HP <= 50f && !IG && Comp != null && !Comp.IsDead)) break;
                        if (MercCast("Entrench", HP <= 70f)) break;
                        if (MercCast("Countermeasures", HP <= 70f)) break;
                        if (MercCast("EMP Discharge", HP <= 50f || EP<=30f)) break;
                        if (MercCast("Diversion", HP <= 70f && SoG && TC)) break;
                        if (MercCast("Shield Probe", !HaveBuff("Shield Probe"))) break;
                        //if (MercCast("Ballistic Shield", HP <= 50f && !HaveBuff("Ballistic Shield"))) break; //buggy
                    }

                    CheckSnapShot();

                    if (MercCast("Target Acquired", EliteOrGreater(CT) || MobsInRangeOf(CT,.60f)>=4)) break;

                    if (MercCast("Followthrough")) break;
                    if (MercCast("Takedown")) break;
                    if (MercCast("Headshot", CT.IsStunned)) break;
                    if (MercCastOnGround("Orbital Strike", EliteOrGreater(CT) || MobsInRangeOf(CT, .80f) >= 3, CT)) Thread.Sleep(850);

                    if (RS < 65f) { MercCast("Rifle Shot"); break; } // Energy regen rate is proportionate to the amt of energy you have, keep it at 50+ unless they're trying to 'Melee Gank' you

                    if (MercCast("Weakening Blast", SoG)) break;
                    if (MercCast("Overload Shot", HaveBuff("Calculated Pursuit"))) break;

                    if (OccurCount(CTDebuffs, "Poisoned") < 2)
                    {
                        if (MercCastOnTimer("Corrosive Grenade", 21f)) break;
                        if (MercCastOnTimer("Corrosive Dart", 21f)) break;
                    }
                    //var OCC = OccurCount(CTDebuffs,"Poisoned");
                    //Logger.Write("OCC: " + OCC.ToString());
                    if (MercCast("Cull", OccurCount(CTDebuffs, "Poisoned") >= 2)) break;
                    if (MercCast("Series of Shots")) break;

                    //if (MercCastOnTimer("Covered Escape", 21f, AbilsContain("Corrosive Mine") && IAmInCombat() && MovementAllowed, true)) break;

                    if (MercCast("Laze Target", SoG)) break;
                    if (MercCast("Explosive Probe", SoG || AbilsContain("Imperial Methodology"))) break;
                    if (MercCast("Interrogation Probe", SoG && !CTHasDebuff("Interrogation Probe"))) break;
                    if (MercCast("Plasma Probe", MobsInRangeOf(CT, .50f) >= 3)) break;

                    if (MercCast("Snipe", CTHasDebuff("Laze"))) break;

                    if (MercCast("Explosive Probe", SoG)) break;
                    if (MercCast("Fragmentation Grenade", MobsInRangeOf(CT, .50f) >= 3)) break;

                    if (TD <= MeleeDist)
                    {
                        if (MercCast("Cover Pulse")) break;
                        if (MercCast("Flash Bang")) break;
                        if (MercCast("Shiv")) break;
                        if (MercCast("Eviscerate")) break;
                        if (MercCast("Ambush")) break;
                    }

                    if (MercCast("Ambush", HaveBuffStacks("Zeroing Shots",2))) break;

                    if (MercCastOnGround("Suppressive Fire", MobsInRangeOf(CT, .5f) >= 3, CT)) break;

                    if (MercCast("Series of Shots", SoG || THP>=50f)) break;

                    if (MercCast("Shatter Shot", SoG && !CTHasDebuff("Armor Reduced"))) break;
                    if (MercCast("Debilitate", SoG)) break;
                    if (MercCast("Leg Shot", SoG)) break;

                    //if (MercCast("Corrosive Dart", !CTHasDebuff("Poisoned (Tech):18") || !CTHasDebuff("Poisoned"))) break;

                    if (MercCast("Ambush", SoG)) break;
                    if (MercCast("Snipe", SoG || CTHasDebuff("Laze Target"))) break;

                    ApplyMassDebuff("Corrosive Dart", "Poisoned (Tech)");

                    if (MercCast("Rifle Shot")) break;

                    if (MercCastOnGround("Suppressive Fire", true, CT)) break;  // This is to handle those moments where the mob is hostile, but YOU CAN'T ATTACK IT (love that shit), so drop an AOE

                    //if (UseMarksSurvRot)
                    //{

                    //    if (MercCast("Takedown")) break;
                    //    if (MercCast("Headshot")) break;
                    //    if (MercCast("Followthrough")) break;

                    //    if (MercCast("Evasion", HP <= 30f)) break;
                    //    if (MercCast("Shield Probe", HP <= 75f)) break;
                    //    if (MercCast("Countermeasures", HaveBuff("Shield Probe"))) break;
                    //    if (MercCast("Cover Pulse", TD <= MeleeDist)) break;
                    //    if (MercCast("Target Acquired", SoG && THP >= 50f)) break;
                    //    if (MercCast("Laze Target", SoG && THP >= 50f)) break;
                    //    if (MercCast("Adrenaline Probe", RS <= 50f)) break;
                    //    if (MercCast("Sniper Volley", HP <= 50f || RS <= 40f)) break;

                    //    if (MercCastOnGround("Orbital Strike", CTT >= CombatToughness.Boss1 && THP >= 30f, CT)) break;
                    //    if (MercCast("Fragmentation Grenade", TWR30 >= 3)) break;

                    //    if (MercCast("Distraction", TC && SoG)) break;
                    //    if (MercCast("Flash Bang", TWR5 >= 2)) break;
                    //    if (MercCast("Debilitate", TC)) break;

                    //    if (MercCast("Shiv", TD <= MeleeDist)) break;
                    //    if (MercCast("Eviscerate", TD <= MeleeDist)) break;

                    //    if (MercCast("Snipe", HaveBuff("Snap Shot"))) break;
                    //    if (MercCast("Shatter Shot", !CTHasDebuff("Armor Reduced (Physical)") && SoG)) break;
                    //    if (MercCast("Takedown")) break;
                    //    if (MercCast("Ambush", HaveBuff("Reactive Shot"))) break;
                    //    if (MercCast("Followthrough")) break;
                    //    if (MercCast("Series of Shots")) break;
                    //    if (MercCast("Ambush", HaveBuff("Followthrough"))) break;
                    //    if (MercCast("Snipe", HaveBuff("Followthrough"))) break;
                    //    if (MercCast("Snipe", HaveBuff("Laze Target"))) break;
                    //    if (MercCast("Headshot")) break;
                    //    if (MercCast("Explosive Probe", SoG)) break;
                    //    if (MercCast("Corrosive Dart", !CTHasDebuff("Poisoned (Tech)") && SoG)) break;
                    //    if (MercCast("Ambush")) break;
                    //    if (MercCast("Snipe")) break;

                    //    if (MercCast("Rifle Shot")) break;
                    //}
                    //else
                    //{


                    //}
                    ////Logger.Write(RS.ToString("0.0") + " Forced Cast:  Rifle Shot");
                    ////Buddy.CommonBot.AbilityManager.Cast("Rifle Shot", CT);

                    Thread.Sleep(150);
                    break;

                }
                //Thread.Sleep(250);
                if (WaitForCast()) break;
                if (!IAmInCombat()) break;
            }
            MoveForward(300);
            return IAmInCombat();
        }

        public static bool MarauderAnnihilationCombat()
        {

            //WaitForCast();
            datLCL = DateTime.Now;

            Thread.Sleep(100);
            LoadVars();

            if (IGAndTargetNotInCombat()) return false;

            if (MercCast("Juyo Form", !HaveBuff("Juyo Form"))) return true;
            if (MercCast("Unnatural Might", Me, !HaveBuff("Unnatural Might"))) return true;

            MoveTo(CT, (float)(.490/Math.Min(1,CT.Scale)), "Force Charge", "Deadly Throw", "Dual Saber Throw", "Force Scream");

            if (!IG && BuddyTor.Me.IsMoving) StopMoving();

            //Thread.Sleep(100);
            if (MercCast("Unleash", IAmStunned())) return true;
            if (MercCast("Disruption", TC)) return true;

            if (MercCast("Saber Ward", Me, HP <= 50f)) return true;
            if (MercCast("Undying Rage", Me, HP <= 20f)) return true;
            if (MercCast("Berserk", Me, HaveBuff("Fury") && HP <= 70)) return true;

            if (MercCast("Pommel Strike", CT.IsStunned)) return true;

            if (MercCast("Rupture")) return true;
            if (MercCast("Deadly Saber")) return true;

            if (HP <= 30f) UseMedPackInInventory();

            if (MercCast("Annihilate")) return true;
            if (MercCast("Ravage")) return true;
            if (MercCast("Retaliation")) return true;
            if (MercCast("Force Scream")) return true;
            if (MercCast("Vicious Slash")) return true;
            if (MercCast("Smash", TWR5 >= 2)) return true;
            if (MercCast("Intimidating Roar", TWR5 >= 4)) return true;

            if (HP <= 80f)
            {
                if (MercCast("Frenzy", Me, !HaveBuff("Fury"))) return true;
                if (MercCast("Cloak of Pain", Me)) return true;
                if (MercCast("Obfuscate")) return true;
                if (MercCast("Intimidating Roar")) return true;
                if (MercCast("Deadly Throw")) return true;
                if (MercCast("Force Choke", HP >= 40f)) return true;
            }

            if (MercCast("Bloodthirst", Me)) return true;
            if (MercCast("Smash", TWR5 >= 2)) return true;
            if (MercCast("Force Scream")) return true;
            if (MercCast("Annihilate")) return true;
            if (MercCast("Sweeping Slash", TWR10 >= 4)) return true;
            if (MercCast("Battering Assault")) return true;

            if (MercCast("Vicious Throw", THP <= 30f)) return true;

            if (MercCast("Assault")) return true;

            return false;
        }

        // For Hybrid Trees - Covers It ALL

        public static bool MarauderCombat()
        {
            while (AllowCombat && !PauseBot)
            {
                
                datLCL = DateTime.Now;

                while (true)
                {

                    LoadVars();
                    //Thread.Sleep(450);
                    if (IGAndTargetNotInCombat()) return false;

                    if (MercCast("Unleash", IAmStunned())) break;
                    if (IAmStunned()) { Thread.Sleep(500); break; }

                    if (MercBuffSelf("Ataru Form", MySpec == SkillTreeId.MarauderCarnage)) break;
                    if (MercBuffSelf("Juyo Form", MySpec == SkillTreeId.MarauderAnnihilation)) break;
                    if (MercBuffSelf("Shii-Cho Form", MySpec == SkillTreeId.MarauderRage)) break;

                    if (MercBuffSelf("Unnatural Might")) break;

                    MoveTo(CT, 2.90f);
                    if (MercCast("Force Charge", MovementAllowed && TD>=1.0f)) ChainCastWait();
                    MoveTo(CT, MeleeDist, "Dual Saber Throw", "Deadly Throw", "Predation");

                    //Thread.Sleep(100);

                    if (TC && SoG)
                    {
                        if (MercCast("Disruption")) break;
                        if (MercCast("Intimidating Roar")) break;
                        if (MercCast("Dual Saber Throw")) break; // Force Choke WILL NOT WORK on all Elites (See Oricon)
                        if (MercCastNew("Force Choke")) break;
                        if (MercCast("Smash")) break;
                    }
                    ///HandleDebuffs();

                    if (HP < 70f)
                    {
                        if (HP <= 30f) UseMedPackInInventory();

                        if (MercCastNew("Berserk", Me, FF)) break;
                        if (MercCastNew("Obfuscate")) break;
                        if (MercCastNew("Cloak of Pain")) break;
                        if (MercCastNew("Saber Ward", CT, HP <= 50f)) break;
                        if (MercCastNew("Undying Rage", CT, HP <= 20f)) break;
                        if (MercCastNew("Unity", CT, HP <= 50f && !IG && LastComp != null && !LastComp.IsDead)) break;
                        if (MercCastNew("Frenzy", CT, HP <= 50f)) break;
                    }

                    //UpdateObjects();
                    if (MercCast("Pommel Strike", CT.IsStunned)) break;

                    if (MercCast("Rupture")) break;
                    if (MercCast("Deadly Saber", BuddyTor.Me)) break;
                    //if (MercCast("Berserk")) break;

                    if (TWR5 >= 4)
                    {
                        if (MercCast("Smash")) break;
                        if (MercCast("Sweeping Slash")) break;
                    }

                    if (MercCast("Vicious Throw", THP <= 30f)) break;
                    if (MercCast("Frenzy", Me, !HaveBuff("Fury") && SoG)) break;
                    if (MercCast("Bloodthirst", Me, !IG && FF)) break;


                    if (MercCast("Obliterate")) break;
                    if (MercCast("Annihilate")) break;
                    if (MercCast("Force Scream")) break;
                    if (MercCast("Dual Saber Throw")) break;
                    if (MercCast("Smash", CT, TWR5 >= 2 || SoG)) break;

                    if (MercCast("Ravage", SoG)) break;
                    //if (MercCastNew("Ravage", CT, SoG)) break;
                    if (MercCast("Massacre")) break;
                    if (MercCast("Force Crush")) break;
                    if (MercCast("Gore")) break;
                    if (MercCast("Deadly Throw")) break;
                    if (MercCast("Battering Assault")) break;

                    if (MercCast("Retaliation")) break;
                    if (MercCast("Intimidating Roar", TWR5 >= 4)) break;

                    if (MercCast("Vicious Slash")) break;
                    if (MercCast("Assault")) break;

                    break;
                }
                Thread.Sleep(150);
                if(WaitForCast()) return IAmInCombat();
                if (!IAmInCombat()) break;

            }
            //WaitForCast();
            return IAmInCombat();

        }

        public static void MarauderRageCombat()
        {

            WaitForCast();
            datLCL = DateTime.Now;

            Thread.Sleep(100);
            LoadVars();

            if (MercCast("Shii-Cho Form", !HaveBuff("Shii-Cho Form"))) return;
            if (MercCast("Unnatural Might", !HaveBuff("Unnatural Might"))) return;

            if (MercCast("Unleash", IAmStunned())) return;

            if (MercCast("Saber Ward", HP <= 50f)) return;
            if (MercCast("Undying Rage", HP <= 20f)) return;
            if (MercCast("Berserk", Me, HaveBuff("Fury") && HP <= 70)) return;

            if (MercCast("Predation", Me, MovementAllowed)) return;
            if (MercCast("Bloodthirst", Me, HP > 70)) return;

            if (MercCast("Cloak of Pain", Me)) return;
            if (MercCast("Obfuscate")) return;

            if (IGAndTargetNotInCombat()) return;

            if (TD >= MeleeDist && TD <= 3.0f) if (MercCast("Force Charge")) return;

            MoveTo(CT, MeleeDist, "Force Charge");
            StopMoving();
            //if (!IG) MoveIfNec(.49f);

            if (!IG && BuddyTor.Me.IsMoving) StopMoving();

            //Thread.Sleep(100);
            if (MercCast("Disruption", TC)) return;

            ///HandleDebuffs();

            if (MercCast("Smash", HaveBuff("Dominate") || HaveBuffStacks("Shockwave", 4))) return;
            if (MercCast("Frenzy", Me, !HaveBuff("Fury") && SoG)) return;
            if (MercCast("Force Crush", SoG)) return;
            if (MercCast("Rupture")) return;
            if (MercCast("Intimidating Roar", TWR10 >= 2)) return;

            if (MercCast("Force Choke")) return;
            if (MercCast("Obliterate")) return;
            if (MercCast("Vicious Throw", THP <= 30f)) return;
            if (MercCast("Pommel Strike", CT.IsStunned)) return;

            if (MercCast("Battering Assault")) return;

            //if (MercCast("Annihilate")) return;
            if (MercCast("Force Scream")) return;

            if (MercCast("Deadly Throw")) return;

            if (MercCast("Deadly Saber")) return;
            if (MercCast("Predation", HaveBuff("Fury") && HP < 50) && !HaveBuff("Predation")) return;
            if (MercCast("Bloodthirst", HaveBuff("Fury") && HP > 50) && !HaveBuff("Bloodthirst")) return;

            if (MercCast("Retaliation")) return;
            if (MercCast("Ravage")) return;

            if (MercCast("Deadly Throw")) return;

            if (MercCast("Bloodthirst")) return;

            if (MercCast("Vicious Slash")) return;
            if (MercCast("Assault")) return;

        }

        public static bool ApplyMassDebuff(string theSpell, string theDebuff)
        {
            bool WasCast = false;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                foreach (TorCharacter u in Attackers.Where(u => !u.IsDead && !u.IsStunned && !u.HasDebuff(theDebuff))) if (AbilityManager.CanCast(theSpell, u)) { TargetUnit(u); AbilityManager.Cast(theSpell, u); WasCast = true; break; }
            }
            if (WasCast) ChainCastWait();
            return false;
        }

        public static DateTime lastTF = Now;
        public static bool FQAndTKW()
        {
            if (!AbilsContain("Tidal Force") || DiffInSeconds(lastTF, Now)<=10f) return false;

            bool WasCast = false;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (AbilityManager.CanCast("Forcequake", CT)) { AbilityManager.Cast("Forcequake", CT.Position); WasCast = true;}
            }
            if (WasCast)
            {
                Thread.Sleep(700); UpdateObjects();
                while (IAmCasting() && !HasBuff("Tidal Force", Me)) { Thread.Sleep(1000); UpdateObjects(); }
                UpdateObjects();
                //bool TFAct = false;
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    //if (HasBuff("Tidal Force", Me))
                    {
                        //Input.Move(MovementDirection.Forward);
                        //TFAct = true;
                        lastTF = Now;
                        if (IAmCasting()) SendMessage(SWTORHWnd, (int)0x100, (IntPtr)(char)0x1b, (IntPtr)0);
                        UpdateObjects();
                        Thread.Sleep(300); AbilityManager.Cast("Telekinetic Wave", CT);
                        //Navigator.MovementProvider.MoveTowards(CT.Position);
                        //Navigator.MovementProvider.MoveTowards(CT.Position);
                    }
                }
                return true;
            }
            return false;
            
        }

        public static void FQShort()
        {
            UpdateObjects();
            if (!IAmCasting())
            {
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    AbilityManager.Cast("Forcequake", CT.Position);
                }
                UpdateObjects();
                //if (IAmCasting())
                {
                    Thread.Sleep(3000);
                    SendKey(0x1b);
                    Thread.Sleep(300);
                }
            }
        }

        public static void ChainCastWait()
        {
            Thread.Sleep(400);
            UpdateObjects();
            while (IAmCasting())Thread.Sleep(400);
        }

        public static DateTime lastPP = Now;

        public static bool SageCombat()
        {

            while (AllowCombat && !PauseBot)
            {
                datLCL = DateTime.Now;

                LoadVars();

                while (true)
                {
                    if (MercCast("Force of Will", IAmStunned())) break;
                    if (IAmStunned()) { Thread.Sleep(500); break; }

                    if (MercCast("Noble Sacrifice", Me, HP >= 30f && (FP <= 20f))) break;
                    //if (MercCast("Noble Sacrifice", HP >= 30f && (FP <= 50f || Me.Force <= Me.ForceMax * .50f))) break;

                    if (CT!=null && TC && SoG)
                    {
                        if (MercCast("Force Stun")) break;
                        if (MercCast("Mind Snap")) break;
                        if (MercCast("Force Wave", TD<=1.50f)) break;
                    }

                    if (MercBuffSelf("Force Valor")) ChainCastWait();
                    if (MercBuffSelf("Force Armor", !HaveBuff("Force-imbalance"))) ChainCastWait();
                    if (MercCast("Rejuvenate", Me, !HaveBuff("Rejuvenate"))) ChainCastWait();
                    if (MercCast("Force Potency", (SoG && (!AmHealer() || !IG)) || (AmHealer() && FP <= 30f))) ChainCastWait();
                    if (MercCast("Mental Alacrity", (SoG && (!AmHealer() || !IG)) || (AmHealer() && FP <= 30f))) ChainCastWait();
                    if (MercCast("Force Potency", Me.ForcePercent <= 50f || SoG)) ChainCastWait();
                    if (MercCast("Weaken Mind", SoG && !CTHasDebuff("Weaken Mind"))) ChainCastWait();

                    if (HP <= 70f)
                    {
                        if (HP <= 30f) UseMedPackInInventory();
                        // Following is to try and avoid 'The Healing Black Hole' - get some dmg in before heals
                        bool PreHealsDmgDone = MercCast("Project") || MercCast("Disturbance") || MercCastOnGround("Force in Balance", true, CT) 
                            || MercCast("Telekinetic Wave", HaveBuff("Tidal Force")) || MercCast("Disturbance");
                        ChainCastWait();
                        if (MercCast("Force Mend", Me, HP<=65f)) break;
                        if (MercCast("Unity", !IG && HP <= 50f && !IG && LastComp != null && !LastComp.IsDead)) break;
                        if (MercCast("Healing Trance", Me, HP <= 50f)) ChainCastWait();
                        if (MercCastOnGround("Salvation", HP <= 70f && !HaveBuff("Salvation"), Me)) break;
                        if (MercCast("Cloud Mind")) break;
                        if (MercCast("Mental Alacrity", Me, HP <= 50f)) break;
                        //if (MercForcedCast("Healing Trance", Me, HP <= 50f)) ChainCastWait();
                        if (MercCast("Deliverance", HaveBuffStacks("Concentration", 3) || HasBuff("Mental Alacrity", Me))) break;
                        if (MercCast("Restoration", Me, NeedsDispell(Me))) break;
                        if (MercCast("Benevolence", Me, HP <= 50f)) break;
                        break;
                    }

                    if (IG && AmHealer())
                    {
                        RunHeals(Is55H ? 75f : 70f);
                        //if (MercCastOnGround("Forcequake", MobsInRangeOf(CT, .80f) >= 3, CT)) break;
                        if (MobsInRangeOf(CT, .80f) >= 2 && MercCastOnGround("Forcequake",true, CT)) { ChainCastWait(); break; }
                        if (MercCast("Telekinetic Throw", CT, FP <= 50f)) break;
                        if (MercCast("Project")) break;
                        if (MercCast("Disturbance", MyAbilities.Contains("Concentration") && !HaveBuffStacks("Concentration", 3))) break;
                        if (MercCast("Disturbance")) break;
                        break;
                    }
                    else if (IG && RunHeals(50f)) break;

                    if (!IG) SageCheckCompHealth(AmHealer() ? 70f : 60f);

                    if (IGAndTargetNotInCombat()) { Thread.Sleep(500); return false; }

                    MoveTo(CT, MyLevel < 12 ? MeleeDist : 2.8f, "Force Speed", "Project", "Weaken Mind");
                    StopMoving();

                    //SickCompOnTarget();

                    if (!CTInCombat() && !IAmInCombat() && !IG)
                    {
                        if (AmHealer())
                        {
                            if (MobsInRangeOf(CT, .8f) >= 3 && MercCastOnGround("Forcequake", true, CT)) Thread.Sleep(900);
                            if (!MercCast("Mind Crush", SoG))
                                MercCast("Disturbance");
                        } 
                        else
                        {
                            if (MercCastOnGround("Force in Balance", SoG || MobsInRangeOf(CT, .8F) >= 2, CT)) break;
                            if (MercForcedCast("Telekinetic Wave", CT)) break;
                            if (MercCastOnGround("Forcequake", MobsInRangeOf(CT, .8F) >= 3, CT)) break;
                        }
                    }

                    //UpdateObjects();

                    if (MercFaceAndCast("Force Wave", MovementAllowed && TD <= 1.0f)) break;

                    if (HasBuff("Psychic Projection", Me) && MercCast("Telekinetic Throw")) { Thread.Sleep(300); break; }
                    if (HasBuff("Tidal Force", Me) && MercCast("Telekinetic Wave")) { lastTF = Now; ChainCastWait(); }

                    if (MercCast("Mind Crush", SoG && (HaveBuffStacks("Presence of Mind", 3)))) break;
                    if (HaveBuffStacks("Presence of Mind", 3) && MercCast("Disturbance")) break;
                    if (MercCastOnGround("Force in Balance", true, CT)) break;
                    if (MercCastOnTimer("Sever Force", 18f)) break;
                    if (MercCast("Turbulence", SoG && CTHasDebuff("Weaken Mind"))) break;

                    if (MercCast("Project")) break;

                    if ((SoG || MobsInRangeOf(CT, .80f) >= 3) && FQAndTKW()) break;

                    if (MercCast("Mind Crush", SoG && (HaveBuffStacks("Concentration", 3) || HasBuff("Mental Alacrity", Me)))) break;

                    if (MercCast("Telekinetic Throw", AbilsContain("Presence of Mind") && !HaveBuffStacks("Presence of Mind", 3))) break;
                    if (MercCast("Disturbance",
                        (AbilsContain("Presence of Mind") && HaveBuffStacks("Presence of Mind", 3)) ||
                        (AbilsContain("Concentration") && !HaveBuffStacks("Concentration", 3)) ||
                        (AbilsContain("Telekinetic Focal Point") && HaveBuffStacks("Telekinetic Focal Point", 4))
                        )) break;

                    if (MercCastOnGround("Forcequake", MobsInRangeOf(CT, .80f) >= 4, CT)) break;
                    if (!IG && Attackers.Count() >= 3 && ApplyMassDebuff("Weaken Mind", "Weaken Mind (Force)")) ChainCastWait();

                    if (MercCast("Force Slow", SoG && !CTHasDebuff("Force Slow"))) break;
                    if (MercCast("Mind Crush", !IG && StrongOrGreater(CT) && (HaveBuffStacks("Concentration", 2) || !AbilsContain("Concentration")))) break;
                    if (!IG && Attackers.Count() >= 3) ApplyMassDebuff("Weaken Mind", "Weaken Mind (Force)");

                    if (MercCastOnGround("Forcequake", AmHealer() && MobsInRangeOf(CT, .80f) >= 3, CT)) break;
                    //if (HaveBuff("Tidal Force") || (!IG && !CTInCombat() && !IAmInCombat()) || HaveBuff("Mental Alacrity")) if (MercCast("Telekinetic Wave")) break;
                    if (SoG && AbilsContain("Focused Insight")) if (ApplyDebuff("Weaken Mind") || ApplyDebuff("Force Slow") || ApplyDebuff("Mind Crush")) break;

                    if (MercCastOnGround("Forcequake", MyAbilities.Contains("Tidal Force") && MobsInRangeOf(CT, .80f) >= 3, CT)) break;

                    if (MercCastOnGround("Forcequake", MobsInRangeOf(CT, .80f) >= 3, CT)) break;
                    /*
                                        if (MercCastNew("Telekinetic Throw", CT, FP <= 30f)) ChainCastWait() ;
                                        if (MercCastNew("Disturbance", CT, MyAbilities.Contains("Tidal Force") || !CTInCombat() || HaveBuff("Presence of Mind") ||
                                            (FP <= 50f && MyAbilities.Contains("Concentration") && !HaveBuffStacks("Concentration", 2)))) break;
                                        //if (MercCastOnGround("Forcequake", (MobsInRangeOf(CT, .80f) >= (IG ? 4 : 2)) || (IG && MobsInRangeOf(CT, .80f) >= 6), CT)) break;

                                        if (MercCast("Mind Crush", SoG)) break;
                                        if (MercCast("Force Slow", SoG)) break;

                                        if (MercFaceAndCast("Force Wave", SoG && TD <= MeleeDist)) break;

                                        //if (MercCast("Deliverance", BuddyTor.Me, HP <= 70f)) break;
                                        if (TD <= MeleeDist)
                                        {
                                            if (MercCast("Force Wave", TD <= MeleeDist)) break;
                                            if (MercCast("Tumult")) break;
                                        }
                                        //if (MercCast("Heroic Moment: Channel the Force", Me.HealthPercent <= 30f)) break;

                                        if (MercCastOnGround("Force in Balance", MobsInRangeOf(CT, .80f) >= 2, CT)) break;
                                        if (MercCastOnGround("Forcequake", MobsInRangeOf(CT, .80f) >= (IG?5:3), CT)) break;
                                        if (MercCast("Weaken Mind", !CTHasDebuff("Weaken Mind"))) break;

                                        //if (MercCast("Turbulence", CTHasDebuff("Weaken Mind"))) break;

                                        if (!IG || FP > 30f)
                                        {

                                            //if (MercCast("Force Stun", SoG)) break;
                                            if (MercCast("Force Slow", SoG && !CTHasDebuff("Slowed (Force)"))) break;

                                            if (MercCastNew("Telekinetic Throw")) ChainCastWait();
                                            if (MercCast("Disturbance")) break;
                                        }

                                        if (MercCast("Disturbance", CT)) break;
                                        if (MercCast("Project", CT)) break;
                                        if (MercCast("Telekinetic Throw", CT)) break;
                                        if (MercCast("Double Strike")) break;
                                        if (MercCast("Saber Strike")) break;

                                        if (MercForcedCast("Project", CT)) break;
                                        if (MercForcedCast("Telekinetic Throw", CT)) break;
                    */
                    if (MercCast("Project", CT)) break;
                    if (MercCast("Disturbance", CT)) break;
                    if (MercCast("Telekinetic Throw", CT)) break;
                    if (MercCast("Double Strike")) break;
                    if (MercCast("Saber Strike")) break;

                    //if (MercCastOnGround("Forcequake", true, CT)) break; // This is where the mob is aggressive, but not attackable, SWTOR bug - AOE it
                    if (DiffInSeconds(datLCast, Now) >= 10f) FQShort();
                    break;

                }
                if (WaitForCast()) break;
                Thread.Sleep(150);
                if (!IAmInCombat() && !ValidCombatTarget(CT)) break;
            }

            return IAmInCombat();

        }

        public static void MadnessCombat()
        {

            WaitForCast();
            datLCL = DateTime.Now;

            Thread.Sleep(200);
            LoadVars();
            if (IGAndTargetNotInCombat()) return;

            if (MercCast("Mark of Power", !HaveBuff("Mark of Power"))) return;
            if (!IG) MoveTo(CT, 2.8f, "Force Speed");
            //if (!IG) MoveIfNec(.49f);

            if (!IG && BuddyTor.Me.IsMoving) StopMoving();

            if (MercCast("Unbreakable Will", IAmStunned())) return;

            if (MercCastOnGround("Death Field", HP <= 50 || SoG, CT)) return;

            if (MercCast("Affliction", !CTHasDebuff("Affliction (Force)"))) return;
            if (MercCast("Creeping Terror")) return;

            if (MercCast("Static Barrier", Me, !HaveBuff("Static Barrier"))) return;
            if (MercCast("Unnatural Preservation", Me, HP <= 70f)) return;
            if (MercCast("Dark Heal", Me, HP <= 70f)) return;
            if (MercCast("Dark Infusion", Me, HP <= 70f)) return;
            if (MercCast("Cloud Mind", Me, CTT != CombatToughness.Player && HP <= 70f)) return;

            if (SorcererCheckCompHealth()) return;

            if (MercCast("Recklessness", Me.ForcePercent <= 50f)) return;
            //if (MercCast("Heroic Moment:  Channel the Force", Me.ForcePercent <= 30f)) return;

            if (MercCast("Crushing Darkness", SoG && !CTHasDebuff("Crushing Darkness (Force)"))) return;

            if (MercCast("Consumption", HP > 50 && Me.ForcePercent <= 20)) return;
            //if (RunHeals(75f)) return;

            if (TD <= MeleeDist)
            {
                if (MercCast("Overload", TD <= MeleeDist)) return;
                if (MercCast("Tumult")) return;
                //if (MercCast("Double Strike")) return;
            }

            if (!IG || Me.ForcePercent > 30f)
            {

                if (MercCast("Electrocute", (TC || TD <= .5f) && SoG)) return;

                if (MercCast("Jolt", TC && SoG)) return;
                if (MercCast("Shock", TC && SoG)) return;

                if (MercCastOnGround("Death Field", SoG || TWR30 >= 3, CT)) return;

                if (MercCast("Force Slow", SoG && !CTHasDebuff("Slow (Force)"))) return;

                if (MercCastOnGround("Force Storm", TWR30 >= 3, CT)) return;
                if (MercCast("Force Lightning")) return;

            }

            if (MercCast("Saber Strike")) return;

        }

        public static DateTime lastLS = Now;
        public static bool FSAndCL()
        {
            if (!AbilsContain("Lightning Storm") || CT==null || UnitIsDead(CT) || DiffInSeconds(lastLS, Now) <= 10f) return false;

            bool WasCast = false;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (Buddy.CommonBot.AbilityManager.CanCast("Force Storm", CT)) { Buddy.CommonBot.AbilityManager.Cast("Force Storm", CT.Position); WasCast = true; }
            }
            if (WasCast)
            {
                Thread.Sleep(700); UpdateObjects();
                while (IAmCasting() && !HasBuff("Lightning Storm", Me)) { Thread.Sleep(1000); UpdateObjects(); }
                UpdateObjects();
                //bool TFAct = false;
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    //if (HasBuff("Tidal Force", Me))
                    {
                        //Input.Move(MovementDirection.Forward);
                        //TFAct = true;
                        lastLS = Now;
                        if (IAmCasting()) SendMessage(SWTORHWnd, (int)0x100, (IntPtr)(char)0x1b, (IntPtr)0);
                        UpdateObjects();
                        Thread.Sleep(300); 
                        Buddy.CommonBot.AbilityManager.Cast("Chain Lightning", CT);
                        Buddy.CommonBot.AbilityManager.Cast("Chain Lightning", CT);
                        Logger.Write("Force Storm and Chain Lightning Double-Whammy.  BOOM.");
                        //Navigator.MovementProvider.MoveTowards(CT.Position);
                        //Navigator.MovementProvider.MoveTowards(CT.Position);
                    }
                }
                return true;
            }
            return false;

        }

        public static bool SorcererCombat()
        {
            while (AllowCombat && !PauseBot)
            {
                LoadVars();

                datLCL = DateTime.Now;
                while (true)
                {

                    if (MercCast("Unbreakable Will", IAmStunned())) break;
                    if (IAmStunned()) { Thread.Sleep(300); break; }

                    if (MercCast("Consumption", Me, HP > 25f && (FP <= 25f))) ChainCastWait();
                    if (MercBuffSelf("Mark of Power")) ChainCastWait();
                    if (MercBuffSelf("Static Barrier", !Me.HasDebuff("Deionized"))) ChainCastWait();
                    if (MercCast("Recklessness", Me, FP <= 20f || EliteOrGreater(CT))) ChainCastWait();
                    if (MercCast("Polarity Shift", Me, FP <= 20f || EliteOrGreater(CT))) ChainCastWait();

                    if (MercCast("Force Barrier", Me, HP <= 25f)) ChainCastWait();

                    if (CT!=null && TC && SoG)
                    {
                        if (MercCast("Electrocute")) break;
                        if (MercCast("Jolt")) break;
                        if (MercCast("Overload", TD <= 1.0f)) break;
                        if (MercCast("Creeping Terror")) break;
                    }

                    if (HP <= 70f)
                    {
                        if (MercCast("Shock") || MercCast("Electrocute") || MercCast("Jolt") || MercCast("Lightning Strike")) ChainCastWait();

                        if (HP <= 30f) UseMedPackInInventory();
                        if (MercCast("Cloud Mind", HP <= 60f)) break;
                        if (MercCast("Unnatural Preservation", Me)) break;
                        if (MercCast("Purge", Me, NeedsDispell(Me))) break;
                        if (MercCast("Innervate", Me, HP <= 60f)) break;
                        if (MercCastOnGround("Revivification", true, Me)) break;
                        if (MercCast("Dark Heal", Me, HP <= 70f)) break;
                        //if (MercCast("Dark Infusion", BuddyTor.Me, HP <= 70f)) break;
                    }

                    if (IG)
                    {
                        RunHeals(!AmHealer()?50f:Is55H ? 85f : 75f);
                        if (AmHealer())
                        { 
                            if (MercCast("Shock")) break;
                            if (MercCast("Crushing Darkness", SoG)) break;
                            if (ApplyMassDebuff("Affliction", "Affliction (Force)")) ChainCastWait();
                            if (MercCastOnGround("Force Storm", MobsInRangeOf(CT, .80f) >= 3, CT)) break;
                            if (MercCast("Force Lightning")) break;
                        }                    } 
                    else
                        if (SorcererCheckCompHealth(AmHealer() ? 60f : 50f)) break;

                    if (IGAndTargetNotInCombat()) return false;
                    MoveTo(CT, MyLevel < 10 ? MeleeDist : 2.90f, "Force Speed");

                    if (!CT.InCombat)
                    { 
                        bool PullDone = 
                            MercCast("Thundering Blast") || MercCast("Chain Lightning") || MercCast("Death Field") || MercCast("Shock") || MercCastOnGround("Force Storm",true,CT) ||MercCast("Force Lightning");
                        ChainCastWait();
                    }

                    if (TD <= MeleeDist)
                    {
                        if (MercCast("Overload", TD <= MeleeDist)) break;
                        if (MercCast("Tumult")) break;
                    }

                    if ((MobsInRangeOf(CT, .80f) >= 3) && FSAndCL()) break;
                    //if (MercCastOnGround("Force Storm", MobsInRangeOf(CT, .80f) >= 3, CT)) break;

                    if (MercCastOnTimer("Creeping Terror", 18f, SoG)) break;
                    if (MercCastOnTimer("Affliction", 18f, !CTHasDebuff("Affliction"))) break;

                    if (MercCast("Force Slow", SoG && !CTHasDebuff("Slow"))) break;

                    if (MercCastOnGround("Death Field", SoG || MobsInRangeOf(CT, .80f) >= 2, CT)) break;
                    if (MercCast("Force Lightning", HaveBuff("Lightning Barrage"))) break;
                    if (MercCast("Chain Lightning", HaveBuff("Lightning Storm"))) { lastLS = Now; break; }
                    if (MercCast("Crushing Darkness", SoG && (HaveBuffStacks("Wrath", 3) || HaveBuff("Polarity Shift")))) break;

                    if (MercCast("Shock")) break;
                    if (MercCastOnGround("Force Storm", MobsInRangeOf(CT, .80f) >= 3, CT)) break;

                    if (MercCast("Lightning Strike", (AbilsContain("Lightning Storm") && !HaveBuff("Lightning Storm")) || (AbilsContain("Subversion") && !HaveBuffStacks("Subversion", 3)))) break;
                    if (MercCast("Thundering Blast", SoG && CTHasDebuff("Affliction"))) break;

                    if (MercCast("Chain Lightning", HaveBuff("Polarity Shift") || MobsInRangeOf(CT, .80f) >= 4)) break;

                    if (MercCast("Crushing Darkness", SoG && !CTHasDebuff("Crushing Darkness (Force)"))) break;
                    if (MercCast("Force Lightning", FP <= 30f)) break;

                    if (MercCast("Force Lightning", AmHealer() || (MyAbilities.Contains("Wrath") && SoG && !HaveBuff("Wrath")))) break;

                    if (MercCast("Shock", CT)) break;
                    //if (MercCast("Force Lightning", CT)) break;

                    if (MercCast("Saber Strike")) break;

                    break;
                }
                Thread.Sleep(150);
                if (WaitForCast()) return IAmInCombat();
                if (!IAmInCombat()) break;
            }
            //WaitForCast();
            return IAmInCombat();

        }

        public static bool CorruptionCombat()
        {
            try
            {
                WaitForCast();
                datLCL = DateTime.Now;

                Thread.Sleep(200);
                LoadVars();

                if (MercCast("Mark of Power", Me, !HaveBuff("Mark of Power"))) return true;

                if (!IG && BuddyTor.Me.IsMoving) StopMoving();

                if (MercCast("Unbreakable Will", IAmStunned())) return true;

                if (MercCast("Static Barrier", Me, !HaveBuff("Static Barrier"))) return true;

                if (MercCast("Force Barrier", Me, HP <= 30f)) return true;
                if (MercCast("Resurgence", Me, !HaveBuff("Resurgence") && HP <= 70f)) return true;
                if (MercCast("Unnatural Preservation", Me, HP <= 70f)) return true;
                if (MercCastOnGround("Revivification", HP <= 70f, Me)) return true;
                if (MercCast("Dark Heal", Me, HP <= 70f)) return true;
                if (MercCast("Dark Infusion", Me, HP <= 70f)) return true;
                if (MercCast("Purge", Me, Me.Debuffs.Count() >= 3)) return true;

                if (!IG) if (SorcererCheckCompHealth()) return true;
                if (IG && AmHealer()) if (RunHeals(85f)) return true;

                if (IGAndTargetNotInCombat()) return false;

                MoveTo(CT, 2.8f); ;

                if (MercCast("Electrocute", TC && SoG)) return true;
                if (MercCast("Jolt", TC && SoG)) return true;
                if (MercCast("Shock", TC && SoG)) return true;

                if (MercCast("Consumption", HP > 50 && Me.ForcePercent <= 20)) return true;

                if (MercFaceAndCast("Overload", TD <= MeleeDist)) return true;
                if (MercCast("Tumult", TD <= MeleeDist)) return true;

                if (!IG || !AmHealer() || Me.ForcePercent > 30f)
                {

                    if (MercCast("Cloud Mind", CTT != CombatToughness.Player && HP <= 70f)) return true;
                    if (MercCast("Recklessness", Me, !IG && SoG)) return true;

                    if (MercCastOnGround("Death Field", MobsInRangeOf(CT, .8f) >= 4, CT)) return true;
                    if (MercCastOnGround("Force Storm", MobsInRangeOf(CT, .80f) >= 4, CT)) return true;
                    if (MercCast("Chain Lightning", MobsInRangeOf(CT, .8f) >= 4)) return true;

                    if (MercCast("Recklessness", Me.ForcePercent <= 50f)) return true;
                    //if (MercCast("Heroic Moment: Channel the Force", Me.ForcePercent <= 30f)) return true;

                    if (MercCast("Creeping Terror", SoG && !CTHasDebuff("Creeping Terror"))) return true;
                    if (MercCast("Shock")) return true;

                    if (MercCast("Lightning Strike", HaveBuff("Wrath"))) return true;
                    if (MercCast("Force Lightning")) return true;

                    if (MercCast("Crushing Darkness", SoG && !CTHasDebuff("Crushing Darkness (Force)"))) return true;
                    if (MercCast("Affliction", !CTHasDebuff("Affliction"))) return true;
                    if (MercCast("Force Slow", SoG && !CTHasDebuff("Slow (Force)"))) return true;
                }

                //if (!IG) foreach (TorCharacter u in Attackers) if (MercCast("Affliction", u, !u.HasDebuff("Affliction (Force)"))) Thread.Sleep(400);

                if (MercCast("Thrash", TD <= MeleeDist)) return true;
                if (MercCast("Saber Strike", TD <= MeleeDist)) return true;
                if (MercCast("Lightning Strike")) return true;
                //Buddy.CommonBot.AbilityManager.Cast("Force Lightning", CT);   // Forced Cast - CanCast gets just a little flaky
            }
            catch { }
            return false;
        }

        public static void CorruptionCombatPvP()
        { // Tried and tried on this - BW seems just about uselesss with it due to all of the bugs and hangs.....  With PVP.
                try
                {
                    Thread.Sleep(300);

                    IG = true;

                    if (Me.IsDead || Me.HealthPercent < .2f) return;

                    WaitForCast();
                    datLCL = DateTime.Now;

                    CT = MyTarget();
                    if (CT == null) return;
                    TD = (float) CT.Distance;
                    HP = (float) Me.HealthPercent;
                    RS = Me.ResourceStat;

                    if (TD >= 3.0f) return;

                    MyBuffs = "";
                    foreach (TorEffect te in Me.Buffs) MyBuffs += te.Name + ";";
                    CTDebuffs = "";
                    if (CT != null) foreach (TorEffect te in CT.Debuffs) CTDebuffs += te.Name + ";";

                    MySpec = SkillTreeId.SorcererCorruption;

                    if (TD <= MeleeDist)
                    {
                        if (MercCast("Overload", TD <= MeleeDist)) return;
                        if (MercCast("Tumult")) return;
                        if (MercCast("Electrocute")) return;
                    }

                    if (MercCast("Mark of Power", !HaveBuff("Mark of Power"))) return;
                    if (!IG) MoveTo(CT, 2.8f, "Force Speed");

                    if (!IG && BuddyTor.Me.IsMoving) StopMoving();
                    if (MercCast("Static Barrier", Me, !HaveBuff("Static Barrier"))) return;

                    if (MercCast("Unbreakable Will", IAmStunned())) return;

                    if (MercCast("Unnatural Preservation", Me, HP <= 70f)) return;
                    if (MercCast("Resurgence", Me, HaveBuff("Resurgence") && HP <= 70f)) return;
                    if (MercCast("Dark Infusion", Me, HP <= 70f)) return;
                    if (MercCast("Dark Heal", Me, HP <= 70f)) return;

                    if (RunHeals(80f)) return;

                    if (MercCast("Recklessness", Me, !IG && SoG)) return;

                    if (MercCast("Recklessness", Me.ForcePercent <= 50f)) return;
                    //if (MercCast("Heroic Moment: Channel the Force", Me.ForcePercent <= 30f)) return;

                    if (MercCast("Consumption", HP > 50 && Me.ForcePercent <= 20)) return;

                    if (TD <= MeleeDist)
                    {
                        if (MercCast("Overload", TD <= MeleeDist)) return;
                        if (MercCast("Tumult")) return;
                    }

                    if (!IG || Me.ForcePercent > 30f)
                    {

                        if (MercCast("Electrocute", (TC || TD <= .5f) && SoG)) return;
                        if (MercCast("Jolt", TC && SoG)) return;

                        if (MercCast("Affliction", !CTHasDebuff("Affliction"))) return;
                        if (MercCast("Shock")) return;

                        if (MercCast("Force Slow", SoG && !CTHasDebuff("Slow (Force)"))) return;
                    }
                    if (MercCast("Force Lightning")) return;

                    if (MercCast("Thrash", TD <= MeleeDist)) return;
                    if (MercCast("Saber Strike", TD <= MeleeDist)) return;
                }
                catch { }
                if (DateTime.Now.Subtract(datLCs).TotalSeconds >= 4) MercForcedCast("Lightning Strike", CT);
        }

        public static bool WatchmanCombatPvP()
        {
            try
            {
                CheckGC();
                Thread.Sleep(150);
                if (IAmDead()) { ClearTarget(); return false; }

                var x = MyTarget();
                if (x == null) return false;
                //x = (TorCharacter)x;
                //WaitForCast();

                if (MercCastX("Force Leap", x)) return true;
                if (MercCastX("Crippling Throw", x)) return true;

                while (x.Distance >= MeleeDist || !x.InLineOfSight) {
                    if (IAmDead()) return false;
                    Buddy.Swtor.Input.MoveTo(MyTarget().Position); 
                    Thread.Sleep(150); 
                    MercCastX("Force Leap", x);
                    MercCastX("Crippling Throw", x); 
                }
                //Buddy.Navigation.Navigator.MoveTo(x.Position);
                x.Face();
                CT = x;
                double HPx = Me.HealthPercent;
                
                MercBuffSelf("Juyo Form");

                if (MercCastX("Resolute", Me, IAmStunned())) return true;

                if (MercCastX("Guarded by the Force", Me, HPx <= 20f)) return true;
                if (MercCastX("Saber Ward", Me, HPx <= 50f)) return true;
                if (MercCastX("Zen", BuddyTor.Me, HPx <= 80f)) return true;
                if (MercCastX("Inspiration", Me, HPx <= 70f)) return true;
                if (MercCastX("Rebuke", Me, HPx <= 70f)) return true;

                if (MercCastX("Zen", BuddyTor.Me)) return true;
                if (MercCastX("Transcendence", BuddyTor.Me)) return true;
                if (MercCastX("Cauterize", x)) return true;
                if (MercCastX("Overload Saber", x)) return true;
                if (MercCastX("Force Kick", x)) return true;
                if (MercCastX("Zealous Strike", x)) return true;
                if (MercCastX("Force Stasis", x)) return true;
                if (MercCastX("Blade Storm", x)) return true;
                if (MercCastX("Pacify", x)) return true;
                if (MercCastX("Cyclone Slash", x)) return true;
                if (MercCastX("Slash", x)) return true;
                if (MercCastX("Riposte", x)) return true;
                if (MercCastX("Strike", x)) return true;

                //if (Buddy.CommonBot.AbilityManager.CanCast("Force Leap", x)) { Buddy.CommonBot.AbilityManager.Cast("Force Leap", x); Thread.Sleep(700); return true; }
                //if (Buddy.CommonBot.AbilityManager.CanCast("Cauterize", x)) { Buddy.CommonBot.AbilityManager.Cast("Cauterize", x); Thread.Sleep(700); return true; }
                //if (Buddy.CommonBot.AbilityManager.CanCast("Force Kick", x)) { Buddy.CommonBot.AbilityManager.Cast("Force Kick", x); Thread.Sleep(700); return true; }
                //if (Buddy.CommonBot.AbilityManager.CanCast("Zealous Strike", x)) { Buddy.CommonBot.AbilityManager.Cast("Zealous Strike", x); Thread.Sleep(700); return true; }
                //if (Buddy.CommonBot.AbilityManager.CanCast("Riposte", x)) { Buddy.CommonBot.AbilityManager.Cast("Riposte", x); Thread.Sleep(700); return true; }
                //if (Buddy.CommonBot.AbilityManager.CanCast("Strike", x)) { Buddy.CommonBot.AbilityManager.Cast("Strike", x); Thread.Sleep(700); return true; }
            }
            catch { }
            return false;
        }

        public static bool BGCombatPvP()
        {
            try
            {
                //CheckGC();
                //Thread.Sleep(150);
                while (true)
                {
                    while (true)
                    {
                        if (!IAmInCombat()) { Thread.Sleep(1000); }
                        TorCharacter x = null;
                        TorPlayer CTTM = null;
                        UpdateObjects();
                        using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                        {
                            try
                            {
                                var ctx = MyTarget();
                                if (ctx!=null && (ctx.Distance>2.9f || !ctx.InLineOfSight)) ClearTarget();
                                if (Me.IsDead) { ClearTarget(); Thread.Sleep(300); return false; }
                                var Attackers=ObjectManager.GetObjects<TorPlayer>().OrderBy(t => t.Distance).Where(t => t.IsHostile && t.cbtFaction != Me.cbtFaction && t.InLineOfSight && t.Distance <= 2.9f);
                                foreach (TorPlayer xp in Attackers.Where(t=>t.CurrentTarget==Me)) { CTTM = xp; break; }
                                if (CTTM==null)foreach (TorPlayer xp in Attackers) { x = xp; break; }
                                //x = MyTarget();
                                MyBuffs = "";
                                foreach (TorEffect te in Me.Buffs) if (te != null) MyBuffs += te.Name + ';';
                                //if (x == null) return false;
                                if (CTTM != null) { TargetUnit(CTTM); CT = CTTM; CT.Face(); }
                                else if (CT != null) { CT = x; TargetUnit((TorNpc)CT); CT.Face(); }
                                TD = 100;
                                if (x != null) TD = MyTarget().Distance;
                                RS = Me.ResourceStat;
                                HP = Me.HealthPercent;

                                CT = x;
                                //HP = BuddyTor.Me.HealthPercent;
                                //double HPx = Me.HealthPercent;
                            }
                            catch { return false; }
                        }

                        while (CT != null && MovementAllowed && (x.Distance >= 2.8f || !x.InLineOfSight))
                        {
                            Buddy.Swtor.Input.MoveTo(MyTarget().Position);
                            Thread.Sleep(150);
                        }

                        if (MercCastX("Determination", IAmStunned())) break;

                        //if (MercCastX("Kolto Overload", Me, HP <= 35f)) 
                        ////if (MercCastX("Kolto Shell", BuddyTor.Me, !HaveBuff("Kolto Shell") && HP <= 85f)) 
                        //if (MercCastOnGround("Kolto Missile", HP < 60f, Me)) 
                        //if (MercCastX("Emergency Scan", Me, HP <= 70)) 
                        //if (MercCastX("Rapid Scan", Me, HP <= 70)) 
                        //if (MercCastX("Energy Shield", Me, HP <= 60f)) 

                        if (TD > .05f && TD <= .8f)
                        {
                            if (MercCastX("Jet Boost", TD <= .8f)) break;
                            if (MercCastX("Shoulder Slam", TD <= .8f)) break;
                            if (MercCastX("Rocket Punch", TD <= .8f)) break;
                            if (MercCastX("Elactro Dart", TD <= .8f)) break;
                            if (MercCastX("Vent Heat", RS <= 20)) break;
                        }

                        if (CTTM != null)
                        {
                            if (MercCastNew("Rail Shot", MyTarget())) break;
                            if (MercCastNew("Unload", MyTarget())) break;
                            AbilityManager.Cast("Sweeping Blasters", CT.Position);
                            WaitForCast();
                        }

                        RunHeals(70f);
                        AbilityManager.Cast("Sweeping Blasters", MyTarget().Position);
                        WaitForCast();
                        AbilityManager.Cast("Explosive Dart", MyTarget());
                        WaitForCast();
                        AbilityManager.Cast("Rapid Shots", CT.Position);
                        WaitForCast();

                        if (MercCastNew("Rapid Shots", MyTarget())) break;
                        Thread.Sleep(300);
                        if (MercCastNew("Explosive Dart", MyTarget())) break;

                        if (CT == null) return false;
                        if (MercCastOnGround("Death from Above", TD >= .6f && RS >= 80f, CT)) break;
                        if (MercCastOnGround("Sweeping Blasters", true, CT)) break;
                        //if (MercCastOnGround("Sweeping Blasters", EnemyPlayersInRangeOf(CT.Position, .80f) >= 3, CT)) 

                        if (MercCastX("Emergency Scan", HP < 70f)) break;

                        if (IGAndTargetNotInCombat()) break;

                        if (MercCastX("Power Shot", HaveBuff("Power Surge"))) break;
                        if (MercCastX("Disabling Shot", TC)) break;
                        if (MercCastX("Electro Dart", TC)) break;
                        if (MercCastX("Neural Dart", TC || SoG)) break;

                        if (MercFaceAndCast("Flame Thrower", TD <= 1.0f)) break;
                        if (MercFaceAndCast("Flame Burst", TD <= 1.0f && RS >= 50f)) break;

                        if (MercCastX("Hunter's Boon", !HaveBuff("Hunter's Boon"))) break;
                        if (MercCastX("Heroic Moment: On the Trail", HP <= 50f)) break;
                        if (MercCastX("Power Surge", true)) break;

                        if (MercCastX("Thermal Sensor Override", RS <= 30f)) break;
                        if (Comp != null) if (MercCastX("Chaff Flare", HP <= 70f)) break;
                        if (MercCastX("Supercharged Gas", HaveBuff("Supercharged Gas"))) break;

                        if (!IG || (IG && RS >= 40f))
                        {
                            if (MercCastX("Explosive Dart", SoG)) break;
                            if (MercCastX("Rapid Shots", HP < 70 && RS >= 30)) break;

                            if (MercCastX("Unload", true)) break;
                            if (MercCastX("Rail Shot", true)) break;

                            if (UseAOE)
                            {
                                if (MercCastX("Fusion Missile", true)) break;
                                if (MercCastX("Explosive Dart", true)) break;
                                if (MercCastX("Missile Blast", (TD <= .8f && !SoG) || RS >= 50f)) break;
                                //if (CTT == CombatToughness.Player) MercCastOnGround("Sweeping Blasters", TD >= .1f && RS >= 35, CT);
                            }

                            if (MercFaceAndCast("Flame Burst", TD <= 1.0f && RS >= 65f)) break;
                        }
                        if (MercCastX("Rapid Shots", true)) break;
                    }
                }
            }
            catch { return false; }
            //Thread.Sleep(300);
        }

        public static bool SageCombatPvP()
        {
            try
            {
                CheckGC();
                Thread.Sleep(150);
                if (IAmDead()) { ClearTarget(); return false; }
                GetEffects();

                var x = MyTarget();

                //RunHeals(70f);

                if (x == null) return false;
                CT = x;
                TD = x.Distance;
                RS = Me.ResourceStat;
                TC = x.IsCasting;
                while (x.Distance >= 2.8f || !x.InLineOfSight)
                {
                    if (IAmDead()) return false;
                    Buddy.Swtor.Input.MoveTo(MyTarget().Position);
                    Thread.Sleep(150);
                }

                x.Face();
                CT = x;
                float HP = BuddyTor.Me.HealthPercent;
                double HPx = Me.HealthPercent;

                if (MercCastX("Force of Will", IAmStunned())) return true;
                if (MercCastX("Force Potency", HP <= 50f)) return true;
                if (HP <= 30f) UseMedPackInInventory();

                HandleDebuffs();

                    if (MercCastX("Force Stun", TC)) return true;
                    if (MercCastX("Mind Snap", TC)) return true;
                    if (MercCastX("Mental Alacrity", RS<=30f)) return true;

                if (MercBuffSelf("Force Armor")) return true;

                if (HP <= 70f)
                {

                    if (MercCastX("Restoration", NeedsDispell(Me))
                        || MercCastOnGround("Salvation", HP <= 50f && !HaveBuff("Salvation"), Me)
                        || MercCastX("Cloud Mind", HP <= 70f)
                        || MercCastX("Force Mend", HP <= 70f)
                        || MercCastX("Rejuvenate", HP <= 70f && !HaveBuff("Rejuvenate"))
                        || MercCastX("Mental Alacrity", HP <= 50f)
                        || MercCastX("Benevolence", HP <= 50f)) { Thread.Sleep(600); MercCast("Project"); return true; }
                }

                //if (IG && MySpec == SkillTreeId.SageSeer) { if (RunHeals(85f)) return true; } else if (RunHeals(70f)) return true;
                //if (!IG && SageCheckCompHealth()) return true;

                if (MercCastX("Telekinetic Throw", HaveBuff("Psychic Projection"))) return true;
                if (MercCastX("Telekinetic Wave", HaveBuff("Tidal Force"))) return true;
                if (MercCastOnGround("Force in Balance", MobsInRangeOf(CT, .80f) >= 2, CT)) return true;
                if (MercCastX("Project",true)) return true;
                if (MercCastOnGround("Forcequake", MyAbilities.Contains("Tidal Force") && MobsInRangeOf(CT, .80f) >= 4, CT)) return true;
                if (MercCastX("Disturbance", MyAbilities.Contains("Tidal Force") || !CT.InCombat || HaveBuff("Presence of Mind"))) return true;

                if (!CT.InCombat)
                {
                    //if (MercCast("Mind Crush")) Thread.Sleep(500);
                    if (MercCast("Disturbance")) Thread.Sleep(500);
                }
                if (MercFaceAndCast("Force Wave", TD <= MeleeDist)) return true;

                //if (MercCast("Deliverance", BuddyTor.Me, HP <= 70f)) return true;
                if (TD <= MeleeDist)
                {
                    if (MercCastX("Force Wave", TD <= MeleeDist)) return true;
                    if (MercCastX("Tumult",true)) return true;
                }

                //if (MercCast("Heroic Moment: Channel the Force", Me.HealthPercent <= 30f)) return true;

                if (MercCastX("Force Potency", Me.ForcePercent <= 50f || SoG)) return true;
                if (MercCastOnGround("Force in Balance", MobsInRangeOf(CT, .80f) >= 2, CT)) return true;
                if (MercCastOnGround("Forcequake", (!IG && MobsInRangeOf(CT, .80f) >= 3) || (IG && MobsInRangeOf(CT, .80f) >= 6), CT)) return true;

                //if (MercCast("Turbulence", CTHasDebuff("Weaken Mind"))) return true;

                if (MercCastX("Noble Sacrifice", HP >= 50 && RS <= Me.ForceMax * .2f)) return true;
                if (MercCastX("Mind Crush", SoG)) return true;

                if (!IG || Me.ForcePercent > 30f)
                {

                    if (MercCastX("Weaken Mind", !CTHasDebuff("Weaken Mind (Force)"))) return true;
                    //if (MercCast("Force Stun", SoG)) return true;
                    if (MercCastX("Force Slow", !CTHasDebuff("Slowed (Force)"))) return true;

                    if (MercCastX("Telekinetic Throw",true)) return true;
                    if (MercCastX("Disturbance",true)) return true;
                    if (MercCastOnGround("Forcequake", MobsInRangeOf(CT, .80f) >= 3, CT)) return true;
                }

                //if (!IG) foreach (TorCharacter u in Attackers) if (MercCast("Weaken Mind", u, !u.HasDebuff("Weaken Mind (Force)"))) WaitForCast();
                if (MercCastX("Double Strike",true)) return true;
                if (MercCastX("Saber Strike", true)) return true;

            }
            catch { }
            return false;
        }

        public static bool WatchmanCombat()
        {   
            WaitForCast();
            datLCL = DateTime.Now;

            Thread.Sleep(100);
            LoadVars();

            if (IGAndTargetNotInCombat())
            {
                Logger.Write("Target not in combat, exiting.");
                return false;
            }

            if (MercCast("Crippling Throw", TD >= 1.0f && TD <= 3.0f)) return true;
            if (MercCast("Dual Saber Throw", TD >= 1.0f && TD <= 3.0f)) return true;
            MoveTo(CT, .490f, "Force Leap", "Transcendence");

            if (MercCast("Resolute", Me, IAmStunned())) return true;

            if (HP <= 30f) UseMedPackInInventory();
            
            MercBuffSelf("Juyo Form");

            if (MercCast("Pacify", TC && SoG)) return true;
            if (MercCast("Force Kick", TC && SoG)) return true;
            if (MercCast("Force Stasis", TC && SoG)) return true;

            if (MercCast("Guarded by the Force", HP <= 20f)) return true;
            if (MercCast("Saber Ward", HP <= 50f)) return true;
            if (MercCast("Inspiration", HP <= 70f)) return true;
            if (MercCast("Rebuke", HP <= 70f)) return true;

            if (MercCast("Zen", BuddyTor.Me)) return true;
            if (MercCast("Transcendence", BuddyTor.Me)) return true;

            if (MercCast("Overload Saber")) return true;

            if (MercCast("Dispatch", THP <= 30f)) return true;
            if (MercCast("Master Strike", SoG && THP >= 30f)) return true;
            if (MercCast("Blade Storm", TWR10 >= 2 || SoG)) return true;
            if (MercCast("Riposte")) return true;
            if (MercCast("Merciless Slash", SoG && THP >= 30f)) return true;
            if (MercCast("Slash")) return true;
            if (MercCast("Zealous Strike")) return true;

            if (MercCast("Cauterize")) return true;

            if (MercCast("Force Sweep", TWR5 >= 2)) return true;
            if (MercCast("Cyclone Slash", TWR5 >= 2)) return true;



            if (MercCast("Crippling Throw", SoG && HP <= 80f)) return true;
            if (MercCast("Leg Slash", SoG && HP <= 80f)) return true;

            if (MercCast("Rebuke")) return true;
            if (MercCast("Strike")) return true;

            return false;
        }

        public static void CheckCompGuard()
        {
            // May Spam 'Unknown Effect Result' and go buck-wild trying to guard, and failing - so I put it on a timer
            if (DateTime.Now.Subtract(LastGuardCheck).TotalSeconds < 10 || !IAmInCombat() || !AmTank || IG) return;

            //if (MySpec == SkillTreeId.GuardianDefense && !IG)
                bool GuardCast=false;
                TorCharacter LastCompX = null;
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    try {
                        if (LastComp != null && !LastComp.HasBuff("Guard") && !LastComp.IsDead )
                        {
                            LastCompX = (TorCharacter)LastComp;
                            GuardCast = true;
                            LastGuardCheck = DateTime.Now;
                            //ClearTarget();
                        }
                    }
                    catch { };
                }
            if (GuardCast)
            {
                TargetUnit(LastCompX); Thread.Sleep(500);
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    AbilityManager.Cast("Guard", LastCompX);
                    AbilityManager.Cast("Guard", LastCompX);
                }
                ClearTarget();
                ChainCastWait();
            }
        }

        public static bool GuardianCombat()
        {
            while (true)
            {
                LoadVars();

                while (AllowCombat && !PauseBot)
                {
                    datLCL = DateTime.Now;
                    //CT = MyTarget();

                    if (MercCast("Resolute", Me, IAmStunned())) break;
                    if (IAmStunned()) { Thread.Sleep(500); break; }

                    if (MercBuffSelf("Soresu Form", MySpec == SkillTreeId.GuardianDefense)) break;
                    if (MercBuffSelf("Shien Form", MySpec == SkillTreeId.GuardianVigilance)) break;
                    if (MercBuffSelf("Shii-Cho", MySpec == SkillTreeId.GuardianFocus)) break;

                    if (MercBuffSelf("Force Might")) break;

                    if (IGAndTargetNotInCombat()) return false;

                    //TC = CT.IsCasting;
                    //TD = CT.Distance;
                    //HP = Me.HealthPercent;

                    //if (TD >= 1.0f && TD <= 3.0f)
                    //{
                    //    if (MercCast("Force Leap")) break;
                    //    if (MercCast("Saber Throw")) break;
                    //    if (MercCast("Guardian Leap", MySpec == SkillTreeId.GuardianDefense)) break;
                    //    if (MercCast("Taunt")) break;
                    //}

                    MoveTo(CT, 2.90f);
                    if (MercCast("Force Leap", MovementAllowed && TD >= 1.0f)) break;
                    MoveTo(CT, MeleeDist, "Saber Throw", "Blade Storm", "Dispatch", "Force Leap");
                    //MoveTo(CT, .490f, "Force Leap", "Crippling Throw", "Saber Throw");

                    if (TC && SoG)
                    {
                        if (MercCast("Zealous Leap", TD <= 1.0f)) break;
                        if (MercCast("Force Push")) break;
                        if (MercCast("Hilt Strike", TD <= .50f)) break;
                        if (MercCast("Pacify")) break;
                        if (MercCast("Force Kick")) break;
                        if (MercCast("Force Stasis")) break;
                    }

                    if (!IG && AmTank) CheckCompGuard();

                    if (HP < 70f)
                    {
                        if (HP <= 30f) UseMedPackInInventory();

                        // Removed breaks for the time being, something showing as cast below, but not casting, and causing a 'loop'/hang, would never continue
                        if (MercCast("Focused Defense", HP < (!AmTank ? 70f : 50f))) break;
                        if (MercCast("Challenging Call", HP<=60f && !AmTank)) break;
                        if (MercCast("Warding Call", HP <= 50f)) break;
                        if (MercCast("Enure", HP <= 60f)) break;
                        if (MercCast("Guarded by the Force", HP <= 20f)) break;
                        if (MercCast("Saber Ward", HP <= 50f)) break;
                        if (MercCast("Inspiration", HP <= 70f)) break;
                        if (MercCast("Rebuke", HP <= 70f)) break;
                        if (MercCast("Combat Focus", HP <= 70f)) break;
                        if (MercCast("Unity", Me, !IG && Comp != null && !Comp.IsDead)) break;
                        if (MercCast("Zen", Me)) break;
                        if (MercCast("Transcendence", Me)) break;
                    }

                    if (IG) HandleGuarding();

                    //if (MercCast("Taunt", IG && SoG && AmTank)) break;  // Reserved for HandleGuarding() Use
                    if (MercCast("Sundering Strike", !CTHasDebuff("Armor Reduced"))) break;

                    if (MercCast("Challenging Call", AmTank)) break;
                    if (MercCast("Hilt Strike", AmTank)) break; // Threat-Gen since Guardian threat is so horribly bad
                    if (MercCast("Guardian Slash")) break;

                    if (MercCast("Dispatch", THP <= 30f || HaveBuff("Keening"))) break;

                    if (MercCast("Plasma Brand")) break;
                    if (MercCast("Force Exhaustion", SoG || THP >= 75f)) break;

                    if (MercCast("Overhead Slash", SoG || THP >= 75f)) break;
                    if (MercCast("Master Strike", SoG)) break;
                    if (MercCast("Saber Throw", !AmTank || !IG)) break;
                    if (MercCast("Cyclone Slash", TWR5 >= 2)) break;
                    if (MercCast("Blade Storm")) break;
                    if (MercCast("Force Sweep", TWR5 >= 2 && AbilsContain("Effluence"))) break;

                    if (MercCast("Zealous Leap")) break;
                    if (MercCast("Riposte")) break;

                    if (MercCast("Force Sweep", TWR5 >= 4)) break;

                    if (MercCast("Crippling Throw", SoG && HP <= 80f)) break;
                    if (MercCast("Leg Slash", SoG && HP <= 80f)) break;
                    if (MercCast("Master Strike", SoG)) { Thread.Sleep(500); WaitForCast(); break; }

                    if (MercCast("Overload Saber")) break;
                    if (MercCast("Merciless Slash", SoG && THP >= 30f)) break;
                    //if (MercCast("Master Strike", SoG && THP >= 30f)) break;

                    if (MercCast("Cauterize")) break;
                    if (MercCast("Zealous Strike")) break;

                    if (MercCast("Riposte")) break;
                    if (MercCast("Rebuke")) break;

                    if (MercCast("Slash")) break;
                    if (MercCast("Strike")) break;

                    if (MercCast("Cyclone Slash", TD <= .60f)) break; // This is for when you're running into a hostile, but NON-ATTACKABLE mob (I just LOVE that bullshit) - more of an 'AOE Strike'

                    break;

                }
                Thread.Sleep(150);
                if (WaitForCast()) return IAmInCombat();
                if (!IAmInCombat()) break;
            }
                return IAmInCombat();

        }

        public static bool FocusCombat()
        {

            WaitForCast();
            datLCL = DateTime.Now;

            Thread.Sleep(100);
            LoadVars();
            if (Attackers == null || Attackers.Count() == 0) return false;

            if (MercCast("Shii-Cho Form", !HaveBuff("Shii-Cho Form"))) return true;
            if (MercCast("Force Might", !HaveBuff("Force Might"))) return true;

            if (IGAndTargetNotInCombat()) return false;

            if (MercCast("Crippling Throw", TD >= 1.0f && TD <= 3.0f)) return true;
            if (MercCast("Zealous Leap", Me, TD <= 1.0f)) return true;
            if (MercCast("Transcendence", Me, TD >= 1.0f)) return true;
            if (MercCast("Zealous Leap", TD <= 1.0f)) return true;

            MoveTo(CT, .490f, "Force Leap");

            if (!IG && BuddyTor.Me.IsMoving) StopMoving();

            if (MercCast("Resolute", Me, IAmStunned())) return true;


            if (HP <= 30) UseMedPackInInventory();
            if (MercCast("Guarded by the Force", Me, HP <= 20f)) return true;
            if (MercCast("Zen", Me, HP <= 70f)) return true;
            if (MercCast("Saber Ward", Me, HP <= 50)) return true;
            if (MercCast("Rebuke", HP <= 70)) return true;

            if (MercCast("Dispatch", THP <= 30f)) return true;

            if (MercCast("Awe", TC && SoG)) return true;
            if (MercCast("Force Kick", TC && SoG)) return true;
            if (MercCast("Force Stasis", TC && SoG)) return true;

            if (MercCast("Overload Saber", Me)) return true;
            if (MercCast("Blade Storm", TWR10 >= 2 || SoG)) return true;
            if (MercCast("Cyclone Slash", TWR5 >= 2)) return true;
            if (MercCast("Force Sweep", TWR5 >= 2)) return true;
            if (MercCast("Cauterize")) return true;
            if (MercCast("Zealous Strike")) return true;
            if (MercCast("Merciless Slash")) return true;
            if (MercCast("Master Strike")) return true;

            if (MercCast("Dispatch")) return true;

            if (MercCast("Crippling Throw", SoG)) return true;
            if (MercCast("Leg Slash", SoG)) return true;
            if (MercCast("Pacify", StrongOrElite(CT))) return true;
            if (MercCast("Riposte")) return true;

            if (MercCastOnGround("Force Sweep", TWR5 >= 3 || SoG, CT)) return true;

            if (MercCast("Master Strike")) return true;
            if (MercCast("Force Leap")) return true;

            if (MercCast("Slash")) return true;
            if (MercCast("Strike")) return true;

            return false;
        }

        public static bool SentinelCombat()
        {
            while (AllowCombat && !PauseBot)
            {
                LoadVars();
                while (true)
                {
                    datLCL = DateTime.Now;

                    //if (Attackers == null || Attackers.Count() == 0) return false;

                    if (MercBuffSelf("Shii-Cho Form", MySpec == SkillTreeId.SentinelFocus)) break;
                    if (MercBuffSelf("Ataru Form", MySpec == SkillTreeId.SentinelCombat)) break;
                    if (MercBuffSelf("Juyo Form", MySpec == SkillTreeId.SentinelWatchman)) break;

                    if (MercBuffSelf("Force Might")) break;

                    if (IGAndTargetNotInCombat()) return false;

                    if (MercCast("Resolute", IAmStunned())) break;
                    if (IAmStunned()) { Thread.Sleep(500); break; }

                    MoveTo(CT, 2.90f);
                    if (MercCast("Force Leap", MovementAllowed && TD >= 1.5f)) break;
                    MoveTo(CT, MeleeDist, "Twin Saber Throw", "Crippling Throw", "Ascendence");

                    if (TC && SoG)
                    {
                        if (MercCast("Force Kick")) break;
                        if (MercCast("Pacify")) break;
                        if (MercCast("Force Stasis")) break;
                        if (MercCast("Awe")) break;
                    }

                    //if (!IG && BuddyTor.Me.IsMoving) StopMoving();

                    if (MercCast("Overload Saber")) break;
                    if (MercCast("Cauterize")) break;

                    if (MercCast("Dispatch", THP <= 30f)) break;

                    if (HP < 70f)
                    {
                        if (HP <= 30f) UseMedPackInInventory();

                        if (MercCast("Rebuke")) break;
                        if (MercCast("Saber Ward", Me, HP <= 50f)) break;
                        if (MercCast("Force Kick")) break;
                        if (MercCast("Pacify")) break;
                        if (MercCast("Crippling Throw")) break;
                        if (MercCast("Guarded by the Force", Me, HP <= 20f)) break;
                    }

                    if (MercCast("Zen", Me)) break;

                    if (MercCast("Dispatch")) break;
                    if (MercCast("Precision Slash", SoG)) break;
                    //if (MercCast("Force Sweep", TWR5 >= 3 && HaveBuff("Felling Blow") && HaveBuffStacks("Singularity", 3))) break;
                    if (MercCast("Merciless Slash", SoG || THP >= 75f)) break;
                    if (MercCast("Twin Saber Throw", SoG || TWR5 >= 2)) break;
                    if (MercCast("Force Sweep", TWR5 >= 3)) break;
                    if (MercCast("Master Strike", SoG || THP >= 75f)) break;
                    if (MercCast("Force Exhaustion")) break;
                    if (MercCast("Zealous Leap")) break;

                    if (MercCast("Blade Storm")) break;
                    if (MercCast("Cyclone Slash", TWR5 >= 2)) break;
                    if (MercCast("Blade Rush")) break;

                    if (MercCast("Zealous Strike")) break;
                    if (MercCast("Riposte")) break;
                    if (MercCast("Cyclone Slash", TWR5 >= 3)) break;
                    if (MercCast("Force Sweep", TWR5 >= 3)) break;
                    if (MercCast("Slash")) break;

                    if (MercCast("Crippling Throw", SoG)) break;
                    if (MercCast("Leg Slash", SoG && !CTHasDebuff("Slowed"))) break;
                    //if (MercCast("Pacify", StrongOrElite(CT))) break;

                    if (MercCastOnGround("Force Sweep", TWR5 >= 3 || SoG, CT)) break;

                    if (MercCast("Strike")) break;

                    break;
                }

                Thread.Sleep(150);
                if (!IAmInCombat()) break;
                if (WaitForCast()) return IAmInCombat();

            } 
            return IAmInCombat();

        }

        public static bool AssassinCombat()
        {
            while (AllowCombat && !PauseBot)
            {
                LoadVars();

                datLCL = DateTime.Now;

                while (true)
                {

                    if (MercCast("Unbreakable Will", IAmStunned())) break;

                    MercBuffSelf("Dark Ward");
                    MercBuffSelf("Mark of Power");

                    MercBuffSelf("Dark Charge", MySpec==SkillTreeId.AssassinDarkness);
                    MercBuffSelf("Lightning Charge", MySpec == SkillTreeId.AssassinMadness);
                    MercBuffSelf("Surging Charge", MySpec == SkillTreeId.AssassinMadness);


                    if (IGAndTargetNotInCombat()) return false;

                    if (!CT.InCombat && CT.HealthPercent > .2f)
                    {
                        MoveTo(CT, 2.9f);
                        MercBuffSelf("Stealth");
                        MercBuffSelf("Stealth");
                        Thread.Sleep(400);
                        if (MovementAllowed)
                        {
                            AbilityManager.Cast("Force Speed", Me);
                            while (CT.Distance > .15f) MoveTo(CT, .15f);
                            if (!MercCast("Maul", CT.Distance <= .20f)) if (!MercCast("Thrash")) MercCast("Shock");
                        }
                        else
                        {
                        }
                        //break;
                    }

                    if (HP <= 70f)
                    {
                        if (HP <= 30f) UseMedPackInInventory();
                        if (MercCast("Force Shroud", Me, HP<=50f && NeedsDispell(Me))) break;
                        if (MercCast("Unity", HP <= 50f && !IG && Comp != null && !Comp.IsDead)) break;
                        if (HP <= 60f) if (MercCast("Deflection")) break;
                        if (MercCast("Overcharge Saber", Me, HP <= 70f)) break;
                    }

                    if (MercCast("Mass Mind Control", (!IG && CHP < 60f))) break;
                    if (MercCast("Mind Control", (!IG && CHP < 60f))) break;

                    if (TC && SoG)
                    {
                        if (MercCast("Electrocute")) break;
                        if (MercCast("Jolt")) break;
                        if (MercCast("Low Slash")) break;
                        if (MercCast("Spike")) break;
                        if (MercFaceAndCast("Overload", true)) break;
                    }

                    if (HandleGuarding()) break;
                    
                    if (!IG && AmTank && HaveBuff("Dark Charge")) CheckCompGuard();
                    if (MercCast("Mass Mind Control", AmTank && IG)) break;

                    if (TD > .55f)
                    {
                        MercCast("Force Speed", TD > 1.50f);
                        MercCast("Discharge");
                        MercCast("Shock");
                    }

                    MoveTo(CT, MeleeDist, "Force Speed", "Shock", "Wither", "Discharge");
                    if (MovementAllowed) Input.MoveStopAll();
                    
                    //MoveTo(CT, MeleeDist);

                    if (MercCast("Assassinate", THP <= 30f)) break;

                    if (MercCast("Wither", (SoG || TWR10 >= 2) && !CTHasDebuff("Wither"))) break;
                    if (MercCast("Voltaic Slash", RS>=50f && SoG)) break;
                    if (MercCast("Creeping Terror", SoG && !CTHasDebuff("Creeping Terror"))) break;

                    if (MercCast("Shock", SoG && HaveBuffStacks("Induction", 2))) break;
                    if (MercCast("Discharge", HaveBuffStacks("Static Charge", 3))) break;
                    if (MercCastOnGround("Death Field", SoG || MobsInRangeOf(CT, .80f) >= 3, CT)) break;
                    if (MercCast("Crushing Darkness", HaveBuff("Raze") && !CTHasDebuff("Crushing Darkness"))) break;
                    if (MercCast("Maul", HaveBuff("Conspirator's Cloak") && (SoG || HP <= 70f || THP > 60f))) break;

                    if (SoG)
                    {
                        if (MercCast("Recklessness")) break;
                        //if (MercCast("Electrocute")) break;
                        if (MercCast("Force Slow")) break;
                        if (MercCast("Crushing Darkness", !IG)) break;
                    }

                    if (MercCast("Shock")) break;
                    if (MercCast("Force Lightning", HaveBuffStacks("Harnessed Darkness", 3) || HaveBuffStacks("Static Charge", 3))) break;
                    if (MercCast("Discharge")) break;

                    if (MercCast("Maul")) break;
                    if (MercCast("Lacerate", TWR10 >= 3 && RS >= 50f)) break;

                    //if (MercCast("Force Lightning")) break;


                    if (MercCast("Thrash")) break;
                    if (MercCast("Saber Strike")) break;

                    Thread.Sleep(150);
                    break;
                }

                if (WaitForCast()) return IAmInCombat();
                if (!IAmInCombat()) break;

            }
            return IAmInCombat();

        }

        public static void DefenseCombat()
        {

            WaitForCast();
            datLCL = DateTime.Now;

            Thread.Sleep(200);
            LoadVars();

            if (IGAndTargetNotInCombat()) return;

            if (CT == null && MyTarget() != null) CT = MyTarget();

            if (!IG) StopMoving();

            MoveTo(CT, MeleeDist, "Force Leap");

            if (MercCast("Resolute", IAmStunned())) return;

            if (!HaveBuff("Soresu Form")) if (AbilityManager.CanCast("Soresu Form", Me)) if (MercCast("Soresu Form", Me)) return;
            if (!HaveBuff("Shii-Cho Form")) if (!AbilityManager.CanCast("Soresu Form", Me)) if (MercCast("Shii-Cho Form", Me)) return;

            if (MercCast("Hilt Strike", CT.IsStunned && RS >= 3)) return;
            if (MercCast("Pommel Strike", CT.IsStunned)) return;

            if (MercCast("Dispatch", HP <= 20 && RS >= 3)) return;
            if (MercCast("Hilt Strike", TC && HP <= 30f && HaveBuff("Saber Ward"))) return;
            if (MercBuffSelf("Endure", HP <= 30)) return;

            if (MercBuffSelf("Saber Ward", HP <= 50)) return;
            if (MercCast("Awe", TWR5 >= 3 && HP <= 60)) return;
            if (MercCast("Force Stasis", TC && HP <= 60f && HaveBuff("Saber Ward"))) return;
            if (MercBuffSelf("Warding Call", HP <= 60)) return;

            if (MercCast("Sundering Strike")) return;
            if (MercCast("Master Strike")) return;
            if (MercCast("Freezing Force", !CTHasDebuff("Slowed (Force)") && (TWR5 >= 2 || SoG))) return;
            if (MercCast("Blade Storm")) return;

            if (MercCast("Force Sweep", TWR5 >= 2 && RS >= 3)) return;
            if (MercCast("Guardian Slash", RS >= 4 && TWR10 >= 3)) return;
            if (MercCast("Cyclone Slash", TWR5 >= 4)) return;
            if (MercCast("Force Push", TWR10 >= 3)) return;

            if (MercCast("Saber Throw", TD >= MeleeDist)) return;
            if (MercCast("Combat Focus", RS <= 6)) return;

            if (MercCast("Force Kick", TC)) return;

            if (MercCast("Opportune Strike", CTT != CombatToughness.Player)) return;


            if (MercCast("Slash", RS >= 6)) return;
            if (MercCast("Strike")) return;

        }

        public static void GetGroupAttackees()
        {
            if (!(IG || AmTank)) return;

            NGUnit = null; // Needs Guarding
            NAUnit = null; // Needs Attacking

            try
            {

                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    foreach (TorCharacter tn in ObjectManager.GetObjects<TorCharacter>().Where(t => t != null && !t.IsDeleted && t.InCombat && !t.IsDead && t.Distance <= 4.0f && t.Toughness != CombatToughness.Player).OrderBy(t => IsRanged ? t.HealthMax : t.Distance))
                        try
                        {
                            TorCharacter tt = tn.CurrentTarget;
                            if (tt != null && tt.Guid != Me.Guid && tt.Toughness == CombatToughness.Player)
                            {
                                if (tn != null && tn.Guid != CT.Guid) { NGUnit = tt; NAUnit = (TorCharacter)tn; break; }
                            }
                        }
                        catch { }
                }
            }
            catch { }
        }

        public static bool HandleGuardingJugg()
        {
            
            //if (!IG) return false;

            if(IG) GetGroupAttackees();

            if (NAUnit != null) try
                {
                    CT = NAUnit;

                    if (MercCast("Taunt", NAUnit)) return true;
                    if (MercCast("Intercede", NGUnit)) return true;
                    if (MercCast("Saber Throw", NAUnit)) return true;
                    //if (MercCast("Guard", NGUnit)) return true;

                }
                catch { }
            return false;
        }

 
        public static bool JuggernautCombat()
        {
            //Thread.Sleep(200);

            while (AllowCombat && !PauseBot)
            {
                LoadVars();
                while (true)
                {

                    datLCL = DateTime.Now;

                    //if (CT == null && MyTarget() != null ) CT = MyTarget();
                    if (IGAndTargetNotInCombat()) return false;

                    if (MySpec == SkillTreeId.JuggernautImmortal) if (MercBuffSelf("Soresu Form")) break;
                    if (MySpec == SkillTreeId.JuggernautVengeance) if (MercBuffSelf("Shien Form")) break;
                    if (MySpec == SkillTreeId.JuggernautRage) if (MercBuffSelf("Shii-Cho Form")) break;

                    if (MercBuffSelf("Unnatural Might")) break;

                    //if (MercCast("Force Charge", CT, MovementAllowed && TD >= 1.0f && TD <= 3.0f)) break;
                    //if (MercCast("Saber Throw", CT, TD >= 1.0f && TD <= 3.0f)) break;
                    //if (MercCast("Force Scream", CT, TD <= 1.0f)) break;
                    //if (MercCast("Taunt", CT, (TD >= 1.2f && TD <= 3.0f) || SoG)) break;
                    //if (!IG) MoveTo(CT, .490f, "Force Charge");
                    MoveTo(CT, 2.90f);
                    MoveTo(CT, MeleeDist, MovementAllowed?"Force Charge":"", "Saber Throw", "Force Scream", AmTank?"Taunt":"");

                    // ALOT of these are bugged in SWTOR for Elites in Oricon - annoying as all hell
                    if (TC && SoG)
                    {
                        if (MercCast("Disruption")) break;
                        if (MercCast("Backhand")) break;
                        if (MercCast("Force Charge", MovementAllowed)) break;
                        if (MercCast("Savage Kick")) break;
                        if (MercCast("Force Choke")) break;
                        if (MercCast("Force Push")) break;
                        //if (MercCast("Taunt", AmTank)) break;
                    }
                    //StopMoving();

                    if (MercCast("Unleash", CT, IAmStunned())) break;
                    if (IAmStunned()) { Thread.Sleep(500); break; }

                    if (MercCast("Smash", CT, TWR5 >= 2 || (SoG && TD <= MeleeDist))) break;

                    if (MercCast("Heroic Moment: Call on the Force", BuddyTor.Me, DateTime.Now.Subtract(datLCCoTF).TotalSeconds >= 900 && HP <= 50f)) { datLCCoTF = DateTime.Now; break; }

                    if (HP <= 70f)
                    {
                        if (HP <= 30f) UseMedPackInInventory();

                        if (MercCast("Endure Pain", HP <= 40f)) break;
                        if (MercCast("Invincible", HP <= 50f)) break;
                        if (MercCast("Saber Ward", HP <= 60f)) break;
                        if (MercCast("Enraged Defense", HP <= 70f)) break;
                        if (MercCast("Saber Reflect", HP <= 70f)) break;
                        if (MercCast("Threatening Scream", TD <= 1.0f && HP <= 60f && !AmTank)) break;
                        if (MercCast("Heroic Moment: Call on the Force", BuddyTor.Me, DateTime.Now.Subtract(datLCCoTF).TotalSeconds >= 900 && HP <= 50f)) { datLCCoTF = DateTime.Now; break; }
                    }
                    
                    CheckCompGuard();
                    HandleGuarding();

                    if (AmTank)
                    {
                        //if (MercCast("Threatening Scream")) break; // Used in HandleGuarding
                        if (MercCast("Backhand")) break;
                        if (MercCast("Vicious Throw", THP <= 30f)) break;

                        if (MercCast("Sundering Assault", !CTHasDebuff("Armor Reduced"))) break;
                        if (MercCast("Crushing Blow")) break;
                        if (MercCast("Force Scream")) break;
                        if (MercCast("Smash")) break;
                        if (MercCast("Sweeping Slash", TWR5 >= 3)) break;
                        if (MercCast("Ravage", SoG || THP >= 75f)) { Thread.Sleep(300); WaitForCast(); break; }
                        if (MercCast("Retaliation")) break;
                        if (MercCast("Vicous Slash")) break;
                        //if (MercCast("Saber Throw")) break; // Used in HandleGuarding

                    }

                    if (MercCast("Vicious Throw", THP <= 30f)) break;
                    if (MercCast("Enrage", SoG && !HaveBuffStacks("Rage", 6))) break;

                    if (MercCast("Impale")) break;
                    if (MercCast("Shatter", SoG)) break;
                    if (MercCast("Force Crush", SoG)) break;
                    if (MercCast("Crushing Blow", CT, CTHasDebuff("Armor Reduced") && (TWR5 >= 2 || SoG))) break;

                    if (MercCast("Ravage", SoG || THP >= 75f)) ChainCastWait();
                    if (MercCast("Obliterate", SoG)) break;
                    if (MercCast("Force Scream")) break;
                    if (MercCast("Smash")) break;
                    if (MercCast("Saber Throw")) break;

                    if (MercCast("Retaliation")) break;
                    if (MercCast("Sundering Assault", !CTHasDebuff("Armor Reduced"))) break;
                    if (MercCast("Threatening Scream", IG && AmTank)) break;
                    //if (MercCast("Backhand")) break;
                    if (MercCastOnTimer("Chilling Scream", 15f, TD<=1.0f && !CTHasDebuff("Slow") && (HP <= 50f || TWR10 >= 2))) break;
                    if (MercCast("Retaliation", CT)) break;

                    if (MercCast("Force Choke")) break;

                    if (MercCast("Intimidating Roar")) break;

                    //if (MercCast("Threatening Scream", (TWR10 >= 3 || SoG))) break;

                    if (MercCast("Vicious Slash")) break;
                    if (MercCast("Sweeping Slash", MobsInRangeOf(Me,.5f)>=3)) break;
                    if (MercCast("Assault")) break;

                    break;

                }

                Thread.Sleep(350);
                
                if (WaitForCast()) return IAmInCombat();
                if (!IAmInCombat()) break;
            }
            return IAmInCombat();
        }

        public static void VengeanceCombat()
        {
            Thread.Sleep(200);

            WaitForCast();
            datLCL = DateTime.Now;

            LoadVars();

            if (CT == null && MyTarget() != null) CT = MyTarget();

            if (MercCast("Shien Form", !HaveBuff("Shien Form"))) return;
            //if (MercCast("Shi-Cho Form", !HaveBuff("Shii-Cho Form"))) return;
            if (MercCast("Unnatural Might", !HaveBuff("Unnatural Might"))) return;

            if (MercCast("Saber Throw", TD >= 1.1f && TD <= 3.0f)) return;
            if (MercCast("Force Charge", TD >= 1.0f && TD <= 3.0f)) return;
            if (MercCast("Force Scream", TD <= 1.0f)) return;
            if (MercCast("Taunt", (TD >= 1.2f && TD <= 3.0f) || SoG)) return;
            //if (!IG) MoveTo(CT, .490f, "Force Charge");
            MoveTo(CT, .490f, "Force Charge");

            if (!IG && BuddyTor.Me.IsMoving) StopMoving();

            if (MercCast("Unleash", Me, IAmStunned())) return;

            if (MercCast("Disruption", TC)) return;

            if (MercCast("Smash", (TWR5 >= 2 || (SoG) && TD <= MeleeDist))) return;

            if (MercCast("Enraged Defense", Me, HP <= 80f)) return;
            if (MercCast("Saber Reflect", BuddyTor.Me, HP <= 70f)) return;
            if (MercCast("Heroic Moment: Call on the Force", BuddyTor.Me, DateTime.Now.Subtract(datLCCoTF).TotalSeconds >= 900 && HP <= 50f)) { datLCCoTF = DateTime.Now; return; }
            if (MercCast("Saber Ward", BuddyTor.Me, HP <= 60f)) return;
            if (MercCast("Invincible", BuddyTor.Me, HP <= 50f)) return;
            if (MercCast("Endure Pain", BuddyTor.Me, HP <= 40f)) return;
            if (HP <= 60f) UseMedPackInInventory();

            //if (MercCast("Force Push", (TWR10 >= 3))) return;

            //if (MercCast("Guard", Comp, CHP <= 50)) return;
            HandleGuardingJugg();

            if (MercCast("Impale")) return;
            if (MercCast("Savage Kick")) return;
            if (MercCast("Sundering Assault")) return;
            if (MercCast("Retaliation")) return;
            if (MercCast("Ravage")) return;

            if (MercCast("Enrage", Me)) return;
            if (MercCast("Crushing Blow")) return;
            if (MercCast("Backhand")) return;
            if (MercCast("Sweeping Slash", (TWR5 >= 3))) return;

            if (MercCast("Vicious Throw", THP <= 30f)) return;
            if (MercCast("Pommel Strike", CT.IsStunned)) return;
            if (MercCast("Force Choke", THP <= 30f)) return;

            if (MercCast("Deadly Throw")) return;
            if (MercCast("Intimidating Roar")) return;

            if (MercCast("Chilling Scream", !CTHasDebuff("Slow (Force)") && (HP <= 50 || TWR10 >= 2))) return;
            if (MercCast("Threatening Scream", (TWR10 >= 3))) return;

            if (MercCast("Vicious Slash")) return;
            if (MercCast("Assault")) return;

        }

        // Credit to ChinaJade and WingIt for this routine
        public static void MovementToggle()
        {
            MovementAllowed = !MovementAllowed;
            Logger.Write("MovementAllowed: " + (MovementAllowed.ToString()));
            MovementToggle(MovementAllowed);
        }

        public static void MovementToggle(bool MoveOn)
        {
            
            if (!MoveOn)
            {
                Buddy.Navigation.Navigator.NavigationProvider = NoNavigationProvider;
                Buddy.Navigation.Navigator.MovementProvider = NoMovementProvider;
            }
            else
            {
                Buddy.Navigation.Navigator.NavigationProvider = DefaultNP;
                Buddy.Navigation.Navigator.MovementProvider = DefaultMP;
            }

        }

        //private static System.EventHandler ShutdownHandler(object obj, System.Windows.ExitEventArgs args)
        ////private static System.EventHandler ShutdownHandler()
        //{
        //    if (thMonMem != null && thMonMem.IsAlive)
        //    {
        //        thMonMem.Abort();
        //        Thread.Sleep(2000);
        //        thMonMem = null;
        //        Thread.Sleep(2000);
        //    }
        //    return null;
        //}

        private static bool HandleDebuffs()
        {
            return HandleDebuffs(Me);
        }

        private static bool HandleDebuffs(TorCharacter unit)
        {
            try
            {

                if (unit == null) return false;

                foreach (TorEffect te in unit.Debuffs)
                {
                    string spellCure = "";
                    if (MySpec == SkillTreeId.MercenaryBodyguard) spellCure = "Cure";
                    else if (MySpec == SkillTreeId.CommandoCombatMedic) spellCure = "Field Aid";
                    else if (MySpec == SkillTreeId.SageSeer) spellCure = "Restoration";
                    else if (MySpec == SkillTreeId.SorcererCorruption) spellCure = "Purge";
                    else { return false; }

                    if (te.Name.Contains("Burning")) if (MercCast(spellCure, unit)) return true;
                    //if (te.Name.Contains("Armor")) if (MercCast(spellCure, unit)) return true;  // Can't be dispelled
                    if (te.Name.Contains("Slowed")) if (MercCast(spellCure, unit)) return true;
                    if (te.Name.Contains("Shocked")) if (MercCast(spellCure, unit)) return true;
                    if (te.Name.Contains("Poisoned")) if (MercCast(spellCure, unit)) return true;
                    if (te.Name.Contains("Crippling")) if (MercCast(spellCure, unit)) return true;
                    if (te.Name.Contains("Crush")) if (MercCast(spellCure, unit)) return true;
                    if (te.Name.Contains("Infected")) if (MercCast(spellCure, unit)) return true;
                    if (te.Name.Contains("Bleeding")) if (MercCast(spellCure, unit)) return true;
                    if (te.Name.Contains("Grav")) if (MercCast(spellCure, unit)) return true;
                    if (te.Name.Contains("Hallucinat")) if (MercCast(spellCure, unit)) return true;
                }
            }
            catch { }
            return false;
        }

        public static bool MercBuffSelf(string theSpell, bool req=true)
        {
            if (theSpell == "") return false;
            if (!req) return false;
            if (HaveBuff(theSpell)) return false;
            return MercCast(theSpell, BuddyTor.Me, req);
        }

        public static bool AbilsContain(string theString)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                try
                {
                    if (MyAbilities.Contains(theString)) return true;
                    return false;
                }
                catch { return false; }
        }

        public static bool ApplyDebuff(string theDebuff)
        {
            if (!CTHasDebuff(theDebuff)) if (MercCast(theDebuff)) return true;
            return false;
        }

        public static bool MercCastNew(string theAbility, TorCharacter theChar = null, bool req = true, bool WaitReportedCastTime=false)
        {
            bool CastComplete = false;
            float CastTime=0f;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            try
            {
                if (!req) return false;
                //UpdateObjects();
                //if (theChar == null) 
                TorCharacter theCharX = null;
                theCharX = (theChar == null ? CT : theChar);
                if (theCharX == null) return false;
                if (theCharX.IsDead || theCharX.HealthPercent < .1f) return false;

                if (MyAbilDct.ContainsKey(theAbility))
                {
                    TorAbility ta = MyAbilDct[theAbility];
                    DateTime lc = MyAbilCast[theAbility];
                    float mindist = ta.MinRange;
                    float maxdist = ta.MaxRange;
                    float ec = ta.ActionPointCost + ta.EnergyCost + ta.ForceCost + ta.HeatCost;
                    CastTime = (ta.CastingTime + ta.ChannelingTime) * 1000;
                    if (ta.IsValid && lc.AddMilliseconds(ta.CooldownTime * 1000) < DateTime.Now && theCharX.Distance <= maxdist && theCharX.Distance >= mindist && theCharX.InLineOfSight &&
                        lc.AddMilliseconds(ta.CooldownTime * 1000) < DateTime.Now && theCharX.Distance <= maxdist && theCharX.Distance >= mindist && theCharX.InLineOfSight && Me.ResourceStat >= ec)
                    //if (Me.IsAbilityReady(ta, theChar)==EffectResult.Ok)  // buggy
                    {
                        //Logger.Write("CastChannelTime: " + ct.ToString() + " Cooldown: " + ta.CooldownTime.ToString() + " GCD: " + ta.GlobalCooldownTime.ToString() + " Cost: " + ec.ToString());
                        //    + " MinDist: " + ta.MinRange + " MaxDist: " + ta.MaxRange);
                        if (ta.TargetRule == TargettingRule.Self) theCharX = Me;
                        Me.AbilityActivate(ta, theCharX, out er);
                        MyAbilCast[theAbility] = DateTime.Now;
                        if (er == EffectResult.Ok)
                        {
                            WriteLogCast(theAbility);
                            //if (!"Stealth;Crouch;Take Cover;Force Speed".Contains(theAbility)) Thread.Sleep(TimeSpan.FromMilliseconds(ct+550));
                            CastComplete = true;
                        }
                    }
                }
                else { /*Logger.Write("Ability " + theAbility + " not found in loaded abilities dictionary."); */}
            }
            catch { }
            if (CastComplete)
            {
                Thread.Sleep(150);
                if (WaitReportedCastTime) Thread.Sleep(TimeSpan.FromMilliseconds(CastTime+100)); else WaitForCast();
            }
            return CastComplete;
        }

        // Used for tracking TorEffects like Corrosive Grenade and Corrosive Dart, where the effect name "Poisoned (Tech)" gets to be a pain

        public static void UpdateCastInfo(TorCharacter theChar, string theSpell)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                while (MyCastTgtDct.Values.Count > 200) MyCastTgtDct.RemoveAt(0);
                string strGUID = theChar.Guid.ToString();
                string strKey = strGUID + theSpell;
                if (MyCastTgtDct.Contains(strKey)) MyCastTgtDct.Remove(strKey);
                datLCast = Now;
                MyCastTgtDct.Add(strKey, Now);
            }
        }

        public static DateTime GetLastCastOnTarget(TorCharacter theChar, string theSpell)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                string strGUID = theChar.Guid.ToString();
                string strKey = strGUID + theSpell;
                if (!MyCastTgtDct.Contains(strKey)) return Now.Subtract(TimeSpan.FromSeconds(300));
                else return Convert.ToDateTime(MyCastTgtDct[strKey]);
            }
        }

        public static bool MercCastOnTimer(string theSpell, float theFreqInSecs, bool Req = true, bool FaceFirst = false)
        {
            if (Req && DiffInSeconds(GetLastCastOnTarget(CT, theSpell), Now) > theFreqInSecs)
            {
                if (FaceFirst)
                    return MercFaceAndCast(theSpell, true);
                else
                    return MercCast(theSpell);
            }
            return false;
        }

        //public static bool Eval(bool test)
        //{
        //    using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
        //    {
        //        if (test) return true;
        //        return false;
        //    }
        //}
        public static bool MercCast(string theSpell, TorCharacter theChar = null, bool req = true)
        {
            bool CastComplete = false;
            try
            {
                //UpdateObjects();
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    if (!MyAbilDct.ContainsKey(theSpell)) return false;

                    if (req)
                    {
                        TorCharacter theCharX = (theChar == null ? CT : theChar);
                        //if (!AmHealer()) UpdateObjects();
                        //Buddy.CommonBot.GameEvents.Update();
                        // More Voodoo - seems to work alot better checking for casting ability 3x, tried it just for the hell of it, don't ask me why it DOES work better this way, maybe something to do with 'caching', who the hell knows
                        bool CC=(AbilityManager.CanCast(theSpell, theCharX) || AbilityManager.CanCast(theSpell, theCharX) || AbilityManager.CanCast(theSpell, theCharX));
                        if (CC)
                        {
                            Buddy.CommonBot.AbilityManager.Cast(theSpell, theCharX);
                            CastComplete = true;
                            UpdateCastInfo(theCharX, theSpell);
                        }
                        else
                            if (AbilityManager.CanCast(theSpell, Me) || AbilityManager.CanCast(theSpell, Me) || AbilityManager.CanCast(theSpell, Me))
                            {
                                WriteLogCast(theSpell);
                                Buddy.CommonBot.AbilityManager.Cast(theSpell, BuddyTor.Me);
                                UpdateCastInfo(Me, theSpell);
                                CastComplete = true;
                            }
                    }
                }
            }
            catch { }
            if (CastComplete)
            {
                WriteLogCast(theSpell);
                UpdateObjects();
                Thread.Sleep(250);
                WaitForCast();
            }
            return CastComplete;
        }

        //public static bool MercCastOnGround(string theSpell, bool requirements, TorCharacter unit)
        //{
        //    if (unit == null) return false;
        //    if (theSpell == "") return false;
        //    return MercCastOnGround(theSpell, requirements, unit, false);
        //}

        public static void WriteLogCast(string theSpell, bool Forced=false)
        {
            try
            {
                if (CT == null) return;
                Logger.Write("SoG: " + (SoG ? "Y " : "N ") + (IG ? "55: " + (Is55H ? "Y" : "N") : "") + " HP: " + HP.ToString("000.0") + " RS: " + RS.ToString("000.0") +
                    " AC: " + (Attackers == null ? 0 : Attackers.Count()).ToString() +
                    " CTScale: " + CT.Scale.ToString("0.0") + " TD: " + (TD * 10f).ToString("0.0") +
                    " THP: " + CT.HealthPercent.ToString("00.00") + " Comp: " + (Comp != null ? Comp.Name : "NONE").ToString() +
                    " CHP: " + CHP.ToString("000.0") + (Forced ? " Forced Cast " : " Casting ") + theSpell //+ " on " + theChar.Name
                    );
            }
            catch { }
        }

        public static bool MercCastOnGround(string theSpell, bool Req, TorCharacter unit, bool OnlyInCombat = false)
        {
            //UpdateObjects();
            bool CastDone = false;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            try
            {
                if (!MyAbilDct.ContainsKey(theSpell)) return false;

                if (unit == null) unit = CT;
                if (theSpell == "") return false;
                if (unit.IsDead) return false;

                if (Req) if (Buddy.CommonBot.AbilityManager.CanCast(theSpell, unit) || Buddy.CommonBot.AbilityManager.CanCast(theSpell, unit) || Buddy.CommonBot.AbilityManager.CanCast(theSpell, unit))
                {
                    datLCs = DateTime.Now;
                    WriteLogCast(theSpell);
                    AbilityManager.Cast(theSpell, unit.Position);
                    CastDone = true;
                    datLCast = Now;
                }
            }
            catch { }
            if (CastDone)
            {
                Thread.Sleep(400);
                if (OnlyInCombat)
                {
                    while (IAmInCombat() && IAmCasting()) Thread.Sleep(500);
                    //return true;
                }
                WaitForCast();
                ClearTarget();
                //WriteAttackersInfo();
                return true;
            }
            return false;
        }

        public static void FaceUnit(TorCharacter theUnit)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                theUnit.Face();          // Bug w/Face() - do it twice to be safe
                theUnit.Face();
            }
            Thread.Sleep(150);
        }

        // Used in 'Directional Casting' such as Pulse Cannon - WE HAVE TO BE FACING THE TARGET FIRST - otherwise - useless
        public static bool MercFaceAndCast(string theSpell, bool req)
        {
            bool CC = false;
            //bool CCM = false;

            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (CT == null || theSpell=="" || CT.IsDead || CT.HealthPercent < .05f) return false;
                if (IG && !MovementAllowed) return false;
                if (!req) return false;
                CC=Buddy.CommonBot.AbilityManager.CanCast(theSpell, CT);
                CT.Face();
                //CCM = Buddy.CommonBot.AbilityManager.CanCast(theSpell, Me);
            }
            if (CC) 
            {
                datLCast = Now;
                CT.Face();
                Thread.Sleep(150);
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    AbilityManager.Cast(theSpell, CT);
                }
                WriteLogCast(theSpell);
                WaitForCast();
                return true;
            }
            //else if (CCM)
            //{
            //    if (MercCast(theSpell, Me))
            //    {
            //        datLCast = Now;
            //        return true;
            //    }
            //}
            return false;
        }

        public static bool MercFaceAndCrouch()
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (!MovementAllowed || CT==null || Me.HasBuff("Crouch")) return false;
                if (Buddy.CommonBot.AbilityManager.CanCast("Crouch", Me))
                {
                    CT.Face();          // Bug w/Face() - do it twice to be safe
                    CT.Face();
                    AbilityManager.Cast("Crouch", Me);
                    Thread.Sleep(250);
                    return true;
                }
            }
            return false;
        }

        //public static bool MercCast(string theSpell)
        //{
        //    return MercCast(theSpell, CT, true);
        //}

        public static bool MercCast(string theSpell, bool req)
        {
            return MercCast(theSpell, CT, (bool)(req));
        }

        //public static bool MercCast(string theSpell, TorCharacter theChar)
        //{
        //    return MercCast(theSpell, CT, true);
        //}

        public static bool MercCastX(string theSpell, bool req = true)
        {
            return MercCastX(theSpell, CT, (bool)(req));
        }

        public static bool MercCastX(string theSpell, TorCharacter theChar = null, bool req = true)
        {
            try
            {
                bool CastDone = false;
                if (theChar == null) return false;

                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    if (Buddy.CommonBot.AbilityManager.CanCast(theSpell, MyTarget()) && CT != BuddyTor.Me)
                    {
                        Buddy.CommonBot.AbilityManager.Cast(theSpell, MyTarget());
                        Logger.Write("PvP Cast " + theSpell);
                        CastDone = true;
                        //WriteAttackersInfo();
                        //return true;
                    }
                    if (Buddy.CommonBot.AbilityManager.CanCast(theSpell, Me))
                    {
                        CastDone = true; Buddy.CommonBot.AbilityManager.Cast(theSpell, Me);
                        Logger.Write("PvP Cast " + theSpell);
                        //WriteAttackersInfo();
                        //return true;
                    }
                }
                if (CastDone) { Thread.Sleep(150); WaitForCast(); return true; }
            }
            catch { }
            return false;
        }

        //public static bool MercLeanCast(string theSpell, TorCharacter theChar, bool req)
        //{
        //    try
        //    {
        //        if (!req) return false;
        //        if (AbilityManager.CanCast(theSpell, theChar)) { AbilityManager.Cast(theSpell, theChar); WaitForCast(); return true; }
        //    }
        //    catch { }
        //    return false;
        //}


        public static bool MercForcedCast(string theSpell, TorCharacter theUnit, bool req=true)
        {
                if (theSpell == "") return false;
                if (theUnit == null) return false;
                datLCs = DateTime.Now;
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                try
                {
                    if (!req) return false;
                    Buddy.CommonBot.AbilityManager.Cast(theSpell, theUnit);
                }
            catch { }
            Thread.Sleep(50); UpdateObjects(); 
            if (IAmCasting()) 
            {
                WriteLogCast(theSpell, true);
                WaitForCast(); 
                return true;
            } return false;
        }

        public static bool MercForcedCastOnGround(string theSpell, Vector3 unitPos, bool req = true)
        {
            if (theSpell == "") return false;
            datLCs = DateTime.Now;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (!req) return false;
                try
                {
                    Buddy.CommonBot.AbilityManager.Cast(theSpell, unitPos);
                }
                catch { }
            }
            Thread.Sleep(100); UpdateObjects(); if (IAmCasting()) { WaitForCast(); return true; } return false;
        }

        static bool HaveTarget()
        {
            if (CT != null) if (!CT.IsFriendly && !CT.IsDead) return true;
            return false;
        }

        static void CheckForGroup()
        {
            IG = (!PullIG && BuddyTor.Me.GroupId != 0);
        }

        public static int GetCTDebuffCount(string EffectName)
        {
            string DebuffsReplaced = CTDebuffs.Replace(EffectName, "/");
            int OrigLen = DebuffsReplaced.Length;
            return OrigLen-DebuffsReplaced.Replace("/", "").Length;
        }

        public static bool HaveBuff(string theBuff)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                return MyBuffs.Contains(theBuff);
            }
        }

        public static bool CTHasDebuff(string theDebuff)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                return CTDebuffs.Contains(theDebuff);
            }
        }

        public static void GetEffects()
        {
            DateTime datStart = Now;

            //SynchObjCache(false, true, true, true);
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                MyBuffs = "";
                if (LogMyBuffs) Logger.Write("My Buffs:");
                string teTemp;
                foreach (TorEffect te in Me.Buffs.AsParallel().ToArray()) if (te!=null && !te.IsDeleted)
                    try
                    {
                        if (te.Name.Length > 0)
                        {
                            teTemp = string.Copy(te.Name);
                            MyBuffs += teTemp + ",";
                            if (LogMyBuffs) Logger.Write("  EffName: " + te.Name);
                        }
                    }
                    catch { }
                CTDebuffs = "";
                try
                {
                    if (CT != null && !CT.IsDead && !CT.IsDeleted)
                    if (LogCTDebuffs) Logger.Write("Curr Target Debuffs:");
                    foreach (TorEffect te in CT.Debuffs.AsParallel().ToList()) 
                        try
                        {
                            //if (te != null && !te.IsDeleted && (!IG || te.Caster == null || te.Caster.Guid == MyGUID))
                            if (te!=null && !te.IsDeleted) if ((!IG || te.Caster == null || te.Caster.Guid == MyGUID))
                            {
                                teTemp = string.Copy(te.Name);
                                CTDebuffs += teTemp + ":" + te.Duration.TotalSeconds.ToString() + ";";
                                if (LogCTDebuffs) Logger.Write("  EffName: " + teTemp);
                            }
                            //Logger.Write("EffName: " + te.Name + " " + " IgnAlac: " + te.IgnoresAlacrity.ToString() + " RealTime: " + te.IsDurationRealtime.ToString());
                        }
                        catch {}
                }
                catch { }
            }
            //Logger.Write("Buffs: " + MyBuffs);
            //Logger.Write("Target Debuffs: " + CTDebuffs);
            //Logger.Write("GetEffects Duration: " + Now.Subtract(datStart).TotalMilliseconds.ToString("0"));
        }

        public static int MobsInRangeOf(TorCharacter CT, float Range)
        {
            //return 0;
            int MC = 0;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            try
            {
                Vector3 CTPos = CT.Position;
                foreach (TorCharacter t in ObjectManager.GetObjects<TorCharacter>().AsParallel().ToList().Where(t => t != null && !t.IsDeleted && !t.IsDead && t.Distance <= 4.0f))
                if (Buddy.Common.Math.Vector3.Distance(CTPos, t.Position)<=Range && t.IsHostile && !t.IsNeutral && !t.IsFriendly && !IsComp(t) & !IsPlayer(t) && t.Guid!=MyGUID && t.HealthPercent>=.1f 
                    ) MC+=1;
            }
            catch { }
            //Logger.Write("MobsInRange: " + MC.ToString());
            return MC;
        }

        //Namely used for moving to a spot where you won't get aggroed, after Med Probe
        // Cycle thru 0 to 360 degrees, in 15 degree increments, looking for a spot 20/40m out out with no mobs within 15m
        public static bool SafeMove()
        {
            try
            {
                float rad = 360f / 6.28f;
                Vector3 testLoc = new Vector3(0, 0, 0);
                Vector3 theLoc = new Vector3(0, 0, 0);
                for (int i = 1; i <= 24; i++)
                {
                    for (int j = 1; j <= 2; j++)
                    {
                        testLoc = Me.Position.RayCast(15 * i / rad, 2.0f * (float)j);
                        if (MobsInRangeOf(testLoc, 1.5f) < 1) { theLoc = testLoc; break; }
                    }
                }
                if (theLoc.X != 0f)
                {
                    DateTime datStart = Now;
                    while (DiffInSeconds(datStart, Now) < 12f && Me.Position.Distance(theLoc) > .05f)
                    {
                        using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                        {
                            Navigator.MoveTo(theLoc, null, true);
                        }
                        Thread.Sleep(150); UpdateObjects();
                    }
                    ClearTarget();
                    return true;
                }
            }
            catch { }
            return false;
        }

        public static int MobsInRangeOf(Vector3 thePos, float Range)
        {
            //return 0;
            int MC = 0;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                try
                {
                    foreach (TorCharacter t in ObjectManager.GetObjects<TorCharacter>().Where(t => t != null && !t.IsDeleted && !t.IsDead && t.Distance <= 4.0f))
                        if (Buddy.Common.Math.Vector3.Distance(thePos, t.Position) <= Range && t.IsHostile && !t.IsNeutral && !t.IsFriendly && !IsComp(t) & !IsPlayer(t) && t.Guid != MyGUID && t.HealthPercent >= .1f
                            ) MC += 1;
                }
                catch { }
            //Logger.Write("MobsInRange: " + MC.ToString());
            return MC;
        }
        public static int EnemyPlayersInRangeOf(Buddy.Common.Math.Vector3 Loc, float Range)
        {
            //return 0;
            int MC = 0;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                try
                {
                    foreach (TorPlayer t in ObjectManager.GetObjects<TorPlayer>().Where(t => t != null && !t.IsDeleted && !t.IsDead))
                        if (t.IsHostile && t.Distance <= 4.0f && Buddy.Common.Math.Vector3.Distance(Loc, t.Position) <= Range && t.HealthPercent >= .2f
                            ) MC += 1;
                }
                catch { }
            }//Logger.Write("MobsInRange: " + MC.ToString());
            return MC;
        }

        public static TorPlayer Me { get { return (TorPlayer)BuddyTor.Me; } }

        public static void UseQuestItem(string theItem, TorCharacter theUnit=null, float WithinRange=1.5f, int SleepAfterUse=5000)
        {
            //foreach (var o in BuddyTor.Me.InventoryEquipment)
            bool itemUsed = false;
            //bool UseItem = false;
            TorItem itemToUse = null;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                foreach (TorItem o in BuddyTor.Me.InventoryQuest)
                {
                    if (o.Name.Contains(theItem) && o.MinimumLevel <= MyLevel)
                    {
                        itemToUse = o;
                    }
                }
            }
            if (itemToUse!=null) 
            {
                Logger.Write("Using Quest Item " + itemToUse.Name + "...");
                if (theUnit != null)
                {
                    MoveTo(theUnit, WithinRange);
                    Thread.Sleep(500);
                }
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    itemToUse.Use();
                    Thread.Sleep(250);
                    itemToUse.Interact();
                    Thread.Sleep(250);
                    //itemToUse.Interact();
                    //Thread.Sleep(150);
                    itemUsed = true;
                }
            }
            if (itemUsed)
            {
                Thread.Sleep(1000);
                WaitForCast();
                UpdateObjects();
                if (SleepAfterUse != 0 && IAmCasting())
                {
                    Thread.Sleep(SleepAfterUse);
                    Logger.Write("Sleeping after Item-Use for " + SleepAfterUse.ToString() + "...");
                }
                return;
            }
        }

        public static void AdjCTIfNull()
        {
            if (CT != null && (CT.Guid==MyGUID || CT.Name == CompName))
            {
                CT = null;
                ClearTarget();
            }

            if (CT != null) return;

            TorCharacter CTx = MyTarget();
            string CTName = "NONE";
            
            if (CTx!=null) CTName = CTx.Name;

            if (!IG && CT == null && CT.Guid!=MyGUID && CTName!=CompName) CT = CTx;
        }

        public static void CheckCombatQuestItemUsage(UInt64 QuestID, uint StepID, string theItem, TorCharacter theTarget, string theTargetName, float theTargetMinHealth, float theDist, Int32 WaitAfterCastMS)
        {
            if (IG || DoRandomGrind) return;

            bool useIt = false;
            
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                try
                {
                    TorCharacter CTx = MyTarget();
                    if (Buddy.CommonBot.ConditionParser.HasQuest(QuestID) && !Buddy.CommonBot.ConditionParser.IsStepComplete(QuestID, StepID))
                        if (theTarget != null && theTarget.Name.Contains(theTargetName) && theTarget.HealthPercent <= theTargetMinHealth) useIt = true;
                }
                catch { }
            }
            if (useIt) { StopMoving(); UseQuestItem(theItem, theTarget, theDist, WaitAfterCastMS); ClearTarget(); Thread.Sleep(2000); }
        }

        public static void CheckCombatQuestItemUsage()
        {
            if (IG || DoRandomGrind) return;

            CheckCombatQuestItemUsage(0xE0006744EE8D74C2, 2, "Savant Subjugation Device", CT, "Savant", 30f, 2.0f, 15000);
            CheckCombatQuestItemUsage(0xE0003BF69E6650DB, 2, "Veek's Modified Ion Gun", CT, "Unstable Defense Droid", 100f, 1.0f, 5000);
            CheckCombatQuestItemUsage(0xE00001C0DD51D63A, 2, "TM-09's Security Spikes", CT, "Reprogrammed Warden Droid", 100f, 2.0f, 5000);
            CheckCombatQuestItemUsage(0xE000AFA93F593BAE, 2, "Prophylaxis", CT, "Infected Gen'Dai", 100f, 1.6f, 5000);
        }

        // If I have myself or my own companion targeted, clear the target - name used due to possibility of a non-pointer/handle-match
        public static void ClearTargetIfNec()
        {
            try
            {
                if (AutoTarget && !IG && MyTarget() != null && (MyTarget().Guid==MyGUID || MyTarget().Name == CompName)) ClearTarget();
            }
            catch { }
        }

        public static bool IsPlayer(TorCharacter theUnit)
        {
            if (theUnit == null) return false;
            if (theUnit.Toughness != CombatToughness.Player) return false;
            return true;
        }

        public static bool IsComp(TorCharacter theUnit)
        {
            if (theUnit == null || theUnit.Toughness != CombatToughness.Companion) return false;
            return true;
        }

        public static bool ValidCombatTarget(TorNpc theUnit)
        {
            try
            {
                return ValidCombatTarget((TorCharacter)theUnit);
            }
            catch { return false; }
        }

        public static bool ValidCombatTarget(TorCharacter theUnit)
        {
            try 
            {
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {   
                    return (theUnit!=null && !theUnit.IsDeleted && theUnit.Name!=null && !OurGUIDs.Contains(theUnit.Guid.ToString()) 
                        && theUnit.HealthPercent>.05f && !IsPlayer(theUnit) && !IsComp(theUnit) && !(IG && (!theUnit.InCombat || theUnit.IsStunned)));
                }
            }
            catch {return false;}
        }


        public static void GetOps()
        {
        }

        public static void GetTarget()
        {
            DateTime datStart = DateTime.Now;
            //if (CT != null && !CT.IsDead && CT.HealthPercent > .1f && HP>65f) return;
            CT = null;

            TorCharacter CompX = LastComp;

            if (!IG)
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                try
                {
                    
                    if (!AutoTarget) { CT = MyTarget(); return; }
                    if (CompX != null) CompName = string.Copy(CompX.Name);
                    
                    MyName = BuddyTor.Me.Name;
                    MyGUID = BuddyTor.Me.Guid;
                    OurGUIDs = MyGUID.ToString() + (CompX != null ? CompX.Guid.ToString() : "");

                    TorCharacter CTx = MyTarget();
                   if (CTx != null && (MyTarget().Toughness==CombatToughness.Companion)) ClearTarget();
                   if (CTx != null && IsPlayer(CTx) && !Me.PvpFlagged) { Logger.Write("Current Target is Player.  Clearing Target..."); CT = null; ClearTarget(); }
                   if (CTx != null && CompName != "" && CompName != null && CTx.Name == CompName) { Logger.Write("Current Target is Companion.  Clearing Target..."); CT = null; ClearTarget(); }
                   if (CT == null || CT.IsDead || CT.HealthPercent < .1f)
                    {
                        if (!IAmInCombat()) { CT = CTx; return; }
                        // Target Comp's attackers if ProtectComp is set, and they're at a lower health than I am
                        if (!MovementAllowed && !IsRanged)
                            try
                            {
                                foreach (TorCharacter o in Attackers.OrderBy(o => o.Distance)) { CT = (TorCharacter)o; return; };
                            }
                            catch { }
                        if (ProtectCompWhenWeak && !IG && CHP <= 70f && CHP < HP && !CompX.IsDead && CompX.HealthPercent > .1f && IAmInCombat() && Attackers != null && Attackers.Count() > 0)
                            foreach (TorCharacter att in Attackers) if (att != null && !att.IsDeleted && !att.IsDead && att.HealthPercent > .2f && att.CurrentTarget.Name == CompName)
                                { /*Logger.Write("Block 2");*/ CT = att; return; }
                        if (Attackers != null) if (Attackers.Count() > 0)
                                foreach (TorNpc d in Attackers) if (d != null && !d.IsDeleted && d.Toughness != CombatToughness.Player && !d.IsDead && d.HealthPercent > .1f && d.Distance<=3.5f)
                                    { /*Logger.Write("Block 1"); */CT = (TorCharacter)d; return; }
                        if (CT == null && CompX != null && CompX.InCombat && CompTarg != null && CompTarg.Guid!=MyGUID) { TargetUnit(CompTarg); CT = CompTarg; return; }
                        if (Attackers != null) if (Attackers.Count() > 0)
                                foreach (TorNpc d in Attackers) if (d != null && !d.IsDeleted && d.Toughness != CombatToughness.Player && !d.IsDead && d.HealthPercent > .1f && d.Distance <= 3.5f)
                                    { /*Logger.Write("Block 1"); */CT = (TorCharacter)d; return; }

                        if (IAmInCombat() && CT == null)
                            foreach (TorCharacter t in ObjectManager.GetObjects<TorCharacter>()
                            .Where(t => t != null && !t.IsDeleted && t.InCombat)
                            .OrderBy(t => t.Distance)
                            )
                                if (!t.IsDead && (t.Toughness != CombatToughness.Player && t.Toughness != CombatToughness.Companion) && !t.IsDead && t.HealthPercent > .1f) { CT = t; return; }
                    }

                }
                catch { }
            else
            {
                //if (CT == null || IsPlayer(CT) || CT.IsDead || CT.HealthPercent < .1f)
                //using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    //TorCharacter GT = null;
                    if (!AutoTarget) { CT = MyTarget(); return; }
                    GetGroupTarget();
                    if (CT != null)
                    {
                        //CT = GT;
                        if (AutoTargetExplicit) TargetUnit(CT);
                        if (IG && CT != null && !CT.IsDeleted && !IsPlayer(CT) && CT.IsHostile) Is55H = (CT.Level >= 55);
                    }
                    else
                    {
                        if (Attackers != null) if (Attackers.Count() > 0) foreach (TorNpc d in Attackers) if (d.Toughness != CombatToughness.Player && !d.IsDead && d.HealthPercent > .1f && !d.IsStunned && d.CurrentTarget != null && d.CurrentTarget.Guid==MyGUID && !d.Name.Contains("ope-5")) { CT = d; break; }
                    }

                }
            }
            //if (IG) CT = MyTarget();


            //if (!IG && CT != null && !(CT.IsNeutral || CT.IsFriendly || CT.IsHostile))
            //{
            //    Logger.Write("Vendor/'Friendly' targeted, blacklisting.");
            //    if (!Buddy.CommonBot.Blacklist.Contains(CT.Guid)) Buddy.CommonBot.Blacklist.Add(CT, BlacklistFlags.Kill, TimeSpan.FromSeconds(300));
            //    if (!MyBlacklist.ContainsKey(CT.Guid)) MyBlacklist.Add(CT.Guid, DateTime.Now);
            //    CT = null;
            //    ClearTarget();
            //}
            if (ReportDurs) Logger.Write("GetTarget Duration: " + DateTime.Now.Subtract(datStart).TotalMilliseconds.ToString("0") + "ms");
        }

        public static void GetDebuffs(TorCharacter theChar, Dictionary<string, int> CopyTo = null, string sCopyTo = null)
        {
            DateTime datStart = DateTime.Now;

            using ((MercHelpers.UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                sLHDebuffs = "";
                sLHBuffs = "";
                LHDebuffs.Clear();
                foreach (TorEffect db in theChar.Debuffs.AsParallel().ToList())
                    try { LHDebuffs.Add(db.Name, db.Stacks); sLHDebuffs += db.Name + ":" + db.Stacks.ToString() + ";"; } 
                    catch { }
                foreach (TorEffect db in theChar.Buffs.AsParallel().ToList())
                    try { sLHBuffs += db.Name + ":" + db.Stacks.ToString() + ";"; }
                    catch { }
                if (sCopyTo != null) sCopyTo = sLHDebuffs;
                if (CopyTo != null) CopyTo = LHDebuffs;
            }
            if (ReportDurs) Logger.Write("GetDebuffs Duration: " + DateTime.Now.Subtract(datStart).TotalMilliseconds.ToString("0") + "ms");
        }

        public static void ShowObjCounts()
        {
            int CacheCt = ObjectManager.Cache.Count();
            int ObjCt = ObjectManager.GetObjects<TorObject>().Count();
            int NPCCt = ObjectManager.GetObjects<TorNpc>().Count();
            int PlyCt = ObjectManager.GetObjects<TorPlayer>().Count();
            int VndCt = ObjectManager.GetObjects<TorVendor>().Count();
            int PlcCt = ObjectManager.GetObjects<TorPlaceable>().Count();

            Logger.Write("ObjectManager: Objects - " + ObjCt.ToString() + " Placeables - " + PlcCt.ToString() + " NPCs - " + NPCCt.ToString() + " Players - " + PlyCt.ToString() + " Vendors - " + VndCt.ToString());
        }

        public static void UpdateObjects(bool FlushOld=false)
        {

            if (!EnableObjMgrUpd) return;
            if (DateTime.Now.Subtract(datLOMU).TotalMilliseconds<250) return;
            DateTime datStart = DateTime.Now;

            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            try
            {

                //Buddy.CommonBot.BotMain.CurrentBot.Pulse();

                if (ObjectManager.Cache.Count() > (int) 1000 || ObjectManager.Cache.Count() < (int) 0) ObjectManager.Cache.Clear();

                if (FlushOld) ObjectManager.FlushOldEntries();
                ObjectManager.Update(); ;
                
                datLOMU = DateTime.Now;
                
                if (ReportDurs) Logger.Write("UpdateObjects Duration: " + DateTime.Now.Subtract(datStart).TotalMilliseconds);
            }
            catch { Logger.Write("Error in UpdateObjects."); ObjectManager.Cache.Clear(); }

            //Logger.Write("UpdateObjects Duration: " + DateTime.Now.Subtract(datStart).TotalMilliseconds);
        }

        // Redundancy here is due to the fact it will not always target with the first line
        public static void TargetUnit(TorNpc theUnit)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                var theUnitX = (TorCharacter)theUnit;
                if (MyTarget() != theUnitX) { theUnitX.Target(); theUnitX.Target(); }
            }
            Thread.Sleep(50);
        }

        public static TorCharacter MyTarget()
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                return Me.CurrentTarget;
            }
        }
        public static void TargetUnit(TorPlayer theUnit)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (MyTarget() != theUnit) { theUnit.Target();}
            }
            Thread.Sleep(50); 
        }

        public static void TargetUnit(TorCharacter theUnit)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (MyTarget() != theUnit) { theUnit.Target(); }
            }
            Thread.Sleep(50);
        }

        public static void ClearTarget()
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (AutoTarget && MyTarget() != null) { BuddyTor.Me.ClearTarget();}
            }
            Thread.Sleep(50); 
        }

        public static float GetAlignment()
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                //float align = Me.ForceAlignmentLight + Me.ForceAlignmentDark;
                float align = Me.ForceAlignmentLight - Me.ForceAlignmentDark;
                //Logger.Write("Alignment: Dark " + Me.ForceAlignmentDark.ToString() + " Light " + Me.ForceAlignmentLight.ToString() + " Tier " + Me.ForceAlignmentTier.ToString() + " Returned " + align.ToString());
                return align;
            }

        }

        public static void UseKoltoStationIG()
        {
            try
            {
                if (DiffInSeconds(datLKSC, Now) < 4f) return;
                datLKSC = Now;
                if (!IG || DiffInSeconds(datLKSU, Now) < 30f) return;
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    foreach (TorPlaceable ks in ObjectManager.GetObjects<TorPlaceable>().Where(t => t.Distance <= .40f && (t.Name.Contains("Kolto Station")
                        || t.Name.Contains("Unrefined Kolto") || t.Name.Contains("Kolto Tank")))) { ks.Interact(); ks.Interact(); datLKSU = Now; break; }
                }
            }
            catch { }
        }

        public static void LoadVars()
        {

            try
            {
                //using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                //{
                //    // Only a hunch at this point, but from what I've seen, querying an object type will force an object-update for all those typed-objects.
                //    //var allObj = ObjectManager.GetObjects<TorObject>();
                //}

                CheckGC();
                SynchObjCache(true, true,true);
                UpdateObjects();

                bool NoTargetWait = false;
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    if (!AutoTarget && (MyTarget() == null || MyTarget().IsDead || MyTarget().HealthPercent < .2f)) NoTargetWait = true;
                }
                if (NoTargetWait) { CT = null; TD = 100; Thread.Sleep(1000); return; }

                if (IAmDead()) return;

                DateTime LVStart = DateTime.Now;

                if (!IG && IAmInCombat()) CheckCombatQuestItemUsage();
                UseKoltoStationIG();

                //if (IsPlayer(MyTarget())) ClearTarget();

                if (!IG && DoRandomGrind) AutoTarget = true;
                //if (!AutoTarget) AutoTargetExplicit = false;

                //ShowObjCounts();

                CheckForGroup();
                GetAttackers();

                CompTarg = null;

                PullIG = false;                                 // They wanna pull shit, they can do it MANUALLY

                CHP = 100;
                TD = 100f;
                RS = 50f;
                TC = false;
                LHH = 0f;
                CTT = CombatToughness.None;
                CTName = "";
                LHD = 100f;
                THP = 0f;
                THP = 100f;

                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {

                    MyName = BuddyTor.Me.Name;
                    MyGUID = BuddyTor.Me.Guid;

                    try
                    {
                        if (!IG && MyTarget() != null && CompName != "" && MyTarget().Name == CompName) ClearTarget();
                        if (MyTarget() != null && MyTarget().Guid==MyGUID) ClearTarget();
                    }
                    catch { }
                    
                    MyLevel = Me.Level;

                    RS = BuddyTor.Me.ResourceStat;
                    HP = BuddyTor.Me.HealthPercent;
                    EP = BuddyTor.Me.EnergyPercent;
                    FP = BuddyTor.Me.ForcePercent;

                    FF = false;

                    LastCombatPt = new Vector3(Me.Position.X, Me.Position.Y, Me.Position.Z);

                    if (Me.Class == CharacterClass.BountyHunter || Me.Class == CharacterClass.Trooper)
                    {
                        RS = Math.Min((float)Me.ResourceStat, (float)Me.EnergyPercent);
                        RS = Math.Min(RS, (float)Me.Energy);
                    }
                }
                
                if (Me.Class == CharacterClass.Warrior) FF = HaveBuffStacks("Fury", 30);
                if (Me.Class == CharacterClass.Knight) FF = HaveBuffStacks("Centering", 30);

                CTP = null;
                GetTarget();
                GetEffects();

                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    if (CT != null) if (CT.Guid != CG)
                    {
                        Logger.Write("Initiating Combat with " + CT.Name + " InGroup: " + IG.ToString() + " My Spec: " + MySpec.ToString() + " IsRanged: " + IsRanged.ToString());
                        if (AutoTargetExplicit && CT != MyTarget() && CT!=Me) TargetUnit(CT);
                        CG = CT.Guid;
                        CS = DateTime.Now;
                    }
                }

                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    if (CT != null)
                    //try
                    {
                        CTT = CombatToughness.None;
                        MeleeDist = .39f;
                        try
                        {
                            THP = CT.HealthPercent;
                            TC = CT.IsCasting;
                            TD = (float)BuddyTor.Me.Position.Distance(CT.Position);
                            SoG = StrongOrGreater(CT);
                            CTT = CT.Toughness;
                            CTName = String.Copy(CT.Name.ToLower());
                            if (CT.Scale == .80f || CT.Scale == 1.6f || CTName.Contains("ed guur") || CTName.Contains("ay stalker") || CTName.Contains("ay hunt") || CTName.Contains("er tank")
                                || CTName.Contains("tan crush") || CTName.Contains("eadtooth") || CTName.Contains("sed kint") || CTName.Contains("ter mak") || CTName.Contains("ted eld")) MeleeDist = 1.0f;
                        }
                        catch { CT = null; TD = 100; TC = false; THP = 0; CTT = CombatToughness.None; TD = 100f; SoG = false; CTName = ""; }
                    }
                    //catch { }
                }
                if (CT!=null && CT != MyTarget() && AutoTargetExplicit && CT.Guid!=MyGUID) TargetUnit(CT);

                TWR30 = 0;
                TWR10 = 0;
                TWR5 = 0;

                if (Attackers != null)
                    try
                    {
                        DateTime datStart = DateTime.Now;
                        using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                        {
                            TWR30 = Attackers.Where(o => o.Distance <= 3.0f).Count();
                            TWR10 = Attackers.Where(o => o.Distance <= 1.50f).Count();
                            TWR5 = Attackers.Where(o => o.Distance <= MeleeDist).Count();
                        }
                        if (ReportDurs) Logger.Write("TWR Dur: " + DateTime.Now.Subtract(datStart).TotalMilliseconds.ToString("0") + "ms");
                    }
                    catch { }
                //}

                UpdateObjects();

                if (ReportDurs) Logger.Write("LoadVar Dur: " + DateTime.Now.Subtract(LVStart).TotalMilliseconds.ToString("0") + "ms");
                //Logger.Write("LoadVar Dur: " + DateTime.Now.Subtract(LVStart).TotalMilliseconds.ToString("0") + "ms");
            }
            catch (Exception ex)
            {
                Logger.Write("Error in LoadVars:  " + ex.Message.ToString());
                CT = null;
                //ClearCacheAndPOI();
            }
            //UpdateObjects();

        }

        public static bool UpdateCompInfo(TorCharacter theComp)
        {
            if (theComp == null) return false;
            try
            {
                LastComp = theComp; CompTarg = LastComp.CurrentTarget; CHP = LastComp.HealthPercent; CompName = theComp.Name; datLCC = DateTime.Now;
            }
            catch { LastComp = null; THP = 100f; return false; }
            return true;
        }

        //public static bool IsBG { get { return BuddyTor.Me.AdvancedClass == Buddy.Swtor.AdvancedClass.Mercenary; } }
        //public static bool IsCM { get { return BuddyTor.Me.AdvancedClass == Buddy.Swtor.AdvancedClass.Commando; } }
        //public static bool IsSage { get { return BuddyTor.Me.AdvancedClass == Buddy.Swtor.AdvancedClass.Sage; } }

        //public static void CheckForHeals(float minH)
        //{
        //    try
        //    {

        //        LHUnit = null;
        //        LHUnit = UnitLowOnHealth(minH);
        //        LHH = 100f;
        //        LHD = 100f;

        //        if (LHUnit != null)
        //        {
        //            LHH = LHUnit.HealthPercent;
        //            LHD = LHUnit.Distance;
        //            LHP = LHUnit.Position;
        //        }
        //    }
        //    catch { }
        //}

        // Get the 'Group Target'
        // Verify that the player's target IS NOT a player.
        // Trying to query objects objects of NPC/Player type, by using type, doesn't work at the moment, so you get Players with an NPC query, and vice versa.
        // To Sum it All Up:  Listen to the song, 'Hot Dog', by Limp Bizkit.

        //public static TorCharacter GetGroupTarget()
        //{
        //    try
        //    {
        //        foreach (TorPlayer unit in ObjectManager.GetObjects<TorPlayer>().OrderBy(o => o.Distance).Where(o => o != null && !o.IsDeleted && o.Toughness == CombatToughness.Player && o.Name != MyName))
        //            try
        //            {
        //                if (unit.Distance <= 4.5f && unit.Toughness == CombatToughness.Player)
        //                {
        //                    TorCharacter t = unit.CurrentTarget;
        //                    if (t != null && t.IsHostile && t.Toughness != CombatToughness.Player && unit.InCombat && !unit.IsStunned && !t.IsDead && t.HealthPercent > .1f)
        //                    {
        //                        Logger.Write("Group Target Determined: " + t.Name);
        //                        return (TorCharacter)t;
        //                    }
        //                }
        //            }
        //            catch { }
        //        foreach (TorCharacter o in ObjectManager.GetObjects<TorCharacter>().OrderBy(o => o.Distance)
        //          .Where(o => o != null && !o.IsDeleted && o.Toughness != CombatToughness.Player && o.Name != MyName && o.InCombat && o.CurrentTarget != null &&
        //           o.CurrentTarget.Name == MyName)) return (TorCharacter)o;
        //    }
        //    catch { } return null;
        //}

        public static bool IsBoss(TorCharacter theChar)
        { 
            if (theChar == null) return false;
            return theChar.Toughness==CombatToughness.Boss2 || theChar.Toughness==CombatToughness.Boss3 || theChar.Toughness==CombatToughness.Boss4 || theChar.Toughness==CombatToughness.RaidBoss;
        }

        public static bool InGroupMobTargetingMe(TorCharacter o)
        {
            try
            {
                return o != null && !o.IsDeleted && o.InCombat &&
                                o.InLineOfSight && o.Distance <= 2.9f && !IsBoss(o) && o.Toughness != CombatToughness.Player && !o.IsStunned && o.IsHostile &&
                                o.CurrentTarget != null && o.CurrentTarget.Guid == MyGUID && !o.Name.Contains("ope-5");
            }
            catch { return false; }
        }

        public static bool InGroupTargetingMob(TorPlayer o)
        { 
            try {
                if (o != null && !o.IsDeleted && o.InCombat && o.Toughness == CombatToughness.Player && o.Distance <= 4.5f && o.CurrentTarget != null && o.Guid!=MyGUID)
                {
                    TorCharacter t = o.CurrentTarget;
                    if (t != null && (t.InLineOfSight || MovementAllowed) && t.IsHostile && t.Toughness != CombatToughness.Player && !t.IsStunned && !t.IsDead && t.HealthPercent > .1f && t.Distance < 2.9f && !t.Name.Contains("ope-5"))
                    {
                        //Logger.Write("Group Target Determined: " + t.Name);
                        CT = (TorCharacter)t; return true;
                    }
                }
            } catch {return false;}
            return false;
        }

        public static bool ValidGroupMobTarget(TorNpc o)
        {
            try
            {
                if (o.Toughness != CombatToughness.Player && o.IsHostile && o.InLineOfSight && o.Distance <= 2.9f && !o.IsDead && o.HealthPercent > .1f && !o.IsStunned
                                        && o.CurrentTarget != null && o.CurrentTarget.Toughness == CombatToughness.Player && o.Guid != MyGUID && !o.Name.Contains("ope-5")) return true;
            }
            catch { return false; }
            return false;
        }

        /* For future use, TC is a PAIN IN THE ASS FOR TARGETING
            Area: 4000004CA903BD77
            Area Name: raid_makeb_lair
         */
         /* KUAT
            Area: 4000004D034ED262
            Area Name: daily_spc_kuat_drives
            Instance ID: 2
            Room: sc3_entranceroom
        */
        /* TFB 
            Area: 4000010722E59D19
            Area Name: raid_asation
            Room: 04_temple_exit_hall
        */
        /* SNV
            Area: 4000004BE144883D
            Area Name: raid_darvannis
            Room: 02_caverns_cave
         * */

        /* DP, Council...
            Area: 400000411B12E022
            Area Name: raid_ori_dreadpalace
            Room: 12_final_boss
        */
        /* TFB, 2nd-To-Last Fight...
            Area: 4000010722E59D19
            Area Name: raid_asation
            Room: 05_hypergate
         */
        /* TFB, Final Boss....
        Area: 4000010722E59D19
        Area Name: raid_asation
        Room: 04_temple_exit */

        public static void GetGroupTarget()
        {
            //if (CT == null || CT.IsDead || CT.HealthPercent < .1f)
            // Kuat Drive Yards - May have boss targeted but then his helpers pop, need to flip to them as they appear, so commented out the If
            if (!AutoTarget) return;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (AmTank) if (GetGroupTankTarget()) return;

                try
                {
                    if (IG && BuddyTor.Client.AreaID == 0x4000004CA903BD77) //Tobarro's Courtyard //if (IsRanged)
                    {
                        CT = null;
                        ClearTarget();
                        foreach (TorNpc o in ObjectManager.GetObjects<TorNpc>().AsParallel().ToList().Where(o => o != null && !o.IsDeleted && !o.IsDead).OrderBy(t => t.Distance).ToList())
                                try
                                {
                                    if (o.IsHostile && o.InCombat && o.Distance <= 2.9f && (o.Name.Contains("Golden Fury") || o.Name.Contains("Droid"))) { CT = (TorCharacter)o; OpsID = 1; return; };
                                }
                                catch { }
                            return;
                        }
                }
                catch { }
            }
            // NEXT, if Melee (DPS or Tank), target the CLOSEST mob
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (!MovementAllowed && !IsRanged)
                    try
                    {
                        foreach (TorNpc o in Attackers.AsParallel().ToList().OrderBy(o => o.Distance)) { CT = (TorCharacter)o; return; };
                    }
                    catch { }
            }
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (IG && InGroupTargetWeakest && IsRanged)
                {
                    foreach (TorNpc unit in ObjectManager.GetObjects<TorNpc>().AsParallel().ToList().OrderBy(o => o.HealthMax).Where(o => o != null && !o.IsDeleted && o.InCombat))
                        try { if (ValidGroupMobTarget(unit)) { CT = unit; return; } }
                        catch { }
                }
                try
                {
                    foreach (TorNpc o in ObjectManager.GetObjects<TorCharacter>().AsParallel().ToList().OrderBy(o => o.Distance).Where(o => InGroupMobTargetingMe(o))) { CT = (TorCharacter)o; return; };
                }
                catch { }
                try
                {
                    if (IsRanged) foreach (TorPlayer o in ObjectManager.GetObjects<TorPlayer>().AsParallel().ToList().OrderBy(o => o.Distance).Where(o => InGroupTargetingMob(o))) { return; }
                }
                catch { }
                CT = null;
            }

            //else return CT;
        }

        public static bool CheckPlayerBuffs(string Buff)
        {
            if (BuddyTor.Me.IsMounted) return false;
            if (DateTime.Now.Subtract(datLBC).TotalSeconds < 20) return false;
            try
            {
                UpdateObjects();
                SynchObjCache(true, true);
                TorCharacter tgt = null;
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    foreach (TorPlayer unit in ObjectManager.GetObjects<TorPlayer>().AsParallel().ToList().OrderBy(t => t.HealthPercent).Where(t => t != null && !t.IsDeleted && t != Me))
                        if (unit.Toughness == CombatToughness.Player && unit.Distance <= 2.8f && unit.IsFriendly && unit.InLineOfSight && !unit.HasBuff(Buff)) { tgt = unit; break; }
                }
                if (tgt!=null)
                    { datLBC = DateTime.Now; MercCast(Buff, tgt); Thread.Sleep(500); ClearTarget(); return true; }
            }
            catch { 
                return false; 
            }
            return false;
        }

        public static void TryRez(TorCharacter theChar)
        {

            if (DiffInSeconds(LastRez, Now) < 300f) return;

            MoveTo(theChar, 2.9f);
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
            if (theChar.InLineOfSight && theChar.Distance <= 2.9f && (theChar.HealthPercent<.2f || theChar.IsDead))
                if (IAmInCombat())
                {
                    if (MySpec == SkillTreeId.SorcererCorruption) MercForcedCast("Reanimation", theChar);
                    else if (MySpec == SkillTreeId.OperativeMedic) MercForcedCast("Resuscitation Probe", theChar);
                    else if (MySpec == SkillTreeId.MercenaryBodyguard) MercForcedCast("Onboard AED", theChar);
                    else if (MySpec == SkillTreeId.SageSeer) MercForcedCast("Revival", theChar);
                    else if (MySpec == SkillTreeId.ScoundrelSawbones) MercForcedCast("Heartrigger Patch", theChar);
                    else if (MySpec == SkillTreeId.CommandoCombatMedic) MercForcedCast("Emergency Medical Probe", theChar);
                    Thread.Sleep(500);
                    LastRez = Now;
                    WaitForCast();
                }
                else
                {
                    theChar.Interact(); Thread.Sleep(500); theChar.Interact();
                }
            }        }

        public static void GetGroupDead()
        {
            IEnumerable<TorPlayer> theDead;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                 theDead = ObjectManager.GetObjects<TorPlayer>().OrderBy(o => o.HealthPercent).Where(t => t != null && !t.IsDeleted && (t.IsDead || t.HealthPercent<.1f)).ToList();
            }
            if (theDead!=null && theDead.Count()>0) foreach (TorPlayer o in theDead)
                {
                    TorCharacter theChar = (TorCharacter)o;
            }
        }

        public static bool ValidHealTarget(TorCharacter t, float minH)
        {
            try
            {

                return (t != null && !t.IsDeleted &&
                              !t.IsHostile && t.Toughness == CombatToughness.Player && t.Distance <= 2.9f);
                // Commented-out - causes players to sometimes get missed for some reason (bad HP ptr?) , and die, no bueno
                // && (float)t.HealthPercent < minH && (float)t.HealthPercent > .1f);
            }
            catch { return false; }
        }

        public static DateTime LastRez = Now.Subtract(TimeSpan.FromMinutes(300));

        public static void RunNPCHeals(float minH)
        {
            if (GroupSize < 8) return;

            LHUnit = null;
            LHH = 100f;
            LHD = 100f;

            LHUnit = null; LHH = 100;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                UpdateObjects();
                try
                {
                    var healNPCList = ObjectManager.GetObjects<TorNpc>().OrderBy(t=>t.Distance).Where(t => t != null && !t.IsDeleted && t.InLineOfSight && t.Distance <= 2.9f && !t.IsHostile
                         && ((t.Name.Contains("Seed of Knowl") || t.Name.Contains("Dying Capt")) && t.HealthPercent <= 75f)).AsParallel().ToArray();
                    if (healNPCList != null && healNPCList.Count() > 0)
                    {
                        foreach (TorCharacter npc in healNPCList)
                            try
                            {
                                { LHH = UHP(LHUnit); LHUnit = npc; break; }
                            }
                            catch { }
                    }
                }
                catch { }
            }
            if (LHUnit != null)
            {
                TargetUnit(LHUnit);
                UpdateObjects();
                Thread.Sleep(400);

                if (Me.AdvancedClass == AdvancedClass.Mercenary) { BGHeals(); }
                else if (Me.AdvancedClass == AdvancedClass.Commando) CMHeals();
                else if (Me.AdvancedClass == AdvancedClass.Sorcerer) { CorruptionHeals(); }
                else if (Me.AdvancedClass == AdvancedClass.Sage) { SeerHeals();}
                else if (Me.AdvancedClass == AdvancedClass.Operative) MedicineHeals();
                else if (Me.AdvancedClass == AdvancedClass.Scoundrel) SawbonesHeals();
                else { Logger.Write("Spec not detected for Heals, exiting loop."); }

                Thread.Sleep(700);
                WaitForCast();
                ClearTarget();
            }
        }

        public static void GetGroupLHUnitInfo(float minH)
        {
            LHUnit = null;
            LHH = 100f;
            LHD = 100f;
            int C = GroupSize <= 8 ? 2 : 1;
            //int C = 1;

            for (int inti = 0; inti < C; inti++)
            {

                MyGroup.Clear();
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    UpdateObjects();
                    MyGroup = ObjectManager.GetObjects<TorPlayer>().OrderBy(o => o.HealthPercent).Where(t => (t.cbtFaction == Me.cbtFaction && ValidHealTarget(t, minH))).AsParallel().ToList();
                    //try 
                    //{
                    //    var seedTest = ObjectManager.GetObjects<TorCharacter>().Where(t=>t!=null && !t.IsDeleted &&  t.InLineOfSight && t.Distance<=2.9f && t.Name.Length > 0 && (t.Name.Contains("Seed of Knowl") || t.Name.Contains("Dying Capt")));
                    //    if (seedTest != null && seedTest.Count() > 0)
                    //    {
                    //        foreach (TorCharacter npc in seedTest) { MyGroup.Add((TorPlayer)npc); break; }
                    //        List<TorPlayer> gTemp = MyGroup.OrderBy(t => t.HealthPercent).ToList();
                    //        MyGroup = gTemp;
                    //    }
                    //} catch {}
                    foreach (TorPlayer unit in MyGroup)//.Where(o=>o.Distance<=3.00f))
                        try
                        {
                            if (unit.IsDead || unit.HealthPercent < .2f)
                            {
                                if (DiffInSeconds(LastRez, Now) >= 300f || !IAmInCombat())
                                    TryRez((TorCharacter)unit);
                            }
                            else
                            {
                                TorPlayer unitX = unit;
                                float uhp = unit.HealthPercent;
                                //Logger.Write("Unit: " + unit.Name + " HP: " + uhp.ToString());
                                if (uhp <= minH && unit.Distance <= 2.9f)
                                {
                                    FP = Me.ForcePercent;
                                    RS = Me.ResourceStat;
                                    LHUnit = unitX;
                                    LHH = (float)LHUnit.HealthPercent;
                                    LHD = LHUnit.Distance;
                                    LHP = LHUnit.Position;
                                    GetDebuffs(LHUnit);
                                    return;
                                }
                            }
                        }
                        catch { }
                    Thread.Sleep(50);
                }
            }
        }

        public static bool MercMoveAndStop(TorCharacter tc, float rng)
        {
            CommonBehaviors.MoveAndStop(ret => tc.Position, rng, true, "Target Position");
            return false;

        }

        public static bool MercCheckCompHealth(float MinH)
        {
            TorCharacter PT = MyTarget();
            try
            {
                var CompX = LastComp;
                if (CompX == null || CompX.IsDead) return false;

                while (CompX.HealthPercent < MinH)
                {
                    if (CHP < 1f && DiffInSeconds(LastRez, Now)>=300f)
                    {
                        MercForcedCast("Onboard AED", CompX);
                        LastRez = Now;
                    }
                    else if (CompX.HealthPercent<MinH)
                    {
                        Thread.Sleep(250);
                        if (WaitForCast()) return false;

                        MoveTo(CompX, 2.8f);

                        TargetUnit(CompX);
                        Thread.Sleep(400);

                        WaitForCast();

                        // Lines commented-out NEVER SEEM TO WORK PERIOD on a Comp
                        bool HealedComp =
                        MercCastOnGround("Kolto Missile", true, CompX)
                         || MercCast("Emergency Scan", CompX)
                         || MercCast("Kolto Shell", CompX, !CompX.HasBuff("Kolto Shell"))
                      // || MercCast("Kolto Shield", CompX, !CompX.HasBuff("Kolto Shield"))
                         || MercCast("Healing Scan", CompX)
                         || MercCast("Rapid Scan", CompX)
                         || MercCast("Rapid Shots", CompX, HaveBuff("Combat Support Cylinder"));

                        Thread.Sleep(250);
                        if (WaitForCast()) return true;
                    }
                }

                }
            catch { Logger.Write("Error in CheckCompHealth()"); }

            TargetUnit(PT);
            Thread.Sleep(300);

            return false;
        }

        public static bool CMCheckCompHealth()
        {
            try
            {

                if (LastComp == null) return false;
                var CompX = LastComp;

                if (CompX == null) return false;
                TorCharacter PT = MyTarget();

                HandleDebuffs(CompX);

                while (CompX.HealthPercent<(AmHealer()?85f:50f))
                {
                    WaitForCast();
                    TargetUnit(CompX);
                    Thread.Sleep(400);
                    if (Comp.Distance > 2.8f) { MoveTo(Comp, 2.8f); Thread.Sleep(300); }
                    if (CHP < 1f)
                    {
                        if (MercCast("Onboard AED", CompX)) return true;
                    }
                    else
                    {

                        if (MercCastOnGround("Kolto Bomb", true, CompX)) Thread.Sleep(600);

                        if (
                            MercCast("Trauma Probe", CompX, !CompX.HasBuff("Trauma Probe")) ||
                            MercCast("Advanced Medical Probe", CompX) ||
                            MercCast("Bacta Infusion", CompX) ||
                            MercCast("Medical Probe", CompX) ||
                            (HaveBuff("Combat Support Cell") && MercCast("Hammer Shot", CompX)))
                        {
                            Thread.Sleep(250);
                            if (PT == null || PT.Toughness == CombatToughness.Companion) 
                                ClearTarget();
                            else 
                                TargetUnit(PT);
                            return true;
                        }
                    }
                }
            }
            catch { Logger.Write("Error in CheckCompHealth()"); }

            return false;
        }

        public static bool OperativeCheckCompHealth(float minH=75f)
        {
            if (WaitForCast() || IG) return false;

            try
            {

                if (LastComp == null) return false;
                var CompX = LastComp;
                if (UHP(CompX) > minH) return false;

                if (UnitIsDead(CompX)) { TryRez(CompX); if (UnitIsDead(CompX)) return false; }
                
                    while (UHP(CompX) <= minH)
                {
                    TargetUnit(CompX);
                    Thread.Sleep(400);

                    if (CompX.Distance > 2.8f) { MoveTo(CompX, 2.8f); Thread.Sleep(300); }
                    else
                    {
                        if (MercCast("Recuperative Nanotech", CompX)) break;
                        if (MercCast("Kolto Probe", CompX, !HasBuffStacks(CompX, "Kolto Probe", 2))) break;
                        if (MercCast("Surgical Probe", CompX, HaveBuffStacks("Tactical Advantage", 2))) break;
                        if (MercCast("Toxin Scan", CompX, NeedsDispell(CompX))) break;
                        if (MercCast("Kolto Infusion", CompX, HaveBuffStacks("Tactical Advantage", 1))) break;
                        if (MercCast("Kolto Injection", CompX)) break;
                    }
                    if (WaitForCast()) return true;
                }
                Thread.Sleep(250);
                ClearTarget();
                if (WaitForCast()) return true;
            }
            catch { Logger.Write("Error in CheckCompHealth()"); }

            return false;
        }

        public static bool SageCheckCompHealth(float minH)
        {
            try
            {
                if (LastComp==null) return false;
                var CompX = LastComp;

                if (CompX.IsDead && DiffInSeconds(LastRez, Now) >= 300f && CompX.Distance <= 2.9f) if (MercForcedCast("Revival", CompX)) { Thread.Sleep(300); WaitForCast(); LastRez = Now; }

                if (CompX.HealthPercent > minH || CompX.IsDead || CompX.HealthPercent<.1f) return false;

                Thread.Sleep(250);
                if (WaitForCast()) return false;

                while (true)
                {

                    if (CompX.Distance > 2.8f) { MoveTo(CompX, 2.8f); }
                    TargetUnit(CompX);
                    TargetUnit(CompX);
                    Thread.Sleep(400);
                    //if (MyTarget() != CompX) break; // Sometimes this shit bugs out - WILL NOT TARGET YOUR COMP - if so, then just get out

                    //if (taForceArmor.IsValid && Me.AbilityActivate(taForceArmor, CompX, out er)) WaitForCast();
                    if (MercCast("Force Armor", CompX,!CompX.HasDebuff("Force-imbalance"))) Thread.Sleep(900);

                    if (MercCast("Healing Trance", CompX, true)) break;
                    if (MercCast("Rejuvenate", CompX, !CompX.HasBuff("Rejuvenate"))) break;
                    if (MercCastOnGround("Salvation", true, CompX)) break;
                    if (MercCast("Benevolence", CompX)) break;
                    if (MercCast("Deliverance", CompX)) break;
                    if (MercCast("Rescue", CompX, CHP <= 20f)) break;

                    Thread.Sleep(250);
                    //if (WaitForCast()) break;
                    break;

                    //if (CompX.HealthPercent > minH || CompX.IsDead || CompX.HealthPercent < .1f) break;
                }
            }

            catch {}
            ClearTarget(); Thread.Sleep(300);

            return false;
        }

        public static bool UnitIsDead(TorCharacter theUnit)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                return theUnit.IsDead || theUnit.HealthPercent < .05f;
            }
        }

        public static bool SorcererCheckCompHealth(float minH = 75f)
        {
            try
            {
                if (WaitForCast()) return false;

                var CompX=LastComp;
                if (CompX==null || CompX.HealthPercent>minH) return false;
                if (UnitIsDead(CompX) && DiffInSeconds(LastRez, Now) < 300) return false;
                MoveTo(CompX, 2.8f);

                while (true)
                {

                    TargetUnit(CompX); Thread.Sleep(350);
                    if (UnitIsDead(CompX))
                    {
                        LastRez = Now;
                        MercCast("Reanimation", CompX);
                        ChainCastWait();
                        break;
                    }

                    if (MyTarget() == null || MyTarget().Name != CompName) break;

                    if (!CompX.HasBuff("Static Barrier") && !CompX.HasDebuff("Deionized")) if (MercCast("Static Barrier", CompX)) Thread.Sleep(900);
                    if (MercCast("Expunge", CompX, NeedsDispell(CompX))) Thread.Sleep(900);

                    bool HealedComp = 
                    MercCast("Resurgence", CompX)
                      || MercCast("Innervate", CompX)
                      || MercCast("Dark Infusion", CompX, !CompX.HasBuff("Dark Infusion"))
                      || MercCastOnGround("Revivification", true, CompX)
                  //  || MercCast("Rejuvenate", CompX, !CompX.HasBuff("Rejuvenate"))
                      || MercCast("Dark Heal", CompX)
                      || MercCast("Rescue", CompX, CHP <= 20);

                    Thread.Sleep(350);
                    if (WaitForCast()) break ;

                    if (CompX.HealthPercent > minH || Me.ResourceStat<=20f) break;
                    
                }
            } catch //(Exception ex) 
            {}
            ClearTarget();
            Thread.Sleep(250);
            return false;
        }

        //public static void TagAlongWithGroup()
        //{
        //    if (BuddyTor.Me.PvpFlagged) return;

        //    foreach (TorPlayer unit in ObjectManager.GetObjects<TorPlayer>().OrderBy(t => t.Distance).Reverse())
        //        if (unit!=null && !unit.IsDeleted) try
        //        {
        //            MoveTo(unit, 2.0f);
        //            break;
        //        }
        //        catch { }
            
        //}


        //public static bool UnitHasBuff(TorCharacter theUnit, string theBuff)
        //{ 
        //    foreach (var buf in theUnit.Buffs) try
        //        {
        //            if (buf != null && !buf.IsDeleted && buf.Name.Contains(theBuff)) return true;
        //        }
        //        catch { }
        //    return false;
        //}


        public static bool BGHeals()
        {
            bool RanHeal = false;

            //if (Me.PvpFlagged && MercCastOnGround("Kolto Missile", true, LHUnit)) return true;
            if (MercCast("Power Surge", LHH <= 50f)) ChainCastWait();

            if (MercCastOnGround("Kolto Missile", true, LHUnit)) return true;
            if (MercCast("Kolto Shell", LHUnit, !HasBuffStacks(LHUnit, "Kolto Shell", 1))) return true;
            if (NeedsDispell(LHUnit) && MercCast("Cure", LHUnit)) return true;

            if (HaveBuffStacks("Supercharge", 30) && MercCast("Supercharge Cells", Me)) return true;
            if (MercCast("Supercharged Gas")) return true;
            if (MercCast("Vent Heat", RS <= 20f)) return true;
            if (LHH >= 75f && IAmInCombat() && MercCast("Rapid Shots", LHUnit)) return true;
            if (MercCast("Power Surge", Me, RS <= 30f)) return true;
            if (MercCast("Thermal Sensor Override", RS <= 30f)) return true;
            if (MercCast("Emergency Scan", LHUnit)) return true;
            if ((HaveBuffStacks("Critical Efficiency",1) || (LHH <= 60f)) && MercCast("Rapid Scan", LHUnit)) return true;
            if (MercCast("Healing Scan", LHUnit, true)) return true;
            if (MercForcedCast("Rapid Shots", LHUnit)) return true;
            //else { if (MercForcedCast("Kolto Missile", LHUnit.Position) || MercForcedCast("Rapid Shota", LHUnit)) RanHeals = true; }
            return RanHeal;
        }

        public static bool RunHeals(float minH, bool UntilFullyHealed = true)
        {
            //if (GC<=4) GetGroupDead();

            TorCharacter pt = null;
            if (!AutoTarget) pt = MyTarget();

            if (GroupSize > 4) RunNPCHeals(minH);

            bool RanHeals = false;
            try
            {
                GetGroupLHUnitInfo(minH);
                if (LHUnit == null || LHUnit.HealthPercent > minH) return false;

                Thread.Sleep(250);
                if (WaitForCast()) return false;
                WaitForCast();

                TargetUnit(LHUnit);
                Thread.Sleep(400);

                while (true)
                {

                    //WaitForCast();
                    MoveTo(LHUnit, 2.9f);
                    if (!LHUnit.InLineOfSight || LHUnit.Distance > 3.0f) break;

                    //LHUnit.Target(); Thread.Sleep(350);
                    //Buddy.CommonBot.GameEvents.Update();
                    //SynchObjCache(false, true, true, true);
                    UpdateObjects();
                    Thread.Sleep(250);

                    if (Me.AdvancedClass == AdvancedClass.Mercenary) { if (!BGHeals()) break; }
                    else if (Me.AdvancedClass==AdvancedClass.Commando) CMHeals();
                    else if (Me.AdvancedClass==AdvancedClass.Sorcerer) {if(!CorruptionHeals())break;}
                    else if (Me.AdvancedClass == AdvancedClass.Sage) { if (!SeerHeals()) break; }
                    else if (Me.AdvancedClass == AdvancedClass.Operative) MedicineHeals();
                    else if (Me.AdvancedClass == AdvancedClass.Scoundrel) SawbonesHeals();
                    else { Logger.Write("Spec not detected for Heals, exiting loop."); break; }

                    Thread.Sleep(700);
                    if (WaitForCast()) { ClearTarget(); return false; }
                    GetGroupLHUnitInfo(minH);
                    if (LHUnit == null || LHH > minH) break;

                    TargetUnit(LHUnit);
                    Thread.Sleep(400);

                }

                //var pt = GetGroupTarget();
                ClearTarget();
                if (!AutoTarget) CT = pt; else  GetGroupTarget();
                if (CT != null && !IsPlayer(CT)) TargetUnit(CT);
                Thread.Sleep(150);
                WaitForCast();
                //return false;
            }
            catch { }
            return RanHeals;

        }
        public static void GetGroupSize()
        {
            try
            {
                var MyGroup=ObjectManager.GetObjects<TorPlayer>();
                GroupSize = MyGroup.Count();
                List<SkillTreeId> GroupSpecs=new List<SkillTreeId>();
                foreach (TorPlayer p in MyGroup)
                    if (p.Guid != MyGUID) { var theSTID = SpecHandler.GetSpec(p); GroupSpecs.Add(theSTID); if (IsTank(theSTID) && theTank==null) theTank = p; Logger.Write("Tank Determined as " + theTank.Name); }
            }
            catch { }
            Logger.Write("In-Group.  Group Size: " + GroupSize.ToString());
        }

        public static void CMHeals()
        {
            if (!MercCastOnGround("Kolto Bomb", true, LHUnit))
            if (!MercCast("Trauma Probe", LHUnit, !HasBuff("Trauma Probe", LHUnit)))
            if (!MercCast("Field Aid", LHUnit, NeedsDispell(LHUnit)))
            if (!MercCastOnGround("Kolto Bomb", true, LHUnit))
            if (!MercCast("Bacta Infusion", LHUnit, LHH <= 65f))
            if (!MercCast("Medical Probe", LHUnit, HaveBuff("Field Triage") || HaveBuff("Tech Override") || LHH <= 70f))
            if (!MercCast("Advanced Medical Probe", LHUnit, true))
            if (!MercCast("Supercharge Cells", Me))
            if (!MercCast("Hammer Shot", LHUnit))AbilityManager.Cast("Kolto Bomb", LHUnit.Position);

        }

        public static bool NeedsDispell(TorCharacter theUnit)
        {
            //bool DoPurge = false;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (theUnit == null) return false;

                try {
                    if (IG && LHUnit!=null && theUnit.Guid == LHUnit.Guid)
                        return (LHDebuffs.ContainsKey("Targeted Laser") && LHDebuffs["Targeted Laser"] >= 3) || sLHDebuffs.Contains("Voice of the Master") ||
                        sLHDebuffs.Contains("Crushing Affliction") || sLHDebuffs.Contains("Corrupted Nanites") ||
                        LHDebuffs.Count() >= 3 || LHDebuffs.Where(t => t.Value >= 3).Count() > 0;
                } catch {}
                
                // Try/Catch done because of sporadic errors here
                bool nd = false;
                try {if (!nd) nd = (theUnit.Debuffs.Count() >= 3);} catch {}
                try {if (!nd) nd = theUnit.Debuffs.Where(t => t.Stacks >= 3).Count() > 0;} catch {}
                //try {if (!nd) nd = theUnit.HasDebuff("Targeted Laser");} catch {}
                try {if (!nd) nd = theUnit.HasDebuff("Death Mark");} catch {}
                try { if (!nd) nd = theUnit.HasDebuff("Crushing Affliction"); }
                catch { }
                return nd;
            }
        }

        public static bool SeerHeals()
        {
            //WaitForCast();

            if (( HP >= 30f && (FP <= 20f) && MercCast("Noble Sacrifice"))) return true;

            if (HaveBuffStacks("Resplendence", 2) && MercCastOnGround("Salvation",true, LHUnit)) return true;
            if (NeedsDispell(LHUnit) && MercCast("Restoration", LHUnit)) ChainCastWait();
            if (MercCast("Force Armor", LHUnit, !LHUnit.HasDebuff("Force-imbalance"))) return true;
            if (MercCast("Rejuvenate", LHUnit)) return true;
            //Thread.Sleep(250); WaitForCast();

            if (MercCast("Rescue", LHUnit, LHH <= 20f)) return true;
            if (MercCast("Healing Trance", LHUnit, true)) return true;
            //if (MercCastNew("Healing Trance", LHUnit, true)) return true;
            if (MercCast("Benevolence", LHUnit)) return true;
            if (MercForcedCast("Healing Trance", LHUnit, true)) { WaitForCast(); return true; }
            //AbilityManager.Cast("Salvation", LHUnit.Position);
            //if (!MercCast("Deliverance", LHUnit, HaveBuff("Mental Alacrity"))) // Deliverance takes so goddamn long to cast it's useless


            return false;
        }

        // MAJOR Heal-Targeting bugs in SWTOR - You ARE gonna hit alot of heals that go to YOU instead of the target in here - game bug, not a bot bug

        //public static bool ShieldTank(string theSpell)
        //{
        //    foreach (TorPlayer unit in ObjectManager.GetObjects<TorPlayer>().OrderBy(o=>o.HealthPercent))//.Where(o=>o.Distance<=3.00f))
        //        if (unit!=null && !unit.IsDeleted && !unit.IsHostile && unit.Toughness==CombatToughness.Player && unit!=Me && unit.Distance <= 3.0f 
        //          && unit.AdvancedClass==AdvancedClass. )

        //}

        public static bool CorruptionHeals()
        {
            bool RanHeals = false;

            if (MercForcedCastOnGround("Revivification", LHUnit.Position, HaveBuffStacks("Force Surge", 2))) return true;
            if (MercCast("Static Barrier", LHUnit, !sLHDebuffs.Contains("Deionized") && !sLHBuffs.Contains("Static Barrier"))) return true;
            //if (NeedsDispell(LHUnit)) if (MercCast("Purge", LHUnit)) Thread.Sleep(700);
            if (NeedsDispell(LHUnit)) if (MercCast("Expunge", LHUnit)) return true;

            //Thread.Sleep(250); WaitForCast();

            if (MercForcedCast("Innervate", LHUnit)) return true;
            if (MercCast("Rescue", LHUnit, LHH <= 20)) return true;
            if (MercCast("Innervate", LHUnit)) return true;
            if (MercForcedCast("Resurgence", LHUnit, !LHUnit.HasBuff("Resurgence"))) return true;
            if (MercCastOnGround("Revivification", true, LHUnit)) return true;
            if (MercCast("Dark Heal", LHUnit, Me.ForcePercent >= 70f)) return true;
            
            return RanHeals;

        }

        // Medicine heals, buggy as all hell, had to tweak ALOT here
        public static void MedicineHeals()
        {
            //if (MercCast("Recuperative Nanotech", LHUnit)) Thread.Sleep(900);
            int TAStacks = GetBuffStacks("Tactical Advantage", Me);
            int KPStacks = GetBuffStacks("Kolto Probe", LHUnit);

            //Logger.Write("TA Stacks: " + TAStacks.ToString() + " KP Stacks: " + KPStacks.ToString());

            if (MercForcedCast("Recuperative Nanotech", LHUnit)) return;
            if (NeedsDispell(LHUnit) &&MercCast("Toxin Scan", LHUnit)) return;
            if (KPStacks < 2 && MercForcedCast("Kolto Probe", LHUnit)) return;
            if (TAStacks >= 3 && MercForcedCast("Surgical Probe", LHUnit)) return;
            if (MercCast("Kolto Infusion", LHUnit, !HasBuff("Kolto Infusion", LHUnit))) return;
            //if (MercCast("Kolto Probe", LHUnit, KPStacks <= 1)) return;
            if (MercCast("Kolto Injection", LHUnit, LHH < 50f)) return;
            //if (MercCastNew("Diagnostic Scan", LHUnit)) return;

        }

        public static void CheckForDeadComp()
        {
            var datStart = DateTime.Now;
            SynchObjCache(true);
            UpdateObjects();

            if (IG || Me.IsMounted || IAmInCombat() || MyLevel < 10 || DiffInSeconds(datLDCC, Now) < 30f) return;

            bool RezComp = false;
            TorCharacter CompX = null;

            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                try
                {
                    // Double-Condom Approach:  Only update ObjectManager if it says we have a dead comp up-front (otherwise massive performance issues with CombatBot)
                    datLDCC = Now;
                    CompX = Comp;
                    if (CompX != null) if (!CompX.IsDeleted) if (CompX.IsDead && CompX.HealthPercent < .10f)
                    {
                        UpdateObjects();

                        CompX = Comp;
                        if (CompX != null) if (!CompX.IsDeleted) if (CompX.IsDead && CompX.HealthPercent < .10f)
                        {
                            StopMoving();
                            RezComp = true;
                            //LastComp = null; // "reset the comp" JIC it's a false positive - so it won't keep looping in 'dead comp mode'
                        }
                    }
                }
                catch { }
            }
            if (RezComp)
            {
                Logger.Write("Reviving Comp... Comp Distance: " + CompX.Distance.ToString() + " Comp Health: " + CompX.HealthPercent.ToString());
                while (DateTime.Now.Subtract(datStart).TotalSeconds < 5 && (CompX.Distance > .50f || !CompX.InLineOfSight)) Buddy.Navigation.Navigator.MoveTo(CompX.Position);
                if (CompX != null && CompX.Distance <= .50f)
                {
                    Thread.Sleep(500);
                    using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                    {
                        CompX.Interact();
                        CompX.Interact();
                    }
                    Thread.Sleep(4000);
                    LastComp = null;
                    SynchObjCache(true);
                    UpdateObjects();
                    var x = Comp;
                    MyRestAndBuffs();
                }
                else
                {
                    if (taDismissComp != null && taDismissComp.IsValid) Me.AbilityActivate(taDismissComp, Me, out er);
                    WaitForCast();
                    if (taSummComp != null && taSummComp.IsValid) Me.AbilityActivate(taSummComp, Me, out er);
                }
            }
        }

        // Buggy, not sure why, but always thinks everything is null and returns false
        //public static bool ValidTarget(TorCharacter theTarget)
        //{   
        //    try {
        //        TorCharacter Targ = null;
        //        if (theTarget == null) if (!IG) Targ = CT; else Targ = MyTarget();

        //        if (Targ == null || Targ == BuddyTor.Me) { Logger.Write("ValidTarget: Null target."); return false; }
        //        //Targ = (TorCharacter)Targ;
        //        if (Targ.IsDead || Targ.HealthPercent < .2f || Targ.IsFriendly) { Logger.Write("TargetInCombat:  Dead or friendly."); return false; }
        //        if (!IG || IGAndTargetNotInCombat()) if (Targ.Distance<=3.0f) return true;
        //    }
        //    catch {}

        //    Logger.Write("Error in ValidTarget.");
        //    return false;
        //}

        public static void HandleBuffs(string theBuff, bool req=true)
        {
            if (req)
            {
                if (BuddyTor.Me.IsDead || BuddyTor.Me.HealthPercent < .2f) return;
                MercBuffSelf(theBuff);
                CheckPlayerBuffs(theBuff);
            }
        }

        public static void MyRestAndBuffs()
        {
            if (IAmInCombat() || Me.IsMounted) return;

            //if (EnableObjMgrUpd) UpdateObjects();

            MercCast("Stealth", BuddyTor.Me, Me.HasBuff("Stealth"));
            
            {
                if (Me.Class == CharacterClass.Warrior)
                {
                    IsRanged = false;
                    WaitForRest(true, "Channel Hatred", true, 0);
                    HandleBuffs("Unnatural Might");
                }
                else if (Me.Class == CharacterClass.Inquisitor)
                {
                    if (Me.AdvancedClass == AdvancedClass.Assassin) IsRanged = false; else IsRanged = true;
                    WaitForRest(true, "Seethe", true, BuddyTor.Me.ForceMax * .8f);
                    HandleBuffs("Mark of Power");
                }
                else if (Me.Class == CharacterClass.Agent)
                {
                    IsRanged = Me.AdvancedClass == AdvancedClass.Sniper;  // All Operative Agents, Melee
                    HandleBuffs("Coordination");
                    WaitForRest(true, "Recuperate", true, 80f);
                }
                else if (Me.Class == CharacterClass.BountyHunter)
                {
                    IsRanged = true;
                    WaitForRest(true, "Recharge and Reload", true, 80f);
                    HandleBuffs("Hunter's Boon");
                }
                else if (Me.Class == CharacterClass.Knight)
                {
                    IsRanged = false;
                    WaitForRest(true, "Introspection", true, 0f);
                    HandleBuffs("Force Might");
                }
                else if (Me.Class == CharacterClass.Consular)
                {
                    IsRanged = true;
                    if (Me.AdvancedClass == AdvancedClass.Shadow) IsRanged = false;
                    WaitForRest(true, "Meditation", true, BuddyTor.Me.ForceMax * .8f);
                    HandleBuffs("Force Valor");
                }
                else if (Me.Class == CharacterClass.Smuggler)
                {
                    IsRanged = true;
                    if (MySpec == SkillTreeId.GunslingerDirtyFighting) IsRanged = false;
                    if (MySpec == SkillTreeId.ScoundrelSawbones) IsRanged = true;
                    HandleBuffs("Lucky Shots");
                    WaitForRest(true, "Recuperate", true, 80f);
                }
                else if (Me.Class == CharacterClass.Trooper)
                {
                    IsRanged = true;
                    WaitForRest(true, "Recharge and Reload", true, 80f);
                    HandleBuffs("Fortification");
                }
                //else if (Me.Class == CharacterClass.Inquisitor)
                //{
                //    IsRanged = true;
                //    WaitForRest(true, "Seethe", true, .8f * BuddyTor.Me.ForceMax);
                //    HandleBuffs("Fortification");
                //}
                }

            // Special Handling for Specs (Group Heals, etc)
            if (MySpec == SkillTreeId.MercenaryBodyguard)
            {
                if (!IG) if (!HaveBuff("High-Velocity Gas Cylinder")) MercCast("High-Velocity Gas Cylinder", BuddyTor.Me);
                if (IG) if (!HaveBuff("Combat Support Cylinder")) MercCast("Combat Support Cylinder", BuddyTor.Me);
                if (IG) RunHeals(95f);
            }
            else if (MySpec == SkillTreeId.CommandoCombatMedic)
            {
                if (IG) while(RunHeals(95f));
                MercBuffSelf("Combat Support Cell", true);
            }
            else if (MySpec == SkillTreeId.ScoundrelSawbones)
            {
                if (IG) while (RunHeals(95f)) ;
                if (!MovementAllowed) IsRanged = true;
                //MercBuffSelf("Combat Support Cell", true);
            }
            else if (MySpec == SkillTreeId.VanguardShieldSpecialist)
            {
                MercBuffSelf("Ion Cell");
            }
            else if (MySpec == SkillTreeId.SageSeer)
            {
                IsRanged = true;
                if (IG) RunHeals(95);
            }
            else if (MySpec == SkillTreeId.SorcererCorruption)
            {
                if (IG) RunHeals(95);
            }
            else if (MySpec == SkillTreeId.OperativeMedic)
            {
                if (IG) RunHeals(95);
            }

            if (!IG && !MovementAllowed) IsRanged = true;
            if (MyLevel < 10) IsRanged = false;
            //MoveOutOfCoverIfNec();

        }

        //public static bool LoopInCombat(bool CombatFunc)
        //{
        //    try
        //    {
        //        LastCombatResult = CombatFunc;
        //        Thread.Sleep(GroupSize>8?400:200);
        //        return !IAmDead() && EnableObjMgrUpd && LastCombatResult;
        //    }
        //    catch { return false; }
        //}

        public static void SetKillPOI()
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                //if (DoRandomGrind || IG) Buddy.CommonBot.Poi.Current = null;
                Thread.Sleep(50);
                Buddy.CommonBot.Poi.Current = new Poi(MyTarget(), PoiType.Kill);
            }
        }

        public static void MassPull(float rangeWithin, string theAbility, int maxMobs)
        {
            int mc = 0;
            IEnumerable<TorNpc> mobs;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                mobs = ObjectManager.GetObjects<TorNpc>().OrderBy(d=>d.Distance).Where(d=> d!=null && !d.IsDeleted && !d.InCombat && d.Distance<=rangeWithin && !d.IsDead && d.HealthPercent > .1f && (d.IsNeutral || d.IsHostile));
            }
            foreach (TorNpc tn in mobs)
            try 
            {
                MoveTo(tn.Position,2.80f);
                TargetUnit(tn);
                Thread.Sleep(400);
                //MercCast(theAbility, tn);
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    AbilityManager.Cast(theAbility, (TorCharacter)tn);
                }
                Thread.Sleep(2000);
                mc += 1;
                if (mc>=maxMobs) break; 
            } catch {}
        }

        public static void ResetDPSInfo()
        {
            if (!IAmInCombat())
            {
                AttackersHP.Clear();
                CombatStart = DateTime.MinValue;
                CombatGCTime = 0;
            }
        }

        // Only allow looping-in-combat if EnableObjMgrUpd is true, otherwise object properties won't be updated, thus the loop must exit
        public static bool MyCombat()
        {
            PauseWait();
            AdvancedClass AC = AdvancedClass.None;
            try
            {
                //LoadVars();
                //ClearCacheAndPOI();
                SynchObjCacheAll();
                //UpdateObjects();
                if (IAmDead() || !AllowCombat) return false;
                AC = Me.AdvancedClass;
                //if (IG || DoRandomGrind) 
                //{
                //    SetKillPOI(); // Combat will hang/error w/o this in raids
                //    Thread.Sleep(300);
                //}
                DateLastPingCombat = DateTime.Now;

            }
            catch { }

            CT = (TorCharacter) MyTarget();

            if (CT != null && CT.Guid != MyGUID && !CT.IsFriendly)
            {
                if (MySpec == SkillTreeId.None)
                    switch (BuddyTor.Me.Class)
                    {
                        case CharacterClass.BountyHunter: MercenaryCombat(); break;
                        case CharacterClass.Warrior: MarauderCombat(); break;
                        case CharacterClass.Inquisitor: SorcererCombat(); break;
                        case CharacterClass.Agent: SniperCombat(); break;
                        case CharacterClass.Smuggler: ScoundrelCombat(); break;
                        case CharacterClass.Trooper: CommandoCombat(); break;
                        case CharacterClass.Knight: SentinelCombat(); break;
                        case CharacterClass.Consular: SageCombat(); break;
                        default: { break; }
                    }

                else 
                    switch (AC)
                    {
                        case AdvancedClass.Sorcerer: SorcererCombat(); break;
                        case AdvancedClass.Assassin: AssassinCombat(); break;
                        case AdvancedClass.Mercenary: MercenaryCombat(); break;
                        case AdvancedClass.Powertech: PowertechCombat(); break;
                        case AdvancedClass.Marauder: MarauderCombat(); break;
                        case AdvancedClass.Juggernaut: JuggernautCombat(); break;
                        case AdvancedClass.Operative: OperativeCombat(); break; 
                        case AdvancedClass.Sniper: SniperCombat(); break; 

                        case AdvancedClass.Sage: SageCombat(); break;
                        case AdvancedClass.Shadow: ShadowCombat(); break;
                        case AdvancedClass.Sentinel: SentinelCombat(); break;
                        case AdvancedClass.Guardian: GuardianCombat(); break;
                        case AdvancedClass.Commando: CommandoCombat(); break;
                        case AdvancedClass.Vanguard: VanguardCombat(); break;
                        case AdvancedClass.Scoundrel: ScoundrelCombat(); break;
                        case AdvancedClass.Gunslinger: GunslingerCombat(); break; 

                        default: 
                        {
                            break;
                            //return false;
                        }
                    }
            }
            try
            {
                SynchObjCacheAll();
            }
            catch { }
            if (!IAmInCombat())
            try
            {
                if (!IG) ShowDPSInfo();
                ResetDPSInfo();
                IAmDead();
                CheckForDeadComp();
                SummonCompIfNec();
                MyRestAndBuffs();
            }
            catch { }
            if (!IG) RunGathering();
            if (!IG && !DoRandomGrind) if (EnableGC) ClearAndReloadProfile();
            return false;

        }

        public static void UseVendor(TorObject theVendor)
        {
            if (DateTime.Now.Subtract(DRGLastVendorUse).TotalMinutes < 20) return;
            Logger.Write("Vendoring and Repairing Items...");

            //TorVendor theVendorX;
            //try { theVendorX = (TorVendor)theVendor; }
            //catch { return;  }

            MoveTo((TorNpc)theVendor,.48f);
            if (theVendor.Distance <= .49f)
            {
                theVendor.Interact();
                theVendor.Interact();
                Thread.Sleep(2000);
                Buddy.CommonBot.Logic.BrainBehavior.SellAllItems();
                Thread.Sleep(6000);                         // Apparently Asynch - Give it enough time to sell it all
                Buddy.Swtor.GuiApiManager.RepairAllItems();
                Thread.Sleep(2000);
                Buddy.Swtor.GuiApiManager.RepairAllItems(); // Fails 1/2 the time, so reducndant
                Thread.Sleep(2000);

                ClearTarget();
                DRGLastVendorUse = DateTime.Now;
                CheckForFRDImmediate = false;
            }
        }

        public static DateTime Now { get { return DateTime.Now; } }

        public static float DiffInSeconds(DateTime datStart, DateTime datEnd)
        {   
            float diff = (float) Math.Abs(datEnd.Subtract(datStart).TotalSeconds);
            //Logger.Write("DiffInSeconds: " + diff.ToString());
            return diff;
        }

        public static void SendCtrlTab()
        {
            char chTab = (char)0x09;
            char chCtrl = (char)0x11;
            SendMessage(SWTORHWnd, (int)0x100, (IntPtr)chCtrl, (IntPtr)0);
            Thread.Sleep(50);
            SendMessage(SWTORHWnd, (int)0x100, (IntPtr)chTab, (IntPtr)0);
            Thread.Sleep(50);
        }

        public static TorNpc FindVendor(int forDur)
        {
            TorVendor TheVendor = null;


            if (DateTime.Now.Subtract(datLFRD).TotalMinutes >= 3 && CheckForFRDImmediate) { CheckForFRDImmediate = false; return null; } // No dice for 3m after deployment, wait until 'The Next Round'

            DateTime datStart = DateTime.Now;

            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                foreach (TorObject d in ObjectManager.GetObjects<TorObject>()
                  .Where(d => d.IsKindOf(Buddy.Swtor.Enums.DomDefIds.npc_class) || d.IsKindOf(Buddy.Swtor.Enums.DomDefIds.character_class)
                    || d.IsKindOf(Buddy.Swtor.Enums.DomDefIds.vndOracle) || d.IsKindOf(Buddy.Swtor.Enums.DomDefIds.vndBuyerComponent)))
                try
                {
                    var x = d;
                }
                catch { }
            }
                
                    Logger.Write("Trying to find a vendor...");
            while (TheVendor == null && DateTime.Now.Subtract(datStart).TotalSeconds <= forDur)
            {
                //ClearObjects();
                for (int i = 0; i < 500; i++)
                {
                    SynchObjCacheAll();
                    UpdateObjects();
                    using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                    {
                        ForcePulse();
                        DateTime dtst = Now;
                        try
                        {
                            if (TheVendor == null) foreach (TorVendor d in ObjectManager.GetObjects<TorVendor>()
                                .AsParallel()
                                .ToArray())
                                    try
                                    {
                                        if (!d.IsHostile)
                                        {
                                            TheVendor = d;
                                            string strTest = string.Copy(d.Name);
                                            Logger.Write("Repair Droid [" + strTest + "] found (Block 0).");
                                        }
                                    }
                                    catch { /*Logger.Write("Error in Block 2.");*/ }
                        }
                        catch { /*Logger.Write("Error in Block 2.");*/ }
                    }
                    using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                    {
                        try
                        {
                            if (TheVendor == null) foreach (TorObject d in ObjectManager.GetObjects<TorVendor>()
                            .ToArray())
                            try
                            {
                                if (!((TorVendor)d).IsHostile)
                                {
                                    if (d.Distance <= 1.5f)
                                    {
                                        TheVendor = (TorVendor)d;
                                        string strTest = string.Copy(d.Name);
                                        Logger.Write("Repair Droid [" + strTest + "] found (Block 1).");
                                    }
                                }
                            }
                            catch { /*Logger.Write("Error in Block 2.");*/ }
                        }
                        catch { /*Logger.Write("Error in Block 2.");*/ }
                    }
                    using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                    {
                        try
                        {
                            if (TheVendor == null)
                            foreach (TorObject d in ObjectManager.GetObjects<TorObject>()
                                .ToArray()
                                .Where(d => d.IsKindOf(Buddy.Swtor.Enums.DomDefIds.npc_class) || d.IsKindOf(Buddy.Swtor.Enums.DomDefIds.character_class) 
                                    || d.IsKindOf(Buddy.Swtor.Enums.DomDefIds.vndOracle) || d.IsKindOf(Buddy.Swtor.Enums.DomDefIds.vndBuyerComponent)))
                                try
                                {
                                    if (!((TorVendor)d).IsHostile && d.Distance<=.5f && ((TorCharacter)d).Toughness!=CombatToughness.Companion && !((TorCharacter)d).IsHostile)
                                    {
                                        TheVendor = (TorVendor)d;
                                        Logger.Write("Repair Droid [" + d.Name + "] found (Block 2).");
                                    }
                                }
                                catch { /*Logger.Write("Error in Block 2.");*/ }
                        }
                        catch { /*Logger.Write("Error in Block 3.");*/ }
                        //Logger.Write("Vendor Null: " + (TheVendor == null).ToString());
                    }
                if (TheVendor != null)
                    {
                        Logger.Write("Vendor [" + TheVendor.Name + "] found, trying to use it.");

                        while (TheVendor.Distance > .50f) { UpdateObjects(); Navigator.MoveTo(TheVendor.Position); Thread.Sleep(150); }
                        if (TheVendor.Distance <= .50f)
                        {
                            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                            {
                                TheVendor.Interact();
                                TheVendor.Interact();
                            }
                            Thread.Sleep(2000);
                            //((TorVendor)TheVendor).Interact();
                            //Thread.Sleep(500);
                            //((TorVendor)TheVendor).Interact();
                            //Thread.Sleep(500);
                            ////MoveToAndInteract((TorNpc)TheVendor, .50f);
                            if (Buddy.Swtor.GuiApiManager.IsGuiVendorEnabled())
                            {
                                Buddy.CommonBot.Logic.BrainBehavior.SellAllItems();
                                Thread.Sleep(6000);                         // Apparently Asynch - Give it enough time to sell it all
                                Buddy.Swtor.GuiApiManager.RepairAllItems();
                                Thread.Sleep(2000);
                                Process.GetCurrentProcess().PriorityClass = BotDefaultPriority;
                                CheckForFRDImmediate = false;
                                return (TorNpc)TheVendor;
                            }
                        }
                        else
                            UseVendor(TheVendor);
                    }
                }
                //return null;
                }
            if (TheVendor == null) {
                ClearObjects();
                Logger.Write("Couldn't find a vendor.");
                if (DRGVendorName != "" && DRGVendorName != null)
                {
                    Logger.Write("Trying to move to Last-Closest-Vendor.");
                    DateTime datStart2 = DateTime.Now;
                    while (!IAmInCombat() && DiffInSeconds(datStart2,DateTime.Now)<=20f) Navigator.MoveTo(DRGVendorPos);
                    if (DiffInSeconds(datStart2, DateTime.Now) > 20f) {DRGVendorName = null;}
                }
                Thread.Sleep(1000);
                return null;
                //ReloadGOM(); 
            }
            else
            {
                Logger.Write("Vendor Found: " + TheVendor.Name + " Distance: " + TheVendor.Distance);
                CheckForFRDImmediate = false;
            }
            return (TorNpc)TheVendor;
        }

        public static void CheckForStims()
        {
            try
            {
                bool StimBuffed = false;
                bool StimUsed = false;
                TorItem tiu = null;

                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    foreach (TorEffect te in Me.Buffs) if (te.Name.Contains("Stim")) { StimBuffed = true; break; }
                    if (!StimBuffed)
                    {
                        CharacterClass CC = Me.Class;
                        var Attrs = ("Skill;Might;Resolve;Reflex").Split(';');
                        foreach (TorItem ti in Me.InventoryEquipment)
                        {
                            bool AttrIn = false;
                            foreach (string attr in Attrs) if (ti!=null && !ti.IsDeleted && ti.Name.Contains(attr)) { AttrIn = true; break; }
                            if (AttrIn && ti != null && !ti.IsDeleted && ti.Name != null && ti.Name.Contains(" Stim"))
                            {
                                bool UseIt = false;
                                if ( 
                                    ((CC == CharacterClass.Smuggler || CC == CharacterClass.Agent) && ti.Name.Contains("Skill")) || 
                                    ((CC == CharacterClass.Knight || CC == CharacterClass.Warrior) && ti.Name.Contains("Might")) ||
                                    ((CC == CharacterClass.Consular || CC == CharacterClass.Inquisitor) && ti.Name.Contains("Resolve")) ||
                                    ((CC == CharacterClass.Trooper || CC == CharacterClass.BountyHunter) && ti.Name.Contains("Reflex"))
                                   )
                                UseIt=true;
                                if (UseIt)
                                {
                                    ti.Use(); 
                                    ti.Interact(); 
                                    tiu = ti; 
                                    StimUsed = true; 
                                    Thread.Sleep(500); 
                                    break; 
                                }
                            }
                        }
                    }
                }
                if (StimUsed) Logger.Write("Stim [" + tiu.Name + "] found in inventory and used.");
            }
            catch { }
        }

        public static void CheckForXPBoost()
        {
            if (!UseXPBoosters) return;

            try
            {
                bool XPBuffed = false;
                TorItem tiu = null;

                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    foreach (TorEffect te in Me.Buffs) if (te.Name.Contains("Experience Boost")) { XPBuffed = true; break; }
                    if (!XPBuffed && Me.Level<55)
                    {
                        foreach (TorItem ti in Me.InventoryEquipment)
                        {
                            if (ti.Name.Contains("Experience Boost")) 
                            {
                                ti.Use();
                                ti.Interact();
                                tiu = ti;
                                Thread.Sleep(500);
                                break;
                            }
                        }
                    }
                }
                if (tiu!=null) Logger.Write("XP Booster [" + tiu.Name + "] found in inventory and used.");
            }
            catch { }
        }

        public static void CheckForGoodies()
        {
            try
            { 

                if (DateTime.Now.Subtract(datLLBScan).TotalMinutes < 2) return;

                Logger.Write("Scanning for 'Goodies' (for Rep, or Lockboxes) in inventory...");
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    var Goodies = ("Credit Box;Credit Case;Makeb HoloSouvenir;Prisoner ID Tags;Voss Historical Tablet;Gormak Power Cells;Voss Mystic's Orb;" +
                        "Talaos City Medallion;Makeb Statue Fragment;Banned Holovid;Prohibited Medical Supplies;Confiscated Artwork;Corrupted Biosample;Dread Guard Cranial Scan;Storage Case;" +
                        "Forward Command Shield of Duty;System Datafiles;CZ-198 Lab Records;Dark Datacron (;Light Datacron (").Split(';');
                    foreach (TorItem ti in Me.InventoryEquipment)
                    {
                        try
                        {
                            if (ti != null && !ti.IsDeleted)
                            {
                                string ItemName = string.Copy(ti.Name);
                                foreach (string frag in Goodies)
                                    if (frag.Length > 0 && ItemName.Contains(frag))
                                    {
                                        Logger.Write("'Goodie' in inventory found: [" + ti.Name + "], opening/using it.");
                                        ti.Interact(); ti.Use();
                                        Thread.Sleep(400);
                                        while (IAmCasting()) Thread.Sleep(1000);
                                    }
                            }
                        }
                        catch { }
                    }
                }
            }
            catch { }
            CheckForStims();
            CheckForXPBoost();
            datLLBScan = DateTime.Now;
        }

        public static int FreeInvSlots()
        {
            try
            {
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    return BuddyTor.Me.FreeInventorySlots;
                }
            }
            catch { return 100; }
        }

        // If low on inventory, deploy a Field Repair Droid if we have that legacy ability, and sell all qualified.  Pain-in-the-Ass tryng to find the Droid once you've deployed it, so it may very well not work.
        public static void CheckInventory()
        {
            if (!InitsComplete || IG) return;

            if (!CheckForFRDImmediate) CheckForGoodies();

            if (FreeInvSlots() > CheckInvMinSlots) { CheckForFRDImmediate = false; return; }
            if (DiffInSeconds(datLFRD, Now) >= 180f && CheckForFRDImmediate) { CheckForFRDImmediate = false; return; } // No dice for 3m after deployment, wait until 'The Next Round'
            //if (!HasBuffStacks(Me, "Field Repair", 1) && CheckForFRDImmediate) { CheckForFRDImmediate = false; return; } // No dice for 3m after deployment, wait until 'The Next Round'
            if (DiffInSeconds(datLFRD, Now) < 900f && !CheckForFRDImmediate) return;
            if (DiffInSeconds(datLInvScan, Now) < 120f && !CheckForFRDImmediate) return;

            //if (DiffInSeconds(datLInvScan,Now) < 120f && !CheckForFRDImmediate) return;

            if (!UseFRD) return;
            datLInvScan = Now;

            TorNpc TheVendor = FindVendor(CheckForFRDImmediate?2:2);
            if (CheckForFRDImmediate && TheVendor == null) return;
            //bool LowDur = false;
            // Buggy - no use trying on this
            //foreach (var eq in BuddyTor.Me.InventoryEquipped) if (eq.HasDurability && eq.DurabilityPercent <= 50f) { LowDur = true; break; }

            if (TheVendor == null && DiffInSeconds(datLFRD, Now) >= 900 && taDeployFRD != null && taDeployFRD.IsValid )
            {
                foreach (TorAbility ta in BuddyTor.Me.KnownAbilitiesContainer)
                {
                    if (ta.Name.Contains("Deploy Field Repair")) 
                    { 
                        taDeployFRD = ta;
                        break;
                        //Logger.Write("Ability " + ta.Name + " found."); 
                    }
                }

                EffectResult er;
                if (Me.IsAbilityReady(taDeployFRD, Me)==EffectResult.Ok)
                { 
                    StopMoving();
                    StopMoving();
                    Thread.Sleep(1000);
                    if (BuddyTor.Me.AbilityActivate(taDeployFRD, Me, out er))
                    {
                        Logger.Write("EffectResult on Deploy:  " + er.ToString());
                        if (er == EffectResult.Ok)
                        {
                            Process.GetCurrentProcess().PriorityClass = ProcessPriorityClass.BelowNormal;
                            Thread.Sleep(5000);
                            CheckForFRDImmediate = true;  // Set the flag, and 'Return back to the Mothership' so a proper object manager update can be done (and the flag will be checked again the next loop in OOCPS)
                            ClearObjects();
                            DoRehook();
                            DoRehook();
                            datLFRD = DateTime.Now;
                            return;
                        }
                        else
                        {
                            datLFRD = DateTime.Now;
                            return;
                        }
                    }
                }
                else return;

                //Thread.Sleep(5000);
                //return; // Try a scan in the next OOC Loop (After returning to the .exe for an Object Update)
                //UpdateObjects();
                //TheVendor = FindVendor(20);
                //if (TheVendor != null) UseVendor(TheVendor);
                //CheckForFRDImmediate = false;
                //if (TheVendor == null) return; else TheVendor.Interact();
                //datLFRD = DateTime.Now;
            }

            if (TheVendor!=null)
                {
                    var datStart = DateTime.Now;
                    datLFRD = datStart;

                    if (TheVendor != null)
                    {
                        UseVendor(TheVendor);
                        CheckForFRDImmediate = false;
                    }

                    if (Me.FreeInventorySlots >= CheckInvMinSlots) return;
                    Thread.Sleep(3000);
                }
        }

        public static void RunGathering()
        {
            if (!IG && MovementAllowed)
            {
                ScanForLootables();
                HarvestIfNec();
                ScanForPlaceables();
                HarvestIfNec();
            }
        }

        //public static void LoadQuests()
        //{
        //    // Xenovirus Prime - Belsavis Daily
        //    myHS_XenovirusPrime = new MyQuestDef();
        //    var myHS = myHS_XenovirusPrime;
        //    myHS.SetProperties(0xE000D987B579F78A, 2,"Handful of Location Markers","", 7000);
        //    //myHS.SetItemToUse("Handful of Location Markers");
        //    myHS.AddToHSList( -49.04824,10.001,-263.1941);
        //    myHS.AddToHSList(-46.53094,10.001,-263.2531 );
        //    myHS.AddToHSList(-46.57342,10.001,-258.4337);
        //    myHS.AddToHSList( -49.1338,10.001,-258.4071);
        //    myHS.AddToHSList( -61.9276,10.001,-263.2448 );
        //    myHS.AddToHSList(-59.28479,10.001,-263.2181);
        //    myHS.AddToHSList( -61.93335,10.001,-258.3529);
        //    myHS.AddToHSList( -59.26503,10.001,-258.3987);
        //    //myHS.AddToHSList(-61.95681, 10.001, -263.2149);

        //    //Droid Malfunction - Belsavis Daily
        //    myHS_DroidMalfunction = new MyQuestDef();
        //    myHS = myHS_DroidMalfunction;
        //    myHS.SetProperties(0xE000BA9BB7DBB97D, 2);
        //    myHS.AddToHSList(-87.60915, 12.50146, -303.4151);
        //    myHS.AddToHSList(-88.06365, 12.37658, -307.7879);
        //    myHS.AddToHSList(-84.47065, 11.88158, -307.719);
        //    myHS.AddToHSList(-82.41384, 11.35196, -309.6615);
        //}

        //public static void CheckQuesting()
        //{
        //    if (IG) return;

        //    myHS_DroidMalfunction.RunThrough();
        //    myHS_XenovirusPrime.RunThrough();
        //}

        public static void CheckQuestingPOI()
        {
            if (IG || DoRandomGrind || !MovementAllowed) return;
            if (DiffInSeconds(datLCQP, Now) <= 15f) return;
            datLCQP = Now;
            Logger.Write("CheckQuestingPOI:  Area - " + BuddyTor.Client.AreaID.ToString());
            // Belsavis Area: 40000001C0831248
                ulong AID = BuddyTor.Client.AreaID;            {
                if ( AID == 0x40000001C0831248)
                {
                    if (HasQuestAndNotStepComplete(0xE000C7B4447005D5, 2)) // A Lesson is Learned
                        { LookForTalkToUse("Captured Scientist", "Gand Weapons Crate", .40f, .40f); }
                    if (HasQuestAndNotStepComplete(0xE000BFC5DA500F88, 2) || HasQuestAndNotStepComplete(0xE000830A40E929B3, 2)) //Strengthening the Chain
                        { LookForTalkToUse("Supplies", "Rattataki Leader", .40f, .40f); }
                    if (Buddy.CommonBot.BotMain.StatusText.Contains(".5228106")) 
                        {   // Equiv, ROUGHLY, to a MoveNoCombat in HonorBuddy (Keep moving, and IGNORE COMBAT until you get there)
                            var dest = new Vector3((float)0.5228106, (float)9.140131, (float)-327.3875); 
                            while (dest.Distance(Me.Position) > 5.0f) { MountUp(); MoveTo(dest, 5.0f); Thread.Sleep(200); } 
                        }
                }
                if (AID == 0x40000004D99C83A6) // Ilum
                {
                    if (HasQuestAndNotStepComplete(0xE000FBC692CF7882, 3)) // Tightened Grip - Imp
                    { LookForTalkToUse("Missile Crate", "", .40f, .40f); }
                    if (HasQuestAndNotStepComplete(0xE000EF4CF39FE4D6, 3)) // Defend the shipment - Imp
                    { LookForTalkToUse("Imperial Crystal Shipment", "", .40f, .40f); }
                    if (HasQuestAndNotStepComplete(0xE0006271F10ACA5D, 4)) // Alien Extraction - Pub
                    { LookForTalkToUse("Portable Prison Cell", "", .40f, .40f); }
                    if (HasQuestAndNotStepComplete(0xE000815F7CF8A573, 2)) // Darkness on Ilum - Pub
                    { LookForTalkToUse("Heating Controls", "", .40f, .40f); }
                }
                if (AID == 0X4000004CC2736D9B) // CZ
                {
                    if (HasQuestAndNotStepComplete(0xE000A89E340382EC, 2)) // What's Yours is Mine
                    { LookForTalkToUse("Kolto Container", "Biotoxin Container", .40f, .40f); }
                }
            }
        }

        public static bool plcIsUsable(TorPlaceable thePlaceable)
        { 
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (thePlaceable==null) return false;
                return thePlaceable.IsUsable;
            }
        }

        public static bool ObjNameContains(TorObject t, string subStr)
        {
            try { return t!=null && !t.IsDeleted && t.Name!=null && t.Name.Contains(subStr); }
            catch { return false; }
        }

        public static bool LookForTalkToUse(string objName1, string objName2 = "", float useRange1 = .40f, float useRange2 = 40f, float scanRange1 = 2.0f, float scanRange2 = 6.0f)
        {
            if (objName1 == "" || objName1 == null) return false;
            IEnumerable<TorObject> theList;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                theList = ObjectManager.GetObjects<TorObject>().AsParallel().ToArray()
                    .Where(t => t!=null && !t.IsDeleted && !MyBlacklist.ContainsKey(t.Guid) && (ObjNameContains(t, objName1) || ObjNameContains(t, objName2))).OrderBy(t => t.Distance);
            }
            foreach (TorObject obj in theList)
            {
                try
                {
                    if (obj.IsKindOf(Buddy.Swtor.Enums.DomDefIds.plcPlaceable))
                    {
                        TorPlaceable plc = (TorPlaceable)obj;
                        if (plcIsUsable(plc))
                        {
                            Logger.Write("CheckQuestingPOI:  Using Placeable [" + plc.Name + "].");
                            MoveToAndInteract(plc, plc.Name.Contains(objName1) ? useRange1 : useRange2);
                            if (IAmInCombat()) return false;
                        }
                    }
                    else
                    {
                        try
                        {
                            TorNpc npc = (TorNpc)obj;
                            Logger.Write("CheckQuestingPOI:  Interacting with mob [" + npc.Name + "].");
                            MoveToAndInteract(npc, npc.Name.Contains(objName1) ? useRange1 : useRange2);
                            if (IAmInCombat()) return false;
                        }
                        catch { }
                    }
                }
                catch (Exception ex) { Logger.Write("Error in LookForTalkToUse: " + ex.Message); }
            }
            return false;
        }
        
        public static bool UseItemOnMobs(string itemName, string mobName = "", float useRange = .40f)
        {
            if (itemName == "" || mobName == null) return false;
            IEnumerable<TorObject> theList;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                theList = ObjectManager.GetObjects<TorNpc>()
                    .Where(t => !MyBlacklist.ContainsKey(t.Guid) && t.Name != null && t.Name.Length > 0 && t.Name.Contains(mobName)).OrderBy(t => t.Distance);
            }
            foreach (TorObject obj in theList)
            {
                if (IAmInCombat()) return false;
                TorNpc npc = (TorNpc)obj;
                Logger.Write("CheckQuestingPOI:  Using Item [" + itemName + "] on Mob [" + npc.Name + "].");
                MoveTo(npc, useRange);
                if (IAmInCombat()) return false;
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    foreach(TorItem itm in Me.InventoryEquipment)if (itm.Name.Contains(itemName)){itm.Use();Thread.Sleep(150);itm.Interact();Thread.Sleep(150);return true;}
                }
            }
            return false;
        }

        public static bool LookForAndInteractWithMobs(string mobName, float mobDist = .40f)
        {
            IEnumerable<TorCharacter> theList;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                theList = ObjectManager.GetObjects<TorCharacter>().Where(t => t.Name.Contains(mobName)).OrderBy(t=>t.Distance);            
            }
            foreach (TorCharacter mob in theList)
            {
                Logger.Write("CheckQuestingPOI:  Interacting with mob [" + mob.Name + "].");
                MoveToAndInteract(mob, mobDist);
                if (IAmInCombat()) return false;
            }
            return false;
        }

        public static bool LookForAndInteractWithPlaceables(string objName, float objDist=.40f)
        {
            IEnumerable<TorPlaceable> theList;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                theList = ObjectManager.GetObjects<TorPlaceable>().Where(t => t.Name.Contains(objName) && !t.DisabledForEveryone).OrderBy(t => t.Distance);
            }
            foreach (TorPlaceable obj in theList)
            {
                Logger.Write("CheckQuestingPOI:  Interacting with placeable [" + obj.Name + "].");
                MoveToAndInteract(obj, objDist);
                Thread.Sleep(2000);
                if (IAmInCombat()) return false;
            }
            return false;
        }

        public static bool HasQuestAndNotStepComplete(ulong questID, uint stepID)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                //Logger.Write("HQ Test: " + questID.ToString("x"));
                return Buddy.CommonBot.BotMain.StatusText.Contains(questID.ToString("X")) && Buddy.CommonBot.ConditionParser.HasQuest(questID) && !Buddy.CommonBot.ConditionParser.IsStepComplete(questID, stepID);
            }

        }

        //    if (IG) return;
        //    try
        //    {
        //        //foreach (TorPlaceable obj in ObjectManager.GetObjects<Buddy.Swtor.Objects.TorPlaceable>().Where(obj => obj.Name != null && !obj.DisabledForEveryone && (obj.AlwaysUsable || obj.IsLootable || obj.IsUsable)).OrderBy(t => t.Distance))
        //        foreach (TorPlaceable obj in ObjectManager.GetObjects<Buddy.Swtor.Objects.TorPlaceable>().Where(obj => obj.Name != null).OrderBy(t => t.Distance))
        //            //if (!MyBlacklist.Contains(obj.Guid.ToString()) && obj.Harvestable!=null && !obj.Harvestable.CanHarvest && obj.QuestIndication!=null && obj.QuestIndication==QuestIndication.QuestActive)
        //            if (!MyBlacklist.ContainsKey(obj.Guid) && obj.QuestIndication != null && obj.IsUsable && obj.Distance!=null && obj.Distance <= 3.0f && obj.Name!=null && !obj.Name.Contains("Training Dummy"))
        //            //if (!MyBlacklist.ContainsKey(obj.Guid) && obj.QuestIndication != null && obj.QuestIndication == QuestIndication.QuestActive && !obj.DisabledForEveryone)
        //            {
        //                Logger.Write("Questing Object Scan: Found [" + obj.Name + "], working on getting there now.");
        //                MoveToAndInteract(obj, .30f);
        //                MyBlacklist.Add(obj.Guid, DateTime.Now);
        //                if (IAmInCombat()) return;
        //            }
        //    }
        //    catch { return; }
        //    return;

        //    //if (Buddy.CommonBot.Poi.Current != null) Logger.Write("POI Type: " + Buddy.CommonBot.Poi.Current.Type + " Loc: " + Buddy.CommonBot.Poi.Current.Location.ToString());
        //    // If not in-group, not doing RandomGrind etc, just go ahead and move to the POI hotspot if appropriate (helps w/questing etc a little)

        //    Vector3 theLoc = new Vector3(0, 0, 0);
        //    string POIName = "";
        //    var CurHS = Buddy.CommonBot.HotspotManager.CurrentHotspot;

        //    string StatusText = Buddy.CommonBot.BotMain.StatusText;
        //    if (StatusText!=null && StatusText.Contains("Using object"))
        //    {
        //        int ForPos = StatusText.IndexOf(" for");
        //        POIName = StatusText.Substring(13, ForPos - 13);
        //        //Logger.Write("POIName: " + POIName);
        //        foreach (TorPlaceable obj in ObjectManager.GetObjects<Buddy.Swtor.Objects.TorPlaceable>().Where(obj => obj.Name != null && obj.Name.ToLower().Contains(POIName.ToLower())).OrderBy(t => t.Distance))
        //        {
        //            Logger.Write("POI Object Scan: Found [" + POIName + "], working on getting there now.");
        //            MoveToAndInteract(obj, .3);
        //            if (IAmInCombat()) return;
        //            Thread.Sleep(7000);
        //        }

        //    }

        //    return;

        //    if (!IG && !IAmInCombat() && !DoRandomGrind && Buddy.CommonBot.Poi.Current != null && Buddy.CommonBot.Poi.Current.Location.X != 0)
        //        Logger.Write("POI Type: " + Buddy.CommonBot.Poi.Current.Type.ToString() + " Name: " + Buddy.CommonBot.Poi.Current.Name + " Loc: " + Buddy.CommonBot.Poi.Current.Location.ToString()); 

        //    if (!IG && !IAmInCombat() && !DoRandomGrind && Buddy.CommonBot.Poi.Current != null && Buddy.CommonBot.Poi.Current.Type != PoiType.Kill && Buddy.CommonBot.Poi.Current.Type != PoiType.Loot &&
        //        Buddy.CommonBot.Poi.Current.Location.X != 0)
        //    {
        //        theLoc = Buddy.CommonBot.Poi.Current.Location;
        //        POIName = Buddy.CommonBot.Poi.Current.Name;
        //    }
        //    else if (CurHS != null && CurHS.X != 0)
        //    {
        //        theLoc = CurHS.ToVector3();
        //        POIName = CurHS.Name;
        //    }

        //    if (POIName != "" && theLoc.X != 0)
        //        try
        //        {
        //            //Vector3 theLoc = new Vector3((float)-243.2681, (float)22.03563, (float)28.79927);
        //            //Buddy.CommonBot.Poi.Current.Type==
        //            //theLoc = new Vector3((float)theLoc.X, (float)theLoc.Y, (float)theLoc.Z);
        //            if (theLoc.X != 0)
        //            {
        //                Logger.Write("POI (" + Buddy.CommonBot.Poi.Current.Name + ": " + Buddy.CommonBot.Poi.Current.Type.ToString() + ") Found and set to " + theLoc.ToString() + "... Working on getting there now.");
        //                MountUp();
        //                while (!IAmInCombat() && Buddy.Common.Math.Vector3.Distance(Me.Position, theLoc) > .45f)
        //                {
        //                    if (MyTarget() != null && MyTarget().Name != Me.Name) break;
        //                    //Buddy.Swtor.Input.MoveTo(theLoc);
        //                    Buddy.Navigation.Navigator.MoveTo(theLoc);
        //                    Thread.Sleep(200);
        //                }
        //            }
        //            if (!IAmInCombat() && MyTarget() == null && Buddy.Common.Math.Vector3.Distance(Me.Position, theLoc) < .45f)
        //                foreach (TorPlaceable obj in ObjectManager.GetObjects<Buddy.Swtor.Objects.TorPlaceable>().Where(obj => obj.Name != null && obj.Name.Contains(POIName)))
        //                {
        //                    obj.Interact();
        //                    Thread.Sleep(7000);
        //                }

        //            LastPOIName = POIName;
        //        }
        //        catch { }
        //    //}
        //    //using (BuddyTor.Memory.AcquireFrame()) { }

        //}

        public static void CheckXP()
        {
            if (DiffInSeconds(LastXPShownTime, Now)>=120f)
            {
                if (Me.Xp > LastXPCheck )
                {
                    ulong XPGained = Me.Xp - LastXPCheck;
                    DateTime LocalTime = DateTime.Now.ToLocalTime();  // Time is all F'd up, just goin with ETA Minutes now.

                    ulong XPRemaining = Me.XpNeeded - Me.Xp;
                    double XPPerHour = XPGained * 3600 / (DateTime.Now.Subtract(LastXPCheckTime).TotalSeconds);
                    StatusETAToLevel = "ETA for Level: " + (XPRemaining * 60 / XPPerHour).ToString("0") + " minutes.";
                    Logger.Write("XP Per Hour: " + XPPerHour.ToString("0,000") + " XP Needed for Level: " + XPRemaining.ToString("0,000") + " " + StatusETAToLevel);
                }
                else
                {
                    LastXPCheck = Me.Xp;
                    LastXPCheckTime = DateTime.Now;
                }
                LastXPShownTime = DateTime.Now;
            }
        }

        public static void CheckForCompTarget()
        {
            if (IG) return;
            try
            {

                var CompX = Comp;
                if (!IG && MyTarget() == null && CompX != null && CompX.InCombat)
                {
                    var CompTargX = CompX.CurrentTarget;
                    if (CompTargX != null && CompTargX != Me && CompTargX != CompX) { TargetUnit(CompTargX); }
                }
            }
            catch { }
        }

        //public static void CheckForQuestingInteract()
        //{
        //    return;
        //    try
        //    {
        //        var CTx = MyTarget();
        //        if (!IG && !IAmInCombat() && CTx != null && !CTx.IsDead && !CTx.IsHostile && !OurGUIDs.Contains(CTx.Guid.ToString()) && CTx.Distance <= .50f) { CTx.Interact(); Thread.Sleep(5000); ClearTarget(); }  // Questing Behavior update - attack a mob, get it to just-about-dead, then talk to it, sketchy in questing profiles
        //    }
        //    catch { }
        //}

        /// <summary>
        /// Roll thru AttackersInfo going back, first to the last point of combat, then gathering info on the combat, and at the end, calculate and display the info, if not already shown.
        /// </summary>
        public static void ShowDPSInfo()
        {
            float HPTotal = 0;
            if (AttackersHP.Count() > 0) foreach (KeyValuePair<ulong, float> kvp in AttackersHP) HPTotal += kvp.Value;
            AttackersHP.Clear();

            double TotSecs = Now.Subtract(CombatStart).TotalSeconds - CombatGCTime + CombatPullTime + .7;
            double DPS = (HPTotal / TotSecs);
            if (DPS > 100f && DPS < 10000 && TotSecs < 300f)
            {
                Logger.Write((IG ? "Group " : "") + "Rough Average (Non-Overkill) DPS Including AOE and Excluding GC Time on Last Group: " + DPS.ToString("0.0") + " Seconds: " +
                TotSecs.ToString("0.0") + " Max Group Combat Health: " + HPTotal.ToString("0,0"));
                StatusLastDPS = "Current DPS: " + DPS.ToString("0.0");
            }

        }

        //public static void ShowDPSInfo()
        //{
        //    if (IG) return;

        //    char chSplit = '\t';

        //    try
        //    {
        //        if (!IAmInCombat() && AttackersInfo.Count() - 1 > LastDPSIndex)
        //        {

        //            //for (int z = AttackersInfo.Count() - 1; z >= AttackersInfo.Count() - 20; z--) Logger.Write(AttackersInfo.ElementAt(z));

        //            int i = AttackersInfo.Count() - 1;
        //            while (i >= 0 && AttackersInfo.ElementAt(i).Split(chSplit)[1] != "True") i -= 1;

        //            if (i <= -1) return;
        //            if (i == LastDPSIndex) return;

        //            LastDPSIndex = i;

        //            DateTime CombatEnd = Convert.ToDateTime(AttackersInfo.ElementAt(i).Split(chSplit)[0]);
        //            DateTime CombatStart = CombatEnd;
        //            //Logger.Write("CombatEnd: " + CombatEnd.ToString());

        //            float MaxGroupHealth = 0;

        //            while (i >= 0 && AttackersInfo.ElementAt(i).Split(chSplit)[1] == "True")
        //            {
        //                float MH = Convert.ToSingle(AttackersInfo.ElementAt(i).Split(chSplit)[2]);
        //                if (MH > MaxGroupHealth) MaxGroupHealth = MH;
        //                i -= 1;
        //            }

        //            while (i >= 0 && AttackersInfo.ElementAt(i).Split(chSplit)[1] != "False") i -= 1;

        //            if (i >= 0)
        //            {
        //                DateTime dt = Convert.ToDateTime(AttackersInfo.ElementAt(i + 1).Split(chSplit)[0]);
        //                CombatStart = dt;
        //            }

        //            //Logger.Write("CombatStart: " + CombatStart.ToString());
        //            if (i <= -1) return;
        //            double TotSecs=CombatEnd.Subtract(CombatStart).TotalSeconds-CombatGCTime+CombatPullTime;
        //            double DPS = (MaxGroupHealth / TotSecs);
        //            if (DPS > 0f && DPS < 5000f)
        //            {
        //                Logger.Write((IG ? "Group " : "") + "Rough Average (Non-Overkill) DPS Including AOE and Excluding GC Time on Last Group: " + DPS.ToString("0.0") + " Seconds: " +
        //                TotSecs.ToString("0.0") + " Max Group Combat Health: " + MaxGroupHealth.ToString("0,0"));
        //                StatusLastDPS = "Current DPS: " + DPS.ToString("0.0");
        //            }

        //            CombatGCTime=0;
        //            CombatPullTime = 0;
        //        }
        //    }
        //    catch { }
        //}

        //public static void WriteAttackersInfo()
        //{
        //    if (AttackersHPTotal == 0 && AttackersInfo.Count() > 0)
        //    { 
        //        string LastEntry=AttackersInfo[AttackersInfo.Count() - 1];
        //        if (Convert.ToDecimal(LastEntry.Split('\t')[2]) == 0) return;
        //    }
        //    AttackersInfo.Add(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss.fff") + '\t' + IAmInCombat().ToString() + '\t' + AttackersHPTotal.ToString("0000000.0") + '\t' + Me.EnemiesAttackers.Count().ToString("00"));
        //}

        public static void UpdateRGStatusInfo()
        {   
            if (!DoRandomGrind || IG) return;
            if (StatusETAToLevel!="" && StatusLastDPS !="")
            {
                Buddy.CommonBot.BotMain.StatusText = StatusLastDPS + " " + StatusETAToLevel;
            }
        }

        public static void GetCompAttackAbil()
        {
            try
            {
                if (taCompAttack != null) return;

                var CompX = Comp;
                if (CompX != null) foreach (TorAbility ta in CompX.KnownAbilitiesContainer)
                    {
                        if (ta.Name.Contains("Attack")) { taCompAttack = ta; Logger.Write("Companion Ability " + ta.Name + " found."); break; }
                        else Logger.Write("Companion Ability " + ta.Name + " found.");
                    }
            }
            catch { }
        }

        //public static void SynthOOC()
        //{
        //    while (true)
        //    {
        //        if (!BotMain.IsRunning) break;
        //        OOC();
        //        Thread.Sleep(1000);
        //    }
        //}

        public static void CheckForBadTarget()
        {
            try
            {
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    if (!IG && DoRandomGrind && MyTarget() != null && !MyTarget().IsDeleted && (MyTarget().IsDead || MyTarget().HealthPercent < .1f)) { ClearTarget(); return; }
                    if (!IG && MyTarget() != null && !MyTarget().IsDeleted && OurGUIDs.Contains(MyTarget().Guid.ToString())) ClearTarget();
                }
            }
            catch { }
        }

        private static void MoveOutOfCoverIfNec()
        {
            //if (EnableObjMgrUpd) { UpdateObjects(); Thread.Sleep(50); }
            if (MovementAllowed && (HaveBuff("Crouch") || HaveBuff("Take Cover")))
            {
                MoveForward(300);
            }
        }

        public static void SummonCompIfNec()
        {
            if (IG || IAmInCombat()) return;
            bool SummDone = false;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (MyLevel >= 10 && !Me.IsMounted && Comp == null && !Me.PvpFlagged && DiffInSeconds(datLSC, Now) >= 120f) if (taSummComp != null && Me.IsAbilityReady(taSummComp, Me)==EffectResult.Ok)
                    {
                        Logger.Write("Trying to summon companion...");
                        if (BuddyTor.Me.AbilityActivate(taSummComp, Me, out er)) SummDone = true;
                        datLSC = DateTime.Now;
                    }
            }
            if (SummDone) Thread.Sleep(1500);
        }

        public static void CheckForQuestItems()
        {
            ScanForLootables();
            ScanForPlaceables();

            foreach (TorPlaceable tp in ObjectManager.GetObjects<TorPlaceable>().OrderBy(d=>d.Distance))
            {
                if (tp.QuestIndication != QuestIndication.Unknown && tp.QuestIndication != QuestIndication.QuestNone) { Logger.Write("Quest Item(?) " + tp.Name + " found, status: " + tp.QuestIndication.ToString()); while (!IAmInCombat())MoveToAndInteract(tp); }
            }
        }

        // NOT (IN-GROUP OR RUNNING RANDOM GRIND)
        public static void OOCQuestingGrinding()
        {

            PauseWait();
            CheckObjCount();

            CheckQuestingPOI();
            if (CheckForFRDImmediate || IAmDead() || IAmInCombat() || ValidCombatTarget(MyTarget()) || IAmMounted()) return; // Run Combat or Return Control to The Brain (questing/grinding logic in the .exe)

            CheckGC();

            DateTime datStart = DateTime.Now;
            
            SynchObjCacheAll();
            UpdateObjects();

            if (MountUp()) return;

            if (DateTime.Now.Subtract(datLOOC).TotalSeconds <= 20) return;
            datLOOC = DateTime.Now;

            CheckForDeadComp();
            SummonCompIfNec();
            ScanForLootables();
            HarvestIfNec();
            ScanForPlaceables();
            
            WaitForComp();

                //while (true)                                                          // Enable this at your own risk - but from what I tested with it worked fairly well - for Bodyguard combat.
                //{
                //    while (SageCombatPvP()) ;
                //    Thread.Sleep(500);
                //    if (IAmDead()) break;
                //}
                //return;

                //if (BuddyTor.Me.PvpFlagged) return;

                //LoadVars();

                //CheckQuesting();             
            //if (ReportDurs) Logger.Write("OOC Dur up Thru Time Check: " + DateTime.Now.Subtract(DateLastPingOOC).TotalMilliseconds);
            if (ReportDurs) Logger.Write("OOC Duration: " + DateTime.Now.Subtract(datLOOC).TotalMilliseconds.ToString("0ms"));

        }


        public static void OOCIG()
        {

            if (Restarting) { Logger.Write("MemMon Restart: Exitng OOC."); return; }

            datLOOC = DateTime.Now;

            try
            {
                CheckGC();
                SynchObjCacheAll();
                if (IAmInCombat() && AllowCombat) { 
                    //MyCombat();
                    //IAmDead();
                    return; 
                }

                if (!IG) return;
            
                if (IAmDead()) return;
                if (GroupSize == 0) GetGroupSize();

                CheckForBadTarget();

                if (AutoTarget) GetGroupTarget();
                else CT = MyTarget();
                if (CT != null) 
                { 
                    if (CT != MyTarget())TargetUnit(CT); 
                    //MyCombat(); 
                    return; 
                }
                
                MyRestAndBuffs();
                
                if (ReportDurs) Logger.Write("OOC Duration: " + DateTime.Now.Subtract(datLOOC).TotalMilliseconds.ToString("0ms"));

            } catch {}
        }

        public static bool NeedRestRSMin(float minH, float minRS)
        {
            try 
            { if (Comp != null) if ((Comp.Position.X != 0) && Comp.HealthPercent > 0f && Comp.HealthPercent < 85f) return true; }
            catch { }
            
            return (Me.ResourceStat < minRS || Me.HealthPercent < minH);
            //if (NR) Logger.Write("Need Rest...");
        }

        public static bool NeedRestRSMax(float minH, float minRS)
        {
            try
            { if (Comp != null) if (Comp.Position.X != 0 && Comp.HealthPercent < 85f) return true; }
            catch { }

            return (Me.ResourceStat > minRS || Me.HealthPercent < minH);
        }

        public static void KillStealth()
        {
        //Logger.Write("Entering WaitForRest...");
            while (HaveBuff("Stealth"))
            {
                if (!MercCast("Stealth")) MercForcedCast("Force Wave", Me);  // Fucking PITA - Trying to cast Stealth while stealthed - WILL NOT WORK (nor will the Stealth ability)
                Thread.Sleep(1000);
                LoadVars();
            }
        }

        public static bool NeedRest(bool WaitForComp, TorCharacter CompX, bool RSIsMinimum, float RSVal)
        {
            UpdateObjects();
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                bool NR = false;
                try { if (WaitForComp && CompX != null && !CompX.IsDead && CompX.HealthPercent < 80f) return true; }
                catch { }

                if (!NR && Me.HealthPercent < 90f) return true;
                if (!NR && RSIsMinimum && Me.ResourceStat < RSVal) return true; // Rest, RS builds as we rest, stop rest when RS >= RSVal
                if (!NR && !RSIsMinimum && Me.ResourceStat > RSVal) return true;

                return false;
            }
        }

        public static void WaitForRest(bool WaitForComp, string theSpell, bool RSIsMinimum, float RSVal)
        {
            DateTime datStart = DateTime.Now;

            if (IAmInCombat() || Me.IsMounted || IAmDead()) return;// false;
            UpdateObjects();
            TorCharacter CompX = (TorCharacter)LastComp;
            try
            {
                if (CompX != null) if (CompX.InCombat) return;
            }
            catch { }
            
            bool NR = NeedRest(WaitForComp, CompX, RSIsMinimum, RSVal);
            if (!NR) return;

            //if (Me.Class == CharacterClass.Agent || Me.Class == CharacterClass.Smuggler) {
            //    MoveForward(300);
            //}
            if (MyTarget() == null) KillStealth();

            StopMoving();
            StopMoving();

            if (IAmInCombat()) return;

            //Logger.Write("Starting Rest - HP: " Me.HealthPercent.ToString(".0") +
            Logger.Write("Starting Rest....");
            DateTime RestStart = DateTime.Now;
            
            ClearTarget();

            while (!IAmCasting() && !IAmInCombat() && !IAmDead() && DateTime.Now.Subtract(RestStart).TotalSeconds <= 3)
            {
                if (IAmInCombat()) return;
                Buddy.CommonBot.AbilityManager.Cast(theSpell, BuddyTor.Me);
                Thread.Sleep(300);
            }

            while (NR && DateTime.Now.Subtract(datStart).TotalSeconds<15)
            {
                if (IAmInCombat()) return;
                NR = NeedRest(WaitForComp, CompX, RSIsMinimum, RSVal);
                Thread.Sleep(1000);
            }

            Logger.Write("Done with Rest.");
            if (IAmCasting()) SendMessage(SWTORHWnd, (int)0x100, (IntPtr)(char)0x1b, (IntPtr)0);
            //using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            //{
            //    Movement.Move(MovementDirection.Forward, TimeSpan.FromMilliseconds(50));
            //    Input.MoveStopAll();
            //    StopMoving();
            //}
                    //if (Me.Class == CharacterClass.Agent || Me.Class == CharacterClass.Smuggler) MoveForward(500);

            Thread.Sleep(300);

        }

        public static void ForcePulse()
        {   
            if (DateTime.Now.Subtract(datLFP).TotalSeconds < 5) return;
            try { datLFP = DateTime.Now; Buddy.CommonBot.BotMain.CurrentBot.Pulse(); }
            catch { }
        }

        public static void WaitForComp()
        {
            var CompX = Comp;
            datLCL = DateTime.Now;
            if (CompX != null) { while (CompX.IsCasting && DateTime.Now.Subtract(datLCL).TotalSeconds <= 5) Thread.Sleep(500); }
        }

        public static ulong PISkill(string Skill)
        {
                foreach (Buddy.Swtor.Objects.Components.ProfessionInfo pi in BuddyTor.Me.ProfessionInfos)if (pi.Name.Contains(Skill)) return (ulong)pi.CurrentLevel;
                return 0;
        }

        public static bool CanHarvestCorpse(TorNpc unit)
        {
            //Logger.Write("Harvest: " + unit.Name + " UnitType: " + unit.CreatureType.ToString());
            try
            {
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    ulong SkillReq = Math.Max(unit.Level - 11, 1) * 8;
                    if (unit != null && !unit.IsDeleted && unit.IsDead && !unit.IsFriendly && unit.Distance <= 4.0f && StrongOrGreater(unit) && !MyBlacklist.ContainsKey(unit.Guid))
                        if
                        (
                            (HasBio && unit.CreatureType == Buddy.Swtor.CreatureType.Creature && PISkill("Bioanalysis") >= SkillReq) ||
                            (HasScav && (unit.CreatureType == Buddy.Swtor.CreatureType.Droid || unit.Name.Contains("Droid")) && PISkill("Scavenging") >= SkillReq)
                        )
                        {
                            //Logger.Write("Can Harvest the corpse.");
                            return true;
                        }
                }
            }
            catch { }
            //Logger.Write("Can't Harvest the corpse.");
            return false;
        }

        public static bool MoveToNoCombat()
        {
            Vector3 theLoc = new Vector3((float)-130.6159, (float)32.53959, (float)163.3082);
            while (Me.Position.Distance(theLoc) > .40f) { Navigator.MoveTo(theLoc); Thread.Sleep(200); }
            return true;
        }

        public static void InteractWithUnit(TorCharacter theUnit)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null)) 
            { 
                theUnit.Interact(); 
                Thread.Sleep(150); 
                //theUnit.Interact(); 
            }
        }

        public static void MoveToAndInteract(TorNpc unit, double ToWithin = .99f)
        {
            if (MyBlacklist.ContainsKey(unit.Guid)) return;//|| !CanHarvestCorpse(unit)) return;

            datLCL = DateTime.Now;
            if (unit.Distance >= 3.0f) MountUp();

            MoveResult MR = MoveResult.Moved;
            Vector3 Loc = CloneUnitPos(unit);
            while (PosDist(Loc) > ToWithin && MR != MoveResult.Failed && MR != MoveResult.PathGenerationFailed && DateTime.Now.Subtract(datLCL).TotalSeconds <= 15)
            {
                if (IAmInCombat()) { ClearTarget(); return; }
                MR = MoveToUnit(unit);
                //MR = Buddy.Navigation.Navigator.MoveTo(Loc);
                if (IAmInCombat()) { ClearTarget(); return; }
                Thread.Sleep(200);
            }
            StopMoving();
            StopMoving();
            Thread.Sleep(1500);
            if (IAmInCombat()) { ClearTarget(); return; }
            if (PosDist(Loc) <= ToWithin)
            {
                //if (Comp != null) while (Comp.IsCasting) Thread.Sleep(1000);
                if (unit != null) {
                    if (IAmInCombat()) { ClearTarget(); return; }
                    InteractWithUnit(unit);
                    Thread.Sleep(2000);
                    if (IAmInCombat()) { ClearTarget(); return; }
                    if (CanHarvestCorpse(unit)) { InteractWithUnit(unit); Thread.Sleep(3500); while (IAmCasting()) Thread.Sleep(1000); }
                    MyBlacklist.Add(unit.Guid, Now);
                    //return; 
                }
            }
            MyBlacklist.Add(unit.Guid, DateTime.Now);
            return;

        }

        public static int GetLootableCount()
        {
            int LC=0;

            foreach (TorNpc unit in ObjectManager.GetObjects<TorNpc>())
                try
                { if (unit!=null) if (!unit.IsDeleted) if (unit.Distance <= MaxDist && unit.IsDead && unit.IsLootable) LC+=1;
                } catch {}
            Logger.Write("Lootables Count: " + LC.ToString());
            return LC;
        }

        public static bool StrongOrGreaterAndCasting()
        {
            return CT != null && (int)CT.Toughness >= 4 && CT.IsCasting; 
        }

        public static bool StrongOrGreater(TorCharacter unit)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (IG) return EliteOrGreater(unit);

                return (int)unit.Toughness >= 4;
                //if (unit != null) if (unit.Toughness == CombatToughness.Strong || unit.Toughness == CombatToughness.Boss1 || unit.Toughness == CombatToughness.Boss2 ||
                //    unit.Toughness == CombatToughness.Boss3 || unit.Toughness == CombatToughness.Boss4 || unit.Toughness == CombatToughness.RaidBoss || unit.Toughness == CombatToughness.Player) return true;
                //return false;
            }
        }

        public static bool EliteOrGreater(TorCharacter unit)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (unit != null) if (unit.Toughness == CombatToughness.Boss1 || unit.Toughness == CombatToughness.Boss2 || unit.Toughness == CombatToughness.Player || unit.Toughness == CombatToughness.Boss3 || unit.Toughness == CombatToughness.Boss4 || unit.Toughness == CombatToughness.RaidBoss) return true;
                return false;
            }
        }

        public static bool BossOrGreater(TorCharacter unit)
        {
            if (unit != null) if (unit.Toughness == CombatToughness.Boss3 || unit.Toughness == CombatToughness.Boss4 || unit.Toughness == CombatToughness.RaidBoss) return true;
            return false;
        }

        public static bool StrongOrElite(TorCharacter unit)
        {
            if (unit != null) if (unit.Toughness == CombatToughness.Strong || unit.Toughness == CombatToughness.Boss1) return true;
            return false;
        }

        public static TorNpc GetNextHarvestable()
        {
            SynchObjCache(true);
            IEnumerable<TorNpc> theHarvestables = new List<TorNpc>();
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                theHarvestables = ObjectManager.GetObjects<TorNpc>().AsParallel().ToList().OrderBy(t => t.Distance).Where(t => CanHarvestCorpse(t));
            }
            foreach (TorNpc unit in theHarvestables) if (!MyBlacklist.ContainsKey(unit.Guid)) return unit;
            return null;
        }

        public static bool HarvestIfNec()
        {
            if (!HarvestCorpses || !MovementAllowed || IG) return false;
            if (!(HasBio || HasScav)) return false;
            if (!TimeForLoot() && !DoRandomGrind) return false;

            CheckForDeadComp();
            datLCL = DateTime.Now;

            if (DateTime.Now.Subtract(datLC).TotalSeconds < 10) return false;
            //Logger.Write("Entering Harvest...");
            if (IAmInCombat()) return false;
            if (BuddyTor.Me.Companion != null) if (BuddyTor.Me.Companion.InCombat) return false;

            int H = 0;

            if (IAmInCombat()) return false;
            //if (DateTime.Now.Subtract(datLCL).TotalSeconds >= 2f) return false;
            float theDist = DoRandomGrind ? 15.0f : MaxNodeDist;
            while (true)
            {
                TorNpc unit = GetNextHarvestable();
                if (unit == null) break;
                try {
                        {
                            Logger.Write("Harvest:  Moving to " + unit.Name + " Distance: " + unit.Distance.ToString() + " Position: " + unit.Position.ToString());
                            if (IAmInCombat()) { ClearTarget(); return true; }
                            MoveToAndInteract(unit);
                            if (IAmInCombat()) { ClearTarget(); return true; }
                            H += 1;
                        }
                    }
                    catch {}
            }
            datLC = DateTime.Now;
            return (H > 0);
        }

        public static bool CanHarvestObj(TorPlaceable obj)
        {
            try
            {
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    if (obj.Name.Contains("Security Chest") && ScanForChests) return true;
                    ulong LR = obj.Harvestable.ProfessionLevelRequired;
                    string SkillName = obj.Harvestable.ProfessionRequired.ToString();
                    ulong MySkill = PISkill(SkillName);
                    //Logger.Write("Skill Level Required for " + obj.Name + ": " + LR.ToString() + " Skill: " + SkillName + " MySkill: " + MySkill.ToString());
                    //if (ObjIsArch(obj) && HasArch && LR <= PISkill("Archaeology")) return true;                         // Arch placeables don't (currently) have the Harvestable or other properties from what I can see, so free-ball it

                    if (obj != null && !obj.IsDeleted && obj.Harvestable != null && obj.Name != null)
                    {
                        if (
                                MySkill >= LR
                           )

                            // (
                            // (obj.Harvestable.ProfessionRequired == ProfessionType.Archaeology || obj.Name.Contains("Crystal Formation")) && HasArch && LR <= PISkill("Archaeology")) || (obj.Harvestable.ProfessionRequired == ProfessionType.Bioanalysis && HasBio && LR <= PISkill("Bioanalysis")) ||
                            // (obj.Harvestable.ProfessionRequired == ProfessionType.Scavenging && HasScav && LR <= PISkill("Scavenging")) || (obj.Harvestable.ProfessionRequired == ProfessionType.Slicing && HasSlicing && LR <= PISkill("Slicing"))
                            //)
                            return true;
                    }
                    //if (obj != null) if (!obj.IsDeleted) if (ObjIsArch(obj) && HasArch && LR <= PISkill("Archaology")) return true;
                }
            }
            catch { }
            return false;
        }

        public static int ChampsElitesNearObj(TorObject obj)
        {
            try
            {
            return (ObjectManager.GetObjects<TorNpc>().Where(d => d!=null && !d.IsDeleted && !d.IsDead && Vector3.Distance(obj.Position,d.Position)<=3.0f &&
                    (d.Toughness==CombatToughness.Boss3 || d.Toughness==CombatToughness.Boss2 ||d.Toughness==CombatToughness.Boss1) 
                 )
                .Count());}
            catch { Logger.Write("Error in ChampsElitesNearObj()"); return 0; }
        }

        public static void MoveToAndInteract(TorObject obj, double ToWithin = .99f, int WaitAfterInteract=4000)
        {
            bool IsSecChest=obj.Name.Contains("Security Chest");

            if (IsSecChest) ToWithin = .30f;
            if (obj.Distance >= 3.0f) MountUp();

            MoveResult MR = MoveResult.Moved;
            datLCL = DateTime.Now;
            while (obj.Distance > ToWithin && MR != MoveResult.Failed && MR != MoveResult.PathGenerationFailed && DateTime.Now.Subtract(datLCL).TotalSeconds <= 20)
            {
                if (IAmInCombat()) { ClearTarget(); return; } // If it's a chest, grab that shit FIRST
                //MR = Buddy.Navigation.Navigator.MoveTo(obj.Position);
                MR = MoveToPlaceable((TorPlaceable)obj);
                Thread.Sleep(200);
                //Buddy.Swtor.Input.MoveTo(obj.Position, MeleeDist); Thread.Sleep(2000); 
            }
            StopMoving();
            Thread.Sleep(1000);
            if (IAmInCombat() && !IsSecChest) { ClearTarget(); return; }
            if (obj.Distance <= ToWithin)
            {
                try
                {
                    using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null)) { obj.Interact(); Thread.Sleep(300); ((TorPlaceable)obj).Interact(); Thread.Sleep(300); ((TorItem)obj).Use(); }
                    if (!IAmInCombat() && obj != null) MyBlacklist.Add(obj.Guid, DateTime.Now);
                }
                catch { }
                Thread.Sleep(4000);
                if (IAmInCombat()) { ClearTarget(); return; }
            }
            if (IAmInCombat()) return;
        }

        public static bool ObjIsChest(TorObject obj)
        {
            return (obj.Name.Contains("ity Chest"));
        }

        public static bool ObjIsArch(TorObject obj)
        {
            return (obj.Name.Contains("eological F") || obj.Name.Contains("Crystal Formation"));
        }

        public static bool ScanForPlaceables()
        {
            if (IG || PauseBot || !ScanForNodes || !MovementAllowed || MaxNodesBetweenFights==0) return false;

            if (!TimeForLoot()) return false;

            CheckForDeadComp();

            datLCL = DateTime.Now;
            int Harv = 0;

            int intI = 0;

            //float theDist = DoRandomGrind ? 6.0f : MaxNodeDist;
            SynchObjCache(false, false, false, false, false, true);

            UpdateObjects();

            IEnumerable<TorPlaceable> thePlaceables = null;
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                try
                {
                    thePlaceables = ObjectManager.GetObjects<Buddy.Swtor.Objects.TorPlaceable>().AsParallel().ToArray().Where(obj => obj.Distance <= MaxNodeDist && obj.Name.Contains("ity Chest")).OrderBy(t => t.Distance);
                    //if(HasSlicing) if (thePlaceables==null || thePlaceables.Count()<1)
                    //        thePlaceables = ObjectManager.GetObjects<Buddy.Swtor.Objects.TorPlaceable>().AsParallel().ToList().Where(obj => obj.Distance <= MaxNodeDist && obj.Name.Contains("it Case")).OrderBy(t => t.Distance);
                    if (thePlaceables == null || thePlaceables.Count() < 1)
                            thePlaceables = ObjectManager.GetObjects<Buddy.Swtor.Objects.TorPlaceable>().AsParallel().ToArray().Where(obj => obj.Distance <= MaxNodeDist && CanHarvestObj(obj)).OrderBy(t => t.Distance);
                }
                catch { }
            }

            if (thePlaceables!=null) foreach (var obj in thePlaceables) 
                try
                {   
                    if (ChampsElitesNearObj(obj) < 1) 
                    {
                        intI += 1;

                        if (!MyBlacklist.ContainsKey(obj.Guid)) if (CanHarvestObj(obj) || obj.Name.Contains("est"))
                        {
                            Logger.Write("Placeable: Moving to " + obj.Name + " Distance: " + obj.Distance.ToString() + " Position: " + obj.Position.ToString());
                            //Dismount();
                            ClearTarget();
                            Poi thePOI = new Poi(obj, PoiType.Loot);
                            Buddy.CommonBot.Poi.Current = thePOI;
                            MountUp();
                            MoveToAndInteract(obj, .99f);
                            if (IAmInCombat()) return false;
                            Harv += 1;
                            if (Harv >= MaxNodesBetweenFights) return false;
                        }
                    }
                }
                catch
                {
                    return false;
                }

            if (ReportDurs) Logger.Write("Scan for Nodes: " +intI.ToString() + " Placeables, " + DateTime.Now.Subtract(datLCL).TotalSeconds.ToString("#.00") + "s");
            return false;
        }

        public static void SendKey(Int32 codeIn)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                SendMessage(SWTORHWnd, (int)0x100, (IntPtr)(char)codeIn, (IntPtr)0);
            }
        }

        public static void SendKey(char codeIn)
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                SendMessage(SWTORHWnd, (int)0x100, (IntPtr)codeIn, (IntPtr)0);
            }
        }
        public static bool MountUp(bool Forced = false)
        {
            if ((!EnableMount && !EnableRocketBoost) || !MovementAllowed || IG || HasBuff("Stealth", Me) || IAmInCombat() || IAmMounted()) return false;

            if (!Forced && (DiffInSeconds(datLMC, Now) < MountCheckFreq)) return false;
            bool DidMount = false;

            datLMC = DateTime.Now;

            if (!BuddyTor.Me.IsMounted)
            {
                StopMoving(); Thread.Sleep(150);
                //if (MercCast("Stealth", BuddyTor.Me, Me.HasBuff("Stealth"))) { Thread.Sleep(250); WaitForCast(); }
                //SendMessage(SWTORHWnd, (int)0x100, (IntPtr)chMount, (IntPtr)0);

                if (EnableRocketBoost && DiffInSeconds(datLRB, Now) >= 30) using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                    {
                        Logger.Write("Trying to mount using the [" + chRocketBoost.ToString() + "] key.");
                        if (!IAmCasting()) 
                        { 
                            SendKey(chRocketBoost); 
                            SendKey(chRocketBoost);
                            Thread.Sleep(250);
                            datLRB = Now;
                        }
                    }
                Thread.Sleep(150);
                UpdateObjects();
                if (IAmCasting())
                {
                    WaitForCast();
                    return true;
                }

                // In theory I shouldn't think the following framelock would even make any difference here, but it definitely seems to 'make things work' alot more often (so far, 100%) so, what the hell, will leave this in
                if (EnableMount) using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    Logger.Write("Trying to mount using the [" + chMount.ToString() + "] key.");
                    StopMoving();
                    SendKey(chMount);
                    SendKey(chMount);
                }
                Thread.Sleep(250);
                UpdateObjects();
                if (IAmCasting())
                {
                    datLMC = DateTime.Now;
                    WaitForCast();
                    return true;
                }
                else
                {
                    if (!EnableRocketBoost)
                    {
                        datLMC = DateTime.Now;
                        return false;
                    }
                }

            }
            else return false;
            DateTime MountStart = DateTime.Now;
            WaitForCast();

            //bool Casting = false;
            //while (true)
            //{
            //    using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            //    {
            //        Casting = Me.IsCasting && DateTime.Now.Subtract(MountStart).TotalSeconds <= 1;
            //    }
            //    if (Casting)    
            //    { 
            //        DidMount = true; 
            //        Thread.Sleep(1000); 
            //    }
            //    else 
            //        break;
            //}

            return DidMount;
        }

        // Doesn't work, Me.IsMounted, wrong
        public static void Dismount()
        {
            Thread.Sleep(500);
            if (BuddyTor.Me.IsMounted)
            {
                Logger.Write("Trying to dismount using the [" + chMount + "] key.");                   // SPELL IT OUT FOR THOSE WHO CAN'T READ

                StopMoving(); Thread.Sleep(250);
                //if (MercCast("Stealth", BuddyTor.Me, Me.HasBuff("Stealth"))) { Thread.Sleep(250); WaitForCast(); }

                while (Me.IsMounted)
                {
                    SendMessage(SWTORHWnd, (int)0x100, (IntPtr)chMount, (IntPtr)0);
                    Thread.Sleep(1000);
                }
                Thread.Sleep(500);
            }
            else return;
        }

        public static bool ScanForLootables()
        {
            //if (!ScanForLoot || ! MovementAllowed) return false;
            if (!MovementAllowed || PauseBot || IG) return false;
            //if (!IAmInCombat() && Me.HasBuff("Crouch")) { MoveForward(300); }
            //if (DateTime.Now.Subtract(datLLS).TotalSeconds < 10) return false;
            if (!TimeForLoot()) return false;

            DateTime datBeg = DateTime.Now;

            //Logger.Write("Scanning for loot....");
            int Looted = 0;

            try
            {
                UpdateObjects();
                UpdateObjects();
                //System.Linq.IOrderedEnumerable<TorNpc> Lootables=null;
                List<TorNpc> Lootables = new List<TorNpc>();
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    try
                    {
                        // Trying to do this with a .Where clause gets just a LITTLE sketchy
                        foreach (TorNpc t in ObjectManager.GetObjects<TorNpc>().ToList().Where(t => t != null && !t.IsDeleted).OrderBy(t => t.Distance))
                            if (t.IsLootable && t.Distance <= MaxNodeDist) Lootables.Add(t);
                    }
                    catch 
                    { 
                        return false;
                    }
                }
                if (ReportDurs) Logger.Write("Lootables Scan: " + DateTime.Now.Subtract(datBeg).TotalMilliseconds.ToString("0") + "ms");
                if (Lootables!=null && Lootables.Count()>0) foreach (TorNpc unit in Lootables)// !t.IsFriendly && t.IsDead))
                    if (!MovementAllowed) 
                    {
                        if (unit.Distance <= .89f && unit.IsLootable) { unit.Interact(); Thread.Sleep(3000); return true; } 
                    }
                    else
                        if (!MyBlacklist.ContainsKey(unit.Guid) && unit.IsLootable)
                    {
                        if (IAmInCombat()) { ClearTarget(); return false; }
                        //if (Me.Class == CharacterClass.Agent || Me.Class == CharacterClass.Smuggler)
                        //{
                        //    MoveForward(300);
                        //}

                        Logger.Write("Loot: Moving to " + unit.Name + " Distance: " + unit.Distance.ToString(".0") + " Position: " + unit.Position.ToString());
                        MoveToAndInteract(unit,unit.Name=="Hover Tank"?1.5f:.89f);
                        if (IAmInCombat()) { 
                            //MyCombat(); 
                            return true; 
                        }
                        Looted += 1;
                        datLLS = DateTime.Now;
                        //return true;
                    }
                }
            catch { return false; }

            //MountUp();

            datLLS = DateTime.Now;

            return Looted >= 1;
        }

        // Returns a Float/Single, Bracketed by (a) Distance, Divved by 5m (dist passed in, in m) (.5), + Health in 8-Digit Format 
        // Ex:  (Func call w/(t,5)) Mob at 7.5m with Health of 30500 would come back as 100030500f.  10.5m, 45200 would come back as 200040500f.  In short brackets by distance in multiples of 5m, and then by health, hitting weakest first.
        // In short, bracket by distance, and then hit the weakest mobs first within each bracket/bucket.
        public static float UnitDistanceBuckets(TorCharacter t, int DistBucketSize)
        {
            string o = "";

            if (t == null) return 0f;
            int b = (int)(t.Distance * 10);
            b /= DistBucketSize;
            string s = t.HealthMax.ToString("00000000") + t.HealthPercent.ToString("000.0");
            o=Convert.ToString(b)+s;
            return Convert.ToSingle(o);

        }

        public static void GetNearestCombatTarget()
        {
            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                try
                {   // First block is a temp select, for Revenge of the Archon, where you've got refueling droids that are NOT in combat, but you need to kill them (otherwise it's goddamn impossible)
                    //foreach (TorNpc t in ObjectManager.GetObjects<TorNpc>()
                    //    .Where(t => t.Distance<=3.0f && t.InLineOfSight && !t.IsDead && t.HealthPercent>.05f && t.Toughness != CombatToughness.Companion)
                    //    .OrderBy(t => t.HealthMax)) Attackers.Add(t);
                    if (CombatStart == DateTime.MinValue && Me.InCombat) CombatStart = Now;
                    foreach (TorCharacter t in ObjectManager.GetObjects<TorCharacter>().AsParallel().ToList()
                        .Where(t => t != null && !t.IsDeleted && !t.IsDead && t.InCombat && t.IsHostile && t.Distance <= 4.0f && !IsComp(t))
                        .OrderBy(t => (IsRanged || HP <= 65.0f) ? (float)t.HealthMax : UnitDistanceBuckets(t, 10))
                        ) // If ranged or getting low on health, hit the weakest units first
                        if (!t.IsDead && t.HealthPercent > .05f && t.CurrentTarget != null && t.Toughness != CombatToughness.Companion
                            ////&& t.CurrentTarget!=null && MyGUIDCompGUID.Contains(t.CurrentTarget.Guid.ToString()))
                            && t.CurrentTarget != null && t.CurrentTarget.Position.Distance(Me.Position) <= 3.5f)
                        { t.Target(); break; }
                    ;
                }
                catch { }               //foreach (TorNpc d in AttX)
        }

        public static void GetAttackers()
        {
            DateTime datStart = DateTime.Now;
            //Attackers = Me.EnemiesAttackers.ToList(); 
            if (Attackers != null) Attackers.Clear();
            //foreach (TorNpc x in Me.EnemiesAttackers) Attackers.Add(x);
            //if ((Attackers == null || Attackers.Count() == 0) && (MyTarget()!=null && !MyTarget().IsDead)) Attackers.Add((TorNpc)MyTarget());
            //return;
            Attackers = null;
            Attackers = new List<TorNpc>();
            TorCharacter CompX = Comp;

            OurGUIDs = MyGUID.ToString() + (CompX != null ? CompX.Guid.ToString() : "");
            string MyGUIDCompGUID = Me.Guid.ToString() + (CompX != null ? CompX.Guid.ToString() : "");

            // Keep the .Where clause simple - if it gets too complex, it will bug and the 'Ape-Shit Syndrome' kicks-in, and the bot will hang and eat up shitloads of memory
            // OR, convert to a List, first.
            if (IAmInCombat())
            {
                SynchObjCache(true);
                if (EnableObjMgrUpd) UpdateObjects();
                if (!IG)
                {
                    try
                    {
                        using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                        {
                            //First block is a temp select, for Revenge of the Archon, where you've got refueling droids that are NOT in combat, but you need to kill them (otherwise it's goddamn impossible)
                            //foreach (TorNpc t in ObjectManager.GetObjects<TorNpc>()
                            //    .Where(t => t.Distance<=3.0f && t.InLineOfSight && !t.IsDead && t.HealthPercent>.05f && t.Toughness != CombatToughness.Companion)
                            //    .OrderBy(t => t.HealthMax)) Attackers.Add(t);
                            if (CombatStart == DateTime.MinValue && Me.InCombat) CombatStart = Now;
                            foreach (TorCharacter t in ObjectManager.GetObjects<TorCharacter>().AsParallel().ToList()
                                .Where(t => t != null && !t.IsDeleted && !t.IsDead && t.InCombat && t.IsHostile && t.Distance <= 3.5f && !IsComp(t))
                                .OrderBy(t => (IsRanged || HP <= 65.0f) ? (float)t.HealthMax : UnitDistanceBuckets(t, 7))
                                ) // If ranged or getting low on health, hit the weakest units first
                                if (!t.IsDead && t.HealthPercent > .05f && t.CurrentTarget != null && t.Toughness != CombatToughness.Companion
                                    && t.CurrentTarget!=null && MyGUIDCompGUID.Contains(t.CurrentTarget.Guid.ToString()))
                                    //&& t.CurrentTarget != null && t.CurrentTarget.Position.Distance(Me.Position) <= 3.5f)
                                    Attackers.Add((TorNpc)t);
                        }
                    }
                    catch { }               //foreach (TorNpc d in AttX)
                }
                if (IG)
                {
                    try
                    {
                        using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                        {
                            foreach (TorCharacter t in ObjectManager.GetObjects<TorCharacter>().AsParallel().ToList()
                                .Where(t => t != null && !t.IsDeleted && t.InCombat)
                                .OrderBy(t => IsRanged ? t.HealthMax : t.Distance)
                                )
                                if (t.IsHostile && ((!MovementAllowed && t.Distance <= 6.0f) || (t.Distance <= 3.0f && !MovementAllowed)) && t.CurrentTarget != null && t.Toughness != CombatToughness.Player &&
                                    !t.IsDead && t.HealthPercent > .1f && t.CurrentTarget.Toughness == CombatToughness.Player)
                                    Attackers.Add((TorNpc)t);
                        }
                    }
                    catch { }               //foreach (TorNpc d in AttX)
                }
            }

            //if (IAmInCombat()) try
            //        {
            //            UpdateObjects();
            //            foreach (TorNpc t in ObjectManager.GetObjects<TorNpc>().AsParallel().ToList()
            //              .Where(t => t != null && !t.IsDeleted && t.InCombat && t.IsHostile)
            //              .OrderBy(t => t.HealthMax))
            //                if (!t.IsDead && t.HealthPercent > .1 && !t.IsStunned && t.CurrentTarget != null
            //                  && t.Toughness != CombatToughness.Player && t.Distance <= 4.0f && t.InLineOfSight)
            //                    Attackers.Add(t);
            //        }
            //        catch { }

            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (!IG && (Attackers == null || Attackers.Count() == 0))
                {
                    if (CompX != null && CompX.InCombat) if (CompX.CurrentTarget != null && !OurGUIDs.Contains(CompX.CurrentTarget.Guid.ToString()))
                        Attackers.Add((TorNpc)CompX.CurrentTarget);
                    if (MyTarget() != null && MyTarget().Name != Me.Name && !MyTarget().IsDead && MyTarget().Toughness != CombatToughness.Player)
                        Attackers.Add((TorNpc)MyTarget());
                }
                foreach (var att in Attackers) if (!AttackersHP.ContainsKey(att.Guid)) AttackersHP.Add(att.Guid, att.HealthMax);
            }
            //while (AttackersInfo.Count() > 1500) AttackersInfo.RemoveAt(0);
            //foreach (var att in Me.EnemiesAttackers) HPTotal += att.HealthMax;
            
            //AttackersHPTotal = 0f;
            //foreach (var att in Attackers) AttackersHPTotal += att.HealthMax;
            //WriteAttackersInfo();

            if (!IG && Attackers != null && Attackers.Count() > 0)
            {
                //Logger.Write("HPTotal: " + HPTotal.ToString());
                if(ReportDurs) Logger.Write("Attackers List (Block 1) Duration: " + DateTime.Now.Subtract(datStart).TotalMilliseconds.ToString("0"));
                //Logger.Write("Attackers List (Block 1) Duration: " + DateTime.Now.Subtract(datStart).TotalMilliseconds.ToString("0"));
                return;
            }
            try
            {
                using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    if (!IAmInCombat() && (!IG || DoRandomGrind))
                    {
                        if (MyTarget() != null && MyTarget().Name != Me.Name && !MyTarget().IsDead)
                            Attackers.Add((TorNpc)MyTarget());
                    }
                    if (!BuddyTor.Me.PvpFlagged)
                    {
                        foreach (TorNpc d in Me.EnemiesAttackers.OrderBy(t => t.Distance))
                            if (!d.IsDead && d.HealthPercent > .2f && d.Distance <= 5.0f) Attackers.Add(d);

                    }
                }
            }
            catch { if (MyTarget() != null && MyTarget().HealthPercent > .2) Attackers.Add((TorNpc)MyTarget()); return; }

            if(ReportDurs) Logger.Write("Attackers List (Block 2) Duration: " + DateTime.Now.Subtract(datStart).TotalMilliseconds.ToString("0"));
        }

        public static int ElitesInRange(Vector3 theLoc)
        {
            return ObjectManager.GetObjects<TorCharacter>().Where(t => t.Position.Distance(theLoc) <= 2.0f && EliteOrGreater(t)).Count();
        }

        public static bool InLevelRange(TorCharacter unit)
        {   
            try
            {
                if (unit==null) return false;
                return (unit.Level >= MyLevel - 6 && unit.Level <= MyLevel + 4);
            }
            catch {}
            return false;
        }

        public static bool ScanForMobs()
        {
            try
            {
                DateTime datStart = DateTime.Now;

                TorNpc theUnit = null;
                float theDist = MaxDist;

                if (IAmInCombat() || PauseBot) return false;
                Logger.Write("Scanning for mobs....");

                IEnumerable<TorNpc> theMobs = new List<TorNpc>();
                
                try
                {
                    UpdateObjects();

                    //MassPull(6.0f, "Weaken Mind", 3);
                    //return true;

                    SynchObjCache(true);

                    using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                    {
                        theMobs = ObjectManager.GetObjects<TorNpc>().ToArray().OrderBy(t => t.Distance).Where(unit =>
                            unit != null && !unit.IsDeleted && !unit.IsDead && (unit.IsHostile || unit.IsNeutral) && unit.Guid != MyGUID && !IsPlayer(unit) && !IsComp(unit) && !unit.IsDead && (unit.Level >= DRGMinLevel)
                                && unit.Level <= Me.Level + 4 && unit.Distance <= MaxDist && unit.Toughness <= CombatToughness.Boss1
                                && !unit.InCombat && ElitesInRange(unit.Position) < (MyLevel < 55 ? 2 : 3)).AsParallel();
                    }

                }
                catch { return false; }
                
                Logger.Write("Mob Scan Count: " + (theMobs != null ? theMobs.Count() : 0).ToString());
                if (theMobs == null || theMobs.Count() == 0) { Thread.Sleep(2000); return false; return false; }
                else
                {
                    using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                    {
                        if (theMobs != null && theMobs.Count() > 0)
                        {
                            //foreach (TorCharacter unit in theMobs.OrderBy(t => t.Distance).Where(unit => unit.InLineOfSight && unit.Toughness >= DRGMinToughness))
                            foreach (TorCharacter unit in theMobs.OrderBy(t => t.Distance).Where(t => t.Toughness >= DRGMinToughness && t.InLineOfSight && !UnitInMyBlacklist(t)))
                                try
                                {
                                    theUnit = (TorNpc)unit; theDist = unit.Distance; break;
                                }
                                catch { }
                            if (theUnit == null) foreach (TorCharacter unit in theMobs.OrderBy(t => t.Distance).Where(t => t.Level >= Me.Level - 20 && !UnitInMyBlacklist(t)))
                                    //if (!MyBlacklist.ContainsKey(theUnit.Guid)) 
                                    try { theUnit = (TorNpc)unit; theDist = unit.Distance; break; }
                                    catch { }
                        }

                    }

                    theMobs = null;

                    if (theUnit == null) return false;
                    if (IAmInCombat()) return false;

                    Logger.Write("Targeting:  Moving to " + theUnit.Name + " Distance: " + theUnit.Distance.ToString() + " Position: " + theUnit.Position.ToString());
                    TargetUnit(theUnit);

                    Vector3 Loc = CloneUnitPos(theUnit);
                    if (PosDist(Loc) >= 3.0f) MountUp();
                    if (PosDist(Loc) >= 3.5f) MountUp(true);

                    if (!Me.IsMounted && taRB != null && taRB.IsValid && PosDist(Loc) >= 3.5f) Me.AbilityActivate(taRB, Me, out er);
                    if (!Me.IsMounted && PosDist(Loc) >= 3.5f) MercCast("Rocket Boost");
                    WaitForCast();

                    StopMoving();
                    if (PauseBot) return false;
                    DateTime datStart2 = Now;
                    while (PosDist(Loc) > 2.8f)
                    {
                        if (DiffInSeconds(datStart2, Now) >= 15f) { ClearTarget(); CT = null; return false; }
                        if (PauseBot) return false;
                        UpdateObjects();
                        if (IAmInCombat())
                        { ClearTarget(); StopMoving(); /*MyCombat();*/ return true; }
                        MoveToUnit(theUnit);//Navigator.MoveTo(Loc);
                        Thread.Sleep(150);
                    }

                    Buddy.CommonBot.Poi.Current = new Poi(theUnit, PoiType.Kill);
                    Thread.Sleep(500);
                    CT = theUnit;
                    StopMoving();

                    //MyCombat();
                    //Thread.Sleep(2000);
                    UpdateObjects();
                    return true;
                }
            }
            catch { return false; }
        }

        // Experimental
        public static bool CheckRelics()
        {
            if (HP <= 40f)
            {
                //foreach(TorItem ti in BuddyTor.Me.InventoryEquipped)if(ti.Name.Contains("Relic")
            }

            return false;
        }

        public static float DRGPathMinDistFromPoint(Vector3 thePoint)
        {   
            float MinDist = 999;
            float Dist = 0;
            foreach (Vector3 CurrPt in DRGGrindPath)
            {
                Dist = Vector3.Distance(CurrPt, thePoint);
                if ( Dist < MinDist) MinDist = Dist;
            }
            if (MinDist != 999) return MinDist; else return 0;
        }


        private static void DRGUpdateVendor()
        {
            try
            {
                if (DRGVendorName == "")
                {
                    foreach (TorVendor t in ObjectManager.GetObjects<TorVendor>().Where(t => t.Distance <= 15f && !t.IsHostile).OrderBy(t => t.Distance))
                    {
                        if (!CheckForFRDImmediate)
                        {
                            DRGVendorName = t.Name;
                            DRGVendorPos = t.Position;
                            Logger.Write("DoRandomGrind:  Last-Closest-Vendor-Info updated to " + t.Name + " at " + t.Position.ToString());
                        }
                        UseVendor(t);
                        break; 
                    }
                }
            }
            catch { }

        }

        public static bool TimeForLoot(bool UpdateTimeStamp = false)
        {
            try
            {
                float td = DiffInSeconds(KillFestLastLootScan, Now);
                //Logger.Write("LastLootScan TimeDiff: " + td.ToString("0"));
                bool ItsTime = KillFestLootFreq < 60f || (td >= KillFestLootFreq && KillFestLootFreq >= 60f);
                if (ItsTime && UpdateTimeStamp) KillFestLastLootScan = DateTime.Now;
                return ItsTime;
            }
            catch (Exception Exception) { Logger.Write("Error in TimeForLoot()  Text: " + Exception.Source); }
            return false;
            }

        // Note that Y- and Z- Coordinates in BW are reversed, so everything where you see a Y is really a Z, and vice-versa
        public static void SectXGetOutOfPubBaseCamp()
        {
            if (!MovementAllowed) return;

            if (DoRandomGrind && !IG && BuddyTor.Client.AreaID == 0x4000003DC0622401 && Me.Position.X >= 27.8 && Me.Position.X <= 46.8 && Me.Position.Z >= -149 && Me.Position.Z <= -134  && Me.Position.Y >= 1.83)
            {
                Vector3 tgtPt = new Vector3((float)47.16545, (float)18.50269, (float)-144.7382);
                MoveResult mr = MoveResult.Moved;
                while (mr != MoveResult.Failed && tgtPt.Distance(Me.Position) > .70f) { Navigator.MoveTo(tgtPt); Thread.Sleep(150); }
                StopMoving();
                Thread.Sleep(300);
                Movement.Move(MovementDirection.Forward, TimeSpan.FromSeconds(1));
                StopMoving();
                Thread.Sleep(2000);
                UpdateObjects();
            }
        }

        public static void SectXGetOutOfImpBaseCamp()
        {
            if (!MovementAllowed) return;

            if (DoRandomGrind && !IG && BuddyTor.Client.AreaID == 0x4000003DC0622401 &&  Me.Position.X >= 53.4 && Me.Position.X <= 73.3 && Me.Position.Z >= -226.6 && Me.Position.Z <= -210.6 && Me.Position.Y >= 14.5)
            {
                Vector3 tgtPt = new Vector3((float)66.17811, (float)15.50269, (float)-210.361);
                MoveResult mr = MoveResult.Moved;
                while (mr != MoveResult.Failed && tgtPt.Distance(Me.Position) > .70f) { Navigator.MoveTo(tgtPt); Thread.Sleep(150); }
                StopMoving();
                Thread.Sleep(300);
                Movement.Move(MovementDirection.Forward, TimeSpan.FromSeconds(1));
                StopMoving();
                Thread.Sleep(2000);
                UpdateObjects();
            }
        }

        public static void DRGCheckForPathAddition()
        {
            bool bAdd = false;

            using ((UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
            {
                if (DRGGrindPath.Count() == 0) bAdd = true;
                if (!bAdd && DRGGrindPath.Count() < 50 && DRGPathMinDistFromPoint(Me.Position) >= 5.0f) bAdd = true;
                if (bAdd)
                {
                    DRGGrindPath.Add(new Vector3((float)Me.Position.X, (float)Me.Position.Y, (float)Me.Position.Z));
                    Logger.Write("DoRandomGrind:  Adding Path Element " + Me.Position.ToString() + " Total Path Elements: " + DRGGrindPath.Count().ToString());
                }
            }
        }

        public static void RunDRGPath()
        {
            if (PauseBot) return;
            
            MyRestAndBuffs();

            try
            {
                MountUp();
                if (DRGGrindPath != null && DRGGrindPath.Count() > 0)
                {
                    int DRGRandomPathPt = Convert.ToInt16(new Random().Next(0, DRGGrindPath.Count()));
                    var pt = DRGGrindPath[DRGRandomPathPt];
                    //foreach (var pt in DRGGrindPath)
                    {
                        try
                        {
                            UpdateObjects();
                            while (!IAmInCombat() && pt.Distance(MyPosition()) >= MeleeDist && !IAmInCombat() && pt.Distance(Me.Position) > .50f)
                            {
                                SynchObjCache(true, true);
                                UpdateObjects();
                                if (PauseBot) return;
                                if (ScanForLootables() || ScanForPlaceables() || ScanForMobs()) return;
                                MountUp();
                                MoveTo(pt, 2.9f);
                                Thread.Sleep(200);
                            }
                        }
                        catch { }
                    }
                }
            }
            catch
            {
                Logger.Write("Error in RunRandomGrind() Block 3.");
            }
        }

        public static bool RunRandomGrind()
        {
            try
            {
                if (!MovementAllowed) return false;
                PauseWait();
                ClearPOI();
                if (ValidCombatTarget(MyTarget()) || IAmInCombat()) { GetNearestCombatTarget(); return true; }
                //ShowDPSInfo();
                UpdateObjects();

                DRGCheckForPathAddition();

                try
                {
                    datLCL = DateTime.Now;
                    CheckXP();
                    UpdateRGStatusInfo();

                    if (IAmInCombat() || ValidCombatTarget(MyTarget())) { LoadVars(); Logger.Write("DRG:  Combat Detected: Running Combat."); /*MyCombat();*/ return false; }

                    CheckInventory();
                    if (CheckForFRDImmediate) return true;

                    CheckForDeadComp();
                    CheckForDeadComp();
                    MyRestAndBuffs();
                    SummonCompIfNec();

                    DRGUpdateVendor();

                    if (DRGGrindPath.Count() >= 500) DRGGrindPath.Clear();

                    SectXGetOutOfPubBaseCamp();
                    SectXGetOutOfImpBaseCamp();

                }
                catch
                {
                    Logger.Write("Error in RunRandomGrind() Block 1.");
                }

                try
                {
                    if (TimeForLoot())
                    {
                        if (PauseBot || IAmInCombat()) return false;
                        if (ScanForLootables()) { Logger.Write("Lootables found, returning."); }
                        if (PauseBot || IAmInCombat()) return false;
                        if (ScanForLootables()) { Logger.Write("Lootables found, returning."); }
                        if (PauseBot || IAmInCombat()) return false;
                        if (HarvestIfNec()) { Logger.Write("Harvestables found, returning."); }
                        if (PauseBot || IAmInCombat()) return false;
                        while (ScanForPlaceables()) ;// { Logger.Write("Placeables found, returning."); }
                        if (PauseBot || IAmInCombat()) return false;
                        KillFestLastLootScan = DateTime.Now;
                    }
                    //if (PauseBot || IAmInCombat()) { MyCombat(); return false; }
                    if (PauseBot) return false;
                    if (IAmInCombat()) { /*MyCombat();*/ return false; }
                    if (ScanForMobs()) { Logger.Write("Mobs were found, returning."); return true; }
                }
                catch //(Exception ex) 
                {
                    //Logger.Write("Error in RunRandomGrind() Block 2.  Text: " + ex.Message); 
                }

                //try
                //{
                //    CT = null;
                //    if (MyTarget() != null) CT = MyTarget();
                //    if (CT != null && !CT.IsFriendly && !CT.IsDead) 
                //    { 
                //        MyCombat(); 
                //        return true; 
                //    }
                //}
                //catch { }

            }
            catch { }

            Thread.Sleep(5000);
            Logger.Write("No mobs or loot found, recursing path.  Path Entries: " + DRGGrindPath.Count().ToString());

            RunDRGPath();            
            return false;
        }
    }

    //public class MyTorObject : Buddy.Swtor.Objects.TorObject
    //{
    //    public virtual override void TorObject(){}
    //}
    class MyMainWindow : Buddywing.MainWindow
    {
        protected override void  OnClosing(System.ComponentModel.CancelEventArgs e)
        {
 	        base.OnClosing(e);
            Environment.Exit(0);
        }
    }
    class MyTargetingProvider : Buddy.CommonBot.DefaultCombatTargetingProvider
    {
        //public virtual List<TorObject> GetObjectsByWeight()
        public List<TorObject> GetObjectsByWeight()
        {
            try
            {
                var theList = new List<TorObject>();
                if (!MercHelpers.AutoTarget) return theList;
                using ((MercHelpers.UseFramelocks ? BuddyTor.Memory.AcquireFrame() : null))
                {
                    bool IC = MercHelpers.IAmInCombat();
                    if ((IC && MercHelpers.MyTarget() == null) || (!IC && !MercHelpers.IG))
                        foreach (TorObject t in ObjectManager.GetObjects<TorCharacter>().Where(t => t != null && !t.IsDeleted && !(MercHelpers.IG && !t.InCombat)
                            && t.Distance <= (!IC ? MercHelpers.PullDist : 2.9f) && t.IsHostile 
                            &&  (!MercHelpers.AutoTargetLOSOnly || t.InLineOfSight) 
                            && !(t.IsDead || t.HealthPercent < .1f)))
                            theList.Add((TorObject)t);
                }
                //Logger.Write("GetObjectsByWeight Called.");
                return theList;
            }
            catch { return new List<TorObject>();}
        }

    }

    class NoMovement_MovementProvider : IMovementProvider
    {
        public void MoveTowards(Buddy.Common.Math.Vector3 location) { /*empty*/ }
        public void StopMovement() { /*empty*/ }
    };

    class NoMovement_NavigationProvider : INavigationProvider
    {
        public void Clear() { /*empty*/ }
        public MoveResult MoveTo(Buddy.Common.Math.Vector3 destination, string destName, bool useRaycast, bool useStraightLine)
        {
            return (MoveResult.Moved);
        }
    };

    class MakebRepublicQuests
    {
        
    }

}


public static class MonMemory
{
    public static void WatchIt()
    {
        Thread.Sleep(30000); // Let the bot 'settle-in'
        var objBot = BotMain.CurrentBot;

        while (true)
        {
            string ProcName=Process.GetCurrentProcess().ProcessName;
            long LastMemUsed = Process.GetCurrentProcess().WorkingSet64;

            if (Process.GetCurrentProcess().WorkingSet64 >= 150000000)
            //if (DateTime.Now.Subtract(JoesCombat.MercHelpers.DateLastPingCombat).TotalSeconds >= 20 || DateTime.Now.Subtract(JoesCombat.MercHelpers.DateLastPingOOC).TotalSeconds >= 20)
            {
                try
                {
                    //JoesCombat.Logger.Write("Bot going haywire - stopping and restarting it.");
                    JoesCombat.MercHelpers.Restarting = true;
                    Thread.Sleep(8000);
                    //while (BotMain.IsRunning)
                    //{
                    //Buddy.CommonBot.BotMain.BotThread.Abort();
                    //Thread.Sleep(1000);
                    //Buddy.CommonBot.BotMain.BotThread.Start();
                    BotMain.CurrentBot.Stop();
                    Thread.Sleep(1000);
                    //}
                    //BotMain.CurrentBot.Stop();
                    //Thread.Sleep(1000);
                    JoesCombat.MercHelpers.DoRehook();
                    Thread.Sleep(4000);
                    LastMemUsed = Process.GetCurrentProcess().PrivateMemorySize64;
                }
                catch { }

                JoesCombat.MercHelpers.Restarting = false;
                LastMemUsed = Process.GetCurrentProcess().PrivateMemorySize64;
            }
            
            //if (Process.GetCurrentProcess().ProcessName != ProcName) break;
            Thread.Sleep(15000);
        }
    }
}

//namespace Buddy.Swtor
//{
//    class Mounts
//    {
//        private static string OverrideMount = "";
//        public static string GetFastestAvailableMount()
//        {
//            if (OverrideMount != "") return OverrideMount;
//            return "";
//        }
//    }

//}


// Questing, wayyyyy experimental and VERY INCOMPLETE at this point.
public class MyHotspotList
{
    private List<Vector3> theHotSpots = new List<Vector3>();
    private string HSName = "";
    private ulong QuestID = 0;
    private uint QuestStepID = 0;

    public void DefineName(string theName)
    {
        HSName = theName;
    }
    public void AddToHSList(Vector3 thePoint)
    {
        theHotSpots.Add(thePoint);
    }

    public void SetIDAndStep(ulong theID, uint theStep)
    {
        QuestID = theID;
        QuestStepID = theStep;
    }
}

public class MyQuestProfile
{
    private string ProfilePath;
    //private static string ProfileContents;
    private string[] ProfileLines;
    private string CurLine;
    private List<MyHotspotList> Hotspots = new List<MyHotspotList>();

    private string GetStringStartingAt(string theString, int thePos)
    {
        bool bStarted = false;
        bool bEnded = false;
        string sIdentifier = "";
        string sCur = "";

        for (int i = thePos; i <= theString.Length - 1; i++)
        {
            sCur = theString.Substring(i, 1);
            if (sCur == "\"")
            {
                if (!bStarted) bStarted = true; else bEnded = true;
            }
            else
            {
                if (bStarted) sIdentifier += sCur;
            }
            if (bEnded) return sIdentifier;
        }
        return "";
    }

    private bool LoadProfile(string strPath)
    {

        ProfileLines = System.IO.File.ReadAllLines(strPath);
        MyHotspotList CurHS;
        int i;
        for (i = 0; i < ProfileLines.Length - 1; i++)
        {
            CurLine = ProfileLines[i];
            if (CurLine.Contains("GrindArea"))
            {
                int NamePos = CurLine.IndexOf("Name");
                string sIDVal = GetStringStartingAt(CurLine, NamePos);
                if (sIDVal != "")
                {
                    MyHotspotList HS = new MyHotspotList();
                    CurHS = HS;
                    HS.DefineName(sIDVal);
                }
            }
            if (CurLine.Contains("<Hotspot "))
            {
            }

        }

        return false;
    }
}

public class MyObject
{
    object TI;

    public object DeclareIt(object theItem)
    {
        TI = theItem;
        return TI;

    }

    public void DisposeIt(object theItem)
    {
        theItem = null;
    }

}
public class MyQuestDef
{
    private static List<Vector3> theHotSpots = new List<Vector3>();
    private static int currIndex = 0;
    private static string ItemToUse = "";
    private static ulong QuestID;
    private static uint StepID;
    private static string objectToUse = "";
    private static int WaitAfterUse;
    private static float DistanceForUse;

    //public void SetIDs(ulong theQuest, uint theStep)
    //{ 
    //    QuestID = theQuest;
    //    StepID = theStep;
    //}

    public void AddToHSList(double x, double y, double z)
    { theHotSpots.Add(new Vector3((float)x, (float)y, (float)z)); }

    public void SetProperties(ulong questID, uint stepID, string theItem = "", string theObject = "", int waitMsAfterUse = 4000, float distForUse = .40f)
    {
        QuestID = questID;
        StepID = stepID;
        ItemToUse = theItem;
        objectToUse = theObject;
        WaitAfterUse = waitMsAfterUse;
        DistanceForUse = distForUse;
    }

    public void RunThrough()
    {

        JoesCombat.MercHelpers.RunGathering();
        if (Buddy.CommonBot.ConditionParser.HasQuest(QuestID) && !Buddy.CommonBot.ConditionParser.IsStepComplete(QuestID, StepID))

            while (!JoesCombat.MercHelpers.IAmInCombat())
            {
                var pt = theHotSpots[currIndex];
                JoesCombat.Logger.Write("Quest Hotspot set to " + theHotSpots[currIndex].ToString());
                while (!JoesCombat.MercHelpers.IAmInCombat() && Buddy.Common.Math.Vector3.Distance(BuddyTor.Me.Position, pt) >= .05f)
                {
                    Buddy.Navigation.Navigator.MoveTo(new Vector3(pt.X, pt.Y, pt.Z));
                    Thread.Sleep(300);
                }
                if (ItemToUse != "" && !JoesCombat.MercHelpers.IAmInCombat())
                {
                    foreach (TorItem o in BuddyTor.Me.InventoryQuest)
                        if (o.Name.Contains(ItemToUse) && o.MinimumLevel <= JoesCombat.MercHelpers.MyLevel)
                        {
                            JoesCombat.Logger.Write("Using Quest Item " + o.Name + "...");
                            o.Interact();
                            //Thread.Sleep(7000);
                        }
                    currIndex += 1;
                    return;
                }
                if (objectToUse != "" && !JoesCombat.MercHelpers.IAmInCombat())
                    foreach (TorPlaceable obj in ObjectManager.GetObjects<Buddy.Swtor.Objects.TorPlaceable>().Where(obj => obj.Name.Contains(objectToUse)))
                    {
                        JoesCombat.MercHelpers.MoveToAndInteract(obj, .40f, WaitAfterUse);
                        currIndex += 1;
                        return;
                    }
                else break;
                if (currIndex >= theHotSpots.Count()) currIndex = 0;
            }
    }
}

//[JoesCombat] MyAbilities: Spotter;Armor Proficiency: Light;Weapon Proficiency: Sniper Rifle;Armor Proficiency: Adaptive;Weapon Proficiency: Blaster Rifle;Hold Position;;Speeder Piloting;Weapon Proficiency: Vibroknife;Armor Proficiency: Medium;Advanced Targeting;Siege Bunker;Recoil Control;Heavy Shot;Muzzle Fluting;Snap Shot;Sniper's Nest;Ballistic Dampers;Cover Screen;
